#include <bits/stdc++.h>

using namespace std;

int main() {
    int n, k;
    cin >> n >> k;

    vector <vector <int>> edges;

    if (k == 1) {
        cout << "YES\n";

        for (int i = 1; i <= n; i++) {
            int nxt = i + 1;
            if (nxt > n) nxt = 1;
            if (i != nxt) edges.push_back({i, nxt});
        }

        cout << edges.size() << endl;
        for (auto edge : edges) {
            for (int u : edge) {
                cout << u << " ";
            }
            cout << endl;
        }
        return 0;
    }

    if (n == k) {
        cout << "NO\n";
        return 0;
    }

    vector <int> dd(n + 1);

    for (int i = 1; i < n; i++) {
        dd[i]++;
        dd[i + 1]++;

        edges.push_back({i, i + 1});
    }

    int v = 2, K = k;

    for (int step = 2; step < k; step++) {
        for (int j = v + 2; j <= n; j++) {
            if (dd[v] < k) {
                edges.push_back({v, j});
                dd[j]++;
                dd[v]++;
            }
        }
        v += 2;
        k--;
    }

    vector <int> deg(n + 1);
    for (auto edge : edges) {
        for (auto u : edge) {
            deg[u]++;
        }
    }

    set <int> st;
    for (int i = 1; i <= n; i++) {
        st.insert(deg[i]);
    }

    if (st.size() != K) {
        cout << "Wrong answer\n";
        cout << st.size() << " " << k << endl;
        return 0;
    }

    cout << "YES\n";
    cout << edges.size() << endl;
    for (auto edge : edges) {
        for (int u : edge) {
            cout << u << " ";
        }
        cout << endl;
    }
}
