import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class Main {
    public static void main(String[] args) throws IOException {
        BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter out = new PrintWriter(System.out);
        int n = Integer.parseInt(bufferedReader.readLine());
        int a = Integer.parseInt(bufferedReader.readLine());
        int b = Integer.parseInt(bufferedReader.readLine());
        if (n == 1 && a == b) {
            out.println(1);
            out.printf("%d:%d%n", a, b);
        } else if (n == 1) {
            out.println(0);
            out.printf("%d:%d%n", a, b);
        } else if (n > a + b) {
            int ties = n - a - b;
            System.out.println(ties);
            matches(n, a, b, ties);
        } else if (n <= a + b) {
            System.out.println("0");
            zeroTies(n, a, b);
        }
        out.close();
    }
    private static void matches(int n, int a, int b, int ties) {
        for (int i = 0; i < ties; i++) {
            System.out.println("0:0");
        }
        zeroTies(n - ties, a, b);
    }
    public static void zeroTies (int n, int a, int b) {
        PrintWriter out = new PrintWriter(System.out);
        if (a < b) {
            for (int i = 0; i < a; i++) {
                out.println("1:0");
            }
            for (int i = 0; i < n - a; i++) {
                if (i == n - a - 1) {
                    out.printf("0:%d%n", b);
                } else {
                    out.println("0:1");
                    b--;
                }
            }
        } else if (a > b) {
            for (int i = 0; i < b; i++) {
                out.println("0:1");
            }
            for (int i = 0; i < n - b; i++) {
                if (i == n - b - 1) {
                    out.printf("%d:0%n", a);
                } else {
                    out.println("1:0");
                    a--;
                }
            }
        } else {
            for (int i = 0; i < a - 1; i++) {
                out.println("1:0");
            }
            out.printf("1:%d%n", b);
        }
        out.close();
    }
}