#include <stdlib.h>
#include <iostream>
#include <string>
#include <deque>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
#define ll long long
#define ull unsigned ll
#define forn(i, n) for (ll i = 1; i <= n; i++)
#define dforn(i, a, b) for (ll i = a; i <= b; i++)
#define rforn(i, n) for (ll i = n; i >= 1; i--)
#define rdforn(i, a, b) for (ll i = b; i <= a; i--)
const ll mod = 1e9 + 7;
const ll N = 1e5;
const ll inf = 1e17;
const double eps = 1e-7;

void solve() {
	ll n;
	cin >> n;
	vector<ll> vec(n), good(n, 1);
	forn(i, n) {
		cin >> vec[i - 1];
	}
	dforn(i, 0, n - 1) {
		good[(vec[i] - i - 1 + n) % n] = 0;
	}
	bool f = 0;
	ll shift = 0;
	forn(i, n - 1) {
		if (good[i] == 1) {
			f = 1;
			shift = i;
			break;
		}
	}
	if (!f) {
		cout << "Impossible" << endl;
		return;
	}
	cout << "Possible" << endl;
	vector<ll> p(n), q(n), np(n), nq(n);
	dforn(i, 0, n - 1) {
		p[i] = (i + shift) % n + 1;
	}
	dforn(i, 0, n - 1) {
		q[p[i] - 1] = vec[i];
		np[p[i] - 1] = i + 1;
	}
	dforn(i, 0, n - 1) {
		nq[q[i] - 1] = i + 1;
	}
	forn(i, n) {
		cout << np[i - 1] << " ";
	}
	cout << endl;
	forn(i, n) {
		cout << nq[i - 1] << " ";
	}
	cout << endl;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t = 1;
	cin >> t;
	while (t) {
		t--;
		solve();
	}
	return 0;
}