#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define int long long
#define endl "\n"

using namespace std;

int check(vector<vector<int>>& g, int k) {
	set<int> mass;
	int result = 0;
	for (int i = 0; i < g.size(); i++)
	{
		result += g[i].size();
		mass.insert(g[i].size());
	}

	if (mass.size() == k) {
		return result / 2;
	}
	
	return 0;
}

signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	//    int n, k; cin >> n >> k;
	//    vector<int> v(n);
	//    for (int i = 0; i < n; i++) cin >> v[i];
	//    int m = 0;
	//    int c = 1;
	//    int ind = 0;
	//    for (int i = 1; i < n; i++) {
	//        if (v[i] >= v[i - 1]) {
	//            c++;
	//        } else {
	//            c = 0;
	//        }
	//        if (c >= k) {
	//            int t = c / k;
	//            for (int j = 1; j <= t; j++) {
	//                v[ind + j * k] = v[ind + j * k - 1] - 1;
	//                ind = i;
	//                m++;
	//            }
	//        }
	//    }
	//    if (c >= k) {
	//        int t = c / k;
	//        for (int j = 1; j <= t; j++) {
	//            v[ind + j * k - 1] = v[ind + j * k - 2] - 1;
	//            m++;
	//        }
	//    }
	//    cout << m << '\n';
	//    for (auto &x: v)
	//        cout << x << ' ';
	//    return 0;

	//int n; cin >> n;
	//vector<vector<int>> v(n);
	//for (int i = 0; i < n; i++) {
	//	int k; cin >> k;
	//	for (int j = 0; j < k; j++) {
	//		int t; cin >> t;
	//		v[i].push_back(t);
	//	}
	//}

	//int spl = 0, comb = 0;

	//for (int i = 0; i < n; i++) {
	//	bool flag = true;
	//	while (flag) {
	//		flag = false;
	//		for (int j = 0; j < v[i].size() - 1; j++) {
	//			if (v[i][j] > v[i][j + 1]) {
	//				flag = true;
	//				v.push_back(vector<int>());
	//				for (int h = 0; h <= j; h++)
	//					v[v.size() - 1].push_back(v[i][h]);
	//				v[i].erase(v[i].begin(), v[i].begin() + (j + 1));
	//				spl++;
	//				break;
	//			}
	//		}
	//	}
	//}

	//sort(v.rbegin(), v.rend());

	//vector<int> res = v[0];
	//v.erase(v.begin());

	//while (v.size()) {
	//	vector<int> new_res;
	//	int i = 0, j = 0;
	//	while (i != res.size()) {
	//		if (!v[0].size()) {
	//			for (int j = i; j < res.size(); j++) new_res.push_back(res[j]);
	//			comb++;
	//			break;
	//		}
	//		if (v[0][v[0].size() - 1] < res[i]) {
	//			for (auto& x : v[0]) new_res.push_back(x);
	//			for (int j = i; j < res.size(); j++) new_res.push_back(res[j]);
	//			comb++;
	//			break;
	//		}
	//		while (v[0][0] < res[i]) {
	//			new_res.push_back(v[0][0]);
	//			v[0].erase(v[0].begin());
	//		}
	//		spl++;
	//		while (i != res.size() && v[0][0] > res[i]) {
	//			new_res.push_back(res[i]);
	//			i++;
	//		}
	//		comb+=2;
	//	}
	//	res = new_res;
	//	v.erase(v.begin());
	//}
	//cout << spl << ' ' << comb;

	int n = 0, k = 0;
	cin >> n >> k;
	if (n == k) {
		cout << "NO" << endl;
		return 0;
	}

	if (k == 1) {
		cout << "YES" << endl;
		cout << n << endl;
		for (int i = 0; i < n - 1; i++)
		{
			cout << i + 1 << " " << i + 2 << endl;
		}
		cout << n << " " << 1 << endl;
		return 0;
	}

	vector<vector<int>> g(n);
	int sum = 2;
	for (int i = 0; i < n - 1; i++)
	{
		g[i].push_back(i + 1);
		g[i + 1].push_back(i);
	}

	//for (size_t i = 0; i < n; i++)
	//{
	//	sum += g[i].size();
	//}

	int result = check(g, k);
	int pos = 1;
	bool flag = true;
	int temp = pos + 1;
	bool test = true;

	while (!result) {
		if (g[pos].size() == n - 1) {
			pos+= 2;
			temp = pos + 1;
			result = check(g, k);
			continue;
		}

		if (temp < n - 1) {
			temp++;
		}
		else {
			pos += 2;
			temp = pos + 1;
			result = check(g, k);
			continue;
		}

		g[pos].push_back(temp);
		g[temp].push_back(pos);
		sum++;

	}

	if (test) {
		cout << "YES" << endl;
		set<pair<int, int>> temp;
		for (int i = 0; i < g.size(); i++)
		{
			for (int j = 0; j < g[i].size(); j++) {
				temp.insert({ min(i + 1, g[i][j] + 1), max(i + 1, g[i][j] + 1) });
			}
		}

		cout << temp.size() << endl;
		for (auto item : temp) {
			cout << item.first << " " << item.second << endl;
		}
	}
	else {
		cout << "NO" << endl;
	}


//int t; cin >> t;
//while (t--) {
//	int n; cin >> n;
//	vector<int> v(n), p(n), q(n);
//	for (int i = 0; i < n; i++) cin >> v[i];
//	if (n == 2) {
//		cout << "Impossible\n";
//	}
//	else {
//		cout << "Possible\n";
//		for (int i = 0; i < n; i++) {
//			int x = v[i] - 1;
//			p[(x + 1) % n] = x;
//			q[x] = (i + 1) % n;
//		}
//		for (auto& x : p) cout << x + 1 << ' '; cout << '\n';
//		for (auto& x : q) cout << x + 1 << ' '; cout << '\n';
//	}
//}


}
