#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>

using namespace std;

void solveE() {
	set<int32_t> sorted;
	vector<vector<int32_t>> data;
	map<int32_t, pair<int32_t, int32_t>> pos;
	int32_t n, t;
	cin >> n;
	data.resize(n);
	int32_t i = 0;
	for (auto& v : data) {
		cin >> t;
		int32_t j = 0;
		v.resize(t);
		for (auto& u : v) {
			cin >> u;
			sorted.insert(u);
			pos[u] = { i, j };
			j++;
		}
		i++;
	}

	i = 0;
	for (auto v : sorted) {
		auto p = pos[v];
		data[p.first][p.second] = i;
		i++;
	}

	int32_t s = 0, u = n;
	for (auto &v : data) {
		int32_t i = 0;
		while (i < v.size() - 1) {
			i++;
			while (i < v.size() && v[i - 1] + 1 == v[i]) {
				i++;
			}
			if (i != v.size()) {
				s++;
				u++;
			}
		}
	}
	cout << s << ' ' << u - 1;
}

void solveF() {
	int32_t n, a, e;
	cin >> n >> a >> e;
	int32_t i = 0;
	int32_t d = 0;
	vector<pair<int32_t,int32_t>> ret;
	while (i < n - 1 && (a != 0 || e != 0)) {
		if (a > e) {
			a--;
			ret.push_back({ 1, 0 });
		}
		else {
			e--;
			ret.push_back({ 0, 1 });
		}
		i++;
	}
	if (a == e && a != 0) {
		if (ret.size() > 0) {
			if (ret.back().first > 0) {
				ret.back().first++;
				a--;
			}
			else {
				ret.back().second++;
				e--;
			}
		}
	}
	while (i < n)
	{
		if (a == e) {
			d++;
		}
		ret.push_back({ a, e });
		a = 0;
		e = 0;
		i++;
	}
	cout << d << '\n';
	for (auto v : ret) cout << v.first << ':' << v.second << '\n';
}

void solveA() {
	cout << "a";
}

int main()
{
	solveE();

	return 0;
}
