#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
using namespace std;
typedef long long ll;
#define d_c(type, name) type name; cin >> name
#define d_cl(name) d_c(ll, name)

int main() {
    d_cl(n);
    d_cl(k);
    if(k >= n) {
        cout << "NO" << endl;
        return 0;
    }
    if(k == 1)
    {
        cout << n << endl;
        for(int i = 0; i < n; i++)
        {
            cout << i + 1 << ' ' << (i + 1) % n + 1 << endl;
        }
        return 0;
    }
    cout << "YES" << endl;
    vector<vector<ll>> currs(n);
    auto add = [&](ll const& from, ll const& to)
    {
        currs[from].push_back(to);
        currs[to].push_back(from);
    };
    for(int i = 1; i < n; i++)
    {
        add(0, i);
    }
    ll l = 1, r = n - 1;
    for(int curr = 2; curr < k;)
    {
        if(curr + 1 < k)
        {
            for(int i = l + 1; i < r; i++)
                add(l, i);
            curr += 2;
            l++, r--;
        }
        else
        {
            add(l, l + 1);
            curr++;
        }
    }
    ll sum = 0;
    for(int i = 0; i < n; i++)
    {
        for(auto& e : currs[i])
        {
            if(e > i)
                sum++;
        }
    }
    cout << sum << endl;
    for(int i = 0; i < n; i++)
    {
        for(auto& e : currs[i])
        {
            if(e > i)
                cout << i + 1 << ' ' << e + 1 << endl;
        }
    }
    return 0;
}
