#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
using namespace std;
typedef long long ll;
#define d_c(type, name) type name; cin >> name
#define d_cl(name) d_c(ll, name)

pair<bool, vector<vector<ll>>> getAns(ll const& n, ll const& k)
{
    if(k >= n) {
        return {n == 1, {}};
    }
    vector<vector<ll>> currs(n);
    if(k == 1)
    {
        for(int i = 0; i < n; i++)
        {
            currs[i].push_back((i + 1) % n);
        }
        return {true, currs};
    }
    auto add = [&](ll const& from, ll const& to)
    {
        if(from >= to)
            return;
        currs[from].push_back(to);
    };
    for(int i = 1; i < n; i++)
    {
        add(0, i);
    }
    ll l = 1, r = n - 1;
    for(int curr = 2; curr < k;)
    {
        if(curr + 1 < k)
        {
            for(int i = l + 1; i < r; i++)
                add(l, i);
            curr += 2;
            l++, r--;
        }
        else
        {
            add(l, l + 1);
            curr++;
        }
    }
    return {true, currs};
}

int main() {
    d_cl(n);
    d_cl(k);
    auto ans = getAns(n, k);
    if(!ans.first)
    {
        cout << "NO" << endl;
        return 0;
    }
    cout << "YES" << endl;
    ll numb = 0;
    for(int i = 0; i < ans.second.size(); i++)
    {
        for(auto& e : ans.second[i])
        {
            if(i < e)
                numb++;
        }
    }
    cout << numb << endl;
    for(int i = 0; i < ans.second.size(); i++)
    {
        for(auto& e : ans.second[i])
        {
            if(i < e)
                cout << i + 1 << ' ' << e + 1 << endl;
        }
    }
    return 0;
}
