#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair

#define f first
#define s second

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int N = (int) 1e6 + 123;
const int MOD = (int) 1e9 + 7;
int a[N], n;
int pos[N];
bool used[N];
int p[N];
int q[N];
int where[N];
void solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        pos[a[i]] = i;
    }

    if (n == 1) {
        cout << "Impossible\n";
        return;
    }

    if (n == 2) {
        if (a[1] == 1 && a[2] == 2) {
            cout << "Possible\n";
            cout << 1 << ' ' << 2 << "\n";
            return;
        } else {
            cout << "Impossible\n";
            return;
        }
    }
//    cout << "a[]: ";
//    for (int i = 1; i <= n; i++)
//        cout << a[i] << ' ';
//    cout << endl;
//    cout << "pos[]: ";
//    for (int i = 1; i <= n; i++)
//        cout << pos[i] << ' ';
//    cout << endl;
    for (int i = 1; i <= n; i++)
        used[i] = 0;

    vector<int> seddle;
    vector<int> cycles;
    for (int i = 1; i <= n; i++) {
        if (pos[i] == i)
            seddle.pb(i);
        else {
            int x = i;
            while (!used[x]) {
                cycles.pb(x);
                used[x] = 1;
                x = pos[x];
            }
        }
    }
    //cout << "cycles: ";
    //for (auto x : cycles) cout << x << ' '; cout << endl;
    if (seddle.empty()) {
        for (int i = 0; i < sz(cycles); i++)
            p[cycles[i]] = cycles[(i + 2) % (sz(cycles))];
    } else if (cycles.empty()) {
        for (int i = 0; i < sz(seddle); i++)
            p[seddle[i]] = seddle[(i + 1) % seddle.size()];
    } else {
        if (cycles.size() > 2) {
            for (int i = 0; i + 1 < seddle.size(); i++)
                p[seddle[i]] = seddle[i + 1];
            p[seddle.back()] = cycles[1];
            for (int i = 0; i + 1 < cycles.size(); i++)
                p[cycles[i]] = cycles[(i + 2) % cycles.size()];
            p[cycles.back()] = seddle[0];
        } else {
            if (seddle.size() == 1) {
                cout << "Impossible\n";
                return;
            }
            vector<int> tmp;
            tmp.pb(cycles[0]);
            tmp.pb(seddle[0]);
            tmp.pb(cycles[1]);
            for (int i = 2; i < sz(seddle); i++)
                tmp.pb(seddle[i]);
            tmp.pb(seddle[1]);
            for (int i = 0; i < sz(tmp); i++)
                p[tmp[i]] = tmp[(i + 1) % tmp.size()];
        }
    }

    for (int i = 1; i <= n; i++)
        where[p[i]] = i;
    for (int i = 1; i <= n; i++)
        q[i] = where[pos[i]];

    for (int i = 1; i <= n; i++) assert(p[i] != i);
    for (int i = 1; i <= n; i++) assert(q[i] != i);
    for (int i = 1; i <= n; i++) assert(a[p[q[i]]] == i);

    cout << "Possible\n";
    for (int i = 1; i <= n; i++)
        cout << p[i] << ' ';
    cout << "\n";
    for (int i = 1; i <= n; i++)
        cout << q[i] << ' ';
    cout << "\n";
}

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int T;

    cin >> T;
    while(T--) solve();


    return 0;
}