#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair

#define f first
#define s second

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int N = (int) 1e6 + 123;
const int MOD = (int) 1e9 + 7;

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    int a, b;
    cin >> a >> b;

    if (n == 1) {
        if (a == b) {
            cout << 1 << endl;
            cout << a << ":" << b;
        } else {
            cout << 0 << endl;
            cout << a << ":" << b;
        }
        return 0;
    }

    vector<pii> ans;

    if (a && ans.size() < n) {
        ans.pb({1, 0});
        a--;
    }
    if (b && ans.size() < n) {
        ans.pb({0, 1});
        b--;
    }
    while (ans.size() < n && a) {
        a--;
        ans.pb({1, 0});
    }
    while (ans.size() < n && b) {
        b--;
        ans.pb({0, 1});
    }
    while (ans.size() < n) {
        ans.pb({0, 0});
    }

    if (a) ans[0].f += a;
    if (b) ans[1].s += b;

    int d = 0;
    for (auto [x, y]: ans) d += (x == y);

    cout << d << endl;
    for (auto [x, y]: ans)
        cout << x << ":" << y << "\n";

    return 0;
}