#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair

#define f first
#define s second

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int N = (int) 1e6 + 123;
const int MOD = (int) 1e9 + 7;

vi columns;
map<int, int> ans;

void init() {

    int cur = 0;
    columns.pb(0);
    ans[0] = 1;
    for (int i = 1; i <= 5982; i++) {
        int x = i;
        int add = 0;
        while (x % 5 == 0) {
            add++;
            x /= 5;
        }
        if (!add) continue;
        cur += add;
        columns.pb(cur);
        ans[cur] = i;

        // 1 2 3 4 .
        // . . . . X
    }
}

map<int, int> asked;

int ask(int x) {
    if (asked.count(x)) return asked[x];
    cout << "? " << x << endl;
    int res;
    cin >> res;
    asked[x] = res;
    return res;
}

void solve(vector<int> v) {
    int s = sz(v);
    if (s == 1) {
        cout << ans[v[0]];
        return;
    }

    int v1 = ask(v[0]);
    int v2 = ask(v[s / 2]);

    if (v1 == 0 && v2 == 0) {
        solve(vector<int>(v.begin() + s / 2, v.end()));
    } else {
        solve(vector<int>(v.begin(), v.begin() + s / 2));
    }
}

int main() {
    init();

    int t; cin >> t;
    while (t--) {
        asked.clear();
        solve(columns);
    }

    return 0;
}