#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair

#define f first
#define s second

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int N = (int) 1e6 + 123;
const int MOD = (int) 1e9 + 7;

int d[N];
vector<pii> ans;

void add(int u, int v){
   // cout << u << " " << v << endl;
    ans.pb({u, v});
    d[u]++;
    d[v]++;
}

void rec(int n, int k){
    if (!k || d[n] == k) return;
    int r = n-1;
    while (d[n] < k){
        add(n, r);
        r--;
    }
    rec(n-1, k-1);
}

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;
    if (n == 1 && k == 1){
        cout << "YES" << endl << 0;
        return 0;
    }
    if (n <= k){
        cout <<"NO";
        return 0;
    }
    if (k == 1){
        cout << "YES" << endl;
        if (n == 2){
            cout << 1 << endl << "1 2";
        }
        else{
            cout << n << endl;
            for (int i = 1; i < n; i++){
                cout << i << " " << i+1 << endl;
            }
            cout << n << " " << 1;
        }
        return 0;
    }
    for (int i = 1; i < n; i++){
        add(i, n);
    }
    rec(n-1, k-1);
    set<int> s;
    vector<int> cnt(n+1);
    cout << "YES" << endl << sz(ans) << endl;
    for (pii p : ans){
        cout << p.f << " " << p.s << endl;
        cnt[p.f]++;
        cnt[p.s]++;
    }
    for (int i = 1; i <= n; i++) s.insert(cnt[i]);
    assert(sz(s) == k);
    return 0;
}