#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define pb push_back
#define sz(x) (int)x.size()
#define pii pair <int, int>
#define fi first
#define se second

using namespace std;

const int maxn = 1e5 + 123;

int a[maxn], p[maxn], q[maxn], d[maxn];
set <int> s[maxn], t;

void solve() {
	int n;

	cin >> n;

	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		d[a[i]] = i;
		s[i].clear();
		s[i].insert(i);
		t.insert(i);
	}

	vector <int> vc;

	for (int i = 1; i <= n; i++) {
		s[i].insert(d[i]);
		vc.pb(i);
	}

	if (n == 1 || (n == 2 && a[1] == 2)) {
		cout << "Impossible\n";
		return;
	}
        
	vector < int > was(n + 1);
	vector < pii > bad;
	vector < int > poh;
	for(int i = 1; i <= n; i++){
		if(d[i] == i){
			poh.pb(i);		
			continue;
		}
		int j = i;
		vector < int > cycle;
		while(!was[j]){
			cycle.pb(j);
			was[j] = true;					
			j = d[j];
		}
		if(sz(cycle) != 2){
			for(int x: cycle)
				poh.pb(x);
		}
		else {
			bad.pb({i, d[i]});
		}
	}

	for(pii x: bad){
		if(sz(poh) == 0){
			poh.pb(x.fi);
			poh.pb(x.se);
		}
		else {
			int y = poh.back();
			poh.pop_back();
			poh.pb(x.fi);
			poh.pb(y);
			poh.pb(x.se);
		}
	}
		
	for(int i = 0; i < n; i++){
		int x = poh[i];
		int y = poh[(i - 1 + n)%n];
		if(d[x] == y){
			cout << "Impossible\n";
			return;
		} 
		q[x] = y;
		p[y] = d[x];
	}
	
	cout << "Possible\n";

    for (int i = 1; i <= n; i++)
		cout << p[i] << " ";

	cout << "\n";

	for (int i = 1; i <= n; i++)
		cout << q[i] << " ";

	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;

	while (t--) {
		solve();
	}

}