#include <bits/stdc++.h>
using namespace std;

#define f first
#define s second
#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

typedef long long ll;

const int N = 5e2;
const int M = N + 7;
const int MOD = 1e9 + 7;
const ll INF = 1e16 + 7;

vector<int> g[M];

void solve() {
    int n, k;
    scanf("%d %d", &n, &k); 
    if (k == 1) {
        if (n == 1) {
            printf("YES\n0\n");
        } else if (n == 2) {
            printf("YES\n1\n1 2\n");
        } else {
            printf("YES\n%d\n", n);
            for (int i = 1; i <= n; i++) {
                printf("%d %d\n", i, i % n + 1);
            }
        }
        return;
    }

    for (int i = 1; i <= n; i++) {
        if (i <= k) {
            assert(sz(g[i]) <= i);
            int need = i - sz(g[i]);
            for (int j = i + 1; j <= min(i + need, n); j++) {
                g[i].pb(j);
                g[j].pb(i);
            }
        } else if (g[i].empty()) {
            g[i].pb(i - 1);
            g[i - 1].pb(i);
        }
    }

    set<int> s;
    for (int i = 1; i <= n; i++) {
        s.insert(sz(g[i]));
    }

    if (sz(s) != k) {
        printf("NO\n");
        return;
    }

    vector<pair<int, int>> ans;
    for (int i = 1; i <= n; i++) {
        for (int j : g[i]) {
            if (i < j) {
                ans.pb({i, j});
            }
        }
    }

    printf("YES\n%d\n", sz(ans));
    for (auto &an : ans) {
        printf("%d %d\n", an.fi, an.se);
    }
}

int main() {
    int TT = 1;
    // scanf("%d", &TT);
    for (int i = 1; i <= TT; i++) {
        solve();
    }
    return 0;
}