#include <bits/stdc++.h>
using namespace std;

string guess(int x, int y) {
    cout << x << " " << y << endl;
    string s;
    cin >> s;
    if (s.back() == '!') {
        exit(0);
    }
    return s;
}

const int MAX = 100;

void solve1(string close, string far, string same) {
    int l = 0, r = MAX;
    int X = -1;
    while (l != r) {
        string L = guess(l, 0);
        string R = guess(r, 0);
        if (R == same) {
            X = (l + r) / 2;
            break;
        }
        if (R != close) {
            r = (l + r) / 2;
        } else {
            l = (l + r) / 2 + 1;
        }
    }
    if (X == -1) {
        X = l;
    }
    guess(X, 0);
    int cnt = 1;
    l = 0, r = MAX;

    while (r - l > 2) {
        int mid = (l + r) >> 1;
        if (cnt) {
            string R = guess(X, r);
            if (R == same) {
                guess(X, mid);
            }
            if (R == close) {
                l = mid;
            } else {
                r = mid;
            }
            cnt = 0;
        } else {
            string L = guess(X, l);
            if (L == same) {
                guess(X, mid);
            }
            if (L == close) {
                r = mid;
            } else {
                l = mid;
            }
            cnt = 1;
        }
    }
    for (int j = l; j <= r; ++j) {
        guess(X, j);
    }
}

void solve2(string x, string y, string same) {
    int l = 0, r = MAX;
    int cnt = 1;
    guess(0, 0);
    while (r - l > 2) {
        int mid = (l + r) >> 1;
        if (cnt) {
            string R = guess(0, r);
            if (R == same) {
                guess(0, mid);
            }
            if (R == x) {
                l = mid;
            } else {
                r = mid - 1;
            }
            cnt = 0;
        } else {
            string L = guess(0, l);
            if (L == same) {
                guess(0, mid);
            }
            if (L == x) {
                r = mid - 1;
            } else {
                l = mid;
            }
            cnt = 1;
        }
    }
    for (int j = l; j <= r; ++j) {
        guess(0, j);
    }
    guess(0, 0);
    l = 0, r = MAX;
    cnt = 1;
    while (r - l > 2) {
        int mid = (l + r) >> 1;
        if (cnt) {
            string R = guess(r, 0);
            if (R == same) {
                guess(mid, 0);
            }
            if (R == y) {
                l = mid;
            } else {
                r = mid - 1;
            }
            cnt = 0;
        } else {
            string L = guess(l, 0);
            if (L == same) {
                guess(mid, 0);
            }
            if (L == y) {
                r = mid - 1;
            } else {
                l = mid;
            }
            cnt = 1;
        }
    }
    for (int j = l; j <= r; ++j) {
        guess(j, 0);
    }
}

int main() {
    guess(0, 0);
    string same = guess(0, 0);
    string x = guess(0, 1);
    guess(0, 0);
    string y = guess(1, 0);

    if (x == y) {
        string z = guess(0, 0);
        solve1(x, z, same);
    } else {
        solve2(x, y, same);
    }
}
