#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define fi first
#define se second

const int N = 1e5 + 3;

int n, a[2 * N], p[2 * N];

inline void solve() {
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		p[a[i]] = i;
	}

	for (int i = n + 1; i < n + n; ++i) 
		p[i] = p[i - n];

	set<int> s;
	for (int i = 1; i < n; ++i)
		s.insert(i);
	for (int i = 2; i < n + n; ++i) {
		s.erase(i - p[i]);
	}
	if (s.empty()) {
		cout << "Impossible\n";
		return;
	}

	cout << "Possible\n";
	int c = *s.begin();

	for (int i = 1; i <= n; ++i) {
		cout << p[i + c] << ' ';
		assert(p[i + c] != i);
	}
	cout << "\n";
	for (int i = 0; i < n; ++i) {
		cout << (i - c + n) % n + 1 << ' ';
		assert(((i - c + n) % n + 1) != i + 1);
	}

	for (int i = 1; i <= n; ++i) {
		assert(a[p[(i - 1 - c + n) % n + 1 + c]] == i);
	}
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}