#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define fi first
#define se second

const int N = 1e5 + 3;

int n, a[2 * N], p[2 * N], ps[2 * N], q[2 * N];

inline void solve() {
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		p[a[i]] = i;
	}

	for (int i = n + 1; i < n + n; ++i) 
		p[i] = p[i - n];

	set<int> s;
	for (int i = 1; i < n; ++i)
		s.insert(i);
	for (int i = 2; i < n + n; ++i) {
		s.erase(i - p[i]);
	}
	if (s.empty()) {
		int cnt = 0;
		for (int i = 1; i <= n; ++i)
			q[i] = i, ps[i] = p[i];
		bool ok = 0;
		while (cnt * n <= 10000000 && !ok) {
			++cnt;
			ok = 1;

			random_shuffle(q + 1, q + 1 + n);
			for (int i = 1; i <= n; ++i) {
				if (q[i] == i || ps[i] == q[i]) {
					ok = 0;
					break;
				}				
			}

			if (ok) {
				cout << "Possible\n";
				for (int i = 1; i <= n; ++i) 
					p[q[i]] = ps[i];
				for (int i = 1; i <= n; ++i)
					cout << p[i] << ' ';
				cout << "\n";
				for (int i = 1; i <= n; ++i)
					cout << q[i] << ' ';
				cout << "\n";
				break;
			}
		}
		if (!ok) {
			cout << "Impossible\n";
		}
		return;
	}

	cout << "Possible\n";
	int c = *s.begin();

	for (int i = 1; i <= n; ++i) {
		cout << p[i + c] << ' ';
		assert(p[i + c] != i);
	}
	cout << "\n";
	for (int i = 0; i < n; ++i) {
		cout << (i - c + n) % n + 1 << ' ';
		assert(((i - c + n) % n + 1) != i + 1);
	}

	for (int i = 1; i <= n; ++i) {
		assert(a[p[(i - 1 - c + n) % n + 1 + c]] == i);
	}
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}