#include<bits/stdc++.h>

using namespace std;
#define For(i,n) for(int i = 0; i < n; i++)
#define ll long long
#define vt vector

template<typename T>
void print(vt<T> & a) {
    For(i, a.size()) {
        cout << a[i] << " ";
    }
    cout << endl;
}

vt<pair<int, int> > edges;

void rec(int l, int r) {
    if (l == r) {
        return;
    }
    edges.push_back(pair<int, int> {l, r});
    if (l + 1 == r) {
        return;
    }
    rec(l + 1, r - 1);
}

void solve()
{
    int n, k; cin >> n >> k;
    if (n == 1 && k == 1) {
        cout << "YES" << endl;
        cout << 0 << endl;
        return;
    }
    if (n <= k) {
        cout << "NO" << endl;
        return;
    }
    if (n == 2) {
        cout << "YES" << endl;
        cout << 1 << endl;
        cout << 1 << " " << 2 << endl;
        return;
    }
    cout << "YES" << endl;
    if (k == 1) {
        for (int i = 1; i <= n; i++) {
            int nxt = i % n + 1;
            edges.push_back({i, nxt});
        }
    } else {
        For(i, n - 1) {
            edges.push_back({1, i + 2});
        }
        for (int i = 1; i <= k - 2; i++) {
            rec(2, i + 2);
        }
    }
    
    cout << edges.size() << endl;
    vt<int> deg(n + 1);
    For(i, edges.size()) {
        cout << edges[i].first << " " << edges[i].second << endl;
        deg[edges[i].second]++;
        deg[edges[i].first]++;
    }
    set<int> st;
    For(i, n) {
        st.insert(deg[i + 1]);
    }
    assert(st.size() == k);
} 


int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int T = 1;

    for(int i = 0; i < T; i++) solve();
    return 0;
}