#include <bits/stdc++.h>
using namespace std;
#define ll long long

vector<int> y;
vector<int> p;
vector<bool> used;
bool dfs(int idx, int n) {
    if (idx == n + 1) {
        return true;
    }
    for (int i = 1; i <= n; ++i) {
        if (used[i] || i == idx || y[idx] == i) continue;
        used[i] = 1;
        p[idx] = i;
        if (dfs(idx + 1, n)) {
            return true;
        }
        used[i] = 0;
    }
    return false;
}

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    y.clear();
    y.resize(n + 1);
    used = vector<bool>(n + 1, false);
    p = vector<int>(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        y[v[i]] = i + 1;
    }
    // for (int i = 1; i <= n; ++i) {
    //     cout << y[i] << ' ';
    // }


    if (dfs(1, n)) {
        cout << "Possible\n";
        map<int, int> mp_q;
        for (int i = 1; i <= n; ++i) {
            cout << p[i] << " ";
            mp_q[p[i]] = i;
        }
        cout << endl;

        for (int i = 1; i <= n; ++i) {
            cout << mp_q[y[i]] << ' ';
        }
        cout << endl;
    } else {
        cout << "Impossible\n";
    }
    
    // poss
    // cout << "Possible\n";
}


int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
