#include <bits/stdc++.h>

#define pb push_back
#define sz(x) (int)(x.size())
#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (int)2e5 + 2;

void init_code() {
	freopen ("input.txt", "r", stdin);
	freopen ("output.txt", "w", stdout);
}

vector<pair<int, int>> edges;

// void rec(int n, int k) {
// 	if (k <= 2) {
// 		if (k == 2) {
// 			for (int i = 2; i <= n; ++i) {
// 				edges.pb({1, i});
// 			}
// 		} else {
// 			for ()
// 		}
// 		return;
// 	}
// }

void solve() {
	int n, k; cin >> n >> k;
	if (n == k) {
		cout << "NO\n";
		return;
	}

	if (k == 1) {
		cout << "YES\n";
		for (int i = 1; i <= n; i++) {
			for (int j = i + 1; j <= n; j++) {
				edges.pb({i, j});
			}
		}
		cout << edges.size() << '\n';
		for (auto p : edges) {
			cout << p.first << " " << p.second << "\n";
		}
		return;
	}


	if (k % 2 == 1) {
		edges.pb({1, 2});
		for (int i = 4; i <= k + 1; i += 2) {
			for (int j = 1; j <= i - 2; j++) {
				edges.pb({i, j});
			}
			edges.pb({i, i - 1});
		}
	} else {
		edges.pb({1, 3});
		edges.pb({2, 3});
		for (int i = 5; i <= k + 1; i += 2) {
			for (int j = 1; j <= i - 2; j++) {
				edges.pb({i, j});
			}
			edges.pb({i, i - 1});
		}
	}

	for (int i = k + 2; i <= n; i++) {
		edges.pb({k + 1, i});
	}

	cout << "YES\n";
	cout << sz(edges) << "\n";
	for (auto p : edges) {
		cout << p.first << " " << p.second << "\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	// init_code();
	int tt; tt = 1;
	while (tt--) solve();
	return 0;
}