#include <bits/stdc++.h>
#define sz(x) (int)(x).size()
#define pb push_back

using namespace std;
using ll = long long;

const int N = (int)1e5 + 3;
const ll mod = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int n; cin >> n;

    set<int> _sorted;
    vector<vector<int>> a(n);

    for(int i = 0; i < n; i++) {
        int m; cin >> m;
        for(int j = 0; j < m; j++) {
            int x; cin >> x;
            a[i].pb(x);
            _sorted.insert(x);
        }
    }

    map<int,int> _id;
    int _cnt = 0;

    for(auto it : _sorted) {
        _id[it] = ++_cnt;
    }

    int splits = 0;
    for(int i = 0; i < n; i++) {
        for(auto &j : a[i]) {
            j = _id[j];
        }
        for(int j = 1; j < sz(a[i]); j++) {
            if(a[i][j] != a[i][j-1] + 1) {
                splits++;
            }
        }
    }

    cout << splits << " " << n + splits - 1;

    return 0;
}
