#include <bits/stdc++.h>

using namespace std;

mt19937 rng(566);

void solveTest() {
	int n; cin >> n;
	vector<int> a2(n);
	for (int i = 0; i < n; ++i) {
		cin >> a2[i];
		--a2[i];
	}
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		a[a2[i]] = i;
	}
	vector<int> p(n);
	iota(p.begin(), p.end(), 0);
	for (int it = 0; it < 500; ++it) {
		shuffle(p.begin(), p.end(), rng);
		bool ok = 1;
		for (int i = 0; ok && i < n; ++i) {
			if (p[i] == i || p[i] == a[i]) {
				ok = 0;
			}
		}
		if (ok) {
			vector<int> ip(n);
			for (int i = 0; i < n; ++i) {
				ip[p[i]] = i;
			}
			cout << "Possible\n";
			for (int i = 0; i < n; ++i) {
				assert(p[i] != i);
				cout << p[i] + 1 << " ";
			}
			cout << "\n";
			for (int i = 0; i < n; ++i) {
				int q = ip[a[i]];
				assert(q != i && a2[p[q]] == i);
				cout << q + 1 << " ";
			}
			cout << "\n";
			return;
		}
	}
	cout << "Impossible\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int t; cin >> t;
	for (int i = 0; i < t; ++i) {
		solveTest();
	}
	return 0;
}