#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;

vector<pair<int, int>> solve(int n) {
    int l = 1, r = n;
    vector<pair<int, int>> result;
    while (l < r) {
        for (int i = l + 1; i <= r; i++) {
            result.emplace_back(l, i);
        }
        l++;
        r--;
    }
    return result;
}

int main() {
#ifdef PC
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    int n, k;
    cin >> n >> k;
    if (n == 1) {
        cout << "YES\n";
        cout << 0 << '\n';
        exit(0);
    }
    if (k == n) {
        cout << "NO\n";
        exit(0);
    }
    if (k + 1 == n) {
        cout << "YES\n";
        auto edges = solve(n);
        cout << edges.size() << '\n';
        for (auto [u, v] : edges) {
            cout << u << ' ' << v << '\n';
        }
        exit(0);
    }
    if (k == 1) {
        cout << "YES\n" << n << '\n';
        for (int i = 1; i + 1 <= n; i++) {
            cout << i << ' ' << i + 1 << '\n';
        }
        cout << 1 << ' ' << n << '\n';
        exit(0);
    }
    if (k == 2) {
        cout << "YES\n" << n - 1 << '\n';
        for (int i = 1; i + 1 <= n; i++) {
            cout << i << ' ' << i + 1 << '\n';
        }
        exit(0);
    }
    auto edges = solve(k - 1);
    for (int i = 1; i < n; i++) {
        edges.push_back({n, i});
    }
    cout << "YES\n";
    cout << edges.size() << '\n';
    for (auto [u, v] : edges) {
        cout << u << ' ' << v << '\n';
    }
    return 0;
}
