#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define y second
#define x first
#define pb push_back
#define mp make_pair

int const maxn = 1005;
char a[maxn][maxn];
vector < int > g[maxn * maxn];
vector < pair < int, int > > go = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
ll inf = 1000000;
ll ans;
vector < int > black, white;
int cur;
int n, m;
int lef[maxn * maxn], righ[maxn * maxn], used[maxn * maxn], was[maxn];

int get(int x, int y) {
    return x * m + y + 1;
}

void dfs2(int v) {
    used[v] = cur;
    for (auto u : g[v]) {
        if (lef[u] && used[lef[u]] != cur) dfs2(lef[u]);
    }
}

bool dfs(int v) {
    used[v] = cur;
    for (auto u : g[v]) {
        if (righ[u] == 0) {
            righ[u] = v;
            lef[v] = u;
            return true;
        }
    }
    for (auto u : g[v]) {
        if (used[righ[u]] != cur && dfs(righ[u])) {
            righ[u] = v, lef[v] = u;
            return true;
        }
    }
    return false;
}

void kun(int no) {
    int find = 1;
    for (auto key : black) lef[key] = 0;
    for (auto key : white) righ[key] = 0;
    while (find) {
        find = 0;
        cur++;
        for (auto v : black) {
            if (v == no) continue;
            if (used[v] != cur && lef[v] == 0 && dfs(v)) {
                cur++, find = 1;
            }
        }
    }
    int sz = 0;
    for (auto key : black) {
        if (lef[key]) sz++;
    }
    if (sz < (int)black.size() - 1) {
        ans += black.size();
        return;
    }
    for (auto key : white) {
        if (righ[key] == 0) {
            cur++;
            dfs2(key);
            for (auto elem : white) {
                if (used[elem] != cur) ans++;
            }
        }
    }
}

main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) cin >> a[i][j];
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '#') continue;
            if ((i + j) % 2 == 0) black.push_back(get(i, j));
            else white.push_back(get(i, j));
            for (auto key : go) {
                int x = i + key.first, y = j + key.second;
                if (x >= 0 && y >= 0 && x < n && y < m && a[x][y] == '.') {
                    g[get(i, j)].push_back(get(x, y));
                }
            }
        }
    }
    ll b = black.size();
    ans = b * (b - 1);
    if (ans > inf) {
        cout << inf;
        exit(0);
    }
    for (auto v : black) {
        kun(v);
    }
    cout << min(ans, inf);
    return 0;
}

