#include <bits/stdc++.h>

using namespace std;

vector<int> calc(vector<int> p, vector<int> want) {
  int n = want.size();
  assert(p.size() == want.size());
  vector<int> ans(n);
  vector<int> pp(n);
  for (int i = 0; i < n; ++i) {
    assert(0 <= p[i] and p[i] < n);
    pp[p[i]] = i;
  }
  for (int i = 0; i < n; ++i) {
    ans[i] = pp[want[i]];
  }
  return ans;
}

void solve() {
  int n;
  cin >> n;
  vector<int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
    --a[i];
  }
  vector<int> id(n);
  iota(id.begin(), id.end(), 0);
  auto h = calc(a, id);
  vector<char> used(n);
  vector<vector<int>> cyc;
  for (int i = 0; i < n; ++i) {
    if (used[i]) continue;
    cyc.push_back(vector<int>());
    int j = i;
    while (!used[j]) {
      cyc.back().push_back(j);
      used[j] = true;
      j = h[j];
    }
  }
  if (cyc.size() == 1) {
    if (cyc[0].size() == 1 or cyc[0].size() == 2) {
      cout << "Impossible";
      return;
    }
  }
  if (cyc.size() == 2) {
    if (cyc[0].size() == 1 and cyc[1].size() == 2) {
      cout << "Impossible";
      return;
    }
    if (cyc[0].size() == 2 and cyc[1].size() == 1) {
      cout << "Impossible";
      return;
    }
  }
  vector<int> kek;
  vector<int> twos;
  for (int i = 0; i < cyc.size(); ++i) {
    if (cyc[i].size() == 2) {
      twos.push_back(i);
    }
  }
  for (int i = 0; i < cyc.size(); ++i) {
    if (cyc[i].size() == 2) continue;
    for (int j = 0; j < cyc[i].size(); ++j) {
      kek.push_back(cyc[i][j]);
    }
  }
  if (twos.size() == 1) {
    assert(kek.size() >= 2);
    int x = cyc[twos[0]][0];
    int y = cyc[twos[0]][1];
    kek.insert(kek.begin(), x);
    kek.insert(kek.begin() + 2, y);
  } else if (twos.size() >= 2) {
    for (int i : twos) {
      for (int j = 0; j < cyc[i].size(); ++j) {
        kek.push_back(cyc[i][j]);
      }
    }
  }
  vector<int> p(n);
  for (int i = 0; i < n; ++i) {
    p[i] = kek[(i - 1 + n) % n];
  }
  auto q = calc(p, h);
  cout << "Possible\n";
  for (int i = 0; i < n; ++i) cout << p[i] + 1 << ' ';
  cout << '\n';
  for (int i = 0; i < n; ++i) cout << q[i] + 1 << ' ';
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0), cout.tie(0);

  int t;
  cin >> t;
  while (t--) {
    solve();
    cout << '\n';
  }

  return 0;
}
