#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

int32_t main() {
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;
    if (n == 1 && k == 1) {
        cout << "YES\n0\n";
        return 0;
    }
    if (n == k) {
        cout << "NO\n";
        return 0;
    }
    cout << "YES\n";
    if (k == 1) {
        cout << n * (n - 1) / 2 << "\n";
        for (int i = 1; i <= n; ++i) {
            for (int j = i + 1; j <= n; ++j) {
                cout << i << " " << j << "\n";
            }
        }
        return 0;
    }
    vector<pii> ans;
    vector<int> deg(n + 1, 0);
    for (int i = 2; i <= n; ++i) {
        deg[i] = 1;
        ans.emplace_back(1, i);
    }
    deg[1] = n - 1;
    for (int i = k; i >= 3; --i) {
        int nd = i - 1;
        for (int j = i - 1; deg[i] < nd - 1; --j) {
            ans.emplace_back(i, j);
            ++deg[i];
            ++deg[j];
        }
        if (deg[i] != nd) {
            ans.emplace_back(i, 2);
            deg[i]++;
            deg[2]++;
        }
    }
    cout << sz(ans) << "\n";
    for (auto &p : ans) {
        cout << p.fi << " " << p.se << "\n";
    }

    return 0;
}
