#include <bits/stdc++.h>
using namespace std;
#define int long long
using ll = long long;
using vi = vector<ll>;
using pi = pair<ll, ll>;
using vpi = vector<pi>;

void solve() {
    int n;
    cin >> n;
    vi first(n);
    for (int i = 0; i < n; i++) {
        first[i] = i;
    }
    vi mass(n);
    for (int i = 0; i < n; i++) {
        cin >> mass[i];
        mass[i]--;
    }
    vi second(n);
    for (int i = 0; i < n; i++) {
        second[mass[i]] = i;
    }
        vpi values(n);
    int is_solved = 0;
    for (int k = 0; k < min(1000ll, n); k++) {
        set<pi> empty_ind;
        for (int i = 0; i < n; i++) {
            empty_ind.insert({i, (i + k) % n});
        }
        for (int i = 0; i < n; i++) {
            for (auto j : empty_ind) {
                if (j.second != i && j.second != second[i]) {
                    values[i].first = j.second;
                    values[j.second].second = second[i];
                    is_solved = 1;
                    empty_ind.erase(j);
                    break;
                }
            }
        }
        if (empty_ind.empty()) {
            is_solved = 1;
            break;
        }
    }
    if (!is_solved) {
        cout << "Impossible" << endl;
        return;
    }
    cout << "Possible" << endl;
    for (int i = 0; i < n; i++) {
        cout << values[i].second + 1 << ' ';
    }
    cout << endl;
    for (int i = 0; i < n; i++) {
        cout << values[i].first + 1 << ' ';
    }

    cout << endl;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
