#include <iostream>
#include <vector>
#include<random>
#include<set>
#include<algorithm>
#include<queue>
#include<map>
using namespace std;

#define int long long
const int LIM = 1000'000;
struct ej {
	int fr;
	int to;
	int fl;
	int mx;
};
vector<ej>ejs;
vector<vector<int>>g;
int S = 0;
int T = 1;
vector<int>usd;
int fl(int s, int amt) {
	if (s == T) {
		return amt;
	}
	usd[s] = 1;
	for (int i = 0; i < g[s].size(); ++i) {
		int ind = g[s][i];
		if (usd[ejs[ind].to] == 0 && ejs[ind].fl != ejs[ind].mx) {
			int res = fl(ejs[ind].to, 1);
			if (res == 0) {
				continue;
			}
			ejs[ind].fl += 1;
			ejs[ind ^ 1].fl -= 1;
			return res;
		}
	}
	//usd[s] = 0;
	return 0;
}
int32_t main() {
	int n, m;
	cin >> n >> m;
	vector<string>a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	int black = 0;
	int white = 0;
	for (int i = 0; i < n; ++i) {
		for (int q = 0; q < m; ++q) {
			if (a[i][q] == '.') {
				if ((i + q) % 2) {
					++black;
				} else {
					++white;
				}
			}
		}
	}
	int ans = white * (white - 1);
	if (ans > LIM) {
		cout << LIM;
		return 0;
	}
	g.assign(2, {});
	map<pair<int, int>, int>mp;
	for (int i = 0; i < n; ++i) {
		for (int q = 0; q < m; ++q) {
			if (a[i][q] == '.') {
				if ((i + q) % 2) {
					mp[{i, q}] = g.size();
					g.push_back({});
					g.back().push_back(ejs.size());
					ejs.push_back({ g.size() - 1, 1, 0, 1 });
					g[1].push_back(ejs.size());
					ejs.push_back({ 1, g.size() - 1, 0, 0 });
				}
				else {
					mp[{i, q}] = g.size();
					g.push_back({});
					g[0].push_back(ejs.size());
					ejs.push_back({ 0, g.size() - 1, 0, 1 });
					g.back().push_back(ejs.size());
					ejs.push_back({ g.size() - 1, 0, 0, 0 });
				}
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int q = 0; q < m; ++q) {
			if ((i + q) % 2 || a[i][q] == '#') {
				continue;
			}
			int our = mp[{i, q}];
			if (i + 1 < n && a[i + 1][q] == '.') {
				int v = mp[{i + 1, q}];
				g[our].push_back(ejs.size());
				ejs.push_back({ our,v,0,1 });
				g[v].push_back(ejs.size());
				ejs.push_back({ v,our,0,0 });
			}
			if (i - 1 >= 0 && a[i - 1][q] == '.') {
				int v = mp[{i - 1, q}];
				g[our].push_back(ejs.size());
				ejs.push_back({ our,v,0,1 });
				g[v].push_back(ejs.size());
				ejs.push_back({ v,our,0,0 });
			}
			if (q - 1 >= 0 && a[i][q - 1] == '.') {
				int v = mp[{i, q - 1}];
				g[our].push_back(ejs.size());
				ejs.push_back({ our,v,0,1 });
				g[v].push_back(ejs.size());
				ejs.push_back({ v,our,0,0 });
			}
			if (q + 1 < m && a[i][q + 1] == '.') {
				int v = mp[{i, q + 1}];
				g[our].push_back(ejs.size());
				ejs.push_back({ our,v,0,1 });
				g[v].push_back(ejs.size());
				ejs.push_back({ v,our,0,0 });
			}
		}
	}
	usd.assign(g.size(), 0);
	while (fl(S, 1)) {
		usd.assign(g.size(), 0);
	}
	vector<vector<int>>newg(g.size());
	for (int i = 0; i < ejs.size(); i += 2) {
		if (ejs[i].fr == S || ejs[i].to == T) {
			continue;
		}
		if (ejs[i].fl == 1) {
			newg[ejs[i].fr].push_back(ejs[i].to);
		} else {
			newg[ejs[i].to].push_back(ejs[i].fr);
		}
	}
	vector<int>even(g.size());
	for (auto it : mp) {
		if ((it.first.first + it.first.second) % 2 == 0) {
			even[it.second] = 1;
		}
	}
	for(int i = 2; i < g.size(); ++i) {
		if (!even[i]) {
			continue;
		}
		if (newg[i].size() != 1) {
			cout << "!!!!";
		}
		int fr = newg[i][0];
		vector<int>reached(g.size());
		reached[fr] = 1;
		queue<int>q;
		q.push(fr);
		while (q.size()) {
			int th = q.front();
			q.pop();
			for (int i = 0; i < newg[th].size(); ++i) {
				if (!reached[newg[th][i]]) {
					reached[newg[th][i]] = 1;
					q.push(newg[th][i]);
				}
			}
		}
		for (int ii = 0; ii < reached.size(); ++ii) {
			if (even[ii] && ii != i && !reached[ii]) {
				++ans;
			}
		}
		if (ans >= LIM) {
			ans = LIM;
			break;
		}
	}
	cout << ans;
	return 0;
}