#include <iostream>
#include <vector>
#include <random>
#include <set>
#include <algorithm>
#include <queue>
#include <map>
#include <cmath>
using namespace std;

#define int long long

string closer = "", further = "", same = "";

bool check_final(string r) {
	for (char c : r) {
		if (c == '!') {
			return true;
		}
	}
	return false;
}

int solve_x(int xl, int xr, int y, bool was = false) {
	string resp;
	cout << xl << ' ' << y << endl;
	cin >> resp;
	if (check_final(resp)) {
		exit(0);
	}
	int last = xl;
	while (xl != xr) {
		int xm = (xl + xr) / 2;
		int d = xm - last;
		int x1 = xm + d;
		if (x1 < 0) {
			x1 = 0;
		}
		if (x1 > 1000000) {
			x1 = 1000000;
		}
		cout << x1 << ' ' << y << endl;
		last = x1;
		cin >> resp;
		if (check_final(resp)) {
			exit(0);
		}
		if (resp == closer) {
			if (x1 <= xm) {
				xl = (x1 + xr) / 2;
			}
			else {
				xr = (x1 + xr) / 2;
			}
		}
		else {
			if (x1 <= xm) {
				xr = (x1 + xr) / 2;
			}
			else {
				xl = (x1 + xr) / 2;
			}
		}
	}
	return xl;
}

int solve_y(int yl, int yr, int x) {
	string resp;
	cout << x << ' ' << yl << endl;
	cin >> resp;
	if (check_final(resp)) {
		exit(0);
	}
	int last = yl;
	while (yl + 1 < yr) {
		int ym = (yl + yr) / 2;
		int d = ym - last;
		int y1 = ym + d;
		if (y1 < 0) {
			y1 = 0;
		}
		if (y1 > 1000000) {
			y1 = 1000000;
		}
		cout << x << ' ' << y1 << endl;
		last = y1;
		cin >> resp;
		if (check_final(resp)) {
			exit(0);
		}
		if (resp == closer) {
			if (y1 <= ym) {
				yl = (y1 + yr) / 2;
			}
			else {
				yr = (y1 + yr) / 2;
			}
		}
		else {
			if (y1 <= ym) {
				yr = (y1 + yr) / 2;
			}
			else {
				yl = (y1 + yr) / 2;
			}
		}
	}
	return yl;
}

vector<string> resps;

void solve_edge() {
	cout << "0 1" << endl;
	string resp;
	cin >> resp;
	further = resp;
	for (string s : resps) {
		if (s != further) {
			closer = s;
		}
	}
	int y = solve_y(0, 1000000, 0);
	cout << 0 << y << endl;
	cin >> resp;
	if (check_final(resp)) {
		exit(0);
	}

	cout << 0 << y + 1 << endl;
	cin >> resp;
	if (check_final(resp)) {
		exit(0);
	}

	cout << 1000000 << y << endl;
	cin >> resp;
	if (check_final(resp)) {
		exit(0);
	}

	cout << 1000000 << y + 1 << endl;
	cin >> resp;
	if (check_final(resp)) {
		exit(0);
	}
}

int32_t main() {
	string resp;
	cout << "0 0" << endl;
	cin >> resp;
	if (check_final(resp)) {
		return 0;
	}
	cout << "1 0" << endl;
	cin >> resp;
	if (check_final(resp)) {
		return 0;
	}
	resps.push_back(resp);
	cout << "1000000 0" << endl;
	cin >> resp;
	if (check_final(resp)) {
		return 0;
	}
	cout << "999999 0" << endl;
	cin >> resp;
	if (check_final(resp)) {
		return 0;
	}
	resps.push_back(resp);
	if (resps[0] != resps[1]) {
		solve_edge();
	}
	else {
		closer = resps[0];
		cout << "999999 20000" << endl;
		cin >> resp;
		if (check_final(resp)) {
			return 0;
		}
		int l, r;
		if (resp == closer) {
			l = 10000, r = 1000000;
		}
		else {
			l = 0, r = 10000;
		}
		int X = solve_x(l, r, 0);
		cout << "20000 999999" << endl;
		cin >> resp;
		if (check_final(resp)) {
			return 0;
		}
		if (resp == closer) {
			l = 10000, r = 1000000;
		}
		else {
			l = 0, r = 10000;
		}
		int Y = solve_y(l, r, X);
		cout << X << ' ' << Y << endl;
		if (check_final(resp)) {
			return 0;
		}
		cout << X << ' ' << Y + 1 << endl;
		if (check_final(resp)) {
			return 0;
		}
		cout << X + 1 << ' ' << Y << endl;
		if (check_final(resp)) {
			return 0;
		}
		cout << X + 1 << ' ' << Y + 1 << endl;
		if (check_final(resp)) {
			return 0;
		}
	}
	return 0;
}