#include <iostream>
#include <vector>

using namespace std;

#define int long long

int32_t main() {
	int n, k;
	cin >> n >> k;
	if (k == 1) {
		cout << "YES\n" << n << '\n';
		for (int i = 0; i < n; ++i) {
			int j = (i + 1) % n;
			cout << i + 1 << ' ' << j + 1 << '\n';
		}
		return 0;
	}
	if (k == n) {
		cout << "NO\n";
		return 0;
	}
	vector<int> d(n);
	int diff = 0;
	int i = 0, j = n - 1;
	vector<pair<int, int>> res;
	while (diff < k) {
		if (diff + 2 <= k) {
			diff += 2;
			for (int a = i + 1; a <= j; ++a) {
				res.push_back({ i, a });
				d[i]++;
				d[a]++;
			}
			i++, j--;
		} else {
			diff++;
			res.push_back({ i, i + 1 });
			d[i]++;
			d[i + 1]++;
		}
	}
	cout << "YES\n";
	cout << res.size() << '\n';
	for (auto p : res) {
		cout << p.first + 1 << ' ' << p.second + 1 << '\n';
	}
	return 0;
}