#include <iostream>
#include <algorithm>

using namespace std;

int main() {
    int n, a, b;
    cin >> n >> a >> b;

    if (n == 1) {
        if (a == b) cout << "1\n" << a << ':' << b << endl;
        else cout << "0\n" << a << ':' << b << endl;
        return 0;
    }

    int draws = max(0, n - a - b);
    int extra = a + b - (n - draws);
    std::vector<pair<int, int>> matches(n);
    for (auto& m : matches) {
        if (a > 0) {
            --a;
            m.first++;
        } else if (b > 0) {
            --b;
            m.second++;
        }
    }

    if (b > 0) {
        matches.back().second += b;
        a += matches.back().first;
        matches.back().first = 0;
    }
    if (a > 0) matches[0].first += a;
    cout << draws << '\n';
    for (auto m : matches) {
        cout << m.first << ':' << m.second << '\n';
    }


    return 0;
}
