def dist(x, y):
    return (x - POINT[0]) ** 2 + (y - POINT[1]) ** 2


def read_input():
    inp = input().strip()
    if inp[-1] == '!':
        exit(0)
    """
    x1, y1 = QUERIES[-2]
    x2, y2 = QUERIES[-1]

    d1 = dist(x1, y1)
    d2 = dist(x2, y2)

    if d2 == 0:
        exit(0)
        return "found!"

    if d1 == d2:
        return 'same'
    if d1 < d2:
        return 'far'
    return 'close'
    """

    return inp

QUERIES = [(0, 0)]
POINT = (12231, 324623)



def create_string(a, b, is_y):
    if is_y:
        QUERIES.append((a, b))
        return f'{a} {b}'
    else:
        QUERIES.append((b, a))
        return f'{b} {a}'


def preprocess(is_y):
    MIN = 0
    MAX = 1000000
    print(f'{create_string(MIN, MIN, is_y)}', flush=True)
    a0 = read_input()
    print(f'{create_string(MIN, MIN + 1, is_y)}', flush=True)
    a1 = read_input()
    print(f'{create_string(MIN, MAX, is_y)}', flush=True)
    a2 = read_input()
    print(f'{create_string(MIN, MAX - 1, is_y)}', flush=True)
    a3 = read_input()

    if a3 == a1:
        return [a1]
    else:
        return [MIN, MAX]


def bin_search(is_y, closer):
    MIN = 0
    MAX = 1000000
    l = MIN
    r = MAX - 1
    prev_query = r
    req_small = True

    while True:
        if req_small:
            prev_query = l - (prev_query - r)
            print(f'{create_string(MIN, prev_query, is_y)}', flush=True)
            a = read_input()
            if a == closer:
                r -= (r - l + 1) // 2
                if r - l % 2 == 0 and r != l:
                    r += 1
            else:
                l += (r - l + 1) // 2
                if r - l % 2 == 0 and r != l:
                    l -= 1
        else:
            prev_query = r + (l - prev_query)
            print(f'{create_string(MIN, prev_query, is_y)}', flush=True)
            a = read_input()
            if a != closer:
                r -= (r - l + 1) // 2
                if r - l % 2 == 0 and r != l:
                    r += 1
            else:
                l += (r - l + 1) // 2
                if r - l % 2 == 0 and r != l:
                    l -= 1

        req_small = not req_small
        if l == r:
            return [l]


def get_ans(py, px):
    for y in py:
        for x in px:
            print(f'{x} {y}', flush=True)
            read_input()


def run(is_y):
    ans = preprocess(is_y)
    CLOSER = ''
    FUTHER = ''
    if len(ans) == 1:
        CLOSER = ans[0]
        return bin_search(is_y, CLOSER)
    else:
        return ans



if __name__ == '__main__':
    py = run(True)
    px = run(False)
    print(len(QUERIES))
    get_ans(py, px)

# See PyCharm help at https://www.jetbrains.com/help/pycharm/
