#include <iostream>
#include <algorithm>
#include <random>

using namespace std;


int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;

    if (n == 1) {
        cout << "YES\n0\n";
        return 0;
    }

    if (k >= n) {
        cout << "NO\n";
        return 0;
    }

    vector<vector<int>> e(n);
    int en = 0;
    int diff = 0;
    for (int i = 0; i < k / 2; i++) {
        for (int j = i + 1; j + i < n; j++) {
            e[i].push_back(j);
            e[j].push_back(i);
            en++;
        }
        diff += 2;
    }
    if (k % 2 == 1) {
        en++;
        e[k / 2].push_back(k / 2 + 1);
        e[k / 2 + 1].push_back(k / 2);
    }

    cout << "YES\n" << en << '\n';
    for (int i = 0; i < n; i++) {
        for (auto j : e[i]) {
            if (i < j) cout << i+1 << ' ' << j+1 << '\n';
        }
    }

    return 0;
}
