#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ALL(x) x.begin(), x.end()
#define RALL(x) x.rbegin(), x.rend()

using ld = long double;

vector<vector<int>> v;
vector<vector<int>> pos;
vector<int> p;

vector<pair<int, int>> check(vector<pair<int, int>> &b, int root) {
    set<int> ls0, rs0;
    vector<pair<int, int>> newb = b;
    vector<pair<int, int>> c(b.size());
    newb[0] = {b[0].first, pos[0][root]};
    c[0] = {pos[0][root] + 1, b[0].second};
    for (int l = b[0].first; l < pos[0][root]; ++l) {
        ls0.insert(v[0][l]);
    }
    for (int r = pos[0][root] + 1; r < b[0].second; ++r) {
        rs0.insert(v[0][r]);
    }
    for (int i = 1; i < b.size(); ++i) {
        set<int> ls, rs;
        for (int l = b[i].first; l < pos[i][root]; ++l) {
            ls.insert(v[i][l]);
        }
        for (int r = pos[i][root] + 1; r < b[i].second; ++r) {
            rs.insert(v[i][r]);
        }
        if (ls0 == ls && rs0 == rs) {
            newb[i] = {b[i].first, pos[i][root]};
            c[i] = {pos[i][root] + 1, b[i].second};
        } else if (ls0 == rs && rs0 == ls) {
            newb[i] = {pos[i][root] + 1, b[i].second};
            c[i] = {b[i].first, pos[i][root]};
        } else {
            return {};
        }
    }
    b = newb;
    return c;
}

int solve(vector<pair<int, int>> b) {
    int l0 = b[0].first, r0 = b[0].second;
    if (l0 == r0 - 1) {
        return v[0][l0];
    }
    int ans = -1;
    vector<pair<int, int>> c;
    for (int root = l0 + 1; root < r0 - 1; ++root) {
        c = check(b, v[0][root]);
        if (c.size()) {
            ans = v[0][root];
            break;
        }
    }
    int l = solve(b), r = solve(c);
    p[l] = p[r] = ans;
    return ans;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n, k;
    cin >> n >> k;
    v.resize(k);
    pos.resize(k);
    for (int i = 0; i < k; i++) {
        v[i].reserve(n);
        pos[i].resize(n);
        for (int j = 0; j < n; j++) {
            int x;
            cin >> x;
            --x;
            v[i].push_back(x);
            pos[i][x] = j;
        }
    }
    p.resize(n, -2);
    solve(vector<pair<int, int>>{k, {0, n}});
    for (int x : p) {
        cout << x + 1 << ' ';
    }
    return 0;
}