#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ALL(x) x.begin(), x.end()
#define RALL(x) x.rbegin(), x.rend()

using ld = long double;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n, k;
    cin >> n >> k;
    if (k == n) {
        if (n == 1) {
            cout << "YES\n0";
        } else {
            cout << "NO";
        }
        return 0;
    }
    vector<vector<int>> g(n);
    vector<int> deg(n);
    int cnt = 0;
    for (int i = 0; i < k + 1; ++i) {
        for (int j = i + 1; j < k + 1 - i; ++j) {
            g[i].push_back(j);
            ++cnt;
            ++deg[i];
            ++deg[j];
        }
    }
    for (int i = k + 1; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            g[j].push_back(i);
            ++cnt;
            ++deg[i];
            ++deg[j];
        }
    }
    set<int> temp{deg.begin(), deg.end()};
    assert(temp.size() == k);
    cout << "YES\n" << cnt << '\n';
    for (int i = 0; i < n; ++i) {
        for (int j : g[i]) {
            cout << i + 1 << ' ' << j + 1 << '\n';
        }
    }

    return 0;
}
