#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

vector<long long>bad;
vector<long long>a;
vector<long long>first_perm;
vector<long long>second_perm;

long long perms = 0;

bool yes(long long n)
{
    set<long long>flag;
    flag.insert(0);
    for(int i = 0; i < bad.size(); i++)
    {
        flag.insert(( (bad[i] - 1) - i + n)%n );
    }

    if(flag.size() == n)
        return false;

    long long q = 1;
    for(auto it : flag)
    {
        if(it + 1 == q)
        {
            q++;
        }else{
            q--;
            break;
        }
    }
    perms = q;
    return true;
}

void bad_perm()
{
    bad.resize(a.size(), 0);
    for(int i = 0; i < a.size(); i++)
    {
        bad[a[i] - 1] = i + 1;
    }
}

void first_p(long long c)
{
    reverse(bad.begin() + c, bad.end());
    reverse(bad.begin(), bad.begin() + c);
    reverse(bad.begin(), bad.end());
    for(int i = 0; i < bad.size(); i++)
        cout << bad[i] << " ";
    cout << "\n";
}

void second_p()
{
    second_perm.resize(bad.size());
    for(int i = 0; i < bad.size(); i++)
    {
        second_perm[ a[bad[i]-1]-1 ] = i + 1;
    }

    for(int i = 0; i < second_perm.size(); i++)
        cout << second_perm[i] << " ";
    cout << "\n";

}


using namespace std;

int main()
{
    //cout << -4 + 5 % 5 << endl;

    long long t = 0;
    cin >> t;
    while(t--)
    {
        bad.resize(0);
        a.resize(0);
        first_perm.resize(0);
        second_perm.resize(0);
        int n;
        cin >> n;
        long long v;
        for(int i = 0; i < n; i++)
        {
            cin >> v;
            a.push_back(v);
        }
        bad_perm();
        if(yes(n))
        {
            cout << "Possible\n";
            first_p(n - perms);
            second_p();

        }else{
            cout << "Impossible\n";
        }
    }
}
