#include <iostream>
#include <vector>
#include <numeric>
#include <set>
using namespace ::std;
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
typedef long long ll;
typedef pair<int, int> pairInt;
typedef pair<ll, ll> pairLL;


void outVect(const vector<int>& vect)
{
	int n = vect.size();
	for (int i = 0; i < n; i++)
	{
		cout << vect[i] + 1 << " ";
	}
	cout << "\n";
}

void doWork()
{
	int n;
	cin >> n;
	vector<int> vect(n);
	vector<int> p(n), q(n);
	for (int i = 0; i < n; i++)
	{
		cin >> vect[i];
		vect[i]--;
		q[i] = i + 1;
		p[(vect[i] + 1)%n] = i;
	}
	q[n - 1] = 0;


	//outVect(p);
	//outVect(q);

	for (int i = 0; i < n; i++)
	{
		if (p[q[i]] == q[i] || q[i] == i)
		{
			for (int j = 0; j < n; j++)
			{
				if (p[q[i]] != q[j] && q[j] != i && 
					p[q[j]] != q[i] && q[i] != j)
				{
					//cout << i << " " << j << "!!!!\n";
					swap(p[q[i]], p[q[j]]);
					swap(q[i], q[j]);
					break;
				}
			}
		}
	}
	while (n > 100);
	for (int i = 0; i < n; i++)
	{
		if (q[i] == i || p[i] == i)
		{
			cout << "Impossible\n";
			return;
		}
	}
	cout << "Possible\n";
	outVect(p);
	outVect(q);
}

int main()
{
	int k = 1;
	cin >> k;
	while (k--)
	{
		doWork();
	}
	return 0;
}





/*
4
2
2 1
3
1 2 3
4
2 1 4 3
5
5 1 4 2 3
*/