#include <iostream>
#include <vector>
#include <numeric>
#include <set>
using namespace ::std;
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
typedef long long ll;
typedef pair<int, int> pairInt;
typedef pair<ll, ll> pairLL;


void doWork()
{
	int n, k;
	cin >> n >> k;
	if (n == k)
	{
		cout << "NO\n";
		return;
	}
	cout << "YES\n";
	if (k == 1)
	{
		cout << n << "\n";
		for (int i = 1; i < n; i++)
		{
			cout << i << " " << i + 1 << "\n";
		}
		cout << n << " 1\n";
		return;
	}
	k++;
	vector<vector<int>> vect(n, vector<int>(n, 0));
	for (int i = k-1; i >= 0; i--)
	{
		for (int j = k-1 - i; j < i; j++)
		{
			vect[i][j] = 1;
			vect[j][i] = 1;
		}
	}

	for (int i = n-1; i > k-1; i--)
	{
		for (int j = 0; j < n; j++)
		{
			if (i != j)
			{
				vect[i][j] = 1;
				vect[j][i] = 1;
			}
		}
	}
	/*
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			cout << vect[i][j] << " ";
		}
		cout << "\n";
	}
	*/
	int m = 0;
	for (int i = 0; i < n; i++)
	{
		m += accumulate(all(vect[i]), 0);
	}
	cout << m/2 << "\n";
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < i+1; j++)
		{
			if (vect[i][j])
			{
				cout << i + 1 << " " << j + 1 << "\n";
			}
		}
	}
}

int main()
{
	int k = 1;
	//cin >> k;
	while (k--)
	{
		doWork();
	}
	return 0;
}