#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <cmath>
#include <queue>
#include <stack>

using namespace std;

typedef long long ll;
typedef long double ld;

void start() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cout.precision(10); cout.setf(ios::fixed);

}

int main() {
	start();
	int n, a, b;
	cin >> n >> a >> b;
	if (n == 1) {
		cout << int(a == b) << '\n';
		cout << a << ':' << b;
	}
	else if (a + b > n) {
		cout << "0\n";
		if (!a || !b) {
			int exta = a - n;
			int extb = b - n;
			for (int i = 0; i < n; ++i) {
				if (a) {
					if (!i)
						cout << 1 + exta << ':' << 0 << '\n';
					else
						cout << "1:0\n";
				}
				else {
					if (!i)
						cout << 0 << ':' << 1 + extb << '\n';
					else
						cout << "0:1\n";
				}
			}
		}
		else {
			int lena = min(n - 1, a);
			int exta = max(0, a - n + 1);
			for (int i = 0; i < lena; ++i) {
				if (!i)
					cout << 1 + exta << ':' << 0 << '\n';
				else
					cout << 1 << ':' << 0 << '\n';
			}
			int lenb = n - lena;
			int extb = max(0, b - lenb);
			for (int i = 0; i < lenb; ++i) {
				if (!i)
					cout << 0 << ':' << 1 + extb << '\n';
				else
					cout << 0 << ':' << 1 << '\n';
			}
		}
	}
	else {
		cout << max(0, n - a - b) << '\n';
		for (int i = 0; i < a; ++i) {
			cout << "1:0\n";
		}
		for (int i = 0; i < b; ++i) {
			cout << "0:1\n";
		}
		for (int i = 0; i < n - a - b; ++i) {
			cout << "0:0\n";
		}
	}
	return 0;
}