﻿// C++
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <assert.h>


using namespace std;
#pragma warning(disable: 4996)

using ll = long long;
using ld = long double;

const int INF = 1e9 + 1e8;
const ll LINF = 2000000000000000000;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define en '\n'
#define pii pair<int,int>
#define vec vector
#define pb push_back
#define szof(x) int((x).size())
#define pll pair<ll,ll>

const int N = 1010;
const int K = 110;
ll pref[K][N];
ll mapping[N];
int p[K][N];
int pos[K][N];

int n, k;
int ans[N];

ll get(int i, int l, int r) {
	return pref[i][r] ^ (l == 0 ? 0 : pref[i][l - 1]);

}
bool check(int root, const vec<pii>& ranges) {

	set<ll>st;

	for (int i = 0; i < k; i++) {
		int ps = pos[i][root];
		ll cur1 = get(i, ranges[i].first, ps - 1);
		ll cur2 = get(i, ps + 1, ranges[i].second);
		st.insert(cur1);
		st.insert(cur2);
		if (szof(st) > 2) {
			return false;
		}
	}

	return true;
}


int go(vec<pii>ranges) {

	if (ranges[0].first == ranges[0].second) {
		return p[0][ranges[0].first];
	}

	int root = -1;
	for (int i = ranges[0].first + 1; i <= ranges[0].second - 1; i++) {
		int v = p[0][i];
		if (check(v, ranges)) {
			root = v;
			break;
		}
	}

	ans[root] = -2;

	vec<pii>rangesLeft(k), rangesRight(k);
	vec<ll>idx;

	for (int i = 0; i < k; i++) {
		int ps = pos[i][root];
		ll cur1 = get(i, ranges[i].first, ps - 1);
		ll cur2 = get(i, ps + 1, ranges[i].second);
		if (szof(idx) != 2) {
			idx.pb(cur1);
			idx.pb(cur2);
		}
		if (cur1 == idx[0]) {
			rangesLeft[i] = { ranges[i].first, ps - 1 };
		}
		else {
			rangesRight[i] = { ranges[i].first, ps - 1 };
		}

		if (cur2 == idx[0]) {
			rangesLeft[i] = { ps + 1,ranges[i].second };
		}
		else {
			rangesRight[i] = { ps + 1,ranges[i].second };

		}
	}

	int L = go(rangesLeft);
	int R = go(rangesRight);
	ans[L] = root;
	ans[R] = root;

	return root;
}

void solve() {
	cin >> n >> k;
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < n; j++) {
			cin >> p[i][j];
			p[i][j]--;
		}
	}

	if (n == 1) {
		cout << -1;
		return;
	}

	for (int i = 0; i < n; i++) {
		mapping[i] = 1LL * rand() * rand() + rand();
	}

	for (int i = 0; i < k; i++) {
		pref[i][0] = mapping[p[i][0]];
		for (int j = 1; j < n; j++) {
			pref[i][j] = pref[i][j - 1] ^ mapping[p[i][j]];
		}
	}

	for (int i = 0; i < k; i++) {
		for (int j = 0; j < n; j++) {
			pos[i][p[i][j]] = j;
		}
	}
	vec<pii>ranges(k, { 0,n - 1 });
	go(ranges);
	for (int i = 0; i < n; i++) {
		cout << ans[i] + 1 << ' ';
	}
}

int main() {
	srand(time(0));
	ios::sync_with_stdio(0);
	cin.tie(0);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	int tst = 1;
	solve();

}