// C++
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>


using namespace std;
#pragma warning(disable: 4996)

using ll = long long;
using ld = long double;

const int INF = 1e9 + 1e8;
const ll LINF = 2000000000000000000;

#define all(x) (x).begin(), (x).end()
#define en '\n'
#define pii pair<int,int>
#define vec vector
#define pb push_back
#define szof(x) int((x).size())
#define pll pair<ll,ll>


void solve() {
	int n;
	cin >> n;

	int total = 0;

	vector<int> a;
	vector<vector<int>> g(n);

	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		total += k;

		for (int j = 0; j < k; j++) {
			int x;
			cin >> x;
			g[i].pb(x);
			a.pb(x);
		}
	}

	sort(a.begin(), a.end());

	map<int, int> mp;
	for (int i = 0; i < a.size(); i++) {
		mp[a[i]] = i;
	}
	
	int split = 0;
	int merge = n - 1;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < g[i].size() - 1; j++) {
			if (mp[g[i][j]] + 1 != mp[g[i][j + 1]]) {
				split++;
				merge++;
			}
		}
	}

	cout << split << ' ' << merge << en;
}


int main() {
	srand(time(0));
	ios::sync_with_stdio(0);
	cin.tie(0);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	int tst = 1;
	//cin >> tst

	while (tst--) {
		solve();
	}

}
