// C++
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <assert.h>


using namespace std;
#pragma warning(disable: 4996)

using ll = long long;
using ld = long double;

const int INF = 1e9 + 1e8;
const ll LINF = 2000000000000000000;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define en '\n'
#define pii pair<int,int>
#define vec vector
#define pb push_back
#define szof(x) int((x).size())
#define pll pair<ll,ll>

bool solve(int n, int k) {
	//int n, k;
	//cin >> n >> k;

	vector<int> d(n, n - 1);
	for (int i = 0; i < k - 1; i++) {
		d[i] = i + 1;
	}

	if (k != 1) {
		for (int i = k - 1; i < n; i++) {
			d[i] = d[i - 1];
		}
	}

	d.back() = n - 1;

	ll sum = accumulate(all(d), 0LL);

	if (sum % 2 == 1) {
		d[n - 2] -= 1;
		sort(rall(d));
	}

	set<int> se(all(d));

	if (se.size() != k) {
		cout << "NO" << en;
		return 0;
	}

	vector<pair<int, int>> ans;

	while (1) {
		vector<pair<int, int>> temp(n);
		for (int i = 0; i < n; i++) {
			temp[i] = { d[i], i };
		}
		sort(rall(temp));

		if (temp[0].first == 0) {
			break;
		}

		int v = temp[0].second;

		for (int i = 1; i < n && d[v] > 0; i++) {
			int u = temp[i].second;

			if (d[u] > 0) {
				ans.push_back({ u, v });
				d[u]--;
				d[v]--;
			}
			else {
				cout << "NO" << en;
				return 0;
			}
		}

		if (d[v] != 0) {
			cout << "NO" << en;
			return 0;
		}
	}

	cout << "YES" << en;
	//cout << ans.size() << en;
	//for (auto to : ans) {
	//	cout << to.first + 1 << ' ' << to.second + 1 << en;
	//}
	return 1;
}


int main() {
	srand(time(0));
	ios::sync_with_stdio(0);
	cin.tie(0);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	int tst = 1;
	//cin >> tst;

	int n, k;
	//cin >> n >> k;
	solve(11, 9);
	
	//for (int n = 1; n <= 500; n++) {
	//	for (int k = 1; k <= n - 2; k++) {
	//		if (!solve(n, k)) {
	//			cout << n << ' ' << k << en;
	//			return 0;
	//		}
	//	}
	//}

	//while (tst--) {
	//  solve();
	//}
}