﻿// C++
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <assert.h>


using namespace std;
#pragma warning(disable: 4996)

using ll = long long;
using ld = long double;

const int INF = 1e9 + 1e8;
const ll LINF = 2000000000000000000;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define en '\n'
#define pii pair<int,int>
#define vec vector
#define pb push_back
#define szof(x) int((x).size())
#define pll pair<ll,ll>

void solve() {
	int n, k;
	cin >> n >> k;

	if (n == 1) {
		cout << "YES" << en << 0;
		return;
	}

	if (n == 2) {
		if (k == 1) {
			cout << "YES" << en;
			cout << 1 << en << "1 2";
		}
		else {
			cout << "NO" << en;
		}
		return;
	}


	vec<int>d(n);
	int cur = n - 1;

	vec<pii>ans;

	auto printAns = [&]() {
		cout << "YES" << en;
		cout << szof(ans) << en;
		for (auto to : ans) {
			cout << to.first + 1 << ' ' << to.second + 1 << en;
		}
		return;
	};

	for (int i = 0; i < n; i++) {
		if (cur <= d[i]) {
			break;
		}
		int iterations = cur - d[i];
		d[i] = cur;
		int j = i + 1;
		for (int kek = 0; kek < iterations; kek++) {
			d[j]++;
			ans.pb({ i,j });
			j++;
		}

		set<int>st;
		cur--;
		for (auto to : d) {
			st.insert(to);
		}
		if (szof(st) == k) {
			printAns();
			return;
		}
	}

	ans.clear();
	//for odd kinda same
	fill(all(d), 2);
	for (int i = 0; i < n; i++) {
		ans.pb({ i,(i + 1) % n });
	}
	cur = n - 1;
	for (int i = 0; i < n; i++) {

		set<int>st;
		for (auto to : d) {
			st.insert(to);
		}
		if (szof(st) == k) {
			printAns();
			return;
		}

		if (cur <= d[i]) {
			break;
		}
		int iterations = cur - d[i];
		d[i] = cur;
		int j = i + 1;
		for (int kek = 0; kek < iterations; kek++) {
			d[j]++;
			ans.pb({ i,j });
			j++;
		}

		st.clear();
		for (auto to : d) {
			st.insert(to);
		}
		if (szof(st) == k) {
			printAns();
			return;
		}

		cur--;
	}

	cout << "NO" << en;
	return;
}


int main() {
	srand(time(0));
	ios::sync_with_stdio(0);
	cin.tie(0);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	int tst = 1;
	//cin >> tst;
	solve();
	//int n, k;
	//cin >> n >> k;
	//solve2(n, k);
	//solve2(3, 1);

	//for (int n = 1; n <= 500; n++) {
	//	for (int k = 1; k <= n - 2; k++) {
	//		if (!solve2(n, k)) {
	//			cout << n << ' ' << k << en;
	//		}
	//	}
	//}

	//while (tst--) {
	//  solve();
	//}
}