#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int long long

const int TRY = 100;

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i], a[i]--;
	
	vector<int> b(n);
	for (int i = 0; i < n; i++)
		b[a[i]] = i;

	for (int k = 0; k < TRY; k++) {
		vector<int> p(n);
		for (int i = 0; i < n; i++)
			p[i] = i;
		random_shuffle(p.begin(), p.end());
		
		bool ok = true;
		for (int i = 0; ok && i < n; i++)
			if (p[i] == i || p[i] == b[i])
				ok = false;

		if (ok) {
			cout << "Possible\n";
			vector<int> c(n);
			for (int i = 0; i < n; i++)
				c[p[i]] = b[i];
			for (int i = 0; i < n; i++)
				cout << c[i] + 1 << ' ';
			cout << '\n';
			for (int i = 0; i < n; i++)
				cout << p[i] + 1 << ' ';
			cout << '\n';
			return;
		}
	}

	cout << "Impossible\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	srand(73);

	int t;
	cin >> t;
	while (t--)
		solve();
}