#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

#define int long long

void solve() {
	int n;
	cin >> n;

	vector<int> num;
	vector<vector<int>> tower(n);
	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;

		tower[i] = vector<int>(k);

		for (int j = 0; j < k; j++)
		{
			int x;
			cin >> x;

			num.push_back(x);
			tower[i][j] = x;
		}
	}

	sort(num.begin(), num.end());
	unordered_map<int, int> por;
	for (int i = 0; i < num.size() - 1; i++)
	{
		por[num[i]] = num[i + 1];
	}

	int ans = 0;

	for (int i = 0; i < n; i++)
	{
		int k = tower[i].size();

		for (int j = 0; j < k - 1; j++)
		{
			int cur = tower[i][j];
			int next = tower[i][j + 1];
			if (por[cur] != next)
				ans++;
		}
	}

	cout << ans << ' ' << n + ans - 1;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}