#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>

using namespace std;

#define int long long

void solve() {
	int n, a, b;
	cin >> n >> a >> b;
	if (n == 1) {
		if (a == b) {
			cout << "1\n";
		}
		else {
			cout << "0\n";
		}
			cout << a << ":" << b;
			return;
	}
	vector<pair<int, int>> ans(n);
	if (a + b >= n) {
		if (a < n) {
			for (int i = 0; i < a; ++i)
				ans[i].first = 1;
			for (int i = a; i < n; ++i)
				ans[i].second = 1, --b;
			ans[n - 1].second += b;
		}
		else {
			for (int i = 0; i < n - 1; ++i)
				ans[i].first = 1, --a;
			ans[n - 2].first += a;
			ans[n - 1].second = b;
		}
	}
	else {
		for (int i = 0; i < a; ++i)
			ans[i].first = 1;
		for (int i = a; i < a + b; ++i)
			ans[i].second = 1;
	}
	int res = 0;
	for (int i = 0; i < n; ++i)
		if (ans[i].first == ans[i].second) ++res;
	cout << res << '\n';
	for (int i = 0; i < n; ++i)
		cout << ans[i].first << ':' << ans[i].second << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}