#include <iostream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <map>

using namespace std;

#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	vector<vector<int>> a(n);
	vector<int> result;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		a[i].resize(k);
		for (int j = 0; j < k; ++j) {
			cin >> a[i][j];
			result.push_back(a[i][j]);
		}
	}
	sort(all(result));
	map<int, int> after;
	for (int i = 0; i < result.size() - 1; ++i) {
		after[result[i]] = result[i + 1];
	}

	int split = 0;

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < a[i].size(); ++j) {
			if (j != a[i].size() - 1 && a[i][j + 1] != after[a[i][j]]) {
				split++;
			}
		}
	}
	int combine = split + n - 1;
	cout << split << ' ' << combine << '\n';

	return 0;
}