#include <bits/stdc++.h>
#define forab(i, a, b) for(long long i=a,i < b; ++i)
#define for0(i,n)for(int i = 0; i < n; ++i)
#define for1(i, n) for (int i = 1; i < n; ++i)
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define en '\n'
#define EPS 1e-9

#define vec vector
#define all(x) (x).begin(),(x).end()
#define allr(x) (x).rbegin(),(x).rend()


using namespace std;

typedef long long ll;
typedef long double ld;

typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef pair<int, ll> pil;
typedef pair<ld, int> pli;

typedef map<int ,int> mii;
typedef map<ll, ll> mll;

typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<vector<int>> vvi;
typedef vector<vector<ll>> vvll;

const int MAXN = 2 * 1e5;
const int INF = 1000000000;
const ll MOD = 1e9 + 7;

template<typename T>
istream& operator>>(istream& in, vector<T>& a){
    for (auto& i : a)
        cin >> i;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T> a){
    for (auto & i : a)
        cout << i << ' ' ;
    return out;
}


void solve(){
    int n, k;
    cin >> n >> k;
    if (k >= n){
        cout << "NO\n";
        return;
    }
    if (k == 0){
        cout << "NO\n";
        return;
    }
    if (k == 1){
        if (n == 2) {
            cout << "YES\n1\n1 2" << en;
            return;
        }
        if (n == 1){
            cout << "YES\n0";
            return;
        }
        cout << "YES" << en;
        cout << n << en;
        for (int i = 0; i < n; i++)
        {
            cout << i+1 << " " << (i+1) % n +1 << en;
        }
        return;
    }
    vector<vector<int>> g(n, vector<int>());
    vector<vector<int>> deg(501, vector<int>());
    deg[0].push_back(0);
    for (int q = 0; q < k; ++q){
        int cur = q + 1;
        for (int i = 500; i >= 0; --i){
            if (!deg[i].size()) continue;
            if (deg[i].size() == 1){
                g[deg[i][0]].push_back(cur);
                g[cur].push_back(deg[i][0]);
                int temp = deg[i][0];
                deg[i].pop_back();
                deg[g[temp].size()].push_back(temp);

            }else{
                g[deg[i][1]].push_back(cur);
                g[cur].push_back(deg[i][1]);
                int temp = deg[i][1];
                deg[i].pop_back();
                deg[g[temp].size()].push_back(temp);
                break;
            }
        }
        deg[g[cur].size()].push_back(cur);
    }
    int cur = 0 ;
    for (int i = 1 ; i < n - k; ++i) {
        g[cur].push_back(k + i);
        cur = k + i;
    }

    set<pair<int,int>> ans;
    for (int i= 0 ; i < n; ++i){
        for (int x : g[i])
            ans.insert({min(i, x), max(x, i)});
    }
    cout << "YES\n";
    cout << ans.size() << en;
    for (auto u : ans)
        cout << u.first + 1 <<' ' << u.second + 1<< en;

}


int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //freopen("C:\\work\\untitled\\input.txt", "r", stdin);

    int tst = 1;
//    cin >> tst;
    while (tst--)
        solve();
}