#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <list>

using namespace std;

template <typename T>
T read() {
    T tmp;
    cin >> tmp;
    return tmp;
}

bool isFill(vector<int> &input) {
    int count = 0;
    for (const auto &item: input) {
        if (item == 0) count++;
    }
    return count <= 1;
}

void print(const vector<int> &v) {
    for (const auto &item: v) cout << item << " ";
    cout << endl;
}

int main() {
    int n = read<int>();int k = read<int>();
//    vector<int>tmp_fill(n);
//    vector<vector<int>> records(k, tmp_fill);
//    for (auto &item: records) {
//        std::generate(item.begin(), item.end(), read<int>);
//    }
    set<vector<int>> records;
    for (int index = 0; index < k; index++) {
        vector<int>tmp_fill(n);
        std::generate(tmp_fill.begin(), tmp_fill.end(),read<int>);
        records.insert(tmp_fill);
    }
    vector<int> result(n, 0);
    while (!isFill(result)) {
        vector<set<int>> bros(n);
//        print(result);
//        for (const auto &item: records) {
//            cout << " ";
//            print(item);
//        }
        for (const auto &item: records) {
            if (item.size() < 3) continue;
            bros[item[1] - 1].insert(item[0]);
            bros[item[1] - 1].insert(item[2]);
        }
        set<int> for_delete;
        for (int index = 0; index < bros.size(); index++) {
            if (bros[index].size() == 2) {
                for (const auto &item: bros[index]) {
                    result[item - 1] = index + 1;
                }
                for (const auto &item: bros[index]) {
                    for_delete.insert(item);
                }
            }
        }
        list<vector<int>> for_erase;
        list<vector<int>> for_insert;
        for (auto &item: records) {
            list<int> filt;
            for (const auto &item: item) {
                if (for_delete.find(item) == for_delete.end()) {
                    filt.push_back(item);
                }
            }
            vector<int> tmp(filt.begin(), filt.end());
            for_erase.push_back(item);
            for_insert.push_back(tmp);
        }
        for (const auto &item: for_erase) {
            records.erase(item);
        }
        for (const auto &item: for_insert) {
            records.insert(item);
        }
    }
    for (const auto &item: result) {
        if (item == 0) {
            cout << -1 << " ";
            continue;
        }
        cout << item << " ";
    }
    cout << endl;
}