#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), pos(n + 1), p(n), q(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pos[a[i]] = i + 1;
    }

    if (n == 1) {
        cout << "Impossible\n";
        return;
    }

    for (int i = 0; i < n - 1; ++i)
        q[i] = i + 2;
    q[n - 1] = 1;

    for (int i = 0; i < n; ++i) {
        p[q[i] - 1] = pos[i + 1];
    }
    bool f = true;
    int idx = -1;

    for (int i = 0; i < n; ++i) {
        if (p[i] == i + 1) {
            idx = i;
            f = false;
            break;
        }
    }

    int iii = 0;
    while (!f) {
        if (iii == n) {
            cout << "Impossible\n";
            return;
        }
        auto qq = q;

        int idx2 = -1;
        for (int i = 0; i < n; ++i) {
            if (q[i] - 1 == idx) {
                idx2 = i;
                break;
            }
        }


        if (iii == idx2) {
            iii++;
            continue;
        }
        swap(qq[iii], qq[idx2]);


        for (int i = 0; i < n; ++i) {
            p[qq[i] - 1] = pos[i + 1];
        }

        f = true;

        for (int i = 0; i < n; ++i) {
            if (p[i] == i + 1) {
                f = false;
                break;
            }
        }
        ++iii;
        if (f)
            q = qq;
    }


    cout << "Possible\n";
    for (int i = 0; i < n; ++i) {
        cout << p[i] << " ";
    }
    cout << endl;
    for (int i = 0; i < n; ++i) {
        cout << q[i] << " ";
    }
    cout << endl;
}

int main() {
#ifdef _DEBUG
    freopen("in.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}