#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double lf;
typedef long double ld;
typedef pair<ll, ll> pll;

const ll N = 2e5 + 10;

set<ll> g[N];

void solve() {
    ll n,k;
    cin>>n >> k;

    if (n == 1) {
        if (k == 1) {
            cout << "YES" << endl;
            cout << 0 << endl;
            return;
        } else {
            cout << "NO" << endl;
            return;
        }
    }

    if(k == 1){
        cout<<"YES\n"<<n<<'\n';
        for(int i=0;i<n;i++) {
            cout<< i + 1 <<' '<<(i + 1) % n + 1<<'\n';
        }
        return;
    }

    multiset<ll> ms;
    set<ll> st;
    for (int i = 0; i < n; ++i)
        ms.insert(0);
    st.insert(0);
    auto add = [&](ll i, ll j) {
        if (g[i].count(j))
            return;
        ms.erase(ms.find(g[i].size()));
        if (!ms.count(g[i].size()))
            st.erase(g[i].size());
        ms.erase(ms.find(g[j].size()));
        if (!ms.count(g[j].size()))
            st.erase(g[j].size());
        g[i].insert(j);
        g[j].insert(i);
        ms.insert(g[i].size());
        ms.insert(g[j].size());
        st.insert(g[i].size());
        st.insert(g[j].size());
    };
    auto erase = [&](ll i, ll j) {
        if (!g[i].count(j))
            return;
        ms.erase(ms.find(g[i].size()));
        if (!ms.count(g[i].size()))
            st.erase(g[i].size());
        ms.erase(ms.find(g[j].size()));
        if (!ms.count(g[j].size()))
            st.erase(g[j].size());
        g[i].erase(j);
        g[j].erase(i);
        ms.insert(g[i].size());
        ms.insert(g[j].size());
        st.insert(g[i].size());
        st.insert(g[j].size());
    };
    auto count = [&]() {
        if (st.count(0))
            return -1ll;
        return ll(st.size());
    };

    ll l = 0, r = n;
    while (count() != k && count() + 1 != k) {
        if (r <= l)
            break;
        for (int i = l + 1; i < r; i++) {
            if (count() == k)
                break;
            add(l, i);
        }
        ++l, --r;
    }

    if (count() + 1 == k) {
        for (int i = 0; i < n; ++i)
            for (int j = i + 1; j < n; ++j) {
                if (g[i].count(j))
                    continue;
                add(i, j);
                if (count() == k)
                    break;
                erase(i, j);
            }
    }

    if (k != count()) {
        cout << "NO" << endl;
        return;
    }

    ll c = 0;
    for (auto& it : g) {
        c += it.size();
    }
    cout << "YES" << endl;
    cout << c/2 << endl;
    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            if (i < j)
                cout << i + 1 << " " << j + 1 << endl;
        }
    }
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
    return 0;
}
