#include <bits/stdc++.h>

#define FOR(i,n) for (int i = 0; i < n; ++i)
#define REP(i,j,k) for(int i = j; i <= k; ++i)

using namespace std;

int A[100500], B[100500], C[100500], AI[100500], BI[100500], CI[100500]; 

int G[100500];
int COL[100500];

set<int> fre;

int n;

bool dfs(int v) {
    if (COL[v]) return false;
    for (int to : fre) {
        if (to == v || G[v] == to) continue;
        B[to] = v;
        C[v] = to;
        fre.erase(to);
        return true;
    }
    
    REP(to,1,n) {
        if (to == v || G[v] == to) continue;
        COL[v] = 1;
        int ret = dfs(B[to]);
        COL[v] = 0;
        if (ret) {
            C[v] = to;
            B[to] = v;
            return true;
        }
    }
    return false;
}

void solve() {
    fre.clear();
    cin >> n;
    if (n == 1) {
        cout << "Impossible\n";
        return ;
    }

    REP(i,1,n) cin >> A[i];
    REP(i,1,n) AI[A[i]] = i;
    fill(C, C + n + 1, 0);

    REP(i,1,n) {
        fre.insert(i);
        G[i] = AI[i];
    }

    REP(i,1,n) {
        vector<int> possibles = {rand() % n + 1, rand() % n + 1, min(i+1,n), max(1,i-1)};
        for (int to : possibles) {
            if (to != i && G[i] != to && fre.find(to) == fre.end()) {
                B[to] = i;
                C[i] = to;
                fre.erase(to);
                break;
            }
        }
    }

    REP(i,1,n) {
        if (C[i] == 0) {
            if (!dfs(i)) {
                cout << "Impossible\n";
                return;
            }
        }
    }

    cout << "Possible\n";
    REP(i,1,n) B[C[i]] = AI[i];
    REP(i,1,n) cout << B[i] << ' '; cout << '\n';
    REP(i,1,n) cout << C[i] << ' '; cout << '\n';
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int tt;
    cin >> tt;
    while (tt--) solve();
}