#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define ld long double

int can = 0;
const int N = 2e5;
int a[N], b[N], cnt = 0;
int n, m, pr[N], h[N], cycle[N], in[N], B[N], used[N];
vector<vector<int>> C;
vector<int> g[N];

void dfs(int v, int d, int p) {
    pr[v] = p;
    h[v] = d;
    for (auto i : g[v]) {
        int u = a[i] ^ b[i] ^ v;
        if (i != p) {
            if (h[u] != -1 && h[u] < h[v]) {
                int tmp = v;
                C.push_back({});
                in[u] = 1;
                while (tmp != u) {
                    in[tmp] = 1;
                    C.back().push_back(pr[tmp]);
                    cycle[pr[tmp]] = 1;
                    tmp = tmp ^ a[pr[tmp]] ^ b[pr[tmp]];
                }
            }
            if (h[u] == -1) dfs(u, d + 1, i);
        }
    }
}

struct dsu {
    vector<int> p, sz;

    dsu() {}

    void build(int n) {
        p.resize(n);
        sz.resize(n, 1);
        iota(p.begin(), p.end(), 0);
    }


    int get(int v) {
        return (v == p[v] ? v : p[v] = get(p[v]));
    }

    bool merge(int v, int u) {
        v = get(v), u = get(u);
        if (v == u) return false;
        if (sz[v] > sz[u]) swap(v, u);
        p[v] = u;
        return true;
    }
};

int dfs2(int v, int pr) {
    used[v] = 1;
    int x = 0;
    for (auto i : g[v]) {
        int u = a[i] ^ b[i] ^ v;
        if (!used[u]) {
            int res = dfs2(u, v);
            x = max(x, res);
        }
    }
    if (B[v] && !x) {
        can--;
        x = 1;
    }
    return x;
}

void solve() {
    cnt = 0;
    for (int i = 0; i < n; i++) {
        g[i].clear();
    }
    fill(in, in + n, 0);
    fill(B, B + n, 0);
    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        int pr;
        for (int j = 0; j < k; j++) {
            int v;
            cin >> v;
            v--;
            if (j) {
                a[cnt] = v, b[cnt] = pr;
                g[v].push_back(cnt);
                g[pr].push_back(cnt);
                cnt++;
            }
            pr = v;
        }
    }
    fill(h, h + n, -1);
    fill(cycle, cycle + cnt, 0);
    C.clear();
    dfs(0, 0, -1);
    dsu G;
    G.build(n);
    for (int i = 0; i < cnt; i++) {
        if (!cycle[i]) {
            G.merge(a[i], b[i]);
        }
    }
    vector<int> st(n);
    for (int i = 0; i < cnt; i++) {
        if (cycle[i]) {
            st[G.get(a[i])]++;
            st[G.get(b[i])]++;
        }
    }

    vector<int> A(n);
    for (int i = 0; i < n; i++) {
        if (G.get(i) == i && st[i] > 2) {
            A[i] = 1;
        }
    }
    int root = -1;
    for (int i = 0; i < n; i++) {
        if (in[i]) {
            int v = G.get(i);
            if (A[v]) {
                B[i] = 1;
                if (root == -1 || h[root] < h[i]) {
                    root = i;
                }
            }
        }
    }
    if (root == -1) {
        cout << "Yes\n";
        return;
    }
    fill(used, used + n, 0);
    can = 1;
    dfs2(root, -1);
    cout << (can >= 0 ? "Yes\n" : "No\n");
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    while (1) {
        cin >> n >> m;
        if (n == 0 && m == 0) {
            return 0;
        }
        solve();
    }
    return 0;
}