#include <bits/stdc++.h>
#define rep(i, n) for (int i = 0; i < (n); ++i)
typedef long long ll;
using namespace std;

vector<int> rev(vector<int> a) {
    vector<int> b(a.size());
    rep(i, a.size()) {
        b[a[i]] = i;
    }
    return b;
}

vector<int> comp(vector<int> a, vector<int> b) {
    vector<int> c(a.size());
    rep(i, a.size()) {
        c[i] = a[b[i]];
    }
    return c;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        rep(i, n) {
            cin >> a[i];
            --a[i];
        }
        if (n == 1) {
            cout << "Impossible\n";
            continue;
        }
        if (n == 2) {
            if (a[0] == 0) {
                cout << "Possible\n2 1\n2 1\n";
            } else {
                cout << "Impossible\n";
            }
            continue;
        }
        vector<vector<int>> cycles;
        vector<int> used(n, 0);
        rep(i, n) {
            if (used[i]) continue;
            cycles.emplace_back();
            cycles.back().push_back(i);
            used[i] = 1;
            for (int j = a[i]; j != i; j = a[j]) {
                used[j] = 1;
                cycles.back().push_back(j);
            }
        }
        if (n == 3 && cycles.size() == 2) {
            cout << "Impossible\n";
            continue;
        }
        vector<int> tmp;
        if (cycles.size() >= 2 && cycles.back().size() == 2) swap(cycles.back(), cycles[cycles.size() - 2]);
        if (cycles.size() >= 2 && cycles[0].size() == 2) swap(cycles[0], cycles[1]);
        rep(i, cycles.size()) {
            tmp.push_back(cycles[i].back());
        }
        rep(i, cycles.size()) {
            if (cycles[i].size() >= 2) tmp.push_back(cycles[i][cycles[i].size() - 2]);
        }
        rep(i, cycles.size()) {
            if (cycles[i].size() <= 2) continue;
            for (int j = cycles[i].size() - 3; j >= 0; --j) {
                tmp.push_back(cycles[i][j]);
            }
        }
        vector<int> qrev(n);
        rep(i, n) {
            qrev[tmp[i]] = i == n - 1 ? tmp[0] : tmp[i + 1];
        }
        auto q = rev(qrev);
        auto arev = rev(a);
        auto p = comp(arev, qrev);
        cout << "Possible\n";
        rep(i, n) cout << p[i] + 1 << ' ';
        cout << '\n';
        rep(i, n) cout << q[i] + 1 << ' ';
        cout << '\n';
    }
    return 0;
}
