#include <bits/stdc++.h>
#define rep(i, n) for (int i = 0; i < (n); ++i)
typedef long long ll;
using namespace std;
typedef pair<int, int> pii;

vector<set<int>> g;
vector<vector<int>> g2;
vector<int> tin, tout, up, tup;
int ct;

void dfs(int v, int p) {
    up[v] = p;
    tup[v] = tin[v] = ++ct;
    for (int u : g[v]) {
        if (u == p)
            continue;
        if (tin[u]) {
            tup[v] = min(tup[v], tin[u]);
            continue;
        }

        dfs(u, v);
        tup[v] = min(tup[v], tup[u]);
    }
    tout[v] = ct;
}

int isp(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}


void del(int v) {
    if (g[v].size() != 1)
        return;
    int u = *g[v].begin();
    g[u].erase(v);
    g[v].erase(u);
    del(u);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    while (1) {
        cin >> n >> m;
        int e = 0;
        if (!n)
            break;
        g = vector<set<int>>(n);
        ct = 0;
        tin = vector<int>(n);
        tout = vector<int>(n);
        tup = vector<int>(n);
        up = vector<int>(n);
        rep(i, m) {
            int k;
            cin >> k;
            int u, v;
            cin >> u;
            --u;
            rep(j, k - 1) {
                cin >> v;
                --v;
                e++;
                g[u].insert(v);
                g[v].insert(u);
                u = v;
            }
        }
        rep(i, n)
            del(i);
        int start = 0;
        while (start < n && g[start].empty())
            start++;
        if (start == n) {
            cout << "Yes\n";
            continue;
        }
        dfs(start, -1);
        int ok = 1;
        g2 = vector<vector<int>>(n + e);
        int cc = 0;
        rep(i, n)
            for (int j : g[i]) {
//                cout << i << ' ' << up[i] << ' ' << j << ' ' << up[j] << endl;
                if (j == up[i] || i == up[j]) {
                    if (j == up[i] && tup[i] > tin[j]) {
                        g2[n + cc].push_back(i);
                        g2[i].push_back(n + cc);
                        g2[n + cc].push_back(j);
                        g2[j].push_back(n + cc);
                        cc++;
                    }
                    continue;
                }
                int u = i, v = j;
                if (u > v)
                    continue;
//                cout << u << ' ' << v << endl;
                while (!isp(v, u)) {
                    g2[n + cc].push_back(v);
                    g2[v].push_back(n + cc);
                    v = up[v];
                }
                while (!isp(u, v)) {
                    g2[n + cc].push_back(u);
                    g2[u].push_back(n + cc);
                    u = up[u];
                }
                assert(u == v);
                g2[n + cc].push_back(v);
                g2[v].push_back(n + cc);
                cc++;
            }
        int sv = -1, tv = -1;
        rep(i, n)
            if (g2[i].size() > 1 && (sv == -1 || isp(sv, i))) {
                sv = i;
            }
        rep(i, n)
            if (g2[i].size() > 1 && !isp(i, sv) && (tv == -1 || isp(tv, i))) {
                tv = i;
            }
        int lca;
        if (tv == -1) {
            lca = sv;
            while (up[lca] != -1)
                lca = up[lca];
            tv = sv;
        } else {
            lca = sv;
            while (!isp(lca, tv)) {
                lca = up[lca];
                assert(lca != -1);
            }
        }
        rep(i, n)
            if (g2[i].size() > 1 && (!isp(i, sv) && !isp(i, tv) || !isp(lca, i)))
                ok = 0;
        if (ok) {
            cout << "Yes\n";
            continue;
        }
        int ccom = 0;
//        rep(i, n)
//            for (int j : g2[i])
//                cout << i << ' ' << j << endl;
        rep(i, cc)
            if (g2[n + i].size() > 1)
                ccom++;
        if (ccom == 1)
            cout << "Yes\n";
        else
            cout << "No\n";
    }
    return 0;
}
