#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define x first
#define y second

vector<vector<int>> gr;
vector<int> inLeft;
vector<bool> used;

bool dfs(int v) {
    if (used[v]) {
        return false;
    }
    used[v] = true;
    for (int u : gr[v]) {
        if (inLeft[u] == -1 || dfs(inLeft[u])) {
            inLeft[u] = v;
            return true;
        }
    }
    return false;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), pr(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        pr[a[i]] = i;
    }
    vector<int> p(n), q(n);
    set<int> qq;
    for (int x = 0; x < n; ++x) {
        qq.insert(x);
    }
    while (n > 4) {
        int x = pr[n - 1];
        for (int t : qq) {
            if (t == n - 1 || t == x) continue;
            qq.erase(t);
            q[n - 1] = t;
            p[t] = x;
            break;
        }
        --n;
    }

    gr.assign(n, {});
    inLeft.assign(n, -1);
    vector<int> ded;
    for (int x : qq) ded.pb(x);
    assert(ded.size() == n);
    for (int v = 0; v < n; ++v) {
        int x = pr[v];
        for (int u = 0; u < n; ++u) {
            if (ded[u] == x || ded[u] == v) continue;
            gr[v].pb(u);
        }
    }

    for (int v = 0; v < n; ++v) {
        used.assign(n, false);
        if (!dfs(v)) {
            cout << "Impossible\n";
            return;
        }
    }
    for (int i = 0; i < n; ++i) {
        //cout << i << " " << inLeft[i] << endl;
        q[inLeft[i]] = ded[i];
        p[q[inLeft[i]]] = pr[inLeft[i]];
    }
    cout << "Possible\n";
    for (int x : p) {
        cout << x + 1 << " ";
    }
    cout << "\n";
    for (int x : q) {
        cout << x + 1 << " ";
    }
    cout << "\n";
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
