#include <bits/stdc++.h>
#pragma GCC optimize 03
using namespace std;
#define pb push_back
#define int long long
#define ld long double
//#define x first
//#define y second

const int N = 1e8;
const int LogN = 18;
mt19937 rnd(42);
int t2[LogN];
int t3[LogN];
const int lN = 1.3e8;
ld dp[N];
int cntm[lN];

int reset3(int mask, int i) {
    int c = mask / t3[i] % 3;
    return mask - c * t3[i];
}

int set3(int mask, int i, int val) {
    return reset3(mask, i) + val * t3[i];
}

void rec(vector<pair<int, int> >& masks, int cur_subm, int ask_mask, int i, int n) {
    if (i == n) {
        masks.emplace_back(cur_subm, cntm[ask_mask]);
    } else {
        if ((cur_subm & t2[i]) > 0) {
            rec(masks, cur_subm, set3(ask_mask, i, 1), i + 1, n);
            rec(masks, cur_subm - t2[i], set3(ask_mask, i, 0), i + 1, n);
        } else {
            rec(masks, cur_subm, set3(ask_mask, i, 2), i + 1, n);
        }
    }
}


int dpmask[LogN][N];

void solve() {
    int n, k;
    cin >> n >> k;
    --k;
    dp[t2[k] - 1] = 1;
    int cntkiller = 0;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        bool killer = (s[0] == '0');
        reverse(s.begin(), s.end());
        int mask = 0;
        s.pop_back();
        for (auto c : s) {
            mask = mask * 3 + c - '0';
        }
        cntkiller += killer;
        if (killer) {
            mask = 0;
            for (auto c : s) {
                mask = mask * 2 + (c - '0');
            }
            dpmask[0][mask]++;
        } else {
            ++cntm[mask];
        }
    }
    for (int i = 0; i < k; ++i)
        for (int j = 0; j < t2[k]; ++j) {
            dpmask[i + 1][j] += dpmask[i][j];
            if ((j & t2[i]) == 0) {
                dpmask[i + 1][(j + t2[i])] += dpmask[i][j];
            }
        }
    for (int i = 0; i < k; ++i)
        for (int j = t3[k] - 1; j >= 0; --j)
        if (cntm[j] > 0) {
            cntm[set3(j, i, 2)] += cntm[j];
        }

    ld ans = 0;
    for (int i = t2[k] - 1; i >= 0; --i)
        if (dp[i] > 0) {
            vector<pair<int, int> > masks;
            int tmask = 0;
            int dmask = 0;
            for (int j = 0; j < k; ++j)
                if ((i & t2[j]) > 0) {
                    tmask += t3[j];
                } else {
                    dmask += t2[j];
                }
            rec(masks, i, tmask, 0, k);
            int sum = 0;
            for (auto [mask, cnt] : masks)
                if (mask != i) {
                    sum += cnt;
                }
            if (sum == 0) {
                ans += dp[i];
            } else {
                sum += cntkiller - dpmask[k][dmask];
                for (auto [mask, cnt] : masks)
                    if (mask != i) {
                        dp[mask] += dp[i] * cnt * 1.0 / sum;
                    }
            }
        }
    cout << fixed << setprecision(10) << ans << endl;
}



signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    t2[0] = t3[0] = 1;
    for (int i = 1; i < LogN; ++i) {
        t2[i] = t2[i - 1] * 2;
        t3[i] = t3[i - 1] * 3;
    }
    solve();
#ifdef LOCAL
    cout << clock() * 1.0 / CLOCKS_PER_SEC << endl;
#endif
}
