#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e6;
vector<int> g[MAXN];
int p[MAXN];
int used[MAXN];
int cur_c = 1;

int dfs(int v) {
    used[v] = cur_c;
    for (auto u : g[v]) {
        if (p[u] == -1) {
            p[u] = v;
            p[v] = u;
            return 1;
        } else if (used[p[u]] != cur_c && dfs(p[u])) {
            p[u] = v;
            p[v] = u;
            return 1;
        }
    }
    return 0;
}

int ans;

void solve(int v) {
    used[v] = cur_c;
    ans--;
    for (auto u : g[p[v]]) {
        if (used[u] != cur_c) {
            solve(u);
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    int n, m;
    cin >> n >> m;
    vector<string> arr(n);
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        for (int j = 0; j < m; ++j) {
            if (arr[i][j] == '.') cnt++;
        }
    }
    cnt /= 2;
    if (cnt >= 2000 || cnt * (cnt - 1) / 2 >= 1000000) {
        cout << 1000000 << endl;
        return 0;
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (arr[i][j] == '.' && arr[i - 1][j] == '.') {
                g[i * m + j].push_back(i * m + j - m);
                g[i * m + j - m].push_back(i * m + j);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 1; j < m; ++j) {
            if (arr[i][j] == '.' && arr[i][j - 1] == '.') {
                g[i * m + j].push_back(i * m + j - 1);
                g[i * m + j - 1].push_back(i * m + j);
            }
        }
    }
    fill(p, p + n * m, -1);
    bool found = true;
    while (found) {
        cur_c++;
        found = false;
        for (int i = 0; i < n * m; ++i) {
            if (g[i].empty() || (i / m + i % m) % 2) continue;
            if (p[i] == -1 && used[i] != cur_c) {
                if (dfs(i)) {
                    found = true;
                }
            }
        }
    }
    cnt *= 2;
    ans = cnt * (cnt - 1);
    for (int i = 0; i < n * m; ++i) {
        if (!g[i].empty()) {
            cur_c++;
            solve(i);
        }
    }
    cout << min(ans / 2, 1'000'000) << endl;
    return 0;
}
