#include <bits/stdc++.h>
using namespace std;

const int MAXM = 17;
int get_3[1 << MAXM];
int first[1 << MAXM];
int deg3[MAXM + 1];

int main() {

#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    deg3[0] = 1;
    for (int i = 1; i <= MAXM; ++i) {
        deg3[i] = deg3[i - 1] * 3;
    }
    for (int i = 0; i < (1 << MAXM); ++i) {
        first[i] = -1;
        for (int j = 0; j < MAXM; ++j) {
            if (i & (1 << j)) {
                first[i] = j;
                get_3[i] += deg3[j];
            }
        }
    }
    vector<int> cnt(deg3[MAXM], 0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        int x = 0;
        for (int i = 0; i < m; ++i) {
            if (s[i] == '1') {
                x |= (1 << i);
            }
        }
        cnt[get_3[x]]++;
    }
    for (int i = 0; i < (1 << m); ++i) {
        vector<int> arr;
        for (int j = i; j > 0; j = (j - 1) & i) {
            arr.push_back(j);
        }
        reverse(arr.begin(), arr.end());
        for (int j : arr) {
            int mask = get_3[i] + get_3[j];
            int id = first[j];
            cnt[mask] = cnt[mask - deg3[id]] + cnt[mask - 2 * deg3[id]];
        }
    }
    vector<double> dp(1 << m);
    for (int mask = 0; mask < (1 << m); ++mask) {
        double sum = 0;
        int den = 0;
        for (int sub = mask; sub > 0; sub = (sub - 1) & mask) {
            if (sub == mask) continue;
            int t = ~((mask & sub) | (mask ^ sub));
            t = (t & ((1 << m) - 1));
            t = get_3[sub] + 2 * get_3[t];
            if (sub & 1) {
                sum += cnt[t] * dp[sub];
            }
            den += cnt[t];
        }
        if (den == 0) {
            dp[mask] = 1;
        } else {
            dp[mask] = sum / den;
        }
    }
    cout << fixed << setprecision(15);
    cout << dp[(1 << m) - 1];
    return 0;
}
