#include <bits/stdc++.h>
using namespace std;

string same, closer;

int ask(int x, int y) {
    cout << x << " " << y << endl;
    string s;
    getline(cin, s);
    if (s.back() == '!') {
        exit(0);
    }
    if (s == same) return 0;
    if (s == closer) return 1;
    return -1;
}

string get_s(int x, int y) {
    cout << x << " " << y << endl;
    string s;
    getline(cin, s);
    if (s.back() == '!') {
        exit(0);
    }
    return s;
}

const int MAXN = 1'000'000;

int main() {
    get_s(0, 0);
    same = get_s(0, 0);
    closer = get_s(1, 1);
    if (closer == same) {
        get_s(0, 1);
        get_s(1, 0);
        return 0;
    }
    int lx = 0, rx = MAXN, ly = 0, ry = MAXN;
    while (rx > lx) {
        int p = (lx + rx - 1) / 2, q = (lx + rx + 2) / 2;
        int r = (ly + ry - 1) / 2, s = (ly + ry + 2) / 2;
        ask(p, r);
        int x = ask(q, r);
        int y = ask(q, s);
        if (x == 1) {
            lx = q;
        } else if (x == -1) {
            rx = p;
        } else {
            lx = q - 1;
            rx--;
        }
        if (y == 1) {
            ly = s;
        } else if (y == -1) {
            ry = r;
        } else {
            ly = s - 1;
            ry--;
        }
    }
    ask(lx, ly);
    return 0;
}
