#include <bits/stdc++.h>
using namespace std;
#define  int int64_t

const int MAXN = 5982, MAXD = 1e12;
string arr[MAXN];

void to_s(string &s, vector<int> v) {
    s += to_string(v.back());
    v.pop_back();
    while (!v.empty()) {
        string t = to_string(v.back());
        for (int i = 0; i + t.size() < 12; ++i) {
            s.push_back('0');
        }
        v.pop_back();
        s += t;
    }
    reverse(s.begin(), s.end());
}

void build() {
    vector<int> cur;
    cur.push_back(1);
    to_s(arr[0], cur);
    for (int i = 2; i <= MAXN; ++i) {
        int car = 0;
        for (int j = 0; j < (int)cur.size(); ++j) {
            cur[j] *= i;
            cur[j] += car;
            if (cur[j] >= MAXD && j + 1 == (int)cur.size()) {
                cur.push_back(0);
            }
            car = cur[j] / MAXD;
            cur[j] %= MAXD;
        }
        to_s(arr[i - 1], cur);
    }
}

const int MAXV = 1e6;
array<int, 10> g[MAXV];
int id = 0;
const int MAXT = 2e4;
int ans[MAXV];
bool is_fin[MAXV];

void build(int v, vector<int> var) {
    if (var.empty()) return;
    if (var.size() == 1) {
        is_fin[v] = true;
        ans[v] = var[0];
        return;
    }
    int mx = MAXV;
    for (int i = 0; i < MAXT; ++i) {
        array<int, 10> cnt;
        for (int j = 0; j < 10; ++j) {
            cnt[j] = 0;
        }
        for (auto x : var) {
            if ((int)arr[x].size() > i) {
                cnt[arr[x][i] - '0']++;
            } else {
                cnt[0]++;
            }
        }
        int cur = -1;
        for (int j = 0; j < 10; ++j) {
            cur = max(cur, cnt[j]);
        }
        if (cur < mx) {
            mx = cur;
            ans[v] = i;
        }
    }
    int i = ans[v];
    array<vector<int>, 10> cnt;
    for (auto x : var) {
        if ((int)arr[x].size() > i) {
            cnt[arr[x][i] - '0'].push_back(x);
        } else {
            cnt[0].push_back(x);
        }
    }
    for (int i = 0; i < 10; ++i) {
        id++;
        g[v][i] = id;
        build(id, cnt[i]);
    }
}


main() {
    build();
    vector<int> all;
    for (int i = 0; i < MAXN; ++i) {
        all.push_back(i);
    }
    build(0, all);
    int tst;
    cin >> tst;
    while (tst--) {
        int v = 0;
        while (!is_fin[v]) {
            cout << "? " << ans[v] << endl;
            int c;
            cin >> c;
            v = g[v][c];
        }
        cout << "! " << ans[v] + 1 << endl;
        string s;
        cin >> s;
    }
    return 0;
}
