#include <bits/stdc++.h>
#define int long long
using ld = long double;
#define all(x) (x).begin(), (x).end()
using namespace std;

mt19937_64 rnd(228);

void solve(int n, vector<int> a) {
    if (n == 1) {
        cout << "Impossible\n";
        return;
    }
    if (n == 2 && a[0] == 1) {
        cout << "Impossible\n";
        return;
    }
    if (n == 3 && a[0] == 0 && a[1] == 2) {
        cout << "Impossible\n";
        return;
    }
    if (n == 3 && a[0] == 2 && a[1] == 1) {
        cout << "Impossible\n";
        return;
    }
    if (n == 3 && a[0] == 1 && a[1] == 0) {
        cout << "Impossible\n";
        return;
    }
    while (1) {
        vector<int> p(n);
        iota(all(p), 0);
        int null = rnd() % (n - 1) + 1;
        swap(p[null], p[0]);
        for (int i = 1; i < n; i++) {
            if (p[i]) {
                swap(p[i], p[rnd() % i]);
            }
        }
        vector<int> ap(n);
        for (int i = 0; i < n; i++) {
            ap[i] = a[p[i]];
        }
        vector<int> q(n);
        for (int i = 0; i < n; i++) {
            q[ap[i]] = i;
        }
        bool f = 1;
        for (int i = 0; i < n; i++) {
            if (p[i] == i) assert(0);
            if (q[i] == i) {
                f = 0;
                break;
            }
        }
        if (f) {
            cout << "Possible\n";
            for (auto& i : p) cout << i + 1 << ' ';
            cout << '\n';
            for (auto& i : q) cout << i + 1 << ' ';
            cout << '\n';
            return;
        }
    }
    assert(0);
}

signed main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    //freopen("../out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (auto& i : a) cin >> i, i--;
        solve(n, a);
    }
    return 0;
}
