#include <bits/stdc++.h>
#define int long long
using ld = long double;
#define all(x) (x).begin(), (x).end()
#define pii pair<int, int>
#define pb push_back
#define ff first
#define ss second
using ull = unsigned long long;

using namespace std;

mt19937_64 rnd(228);
#ifdef LOCAL
    int X, Y;
    int px = -1, py = -1;
    string SAME = "sane", INC = "inc", DEC = "dec", TRASH = "trash";
    string FOUND = "a a!";
    int qcnt = 0;
#endif

int sq(int x) { return x * x; }
int DIST(int x, int y) {
    return sq(x - X) + sq(y - Y);
}

string get(int x, int y) {
    cout << x << " " << y << endl;
#ifdef LOCAL
    ++qcnt;
    if (qcnt > 100) {
        cout << "OVERQUERY\n";
        exit(0);
    }
    if (px == -1) {
        px = x;
        py = y;
        return TRASH;
    }
    if (x == X && y == Y) {
        cout << "OK " << qcnt << '\n';
        exit(0);
    }
    int pdist = DIST(px, py);
    int cdist = DIST(x, y);
    px = x;
    py = y;
    if (pdist == cdist) {
        return SAME;
    }
    return (cdist < pdist ? INC : DEC);
#endif
    string s; getline(cin, s);
    if (s.back() == '!') exit(0);
    return s;
}

string same = "";
string inc = "";

bool first = 1;
int bst = -1;
string query(int a) {
    if (first) return get(0, a);
    else return get(a, bst);
}

void rec(int l, int r, int& res, int lst=-1) {
    if (l == r) {
        res = l;
        return;
    }
    if (r - l == 1) {
        if (lst >= r) {
            auto s = query(r + r - lst);
            if (s == same) {
                res = r;
            } else {
                res = l;
            }
        } else {
            auto s = query(l + l - lst);
            if (s == same) {
                res = l;
            } else {
                res = r;
            }
        }
        return;
    }
    int x = (l + r) / 2;
    int y = (l + r) / 2 + 1;
    query(x);
    string s = query(y);
    if (s == inc) {
        string t = query(r);
        if (t == inc) {
            int c = (y + r) / 2;
            if ((y + r) % 2 == 0) {
                rec(c + 1, r, res, r);
            } else {
                rec(c + 1, r, res, r);
            }
        } else if (t != same) {
            int c = (y + r) / 2;
            if ((y + r) % 2 == 0) {
                rec(y, c-1, res, r);
            } else {
                rec(y, c,res, r);
            }
        } else {
            int c = (y + r) / 2;
            res = c;
            return;
        }
    } else {
        string t = query(l);
        if (t == inc) {
            int c = (l + y) / 2;
            if ((y + l) % 2 == 0) {
                rec(l, c-1,res, l);
            } else {
                rec(l, c, res, l);
            }
        } else if (t != same) {
            int c = (l + y) / 2;
            if ((l + y) % 2 == 0) {
                rec(c, x, res, l);
            } else {
                rec(c+1, x,res, l);
            }
        } else {
            int c = (l + y) / 2;
            res = c;
            return;
        }
    }
}

void solve() {
    get(0, 0);
    same = get(0, 0);
    inc = get(1, 1);
    if (same == inc) {
        get(0, 1);
        get(1, 0);
        return;
    }
    int N = 1e6;
    rec(0, N, bst);
    first = 0;
    int resx = 0;
    rec(0, N, resx);
    get(resx, bst);

#ifdef LOCAL
    cout << "WA " << qcnt << '\n';
#endif
}

signed main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    //freopen("../out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

#ifdef LOCAL
    cin >> X >> Y;
    cin >> SAME >> INC >> DEC;
#endif
    solve();
    return 0;
}
