#include <bits/stdc++.h>
//#define int long long
using ll = long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
#define pii pair<int, int>
#define pb push_back
#define ff first
#define ss second
using ull = unsigned long long;

using namespace std;

mt19937_64 rnd(228);

int const N = 5982, L = 20028 / 9, BASE = 1000000000, LEN = 20000;

int fac[L], fid = 1, flen = 0;
int FAC[L], FLEN = 0;
int ppw10[9];

void init_fac(int* a, int& len) {
	fill(a, a + L, 0);
	a[0] = 1;
	fid = 1;
	len = 1;
}

int get_digit(int* a, int i) {
	int full = i / 9;
	int prt = i % 9;
	return a[full] / ppw10[prt] % 10;
}

int real_len() {
	int res = 9 * flen;
	while (0 == get_digit(fac, res - 1)) {
		--res;
	}
	return res;
}

void mlt(int* a, int& len, int x) {
	int bonus = 0, i = 0;
	for (; bonus || i < len; ++i) {
		ll cur = x * 1ll * a[i] + bonus;
		a[i] = cur % BASE;
		bonus = cur / BASE;
	}
	len = i;			
}

void make_fac(int n) {
	while (fid < n) {
		++fid;
		mlt(fac, flen, fid);
	}
}

int const K = 10;
int pos[K], val[K], asked = 0;

int query(int x) {
	cout << "? " << x << endl;
	int dig;
#ifdef LOCAL
	dig = get_digit(FAC, x);
#else
	cin >> dig;
#endif
	pos[asked] = x;
	val[asked] = dig;
	++asked;
	return dig;
}

bool check() {
	for (int i = 0; i < asked; ++i) {
		if (get_digit(fac, pos[i]) != val[i]) {
			return false;
		}
	}
	return true;
}

int solve() {	
	asked = 0;
	init_fac(fac, flen);
	query(0);
	while (asked < K && val[asked - 1] == 0) {
		int zeros = pos[asked - 1] + 1;
		int mn = min(N, 5 * zeros);
		make_fac(mn);
		int rlen = real_len();
		query(rlen - 1);
		if (val[asked - 1] == 0 && asked == 3) {
			query(rlen - 2);
		}                  
	} 
	int l = pos[asked - 1];
	int r = l;
	bool wasl = false;
	while (asked < K) {
		if (!wasl) {
			--l;
			wasl = true;
			if (l >= 0) {
				query(l);
			}
		} else {
			++r;
			wasl = false;
			if (r < LEN) {
				query(r);
			}	
		}
	}
	
	init_fac(fac, flen);
	while (!check()) {
		make_fac(fid + 1);
	}
	return fid;
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    //freopen("../out.txt", "w", stdout);
#endif
	ppw10[0] = 1;
	for (int i = 1; i < 9; ++i) {
		ppw10[i] = 10 * ppw10[i - 1];
	}
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    
    int t;
    cin >> t;
    while (t--) {
#ifdef LOCAL
		int n;
		cin >> n;
		init_fac(FAC, FLEN);
		for (int i = 2; i <= n; ++i) {
			mlt(FAC, FLEN, i);
		}
#endif

    	int ans = solve();
    	cout << "! " << ans << endl;
#ifdef LOCAL
    		cout << (ans == n ? "OK " : "WA");
    		cout << ' ' << asked << '\n';
    		if (ans != n) {
    			cout << n << '\n';
    			exit(0);
    		}
#else
   			string RES;
   			cin >> RES;
   			if (RES == "NO") {
   				exit(0);
   			}
#endif
   	}
    return 0;
}
