#include <bits/stdc++.h>

using namespace std;

constexpr int N = 1e5;

int n;
vector<array<int, 2>> nei[N];
int tin[N], tup[N], ct;
int ccyc[N], hc[N];

void calct(int v, int p) {
  tup[v] = tin[v] = ++ct;
  for (auto& [u, nb]: nei[v]) if (!tin[u]) {
    calct(u, v);
    tup[v] = min(tup[v], tup[u]);
    ccyc[v] += ccyc[u];
    ccyc[v] += tup[u] == tin[v];
    if (tup[u] > tin[v] && ccyc[u]) ++hc[v];
    nb = 1;
  } else if (u != p && tin[u] < tin[v]) {
    nb = 2;
    tup[v] = min(tup[v], tin[u]);
  } else if (u != p) {
    nb = 2;
  }
}

int r;

bool gather_v(int v) {
  if (tup[v] < tin[v]) return 1;
  int cup = ccyc[r], nc = 0;
  for (auto [u, nb]: nei[v]) if (nb == 1) {
    nc += !!ccyc[u];
    cup -= ccyc[u];
  }
  return nc + !!cup < 3;
}

set<int> cs;
set<int> cinv[N];
map<int, int> cntdv;

int gather_c2(int v, int C) {
  int res = 0, cc = 0;
  for (auto [u, nb]: nei[v]) if (nb == 1 && tup[u] == tup[v]) {
    res += gather_c2(u, C);
  }
  for (auto [u, nb]: nei[v]) if (nb == 1 && tup[u] != tup[v]) {
    if (tup[u] == tin[v]) cc = 1;
    else res += !!ccyc[u];
  }
  cinv[v].insert(C);
  return res + cc;
}

bool gather_c(int v) {
  if (tup[v] >= tin[v]) return 1;
  bool ok = 1;
  int p = -1;
  for (auto [u, nb]: nei[v]) if (nb == 0) {
    p = u;
    ok &= tup[v] == tin[u];
  }
  if (!ok) return 1;
  cs.insert(v);
  int bv = gather_c2(v, v), pc = 0;
  if (ccyc[p] != ccyc[v] + 1 + hc[p] || tup[p] < tin[p]) pc = 1;
  if (tup[p] >= tin[p]) bv += !!(ccyc[r] - ccyc[p]);
  bv += hc[p];
  cinv[p].insert(v);
  return bv + pc < 3;
}

bool check_chamomile() {
  for (int i = 0; i < n; ++i) if (cinv[i].size() > 1) {
    for (auto C: cinv[i]) ++cntdv[C];
  }
  for (auto [k, v]: cntdv) if (v + 1 == cs.size()) {
    return 1;
  }
  return 0;
}

bool solve() {
  int m; cin >> n >> m;
  if (!n) return 0;
  for (int i = 0; i < m; ++i) {
    int k; cin >> k;
    int p, c; cin >> p;
    while (--k) {
      cin >> c;
      nei[p - 1].push_back({c - 1, 0});
      nei[c - 1].push_back({p - 1, 0});
      p = c;
    }
  }
//  for (r = 0; r < n; ++r) {
    bool ok = 1;
    calct(r, r);
    for (int i = 0; i < n; ++i) {
      ok &= gather_c(i) && gather_v(i);
    }
    if (!ok && check_chamomile()) ok = 1;
    if (!ok) {
      cout << "No\n";
    } else {
      cout << "Yes\n";
    }
    ecyc:;
    ct = 0;
    fill_n(tin, n, 0);
    fill_n(tup, n, 0);
    fill_n(ccyc, n, 0);
    fill_n(hc, n, 0);
    for (int i = 0; i < n; ++i) {
      for (auto& [u, nb]: nei[i]) nb = 0;
      cinv[i].clear();
    }
    cs.clear();
    cntdv.clear();
//  }
  return 1;
}


int main() {
  cin.tie(0)->sync_with_stdio(0);
  while (solve()) {
    for (int i = 0; i < n; ++i) nei[i].clear();
  }
  return 0;
}
