#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<vector<int>> towers;

    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;

        int prev = -1;

        for (int j = 0; j < k; j++) {
            int v;
            cin >> v;
            if (prev == -1 || prev > v) {
                towers.emplace_back();
            }
            towers.back().push_back(v);
            prev = v;
        }
    }

    vector<pair<int, int>> w;
    for (int i = 0; i < towers.size(); i++) {
        for (int q : towers[i]) {
            w.push_back({q, i});
        }
    }

    sort(w.begin(), w.end());

    int prev = -1;
    int zxc = 0;

    for (auto [a, b] : w) {
        if (prev != -1 && prev != b) {
            zxc++;
        }
        prev = b;
    }

    int add = zxc - (towers.size() - 1);

    int s = towers.size() + add - n;
    int c = towers.size() + add - 1;

    cout << s << " " << c << "\n";

    return 0;
}
