//
// Created by nef on 07.12.2022.
//
#include <bits/stdc++.h>

using namespace std;

#define int long long


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while(t --> 0) {
        int n;
        cin >> n;

        vector<int> a(n);
        for(int& x: a) {
            cin >> x;
            x--;
        }

        if(n == 1) {
            cout << "Impossible\n";
            continue;
        }

        vector<int> fixpoints;
        vector<pair<int, int>> cycles2;
        vector<vector<int>> bigcycles;
        vector<bool> used(n);
        for(int i = 0; i < n; i++) {
            if(a[i] == i) {
                fixpoints.push_back(i);
            } else if(a[a[i]] == i) {
                if(i < a[i]) {
                    cycles2.emplace_back(i, a[i]);
                }
            } else if(!used[i]) {
                int j = i;
                bigcycles.emplace_back();
                do {
                    used[j] = true;
                    bigcycles.back().push_back(j);
                    j = a[j];
                } while(j != i);
                reverse(bigcycles.back().begin(), bigcycles.back().end());
            }
        }

        vector<int> p(n, -1);
        vector<int> q(n, -1);
        for(auto& cyc: bigcycles) {
            for (int i = 0; i < cyc.size(); i++) {
                q[cyc[i]] = cyc[(i + 2) % cyc.size()];
                p[cyc[(i + 2) % cyc.size()]] = cyc[(i + 1) % cyc.size()];
            }
        }
        if(cycles2.size() >= 2) {
            for(int i = 0; i < cycles2.size(); i++) {
                q[cycles2[i].first] = cycles2[(i + 1) % cycles2.size()].first;
                p[cycles2[(i + 1) % cycles2.size()].first] = cycles2[i].second;
                q[cycles2[i].second] = cycles2[(i + 1) % cycles2.size()].second;
                p[cycles2[(i + 1) % cycles2.size()].second] = cycles2[i].first;
            }
        }
        if(fixpoints.size() >= 2) {
            for (int i = 0; i < fixpoints.size(); i++) {
                q[fixpoints[i]] = fixpoints[(i + 1) % fixpoints.size()];
                p[fixpoints[(i + 1) % fixpoints.size()]] = fixpoints[i];
            }
        }
        if(cycles2.size() == 1) {
            auto [x, y] = cycles2[0];
            int a = find_if_not(q.begin(), q.end(), [](int x) {return x == -1;}) - q.begin();
            if(a == n) {
                cout << "Impossible\n";
                continue;
            }
            int b = q[a];
            int c = p[b];
            int d = find_if_not(q.begin() + a + 1, q.end(), [](int x) {return x == -1;}) - q.begin();
            assert(d < n);
            int e = q[d];
            int f = p[e];
            q[a] = x;
            p[x] = c;
            q[x] = b;
            p[b] = y;
            q[d] = y;
            p[y] = f;
            q[y] = e;
            p[e] = x;
        }
        if(fixpoints.size() == 1) {
            int x = fixpoints[0];
            int a = find_if_not(q.begin(), q.end(), [](int x) {return x == -1;}) - q.begin();
            if(a == n) {
                cout << "Impossible\n";
                continue;
            }
            int b = q[a];
            int c = p[b];
            q[a] = x;
            p[x] = c;
            q[x] = b;
            p[b] = x;
        }

        cout << "Possible\n";
        for(int x: p) {
            cout << x + 1 << " ";
        }
        cout << "\n";
        for(int x: q) {
            cout << x + 1 << " ";
        }
        cout << "\n";
    }

    return 0;
}
/*
4
2
2 1
3
1 2 3
4
2 1 4 3
5
5 1 4 2 3
*/