//
// Created by nef on 07.12.2022.
//
#include <bits/stdc++.h>

using namespace std;

//#define int long long


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    map<int, int> ss;
    for(int i = 0; i < n; i++) {
        string s;
        cin >> s;
        int mask = 0;
        for(int j = 0; j < m; j++) {
            mask |= (s[j] - '0') << j;
        }
        ss[mask]++;
    }

    vector<int> cnt_ss_supermask(1 << m);
    for(auto& [mask, cnt]: ss) {
        for(int submask = mask; submask > 0; submask = (submask - 1) & mask) {
            cnt_ss_supermask[submask] += cnt;
        }
    }

    vector<int> cnt_ss_eq(1 << m);
    vector<double> distrib(1 << m);
    distrib.back() = 1;
    for(int mask = (1 << m) - 1; mask > 0; mask--) {
        for(int submask = mask; submask > 0; submask = (submask - 1) & mask) {
            cnt_ss_eq[submask] = cnt_ss_supermask[submask];
//            cerr << submask << ": " << cnt_ss_eq[submask] << endl;
        }
        for(int i = 0; i < m; i++) {
            if((mask >> i) & 1) {
                for (int submask = mask; submask > 0; submask = (submask - 1) & mask) {
                    if(!((submask >> i) & 1)) {
                        cnt_ss_eq[submask] -= cnt_ss_eq[submask | (1 << i)];
                    }
                }
            }
        }
        int cnt_to_self = n;
        for (int submask = (mask - 1) & mask; submask > 0; submask = (submask - 1) & mask) {
//            cerr << mask << " -> " << submask << ": " << cnt_ss_eq[submask] << endl;
            cnt_to_self -= cnt_ss_eq[submask];
        }
        if(cnt_to_self < n) {
            for (int submask = (mask - 1) & mask; submask > 0; submask = (submask - 1) & mask) {
                double prob = (double) cnt_ss_eq[submask] / (n - cnt_to_self);
                distrib[submask] += prob * distrib[mask];
            }
            distrib[mask] = 0;
        }
    }

    double ans = 0;
    for(int mask = 0; mask < (1 << m); mask++) {
        if(mask & 1) {
            ans += distrib[mask];
        }
    }
    cout << fixed << setprecision(10) << ans << endl;

//    for(double x: distrib) {
//        cerr << x << " ";
//    }
//    cerr << endl;

    return 0;
}