//
// Created by nef on 07.12.2022.
//
#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1000000;

int realx = 10;
int realy = 100;
int prevx = -1;
int prevy = -1;
int ops = 0;

string ask(int x, int y) {
    assert(0 <= x && x <= INF && 0 <= y && y <= INF);
    cout << x << " " << y << endl;
    ops++;
//    if(x == realx && y == realy) {
//        throw ops;
//    }
//    if(prevx != -1) {
//        int curdist = (x - realx) * (x - realx) + (y - realy) * (y - realy);
//        int prevdist = (prevx - realx) * (prevx - realx) + (prevy - realy) * (prevy - realy);
//        prevx = x;
//        prevy = y;
//        if(curdist == prevdist) {
//            return "Same distance";
//        } else if(curdist > prevdist) {
//            return "Farther";
//        } else {
//            return "Closer";
//        }
//    }
//    prevx = x;
//    prevy = y;
//    return "Not found";
    string s;
    getline(cin, s);
    if(s.find('!') != string::npos) {
        exit(0);
    }
    return s;
}

string closer;

void binsearch_vertical(int x) {
    int l = 0;
    int r = INF;
    while(r - l > 1) {
        int m = (l + r) / 2 + 1;
        ask(x, m);
        string ans1 = ask(x, m - 1);
        if(ans1 == closer) {
            r = m - 2;
            string ans2 = ask(x, l);
            if(ans2 == closer) {
                r = (l + m) / 2 - 1;
                l++;
            } else {
                l = (l + m) / 2;
            }
        } else {
            l = m + 1;
            string ans2 = ask(x, r);
            if(ans2 == closer) {
                l = (m + r + 1) / 2;
                r--;
            } else {
                r = (m + r - 1) / 2;
            }
        }
    }
    ask(x, l);
    ask(x, l + 1);
    assert(false);
}

void binsearch_both() {
    int l = 0;
    int r = INF;
    while(r - l > 1) {
        int m = (l + r) / 2 + 1;
        ask(m, 0);
        string ans1 = ask(m - 1, 0);
        if(ans1 == closer) {
            r = m - 1;
            if(l < r) {
                string ans2 = ask(l, 0);
                if(ans2 == closer) {
                    r = (l + m) / 2 - 1;
                } else {
                    l = (l + m) / 2;
                }
            }
        } else {
            l = m;
            if(l < r) {
                string ans2 = ask(r, 0);
                if(ans2 == closer) {
                    l = (m + r + 1) / 2;
                } else {
                    r = (m + r - 1) / 2;
                }
            }
        }
    }
    int x = l;
    if(l < r) {
        ask(l, 0);
        string ans1 = ask(r, 0);
        x = ans1 == closer ? r : l;
    }
    binsearch_vertical(x);
}

int solve() {
    try {
        ask(0, INF / 2);
        string ans1 = ask(1, INF / 2);
        ask(INF, INF / 2);
        string ans2 = ask(INF - 1, INF / 2);
        if (ans1 == ans2) {
            closer = ans1;
            binsearch_both();
        } else {
            ask(INF / 2, 0);
            string ans3 = ask(INF / 2, 1);
            ask(INF / 2, INF);
            string ans4 = ask(INF / 2, INF - 1);
            if (ans3 == ans4) {
                closer = ans3;
                if (ans1 == closer) {
                    binsearch_vertical(INF);
                } else {
                    binsearch_vertical(0);
                }
            } else {
                ask(0, 0);
                ask(0, INF);
                ask(INF, 0);
                ask(INF, INF);
                assert(false);
            }
        }
    } catch(int ops) {
        return ops;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

//    srand(time(0));
//    for(int i = 0; i < 10000; i++) {
//        realx = rand() % INF;
//        realy = rand() % INF;
//        cerr << realx << " " << realy << endl;
//        prevx = -1;
//        prevy = -1;
//        ops = 0;
//        solve();
//        cerr << ops << endl;
//        assert(ops <= 64);
//    }

    return 0;
}