#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define X first
#define Y second
#define pb push_back
#define sz(a) (int)a.size()

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}

const int N = 1005;
int n, m;
bool a[N][N];
int current_vert_white = 0;
int current_vert_black = 0;
const ll MX = 1e6;
int num[N][N];
vector<int> g[N + N];
int curcol, used[N + N], covered[N + N], match[N + N];
ll white = 0;
ll black = 0;
ll ans = 0;
int banned = -1;
int banned_white = -1;
set<int> cant_delete;

vector<int> neight(int v) {
    vector<int> ret;
    for (auto& d : g[v]) {
        for (auto& h : g[d]) {
            if (h == v)
                continue;
            ret.pb(h);
        }
    }
    sort(ret.begin(), ret.end());
    ret.erase(unique(ret.begin(), ret.end()), ret.end());
    return ret;
}

bool dfs(int v) {
    used[v] = curcol;
    for (int u : g[v]) {
        if (u == banned)
            continue;
        if (match[u] == -1) {
            covered[v] = 1;
            match[u] = v;
            match[v] = u;
            return true;
        }
    }
    for (int u : g[v]) {
        if (u == banned)
            continue;
        if (used[match[u]] != curcol && dfs(match[u])) {
            covered[v] = 1;
            match[u] = v;
            match[v] = u;
            return true;
        }
    }
    return false;
}

pair<int, int> kuhn() {
    curcol = 0;
    for (int i = 0; i < white; ++i) {
        used[i] = 0;
        match[i] = -1;
        covered[i] = 0;
    }
    for (int i = N; i < N + black; ++i) {
        used[i] = 0;
        match[i] = -1;
        covered[i] = 0;
    }
    while (true) {
        ++curcol;
        bool ch = 0;
        for (int i = 0; i < white; ++i) {
            if (i == banned_white)
                continue;
            if (!covered[i] && used[i] != curcol) {
                bool f = dfs(i);
                ch |= f;
            }
        }
        if (!ch)
            break;
    }
    int not_covered = -1;
    int lol = 0;
    for (int i = 0; i < white; ++i) {
        lol += covered[i];
        if (!covered[i])
            not_covered = i;
    }
    return {lol, not_covered};
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c;
            cin >> c;
            num[i][j] = -1;
            if (c == '.') {
                a[i][j] = 1;
                if ((i + j) % 2 == 0) {
                    ++white;
                    num[i][j] = current_vert_white++;
                } else {
                    ++black;
                    num[i][j] = N + current_vert_black++;
                }
            }
        }
    }
    ans += white * (white - 1) / 2;
    ans += black * (black - 1) / 2;
    if (ans >= MX) {
        cout << min(ans, MX);
        return;
    }
    assert(black == white);
    vector<pair<int, int>> dif = {{1, 0}, {0, 1}};
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
//            cout << i << ' ' << j << ' ' << num[i][j] << '\n';
            if (a[i][j] != 1)
                continue;
            for (auto& d : dif) {
                int x = d.X + i;
                int y = d.Y + j;
                if (x < 0 || x >= n)
                    continue;
                if (y < 0 || y >= m)
                    continue;
                if (num[x][y] == -1)
                    continue;
                g[num[i][j]].pb(num[x][y]);
                g[num[x][y]].pb(num[i][j]);
//                cout << num[i][j] << ' ' << num[x][y] << '\n';
            }
        }
    }
//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < m; ++j) {
//            cout << num[i][j] << " \n"[j + 1 == m];
//        }
//    }
    for (int i = 0; i < black; ++i) {
        banned = i + N;
        banned_white = -1;
        auto pot = kuhn();
        assert(pot.X < black);
        if (pot.X != black - 1) {
            ans += white;
            continue;
        }
        cant_delete.clear();
        assert(pot.Y != -1);
        cant_delete.insert(pot.Y);
        int not_covered = pot.Y;
        for (int j = 0; j < white; ++j) {
            banned_white = j;
            if (!covered[j]) {
                cant_delete.insert(j);
                continue;
            }
            covered[j] = 0;
            match[match[j]] = -1;
            ++curcol;
            if (dfs(not_covered)) {
                not_covered = j;
                cant_delete.insert(j);
            }
        }
        ans += white - sz(cant_delete);
    }
    cout << ans;
}