#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("sse,ss2,sse3,ssse3,abm,mmx,tune=native")
#include <vector>
#include <iostream>
#include <stack>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <tuple>
#include <vector>
#include <bitset>
#include <queue>
#include <unordered_map>
#include <random>
#include <ctime>
#include <time.h>
#include <list>
#include <numeric>

using namespace std;

mt19937 mt_rand(time(0));
const int maxN = 5982;
vector<int> to_vec(int i) {
	vector<int>res;
	while (i) {
		res.push_back(i % 10);
		i /= 10;
	}
	return res;
}
vector<int>pl(const vector<int>& a, const vector<int>& b) {
	int add = 0;
	int sz = max(a.size(), b.size());
	vector<int>res(sz + 1);
	for (int i = 0; i < sz; ++i) {
		int tmp = add;
		if (i < a.size()) {
			tmp += a[i];
		}
		if (i < b.size()) {
			tmp += b[i];
		}
		res[i] = tmp % 10;
		add = tmp / 10;
	}
	if (add) {
		res.back() = add;
	}
	else res.pop_back();
	return res;
}
void mult(vector<int>&buff, const vector<int>& bg, int d) {
	int add = 0;
	for (auto t : bg) {
		int curr = add + t * d;
		buff.push_back(curr % 10);
		add = curr / 10;
	}
	if (add)
		buff.push_back(add);
}
vector<int>mult(const vector<int>& bg, const vector<int>& sm) {
	vector<vector<int>>to_plus;
	for (int i = 0; i < sm.size(); ++i) {
		vector<int>buff;
		for (int j = 0; j < i; ++j)buff.push_back(0);
		mult(buff, bg, sm[i]);
		to_plus.push_back(buff);
	}
	while (to_plus.size() > 1) {
		int sz = to_plus.size();
		vector<int>a = pl(to_plus[sz - 2], to_plus.back());
		to_plus.pop_back();
		to_plus.back() = a;
	}
	return to_plus[0];
}
map<vector<int>, int>mp;
const int K = 20000;
void dfs(const vector<vector<int>>& a, vector<int>can_be, vector<int>pref) {
	if (can_be.empty())
		return;
	if (can_be.size() == 1) {
		mp[pref] = -can_be[0];
		return;
	}
	int opt = -1;
	int res = maxN + 1;
	for (int b = 0; b < K; ++b) {
		vector<int>cnt(10);
		int mx = 0;
		for (auto d : can_be) {
			int bb = 0;
			if (a[d].size() > b) {
				bb = a[d][b];
			}
			++cnt[bb];
			mx = max(mx, cnt[bb]);
		}
		if (mx < res) {
			res = mx;
			opt = b;
		}
	}
	mp[pref] = opt;
	vector<vector<int>>can_be_suff(10);
	for (auto d : can_be) {
		int bb = 0;
		if (a[d].size() > opt) {
			bb = a[d][opt];
		}
		can_be_suff[bb].push_back(d);
	}
	int ddd = 0;
	for (const auto& vec : can_be_suff) {
		pref.push_back(ddd++);
		dfs(a, vec, pref);
		pref.pop_back();
	}
}
void precalc(const vector<vector<int>>&a) {
	vector<int>can_be;
	vector<int>pref;
	for (int i = 1; i <= maxN; ++i) {
		can_be.push_back(i);
	}
	dfs(a, can_be, pref);
}
int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(0);
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else 
	// skip
#endif
	vector<vector<int>>a;
	a.push_back({ 1 });
	for (int i = 1; i <= maxN; ++i) {
		//cout << i << endl;
		a.push_back(mult(a.back(), to_vec(i)));
	}
	precalc(a);

	int t;
	cin >> t;
	while (t--) {
		vector<int>curr;
		int bb = 0;
		while (bb == 0) {
			int d = mp[curr];
			if (d < 0) {
				bb = -d;
				break;
			}
			cout << "? " << d << endl;
			int v;
			cin >> v;
			curr.push_back(v);
		}
		cout << "! " << bb << endl;
		string s;
		cin >> s;
		if (s == "NO") {
			break;
		}
	}
}
