#include <bits/stdc++.h>

#define gsize(x) (int)((x).size())

using namespace std;

typedef long long ll;

const int maxn = 1000;

int ans[maxn], k;
vector<int> ind[maxn];


void solve(vector<int> s, int p = -2) {
  /*  cout << p << " |";
    for (int x: s) cout << x << ' ';
    cout << "|" << endl;*/
    if (gsize(s) == 0) return;

    int m = gsize(s);
    vector<int> mi(m, maxn), ma(m, 0);

    for (int i = 0; i < k; i++) {
        int cmi = maxn;
        for (int j = 0; j < m; j++) {
            cmi = min(cmi, ind[s[j]][i]);
        }
        for (int j = 0; j < m; j++) {
            int nind = ind[s[j]][i] - cmi;
            mi[j] = min(mi[j], nind);
            ma[j] = max(ma[j], nind);
        }
    }

    vector<pair<int, int>> ta(m);
    for (int i = 0; i < m; i++) {
        ta[i].first = ma[i] - mi[i];
        ta[i].second = s[i];
    }
    sort(ta.begin(), ta.end());

    if (gsize(ta) == 1) {
        ans[ta[0].second] = p;
        return;
    }

    int rt = ta[0].second;
    if (ta[1].first == ta[0].first) {
        rt = ta[1].second;
        vector<int> x, y;
        for (int j = 0; j < m; j++) {
            if (ind[s[j]][0] < ind[rt][0]) {
                x.push_back(s[j]);
            } else if (ind[s[j]][0] > ind[rt][0]) {
                y.push_back(s[j]);
            }
        }
        sort(x.begin(), x.end());
        sort(y.begin(), y.end());


        for (int i = 1; i < k; i++) {
            vector<int> tx, ty;
            for (int j = 0; j < m; j++) {
                if (ind[s[j]][i] < ind[rt][i]) {
                    tx.push_back(s[j]);
                } else if (ind[s[j]][i] > ind[rt][i]) {
                    ty.push_back(s[j]);
                }
            }
            sort(tx.begin(), tx.end());
            sort(ty.begin(), ty.end());
            if (x != tx && x != ty) {
                rt = ta[0].second;
                break;
            }
        }
    }
    ans[rt] = p;

    vector<int> a, b;
    for (int j = 0; j < m; j++) {
        if (ind[s[j]][0] < ind[rt][0]) {
            a.push_back(s[j]);
        } else if (ind[s[j]][0] > ind[rt][0]) {
            b.push_back(s[j]);
        }
    }

    solve(a, rt);
    solve(b, rt);
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int n;
    cin >> n >> k;

    for (int i = 0; i < k; i++) {
        for (int j = 0; j < n; j++) {
            int x;
            cin >> x;
            ind[x - 1].push_back(j);
        }
    }

    vector<int> cset(n);
    for (int i = 0; i < n; i++) {
        cset[i] = i;
    }


    solve(cset);

    for (int i = 0; i < n; i++) {
        cout << ans[i] + 1 << ' ';
    }
    cout << endl;

    return 0;
}
