#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int N, K;
vector<pair<int, int>> ans;

void easy() {
    if (N == 2) {
        cout << "YES\n1\n1 2\n";
        return;
    }
    if (N == 1) {
        cout << "YES\n0\n";
        return;
    }

    cout << "YES\n" << N << '\n';
    for (int i = 1; i <= N; ++i) {
        cout << i << " " << (i) % N + 1 << "\n"; 
    }
}

auto main() -> signed {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    cin >> N >> K;

    if (K == 1) {
        easy();
        exit(0);
    }
    if (K >= N) {
        cout << "NO\n";
        exit(0);
    }

    cout << "YES\n";

    vector<vector<int>> a(K - 1, vector<int> (N, 1));
    for (int i = 0; i < K - 1; ++i) a[i][0] = N - 1;

    int l = 1, r = 2;
    for (int i = 1; i < K - 1; i++) {
        for (int j = l; j <= r; j++) {
            a[i][j] += a[i-1][j];
            if ((r - l) % 2 == 0 && j == (r + l) / 2) {
                a[i][j]--;
            }
        }
        r++;
    }

    for (int u = 0; u < N; ++u) {
        auto &cnt = a[K - 2][u];
        for (int v = u + 1; cnt > 0; --cnt, ++v) {
            --a[K - 2][v];
            ans.push_back({u + 1, v + 1});
        }
    }

    // for (auto vv: a) {
    //     for (auto v : vv) cout << v << ' ';
    //     cout << '\n';
    // }

    cout << ans.size() << "\n";
    for (auto [u, v] : ans) {
        cout << u << ' ' << v << '\n';
    }

    return 0;
}