#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

typedef long long ll;

int main() {
	ll t; cin >> t;
	while (t--) {
		ll n; cin >> n;
		vector <ll> int_to_ind(n + 1);
		vector <ll> arr(n + 1);
		vector <ll> cnt(n + 1);
		for (ll i = 1; i <= n; ++i) {
			ll k; cin >> k;
			int_to_ind[k] = i;
			arr[i] = k;
			cnt[i - k >= 0 ? i - k : n + (i - k)] = 1;
		}
		ll zd = -1;
		for (ll i = 1; i < n; ++i) {
			if (cnt[i] == 0) {
				zd = i;
				break;
			}
		}
		if (zd == -1) {
			cout << "Impossible\n";
			continue;
		}
		cout << "Possible\n";
		vector <ll> ans_1(n + 1);
		vector <ll> ans_2(n + 1);
		for (ll i = 1 + zd; i <= zd + n; i++)
			ans_2[i - zd] = i <= n ? i : i - n;
		for (ll i = 1; i <= n; ++i)
			ans_1[ans_2[i]] = int_to_ind[i];
		for (ll i = 1; i <= n; ++i)
			cout << ans_1[i] << " ";
		cout << "\n";
		for (ll i = 1; i <= n; ++i)
			cout << ans_2[i] << " ";
		cout << "\n";		
	}
}