#include <bits/stdc++.h>

using namespace std;

string same;
string closer;
string further;

bool is_finish(const string &s) {
    return s[s.size() - 1] == '!';
}

void read_smart(basic_istream<char> &a, string &s) {
    getline(cin, s);
    if (is_finish(s)) {
        exit(0);
    }
}

void decrypt() {
    cout << "0 0" << endl;
    string t;
    read_smart(cin, t);
    cout << "0 0" << endl;
    read_smart(cin, same);
    cout << "0 1" << endl;
    read_smart(cin, t);
    cout << "1 1" << endl;
    string p;
    read_smart(cin, p);
    if (t == p) {
        closer = t;
        cout << "0 1" << endl;
        read_smart(cin, further);
    } else {
        cout << "1000000 1000000" << endl;
        read_smart(cin, further);
        cout << "1 1" << endl;
        read_smart(cin, closer);
    }
}

void solve() {
    int left_x = 0, right_x = 1e6, left_y = 0, right_y = 1e6;
    cout << "0 0" << endl;
    string t;
    read_smart(cin, t);
    while (left_x != right_x && left_y != right_y) {
        cout << left_x << " " << right_y << endl;
        string s1, s2;
        read_smart(cin, s1);
        if (s1[s1.size() - 1] == '!') {
            return;
        }
        cout << right_x << " " << right_y << endl;
        read_smart(cin, s2);
        if (s2[s2.size() - 1] == '!') {
            return;
        }
        if (s1 == further) {
            right_y = (left_y + right_y) / 2;
        } else if (s1 == closer) {
            left_y = (left_y + right_y + 1) / 2;
        } else if (s1 == same) {
            left_y = right_y = (left_y + right_y) / 2;
        }
        if (s2 == further) {
            right_x = (left_x + right_x) / 2;
        } else if (s2 == closer) {
            left_x = (left_x + right_x + 1) / 2;
        } else if (s2 == same) {
            left_x = right_x = (left_x + right_x) / 2;
        }
        cout << left_x << " " << left_y << endl;
        read_smart(cin, t);
    }
}

int main() {
    decrypt();
    solve();
}