#include <bits/stdc++.h>

using namespace std;

string same;
string closer;
string further;

bool is_finish(const string &s) {
    return s[s.size() - 1] == '!';
}

bool read_smart(basic_istream<char> &a, string &s) {
    getline(cin, s);
    return is_finish(s);
}

bool decrypt() {
    cout << "0 0" << endl;
    string t;
    if (read_smart(cin, t)) {
        return true;
    }
    cout << "0 0" << endl;
    if (read_smart(cin, same)) {
        return true;
    }
    cout << "0 1" << endl;
    if (read_smart(cin, t)) {
        return true;
    }
    cout << "1 1" << endl;
    string p;
    if (read_smart(cin, p)) {
        return true;
    }
    if (t == p) {
        closer = t;
        cout << "0 1" << endl;
        if (read_smart(cin, further)) {
            return true;
        }
    } else {
        cout << "1000000 1000000" << endl;
        if (read_smart(cin, further)) {
            return true;
        }
        cout << "1 1" << endl;
        if (read_smart(cin, closer)) {
            return true;
        }
    }
    return false;
}

bool solve() {
    int left_x = 0, right_x = 1e6, left_y = 0, right_y = 1e6;
    cout << "0 0" << endl;
    string t;
    if (read_smart(cin, t)) {
        return true;
    }
    while (left_x != right_x && left_y != right_y) {
        cout << left_x << " " << right_y << endl;
        string s1, s2;
        read_smart(cin, s1);
        if (s1[s1.size() - 1] == '!') {
            return true;
        }
        cout << right_x << " " << right_y << endl;
        read_smart(cin, s2);
        if (s2[s2.size() - 1] == '!') {
            return true;
        }
        if (s1 == further) {
            right_y = (left_y + right_y) / 2;
        } else if (s1 == closer) {
            left_y = (left_y + right_y + 1) / 2;
        } else if (s1 == same) {
            left_y = right_y = (left_y + right_y) / 2;
        }
        if (s2 == further) {
            right_x = (left_x + right_x) / 2;
        } else if (s2 == closer) {
            left_x = (left_x + right_x + 1) / 2;
        } else if (s2 == same) {
            left_x = right_x = (left_x + right_x) / 2;
        }
        cout << left_x << " " << left_y << endl;
        if (read_smart(cin, t)) {
            return true;
        }
    }
    return false;
}

int main() {
    if (decrypt()) {
        return 0;
    }
    solve();
}