#include <bits/stdc++.h>
using namespace std;

#define int long long

void shift(vector<int> &vec, int d) {
    vector<int> kek;
    int n = vec.size();
    for (int i = n - d; i < n; ++i) {
        kek.push_back(vec[i]);
    }
    for (int i = 0; i < n - d; ++i) {
        kek.push_back(vec[i]);
    }
    vec = kek;
}

void shift_left(vector<int> &vec, int d) {
    vector<int> kek;
    int n = vec.size();
    for (int i = 0; i < n - d; ++i) {
        kek.push_back(vec[i]);
    }
    for (int i = n - d; i < n; ++i) {
        kek.push_back(vec[i]);
    }
    vec = kek;
}

void sol(vector<int> a) {
    int n = a.size();
    vector<int> p(n), q(n);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
    }
    for (int i = 0; i < n; ++i) {
        q[i] = i;
    }
    do {
        do {
            bool f = 1;
            for (int i = 0; i < n; ++i) {
                f &= a[p[q[i]]] == i;
                f &= p[i] != i;
                f &= q[i] != i;
            }
            if (f) {
                cout << "NEW\n";
                for (int x: p) {
                    cout << x + 1 << ' ';
                }
                cout << '\n';
                for (int y : q) {
                    cout << y + 1 << ' ';
                }
                cout << '\n';

            }
        } while (next_permutation(q.begin(), q.end()));
    } while (next_permutation(p.begin(), p.end()));
}

void check(vector<int> a, vector<int> p, vector<int> q) {
    cout << '\n';
    for (int i = 0; i < a.size(); ++i) {
        cout << a[q[p[i]]] << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> q;
    while (q--) {
        int n;
        cin >> n;
        vector<int> a(n);
        vector<int> a_1(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            a[i]--;
            a_1[a[i]] = i;
        }
        vector<int> p(n);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
        vector<int> res(n);
        vector<int> qq(n);
        bool ok = 1;
        for (int P = 0; P < 100; ++P) {
            random_shuffle(p.begin(), p.end());
            bool flag = 1;
            for (int i = 0; i < n; ++i) {
                res[i] = a[p[i]];
                if (p[i] == i) {
                    flag = 0;
                    break;
                }
                if (res[i] == i) {
                    flag = 0;
                    break;
                }
            }
            if (!flag) {
                continue;
            }
            for (int i = 0; i < n; ++i) {
                qq[res[i]] = i;
            }
            ok = 0;
            break;
        }
        if (ok) {
            cout << "Impossible\n";
        } else {
            cout << "Possible\n";
            for (int x: qq) {
                cout << x + 1 << ' ';
            }
            cout << '\n';
            for (int x: p) {
                cout << x + 1 << ' ';
            }
            //check(a, qq, p);
        }
        continue;
        for (int x: a_1) {
            // cerr << x << " ";
        }
        map<int, int> used;
        map<int, int> used2;
        for (int i = 0; i < n; ++i) {
            used[(n + a_1[i] - i) % n] = 1;
            used2[(n - a_1[i] + i) % n] = 1;
        }
        int d = 1;
        while (used[d] == 1) {
            d++;
        }
        int d2 = 1;
        while (used2[d2] == 1) {
            d2++;
        }
        // cerr << d << '\n';
        if (d == n && d2 == n) {
            cout << "Impossible\n";
            continue;
        }
        if (d != n) {
            shift(a_1, d);
        } else {
            shift_left(a_1, d2);
        }
        vector<int> q(n);
        for (int i = 0; i < n; ++i) {
            q[i] = i;
        }
        if (d != n) {
            shift(q, n - d);
        } else {
            shift_left(q, n - d2);
        }
        cout << "Possible\n";
        for (int x: a_1) {
            cout << x + 1 << ' ';
        }
        cout << '\n';
        for (int x: q) {
            cout << x + 1 << ' ';
        }
        check(a, q, a_1);
        cout << '\n';
    }
    return 0;
}