#include <bits/stdc++.h>
using namespace std;

#define int long long

vector <vector <char> > g;
vector <vector <int> > used;
int n, m;
pair<int, int> dfs(int x, int y, int time) {
//    cerr << x << ' ' << y << ' ' << time << '\n';
    used[x][y] = time;
    pair<int, int> ans = {0, 0};
    if (x > 0 && g[x - 1][y] == '.' && used[x - 1][y] < time) {
        auto q = dfs(x - 1, y, time);
        ans.first += q.first;
        ans.second += q.second;
    }


    if (y > 0 && g[x][y - 1] == '.' && used[x][y - 1] < time) {
        auto q = dfs(x, y - 1, time);
        ans.first += q.first;
        ans.second += q.second;
    }

    if (x < n - 1 && g[x + 1][y] == '.' && used[x + 1][y] < time) {
        auto q = dfs(x + 1, y, time);
        ans.first += q.first;
        ans.second += q.second;
    }

    if (y < m - 1 && g[x][y + 1] == '.' && used[x][y + 1] < time) {
        auto q = dfs(x, y + 1, time);
        ans.first += q.first;
        ans.second += q.second;
    }
    if ((x + y) % 2 == 0) {
        ans.first ++;
    } else {
        ans.second ++;
    }
    return ans;
}
bool poc = true;

bool check(int x, int y) {
    if (g[x][y] != '.') {
        return true;
    }
    int cnt = 0;
    if (x == 0 || g[x - 1][y] != '.')
        cnt++;
    if (x == n - 1 || g[x + 1][y] != '.')
        cnt++;
    if (y == 0 || g[x][y - 1] != '.')
        cnt++;
    if (y == m - 1 || g[x][y + 1] != '.')
        cnt++;
    if (cnt == 4){
//        for (int i = 0; i < n; ++i) {
//            for (int j = 0; j < m; ++j) {
//                cerr << g[i][j] ;
//            }
//            cerr << '\n';
//        }
//        cerr << "asdamdoke" << x << ' ' << y << '\n';
        poc = false;
        return false;
    }
    if (cnt == 3) {
//        cerr <<  "filling" << x << ' ' << y <<'\n';
        if (x != 0 && g[x - 1][y] == '.') {
            g[x - 1][y] = '$';
        }
        if (x != n - 1 && g[x + 1][y] == '.') {
            g[x + 1][y] = '$';
        }
        if (y != 0 && g[x][y - 1] == '.') {
            g[x][y - 1] = '$';
        }
        if (y != m - 1 && g[x][y + 1] == '.') {
            g[x][y + 1] = '$';
        }
        g[x][y]  = '$';
        return true;
    }
    return true;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    g.resize(n, vector<char>(m));
    int a[2] = {0, 0};
    set<pair<int, int> > e, be, we;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> g[i][j];
            if (g[i][j] == '.') {
                a[(i + j) % 2]++;
                e.insert({i, j});
                if ((i + j) % 2 == 0) {
                    be.insert({i, j});
                } else {
                    we.insert({i, j});
                }
            }
        }
    }
    int ans = (a[0] * (a[0] - 1)) / 2 + ((a[1] * (a[1] - 1))) / 2;
    if (ans > 1e6) {
        cout << 1000000 << '\n';
        return 0;
    }
//    cerr << "pans = " << ans << '\n';
    int time = 2;
    for (auto [x, y]: be) {
        for (auto [a, b]: we) {
//            cerr << x << ' ' << y << ' ' << a << ' ' << b << '\n';
            used.assign(n, vector<int>(m, 0));
            g[x][y] = '#';
            g[a][b] = '#';
            time++;
            poc = true;
            for (auto [q, p] : e) {
                if (!check(q, p)) {
//                    cerr << "cool\n";
                    ans++;
                    break;
                }
            }
//            for (int i = 0; i < n; ++i) {
//                for (int j = 0; j < m; ++j) {
//                    cerr << g[i][j] ;
//                }
//                cerr << '\n';
//            }
            if (poc) {
                for (auto [q, p]: e) {
                    if (used[q][p] < time && g[q][p] == '.') {

                        auto qwe = dfs(q, p, time);

                        if (qwe.first != qwe.second) {
//                            cerr << "cool\n" << qwe.first << ' ' << qwe.second << '\n';
                            ans++;
                            break;
                        }
                    }
                }
            }
            for (auto [p, q]: e) {
                if (g[p][q] == '$') {
                    g[p][q] = '.';
                }
            }
//            cerr << "helol\n";
//            for (int i = 0; i < n; ++i) {
//                for (int j = 0; j < m; ++j) {
//                    cerr << g[i][j] ;
//                }
//                cerr << '\n';
//            }

            g[x][y] = '.';
            g[a][b] = '.';
        }
    }
    cout << ans <<'\n';
    return 0;
}