#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int INF = 1e9;

void solve() {
    int n;
    cin >> n;
    int a[n], v = -1;
    vector <int> petels;
    set <int> d;
    int q[n], p[n];
    for (int &i : a)
        cin >> i, --i;
    for (int i = 0; i < n; ++i) {
        if (a[i] == i) {
            petels.push_back(i);
        } else if (a[a[i]] == i) {
            if (d.find(a[i]) == d.end())
                d.insert(i);
        } else {
            v = i;
            q[i] = a[i];
        }
    }
    vector <int> pairs;
    for (int x : d)
        pairs.push_back(x);
    if (n == 1 || (n == 2 && a[0] == 1) || (n == 3 && !petels.empty() && !pairs.empty())) {
        cout << "Impossible\n";
        return;
    }
    if (v == -1) {
        int A = pairs.size(), B = petels.size();
        if (A == 1 && B == 2) {
            q[pairs[0]] = petels[0];
            q[petels[0]] = a[pairs[0]];
            q[a[pairs[0]]] = petels[1];
            q[petels[1]] = pairs[0];
        }
        else {
            for (int i = 0; i < B - 1; ++i) {
                q[petels[i]] = petels[i + 1];
            }
            if (B == 0) {
                for (int i = 0; i < A - 1; ++i) {
                    q[pairs[i]] = pairs[i + 1];
                }
                q[pairs[A - 1]] = a[pairs[0]];
                for (int i = 0; i < A - 1; ++i) {
                    q[a[pairs[i]]] = a[pairs[i + 1]];
                }
                q[a[pairs[A - 1]]] = pairs[0];
            } else if (A == 0) {
                q[petels[B - 1]] = petels[0];
            } else {
                if (A == 1) {
                    int x = pairs[0], y = a[x];
                    q[petels[0]] = x;
                    q[x] = petels[1];
                    q[petels[1]] = y;
                    q[y] = petels[2];
                    q[petels[B - 1]] = petels[0];
                }
                else {
                    for (int i = 0; i < A - 1; ++i) {
                        q[pairs[i]] = pairs[i + 1];
                    }
                    q[pairs[A - 1]] = a[pairs[0]];
                    for (int i = 0; i < A - 1; ++i) {
                        q[a[pairs[i]]] = a[pairs[i + 1]];
                    }
                    q[a[pairs[A - 1]]] = pairs[0];
                    q[pairs[0]] = petels[0];
                    q[petels[B - 1]] = pairs[1];
                }
            }
        }
    }
    else {
        for (int x: petels) {
            int u = q[v];
            q[v] = x;
            q[x] = u;
        }
        for (int x: pairs) {
            int y = a[x];
            int u = q[v], t = q[u];
            q[v] = x;
            q[x] = u;
            q[u] = y;
            q[y] = t;
        }
    }
    int places[n];
    for (int i = 0; i < n; ++i)
        places[a[i]] = i;
    for (int i = 0; i < n; ++i) {
        p[q[i]] = places[i];
    }
    cout << "Possible\n";
    for (int &i : p)
        cout << i + 1 << " ";
    cout << '\n';
    for (int &i : q)
        cout << i + 1 << " ";
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(0); cin.tie(NULL); cout.tie(NULL); srand(time(NULL));

    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }

    return 0;
}