#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

#define int long long

signed main() {
	int n, s = 0, c = 0, cnt_towers;
	cin >> n;
	cnt_towers = n;
	set <int> cubes;
	vector <vector <int>> v(n);
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		v[i].resize(k);
		for (int j = 0; j < k; j++) {
			cin >> v[i][j];
			cubes.insert(v[i][j]);
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < v[i].size(); j++) {
			if (j < v[i].size() - 1) {
				if (v[i][j] > v[i][j + 1]) {
					s++;
					cnt_towers++;
				}
				else if (v[i][j + 1] - v[i][j] > 1) {
					auto next_cube = cubes.find(v[i][j]);
					
					if (next_cube != cubes.end() and v[i][j + 1] == *(++next_cube)) {
						continue;
					}
					s++;
					cnt_towers++;
				}
			}
		}
	}

	cout << s << " " << cnt_towers - 1;
}