#include <iostream>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    int n;
    cin >> n;
    vector<int> a;
    vector<vector<int> > towers(n);
    set<int> vals;
    for(int i = 0; i < n; ++i){
        int c;
        cin >> c;
        towers[i] = vector<int> (c);
        for(int j = 0; j < c; ++j){
            cin >> towers[i][j];
            int b = towers[i][j];
            if(vals.find(b) == vals.end()){
                vals.insert(b);
                a.push_back(b);
            }
        }
    }
    sort(a.begin(), a.end());
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < towers[i].size(); ++j){
            int b = towers[i][j];
            int l = 0;
            int r = a.size();
            while(r - l > 1){
                int m = (l + r)/2;
                if(a[m] > b){
                    r = m;
                }else{
                    l = m;
                }
            }
            if(a[l] == b){
                towers[i][j] = l;
            }
        }
    }
    long long ans_s = 0;
    long long ans_c = n-1;
    for(int i = 0; i < n; ++i){
        int d = towers[i][0];
        for(int j = 0; j < towers[i].size(); ++j){
            int b = towers[i][j];
            if(b < d){
                ++ans_c;
                ++ans_s;
            }
            d = b;
        }
    }
    cout << ans_s << ' ' << ans_c;
    return 0;
}
