#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, k;
	cin >> n >> k;
	if (k >= n) {
		cout << "NO";
		return 0;
	}
	vector <int> v(n);
	vector <pair<int,int>> otv;
	for (int i = 0; i < n; i++) {
		v[i] = i + 1;
	}
	int l = 0, r = n - 1;
	while (r-l >= 1 && k != 0){
		if (k > 1) { 
			for (int i = l+1; i <= r; i++) 
				otv.push_back(make_pair(v[l], v[i]));			
			k -= 2;
		}
		else if (k == 1) {
			for (int i = l; i <= r - 1; i++) 
				for (int j = i + 1; j <= r; j++) 
					otv.push_back(make_pair(v[i], v[j ]));				
			k--;
		}
		if(k == 0)
			break;
		
		l++;
		r--;
	}

	if (k == 0) {
		cout << "YES\n";
		cout << otv.size() << "\n";
		for (int i = 0; i < otv.size(); i++) {
			cout << otv[i].first << " " << otv[i].second << "\n";
		}
	}
	else cout << "NO";
}