#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
using ull = unsigned long long;

template<class T, class U> inline void umin(T& a, const U b) { if (b < a) a = b; }
template<class T, class U> inline void umax(T& a, const U b) { if (b > a) a = b; }

const int N = 100100;
int a[N], n, pos[N], my_p[N], my_q[N];
bool good[N];

void solve() {
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pos[a[i]] = i;
    }

    fill(good, good + n, true);

    for (int i = 1; i <= n; i++) {
        int id = (a[i] - i + n) % n;
        good[id] = false;
    }

    for (int i = 1; i < n; i++) {
        if (good[i]) {
            cout << "Possible\n";
            for (int j = 1; j <= n; j++) {
                int val = j + i;
                if (val > n) {
                    val -= n;
                }

                my_q[j] = pos[val];
            }
            for (int j = 1; j <= n; j++) {
                int val = j - i;
                if (val < 1) {
                    val += n;
                }
                my_p[j] = val;
            }

            for (int j = 1; j <= n; j++) {
                cout << my_p[j] << " ";
            }
            cout << '\n';
            for (int j = 1; j <= n; j++) {
                cout << my_q[j] << " ";
            }
            cout << '\n';
            return;
        }
    }

    cout << "Impossible\n";
}

signed main() {
    cout.precision(15);
#ifdef KEK
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(0);
    ios::sync_with_stdio(false);
#endif
    int qq; cin >> qq;
    for (; qq; qq--) {
        solve();
    }
}

//Impossible
//Possible
//2 3 1
//2 3 1
//Possible
//3 4 1 2
//4 3 2 1
//Possible
//3 4 5 1 2
//5 3 1 2 4
//Impossible
