#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
using ull = unsigned long long;

template<class T, class U> inline void umin(T& a, const U b) { if (b < a) a = b; }
template<class T, class U> inline void umax(T& a, const U b) { if (b > a) a = b; }

const int N = 10100;
vector<int> ars[N];
vector<int> al;
int n;

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        int siz;
        cin >> siz;
        ars[i].resize(siz);
        for (int j = 0; j < siz; j++) {
            cin >> ars[i][j];
            al.push_back(ars[i][j]);
        }
    }
    std::sort(al.begin(), al.end());

    int al_segs = 0;
    int comb = 0;

    for (int i = 0; i < n; i++) {
//        std::cerr << ars[i].size() << '\n';
        comb++;
        for (int j = 0; j < ars[i].size(); ) {
            int cur_j = j;
            int pos = std::lower_bound(al.begin(), al.end(), ars[i][cur_j]) -
                    al.begin();
            while (cur_j < ars[i].size() - 1 && pos < al.size() - 1 &&
                    ars[i][cur_j + 1] == al[pos + 1]) {
                pos++;
                cur_j++;
            }

//            std::cerr << pos << " " << cur_j << '\n';
            if (cur_j == ars[i].size() - 1) {
                break;
            }
//            std::cerr << pos << " " << al[pos] << " " << al[pos + 1] << '\n';

            al_segs++;
            comb++;
            j = cur_j + 1;
        }
    }

    cout << al_segs << " " << comb - 1 << '\n';
}

signed main() {
    cout.precision(15);
#ifdef KEK
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(0);
    ios::sync_with_stdio(false);
#endif
    solve();
}