#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
using ull = unsigned long long;

template<class T, class U> inline void umin(T& a, const U b) { if (b < a) a = b; }
template<class T, class U> inline void umax(T& a, const U b) { if (b > a) a = b; }

void solve() {
    int n, k;
    cin >> n >> k;
    if (k == n) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    vector<pii> ans;
    while (k >= 2) {
        for (size_t i = 1; i < n; ++i) {
            ans.emplace_back(i, n);
        }
        n -= 2;
        k -= 2;
    }
    if (k == 1) {
        if (n == 2) {
            ans.emplace_back(1, 2);
        } else {
            for (size_t i = 1; i < n; ++i) {
                ans.emplace_back(i, i + 1);
            }
            ans.emplace_back(n, 1);
        }
    }
    cout << ans.size() << endl;
    for (auto [a, b] : ans) {
        cout << a << ' ' << b << endl;
    }
}

signed main() {
    cout.precision(15);
#ifdef KEK
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(0);
    ios::sync_with_stdio(false);
#endif
    solve();
}