#include <bits/stdc++.h>

using namespace std;

mt19937 gen(time(0));

string guess(int x, int y) {
    cout << x << ' ' << y << endl;
    string s;
    cin >> s;
    if (s.back() == '!') {
        exit(0);
    }
    return s;
}

string guessX(int x) {
    return guess(x, 0);
}
string guessY(int y) {
    return guess(0, y);
}

const int N = 1e6;
string father;
string closer;
string middle;

int GetX() {
    int l = 0, r = N;
    guessX(0);
    string st = guessX(r);
    if (st != father && st != closer) {
        return (l + r) / 2;
    }
    int last = r;
    while (l <= r) {
        int mid = (l + r) / 2;
        if (r == l + 1) {
            if (last == l) {
                mid = r;
            } else {
                mid = l;
            }
        }
        string now_str = guessX(mid);
        if (now_str == closer) {
            if (last == l) {
                r = mid;
            } else {
                l = mid;
            }
        } else if (now_str == father) {
            if (last == l) {
                l = mid;
            } else {
                r = mid;
            }
        } else {
            return (l + r) / 2;
        }
        last = mid;
    }
}

int GetY() {
    int l = 0, r = N;
    guessY(0);
    string st = guessY(r);
    if (st != father && st != closer) {
        return (l + r) / 2;
    }
    int last = r;
    while (l <= r) {
        int mid = (l + r) / 2;
        if (r == l + 1) {
            if (last == l) {
                mid = r;
            } else {
                mid = l;
            }
        }
        string now_str = guessY(mid);
        if (now_str == closer) {
            if (last == l) {
                r = mid;
            } else {
                l = mid;
            }
        } else if (now_str == father) {
            if (last == l) {
                l = mid;
            } else {
                r = mid;
            }
        } else {
            return (l + r) / 2;
        }
        last = mid;
    }
}

void solve() {
    string z = guess(0, 0);
    string a = guess(1, 0);
    string b = guess(0, 0);
    string c = guess(0, 1);
    string d = guess(0, 0);
    if (a == c) {
        father = b;
        closer = a;
    } else {
        guess(0, N);
        guess(N, 0);
        string z2 = guess(N, N);
        string a2 = guess(N - 1, N);
        string b2 = guess(N, N);
        closer = a2;
        father = b2;
    }
    int x = GetX();
    int y = GetY();
    guess(x, y);
}

int main() {
//#ifdef LOCAL
//    freopen("input.txt", "rt", stdin);
//    freopen("output.txd", "wt", stdout);
//#endif
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
    solve();
    return 0;
}

//YES
//6
//3 4
//2 4
//1 4
//4 5
//2 3
//3 5
