#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define sz(x) ((int)(x).size())
#define em_back emplace_back

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

void write(vi xa, vi xb) {
    int d = 0, n = sz(xa);
    for (int i = 0; i < n; ++i) {
        d += xa[i] == xb[i];
    }
    cout << d << "\n";
    for (int i = 0; i < n; ++i) {
        cout << xa[i] << ":" << xb[i] << "\n";
    }
    exit(0);
}

void solve() {
    int n, a, b;
    cin >> n >> a >> b;

    int d = 0;
    if (n == 1) {
        d = (a == b);
        cout << d << "\n" << a << ":" << b << "\n";
        return;
    }
    vi xa(n, 0), xb(n, 0);

    if (a + b <= n) {
        for (int i = 0; i < a; ++i) {
            xa[i] = 1;
        }
        for (int i = 0; i < b; ++i) {
            xb[a + i] = 1;
        }
        write(xa, xb);
    }

    if (a < n) {
        for (int i = 0; i < a; ++i) {
            xa[i] = 1;
        }
        for (int i = a; i < n; ++i) {
            xb[i] = 1;
            b--;
        }
        xb[n - 1] += b;
        write(xa, xb);
    }

    if (b < n) {
        for (int i = 0; i < b; ++i) {
            xb[i] = 1;
        }
        for (int i = b; i < n; ++i) {
            xa[i] = 1;
            a--;
        }
        xa[n - 1] += a;
        write(xa, xb);
    }

    for (int i = 1; i < n; ++i) {
        xa[i] = 1;
        a--;
    }
    xa[1] += a;
    xb[0] = b;
    write(xa, xb);
}

int main() {
    ios::sync_with_stdio(0);
    cout.tie(0), cin.tie(0);

    int z = 1;
    /// cin >> z;

    while (z--) {
        solve();
    }
    return 0;
}
