#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define sz(x) ((int)(x).size())
#define em_back emplace_back

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

int n, k;
vector<pii> vx;

void solve() {
    cin >> n >> k;
    if (k == 1 && n == 1) {
        cout << "YES\n0\n";
        return;
    }
    if (n == k) {
        cout << "NO\n";
        return;
    }

    if (k == 1) {
        cout << "YES\n";
        cout << n*(n - 1)/2 << "\n";
        for (int i = 1; i <= n; ++i) {
            for (int j = i + 1; j <= n; ++j) {
                cout << i << " " << j << "\n";
            }
        }
        return;
    }

    if (k == 2) {
        cout << "YES\n";
        cout << n - 1 << "\n";
        for (int i = 2; i <= n; ++i) {
            cout << i - 1 << " " << i << "\n";
        }
        return;
    }
    vector<pii> e;

    /// {deg, num}
    vx.em_back(1, 1);
    vx.em_back(2, 2);
    vx.em_back(1, 3);

    e.em_back(1, 2);
    e.em_back(2, 3);

    for (int i = 4; i <= k + 1; ++i) {
        sort(all(vx));

        int it = -1;
        for (int j = 1; j < sz(vx); ++j) {
            if (vx[j - 1].first == vx[j].first) {
                it = j;
                break;
            }
        }
        assert(it != -1);

        int deg = 0;
        for (int t = it; t < sz(vx); ++t) {
            ++deg;
            vx[t].first++;
            e.em_back(i, vx[t].second);
        }
        vx.em_back(deg, i);
    }

    int old = 1;
    for (int i = k + 2; i <= n; ++i) {
        e.em_back(old, i);
        old = i;
    }

    cout << "YES\n";
    cout << sz(e) << "\n";
    for (auto [u, v] : e) {
        cout << u << " " << v << "\n";
    }
}

int main() {
    ios::sync_with_stdio(0);
    cout.tie(0), cin.tie(0);

    int z = 1;
    ///cin >> z;

    while (z--) {
        solve();
    }
    return 0;
}
