#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

using namespace std;
#define pii pair<int,int>

bool rec(int i, int n, vector<int> &p, vector<int> &q, vector<int> &a, vector<bool> &used, vector<int> &pos) {
    if(i == n + 1) return true;

    for (int x = 1; x <= n; x++) {
        if (used[x]) continue;

        if (i != x && pos[i] != x) {
            q[i] = x;
            p[x] = pos[i];
            a[p[q[i]]] = i;

            used[x] = true;
            if (rec(i + 1, n, p, q, a, used, pos)) return true;
            used[x] = false;
        }
    }
    return false;
}

void solve() {
    int n = 100000;
    cin >> n;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        //a[i] = i;
    }

    vector<int> p(n + 1), q(n + 1), pos(n + 1);
    vector<bool> used(n + 1, false);

    for(int i = 1; i <= n; i++){
        pos[a[i]] = i;
    }

    if (!rec(1, n, p, q, a, used, pos)) {
        cout << "Impossible\n";
    } else {
        cout << "Possible\n";
        for (int i = 1; i <= n; i++) {
            cout << p[i] << " ";
        }cout << "\n";
        for (int i = 1; i <= n; i++) {
            cout << q[i] << " ";
        }cout << "\n";


        for(int i = 1; i <= n; i++){
            if(a[p[q[i]]] != i) cout << "error";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
