#include <iostream>
#include <vector>
#include <map>
#include <iterator>
#include <string>
#include <cassert>

using namespace std;

const int M = 10;

string read() {
	string s;
	getline(cin, s);
	while (s.size() > 0 && (s.back() == '\n' || s.back() == ' '))
		s.pop_back();
	return s;
}

int main() {
	string closer, further;

	cout << "0 0" << endl;

	string s = read();
	if (s.back() == '!')
		return 0;

	cout << "0 1" << endl;
	s = read();
	if (s.back() == '!')
		return 0;

	string a = s;


	cout << M << " " << M << endl;

	s = read();
	if (s.back() == '!')
		return 0;


	cout << M << " " << M - 1 << endl;

	s = read();
	if (s.back() == '!')
		return 0;


	string b = s;

	if (a == b) {
		closer = a;
		cout << M << " " << M << endl;
		further = read();
	}
	else {
		cout << M << " " << M << endl;
		read();

		cout << M - 1 << " " << M << endl;

		s = read();
		if (s.back() == '!')
			return 0;

		if (b == s) {
			closer = b;
			further = a;
		}
		else {
			string x = s;

			cout << "0 0" << endl;

			read();

			cout << "1 0" << endl;

			s = read();
			if (s.back() == '!')
				return 0;

			if (s != a) {
				assert(false);
			}
			else {
				closer = a;
				further = b;
			}
		}
	}

	int lx = 0, rx = M, ly = 0, ry = M;

	while (true) {
		int mx = (lx + rx) / 2;
		int my = (ly + ry) / 2;

		cout << mx << " " << my << endl;

		s = read();
		if (s.back() == '!')
			return 0;

		int xdir = (mx == 0 ? +1 : -1);

		cout << mx + xdir << " " << my << endl;

		s = read();
		if (s.back() == '!')
			return 0;

		if (xdir == -1) {
			if (s == closer)
				rx = mx - 1;
			else
				lx = mx;
		}
		else {
			if (s == closer)
				lx = mx + 1;
			else
				rx = mx;
		}

		int ydir = (my == 0 ? +1 : -1);

		cout << mx + xdir << " " << my + ydir << endl;

		s = read();
		if (s.back() == '!')
			return 0;

		if (ydir == -1) {
			if (s == closer)
				ry = my - 1;
			else
				ly = my;
		}
		else {
			if (s == closer)
				ly = my + 1;
			else
				ry = my;
		}
	}

	return 0;
}