#include <iostream>
#include <vector>
#include <map>
#include <iterator>
#include <string>
#include <cassert>
#include <algorithm>

using namespace std;

const int M = 1e6;

long long dist(long long x, long long y) {
	return (x - 566ll) * (x - 566ll) + (y - 239ll) * (y - 239ll);
}

int g = 0;
int px = -1, py = -1;
string read(int x, int y) {
	g++;
	cout << x << " " << y << endl;
	//if (dist(x, y) < dist(px, py)) cout << "c" << endl;
	//else if (dist(x, y) > dist(px, py)) cout << "f" << endl;
	//else cout << "k" << endl;
	px = x; py = y;
	string s;
	getline(cin, s);
	while (s.size() > 0 && (s.back() == '\n' || s.back() == ' '))
		s.pop_back();
	return s;
}

int main() {
	string closer, further;

	string s = read(0, 0);
	if (s.back() == '!')
		return 0;

	s = read(0, 1);
	if (s.back() == '!')
		return 0;

	string x = s;

	s = read(1, 1);
	if (s.back() == '!')
		return 0;

	string y = s;

	s = read(0, 0);
	if (s.back() == '!')
		return 0;

	string z = s;

	int lx = 0, rx = M, ly = 0, ry = M;

	if (x == y) {
		closer = x;
		further = z;
	}
	else {
		closer = (x == z ? y : x);
		further = z;
	}

	bool tt = false;
	int lxdir, lydir;
	while (true) {
		rx = max(lx, rx);
		ry = max(ly, ry);
		//cout << "bbb: " << lx << " " << rx << "  " << ly << " " << ry << endl;

		int mx = (lx + rx) / 2;
		int my = (ly + ry) / 2;

		s = read(mx, my);
		if (s.back() == '!')
			return 0;

		if (tt) {
			if (s == closer) {
				if (lxdir == -1) {
					if (lx + 1 < rx)
						rx = (rx + mx) / 2;
				}
				else {
					if (lx + 1 < rx)
						lx = (lx + mx) / 2;
				}

				if (lydir == -1) {
					if (ly + 1 < ry)
						ry = (ry + my) / 2;
				}
				else {
					if (ly + 1 < ry)
						ly = (ly + my) / 2;
				}
			}
			else if (s == further) {
				if (lxdir == -1) {
					if (lx + 1 < rx)
						lx = (lx + mx) / 2;
				}
				else {
					if (lx + 1 < rx)
						rx = (rx + mx) / 2;
				}

				if (lydir == -1) {
					if (ly + 1 < ry)
						ly = (ly + my) / 2;
				}
				else {
					if (ly + 1 < ry)
						ry = (ry + my) / 2;
				}
			}
		}

		int xdir = (lx == rx ? 0 : (mx == 0 ? +1 : -1));
		if (lx + 1 == rx) {
			xdir = 1;

			s = read(mx + 1, my);
			if (s.back() == '!')
				return 0;

			if (s == closer)
				lx = rx;
			else
				rx = lx;
		}
		else if (xdir != 0) {
			s = read(mx + xdir, my);
			if (s.back() == '!')
				return 0;

			if (s == closer)
				lxdir = xdir;
			else
				lxdir = -xdir;

			if (xdir == -1) {
				if (s == closer)
					rx = mx - 1;
				else
					lx = mx;
			}
			else {
				if (s == closer)
					lx = mx + 1;
				else
					rx = mx;
			}
		}

		int ydir = (ly == ry ? 0 : (my == 0 ? +1 : -1));
		if (ly + 1 == ry) {
			ydir = 1;

			s = read(mx + xdir, my + 1);
			if (s.back() == '!')
				return 0;

			if (s == closer)
				ly = ry;
			else
				ry = ly;
		}
		else if (ydir != 0) {
			s = read(mx + xdir, my + ydir);
			if (s.back() == '!')
				return 0;

			if (s == closer)
				lydir = ydir;
			else
				lydir = -ydir;

			if (ydir == -1) {
				if (s == closer)
					ry = my - 1;
				else
					ly = my;
			}
			else {
				if (s == closer)
					ly = my + 1;
				else
					ry = my;
			}
		}

		tt = true;
	}

	return 0;
}