#include <iostream>
#include <vector>
#include <map>
#include <iterator>
#include <string>
#include <cassert>

using namespace std;

const int M = 1e6;

int g = 0;
string read(int x, int y) {
	g++;
	cout << x << " " << y << endl;
	string s;
	getline(cin, s);
	while (s.size() > 0 && (s.back() == '\n' || s.back() == ' '))
		s.pop_back();
	return s;
}

int main() {
	string closer, further;

	string s = read(0, 0);
	if (s.back() == '!')
		return 0;

	s = read(0, 1);
	if (s.back() == '!')
		return 0;

	string x = s;

	s = read(1, 1);
	if (s.back() == '!')
		return 0;

	string y = s;

	s = read(0, 0);
	if (s.back() == '!')
		return 0;

	string z = s;

	int lx = 0, rx = M, ly = 0, ry = M;

	if (x == y) {
		closer = x;
		further = z;
	}
	else {
		closer = (x == z ? y : x);
		further = z;
	}

	while (true) {
		int mx = (lx + rx) / 2;
		int my = (ly + ry) / 2;

		s = read(mx, my);
		if (s.back() == '!')
			return 0;

		int xdir = (lx == rx ? 0 : (mx == 0 ? +1 : -1));
		if (xdir != 0) {
			s = read(mx + xdir, my);
			if (s.back() == '!')
				return 0;

			if (xdir == -1) {
				if (s == closer)
					rx = mx - 1;
				else
					lx = mx;
			}
			else {
				if (s == closer)
					lx = mx + 1;
				else
					rx = mx;
			}
		}

		int ydir = (ly == ry ? 0 : (my == 0 ? +1 : -1));
		if (ydir != 0) {
			s = read(mx + xdir, my + ydir);
			if (s.back() == '!')
				return 0;

			if (ydir == -1) {
				if (s == closer)
					ry = my - 1;
				else
					ly = my;
			}
			else {
				if (s == closer)
					ly = my + 1;
				else
					ry = my;
			}
		}
	}

	return 0;
}