#include <iostream>
#include <vector>
#define ff first
#define ss second
using namespace std;
using pii = pair<int, int>;

void Solve() {
  int n, a, b;
  cin >> n >> a >> b;
  vector<pii> games;
  while (a > 0 && games.size() < n) {
    games.push_back({1, 0});
    a--;
  }
  while (b > 0 && games.size() < n) {
    games.push_back({0, 1});
    b--;
  }
  while (a-- > 0) games[0].ff++;
  while (b-- > 0) games[n-1].ss++;

  while (games.size() < n) games.push_back({0, 0});

  int draws = 0;
  for (pii &game : games) draws += game.ff == game.ss;

  cout << draws << endl;
  for (pii &game : games) cout << game.ff << ":" << game.ss << endl;

}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
//  cin >> tt;
  while (tt--) {
    Solve();
  }
  return 0;
}
