#include <iostream>
#include <vector>
#define ff first
#define ss second
using namespace std;
using pii = pair<int, int>;

void Solve() {
  /*int n, a, b;
  cin >> n >> a >> b;
  vector<pii> games;

  if (n == 1) {
    cout << a << ":" << b << endl;
    return;
  }

  games.push_back({a, 0});
  games.push_back({0, b});

  while (games.size() < n && games[0].ff > 0 && games[1].ss > 0) {
    if (games[0].ff > 0) {
      games.push_back({1, 0});
      games[0].ff--;
    }
    if (games[1].ss < 0) {
      games.push_back({0, 1});
      games[1].ss--;
    }
  }

  while (games.size() < n) games.push_back({0, 0});

  int draws = 0;
  for (pii &game : games) draws += game.ff == game.ss;

  cout << draws << endl;
  for (pii &game : games) cout << game.ff << ":" << game.ss << endl;*/

  int n, a, b;
  cin >> n >> a >> b;

  bool swapped = false;
  if (a > b) {
    swapped = true;
    std::swap(a, b);
  }

  std::vector <std::pair <int, int>> games;
  games.reserve(n);

  while (a > 0 && games.size() < n - 1) {
    games.emplace_back(1, 0);
    --a;
  }

  while (b > 0 && games.size() < n - 1) {
    games.emplace_back(0, 1);
    --b;
  }

  if (a == 0 && b == 0) {
    while (games.size() < n) {
      games.emplace_back(0, 0);
    }
  } else {
    games.emplace_back(a, b);
  }

  int draws = 0;
  for (auto& [x, y] : games) {
    draws += (x == y);
    if (swapped) {
      std::swap(x, y);
    }
  }

  std::cout << draws << "\n";
  for (const auto& [x, y] : games) {
    std::cout << x << ":" << y << "\n";
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
//  cin >> tt;
  while (tt--) {
    Solve();
  }
  return 0;
}
