#include <bits/stdc++.h>
using namespace std;

#define INF 1000000000
#define vec vector
#define pii pair<int, int>
#define all(m) m.begin(), m.end()
#define rall(m) m.rbegin(), m.rend()
#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0)

template<class T>
istream &operator>> (istream& in, vector<T> &arr) {
    for (T& el : arr) in >> el;
    return in;
}

template<class T>
ostream &operator<< (ostream& out, vector<T> &arr) {
    for (int i = 0; i < arr.size(); i++) out << arr[i] << ' ';
    return out;
}

void show(vector<pair<int, int>> &ans) {
    cout << "YES\n";
    cout << ans.size() << '\n';
    for (auto el : ans) {
        cout << el.first + 1 << ' ' << el.second + 1 << '\n';
    }
}


int main() {
    fast;
    int n, k;
    cin >> n >> k;
    vector <int> ans(n, -1);
    vector<vector<int>> lists(k, vector<int>(n));
    for (int i = 0; i < k; ++i){
        for (int j = 0; j < n; ++j){
            cin >> lists[i][j];
            lists[i][j]--;
        }
    }
    while (lists[0].size() > 1) {
        vector<vector<bool>> neigh_mask(n, vector<bool>(n, false));
        vector<pair<int, int>> neigh(n, {-1, -1});
        vector<int> neigh_cnt(n, 0);
        for (auto &list: lists) {
            neigh_cnt[list[0]] = INF;
            neigh_cnt[list[list.size() - 1]] = INF;
            for (int i = 1; i < list.size() - 1; ++i) {
                if (!neigh_mask[list[i]][list[i - 1]]) {
                    neigh_cnt[list[i]] += 1;
                    neigh_mask[list[i]][list[i - 1]] = true;
                    if (neigh[list[i]].first != -1) {
                        neigh[list[i]].second = list[i - 1];
                    } else {
                        neigh[list[i]].first = list[i - 1];
                    }
                }
                if (!neigh_mask[list[i]][list[i + 1]]) {
                    neigh_cnt[list[i]] += 1;
                    neigh_mask[list[i]][list[i + 1]] = true;
                    if (neigh[list[i]].first != -1) {
                        neigh[list[i]].second = list[i + 1];
                    } else {
                        neigh[list[i]].first = list[i + 1];
                    }
                }
            }
        }
        vector<bool> mask_pre(n, false);
        for (int i = 0; i < n; ++i) {
            if (neigh_cnt[i] == 2) {
                ans[neigh[i].first] = i + 1;
                ans[neigh[i].second] = i + 1;
                mask_pre[neigh[i].first] = true;
                mask_pre[neigh[i].second] = true;
            }
        }
        vector<vector<int>> nlists(k, vector<int>());
        for (int i = 0; i < k; ++i) {
            for (int item: lists[i]) {
                if (!mask_pre[item]) nlists[i].push_back(item);
            }
        }
        lists = nlists;
    }
    cout << ans;
    return 0;
}
