#include<iostream>
#include<vector>
#include<list>
#include<algorithm>

int main() {
	int n, k;
	std::cin >> n >> k;

	if (n == 2 && k == 1) {
		std::cout << "YES\n" << 1 << std::endl << "1 2" << std::endl;
		return 0;
	}

	if (n <= k) {
		std::cout << "NO\n";
		return 0;
	}
	else
		std::cout << "YES\n";

	if (k == 1) {
		std::cout << n << '\n';
		for (int i = 0; i < n; i++)
			std::cout << i + 1 << ' ' << (i + 1) % n + 1 << '\n';
		return 0;
	}

	std::list<std::pair<int, int>> result;

	for (int i = 0; i <= k / 2; i++)
		for (int r = i + 1; r < n - i; r++)
			result.push_back({ i + 1, r + 1 });

	if (k % 2 == 1)
		result.push_back({ n >> 1, (n >> 1) + 1 });

	std::cout << result.size() << '\n';
	for (auto& el : result)
		std::cout << el.first << ' ' << el.second << '\n';
	
}