#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cassert>
#include <random>
#include <map>
using namespace std;
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second
#define m_p make_pair
const int N = 100005;

int n;
int a[N];

int u[N];
bool c[N];

int p[N], q[N];

bool solv()
{
	for (int i = 1; i <= n; ++i)
		u[a[i]] = i;
	if (n <= 5)
	{
		for (int i = 1; i <= n; ++i)
		{
			q[i] = i;
		}
		do
		{
			for (int i = 1; i <= n; ++i)
			{
				p[q[i]] = u[i];
			}
			bool z = true;
			for (int i = 1; i <= n; ++i)
			{
				if (p[i] == i || q[i] == i)
				{
					z = false;
					break;
				}
				if (a[p[q[i]]] != i)
				{
					z = false;
					break;
				}
			}
			if (z)
			{
				cout << "Possible\n";
				for (int i = 1; i <= n; ++i)
					cout << p[i] << ' ';
				cout << "\n";
				for (int i = 1; i <= n; ++i)
					cout << q[i] << ' ';
				cout << "\n";
				return true;
			}
		} while (next_permutation(q + 1, q + n + 1));
		cout << "Impossible\n";
		return false;
	}

	for (int i = 1; i <= n; ++i)
		c[i] = false;
	vector<vector<int> > vv;
	for (int i = 1; i <= n; ++i)
	{
		if (c[i])
			continue;
		int x = i;
		vector<int> v;
		while (!c[x])
		{
			c[x] = true;
			v.push_back(x);
			x = u[x];
		}
		vv.push_back(v);
	}

	int maxu = 0;
	for (int i = 0; i < sz(vv); ++i)
		maxu = max(maxu, sz(vv[i]));

	vector<int> v;
	for (int i = 0; i < sz(vv); ++i)
	{
		for (int j = 0; j < sz(vv[i]); ++j)
			v.push_back(vv[i][j]);
	}

	if (maxu + maxu > n)
	{
		v.clear();
		vector<int> u;
		for (int i = 0; i < sz(vv); ++i)
		{
			if (sz(vv[i]) == maxu)
			{
				for (int j = 0; j < sz(vv[i]); j += 2)
				{
					v.push_back(vv[i][j]);
				}
				for (int j = 1; j < sz(vv[i]); j += 2)
				{
					v.push_back(vv[i][j]);
				}
			}
			else
			{
				for (int j = 0; j < sz(vv[i]); ++j)
				{
					u.push_back(vv[i][j]);
				}
			}
		}
		reverse(all(v));

		vector<int> nv;
		for (int i = 0; i < sz(v); ++i)
		{
			nv.push_back(v[i]);
			if (i < sz(u))
				nv.push_back(u[i]);
		}
		v = nv;
		maxu = 1;
	}

	for (int i = 0; i < n; ++i)
	{
		q[v[i]] = v[(i + maxu) % n];
	}

	for (int i = 1; i <= n; ++i)
	{
		p[q[i]] = u[i];
	}

	for (int i = 1; i <= n; ++i)
	{
		assert(a[p[q[i]]] == i);
	}

	for (int i = 1; i <= n; ++i)
	{
		if (p[i] == i || q[i] == i)
		{
			cout << "Impossible\n";
			/*for (int i = 0; i < sz(vv); ++i)
				cout << sz(vv[i]) << ' ';
			exit(0);*/
			return false;
		}
	}
	cout << "Possible\n";
	for (int i = 1; i <= n; ++i)
		cout << p[i] << ' ';
	cout << "\n";
	for (int i = 1; i <= n; ++i)
		cout << q[i] << ' ';
	cout << "\n";

	sort(p + 1, p + n + 1);
	sort(q + 1, q + n + 1);
	for (int i = 1; i <= n; ++i)
	{
		assert(p[i] == i);
		assert(q[i] == i);
	}
	return true;
}

int main()
{
#ifdef BOMB
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif

	/*cin >> n;
	for (int i = 1; i <= n; ++i)
		a[i] = i;
	do
	{
		if (!solv())
		{
			for (int i = 1; i <= n; ++i)
				cout << a[i] << ' ';
			cout << "\n";
			solv();
			solv();
			solv();
			return 0;
		}
	} while (next_permutation(a + 1, a + n + 1));
	return 0;*/

	int tt = 1;
	cin >> tt;
	while (tt--)
	{
		cin >> n;
		for (int i = 1; i <= n; ++i)
			cin >> a[i];
		solv();
	}
	return 0;
}