#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;

int main() 
{
	cin.tie();
	cout.tie();
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;

	map<int, vector<int>> mp;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;

		for (int j = 0; j < k; ++j)
		{
			int a;
			cin >> a;
			mp[i].push_back(a);
		}
	}

	ll split = 0, combine = 0;

	map<int, vector<int>> res;
	for (int i = 0; i < n; ++i) {
		auto& vec = mp[i];
		int k = mp[i].size();

		vector<int> curr(1, vec[0]);
		for (int j = 0; j < k - 1; ++j)
		{
			if (vec[j] < vec[j + 1]) {
				curr.push_back(vec[j + 1]);
			}
			else {
				res[curr[0]] = curr;
				curr.clear();
				curr.push_back(vec[j + 1]);
				++split;
			}
		}
		res[curr[0]] = curr;
	}

	vector<int> v = res.begin()->second;
	res.erase(res.begin());
	for (auto it = res.begin(); it != res.end();) {
		++combine;
		if (it->first < v.back()) {
			++split;
			for (int i = 0; i < v.size(); ++i) {
				if (it->first < v[i]) {
					vector<int> curr(v.begin() + i, v.end());
					res[curr[0]] = curr;
					v.erase(v.begin() + i, v.end());
					for (int j = 0; j < it->second.size(); ++j) {
						v.push_back(it->second[j]);
					}
					break;
				}
			}
		}
		else {
			for (int j = 0; j < it->second.size(); ++j) {
				v.push_back(it->second[j]);
			}
		}
		it = res.erase(it);
	}

	cout << split << " " << combine << endl;



	//int n, k;
	//cin >> n >> k;
	//vector<int> vec(n);
	//vector<int> ans(n);
	//for (int i = 0; i < n; ++i)
	//{
	//	cin >> vec[i];
	//}

	//int asc = 0;
	//int cnt = 1;
	//int change_cnt = 0;
	//ans[0] = vec[0];
	//for (int i = 1; i < n; ++i)
	//{
	//	ans[i] = vec[i];

	//	if (asc == 0)
	//	{
	//		if (vec[i] > vec[i - 1])
	//			asc = 1;
	//		else if (vec[i] < vec[i - 1])
	//			asc = -1;
	//		cnt++;
	//	}

	//	else if (asc == 1)
	//	{
	//		if (vec[i] >= vec[i - 1])
	//			cnt++;
	//		else
	//		{
	//			cnt = 1;
	//			asc = -1;
	//		}
	//	}

	//	else if (asc == -1)
	//	{
	//		if (vec[i] <= vec[i - 1])
	//			cnt++;
	//		else
	//		{
	//			cnt = 1;
	//			asc = 1;
	//		}
	//	}

	//	if (cnt >= k)
	//	{
	//		change_cnt++;
	//		if (asc == 1)
	//		{
	//			if (i >= n - 2)
	//			{
	//				ans[i] = 0;
	//			}
	//			else
	//			{
	//				if (vec[i + 1] < vec[i + 2])
	//				{
	//					ans[i] = vec[i - 1] - 1;
	//				}
	//				else if (vec[i + 1] > vec[i + 2])
	//				{
	//					ans[i] = 0;
	//				}
	//				else
	//				{
	//					if (vec[i + 1] >= vec[i - 1] - 1 || i + k - 1 >= n)
	//					{
	//						ans[i] = 0;
	//					}
	//					else
	//					{
	//						ans[i] = 0;
	//						for (int j = i + 1; j <= i + k - 1; ++j)
	//						{
	//							if (vec[j] < vec[j - 1])
	//							{
	//								ans[i] = 0;
	//								break;
	//							}

	//							if (vec[j] > vec[j - 1])
	//							{
	//								ans[i] = vec[i - 1] - 1;
	//								break;
	//							}
	//						}
	//					}
	//				}
	//			}
	//		}

	//		if (asc == -1)
	//		{
	//			if (i >= n - 2)
	//			{
	//				ans[i] = 100000;
	//			}
	//			else
	//			{
	//				if (vec[i + 1] > vec[i + 2])
	//				{
	//					ans[i] = vec[i - 1] - 1;
	//				}
	//				else if (vec[i + 1] < vec[i + 2])
	//				{
	//					ans[i] = 100000;
	//				}
	//				else
	//				{
	//					if (vec[i + 1] >= vec[i - 1] - 1 || i + k - 1 >= n)
	//					{
	//						ans[i] = 0;
	//					}
	//					else
	//					{
	//						ans[i] = 100000;
	//						for (int j = i + 1; j <= i + k - 1; ++j)
	//						{
	//							if (vec[j] > vec[j - 1])
	//							{
	//								ans[i] = 100000;
	//								break;
	//							}

	//							if (vec[j] > vec[j - 1])
	//							{
	//								ans[i] = vec[i - 1] + 1;
	//								break;
	//							}
	//						}
	//					}
	//				}
	//			}
	//		}

	//		if (asc == 0)
	//		{
	//			--i;
	//			if (i >= n - 2)
	//			{
	//				ans[i] = 100000;
	//			}
	//			else
	//			{
	//				if (vec[i + 1] > vec[i + 2])
	//				{
	//					ans[i] = 0;
	//				}
	//				else if (vec[i + 1] < vec[i + 2])
	//				{
	//					ans[i] = 100000;
	//				}
	//				else
	//				{
	//					if (vec[i + 1] >= vec[i - 1] - 1 || i + k - 1 >= n)
	//					{
	//						ans[i] = 0;
	//					}
	//					else
	//					{
	//						ans[i] = 100000;
	//						for (int j = i + 1; j <= i + k - 1; ++j)
	//						{
	//							if (vec[j] > vec[j - 1])
	//							{
	//								ans[i] = 100000;
	//								break;
	//							}

	//							if (vec[j] > vec[j - 1])
	//							{
	//								ans[i] = 0;
	//								break;
	//							}
	//						}
	//					}
	//				}
	//			}
	//		}

	//		asc = 0;
	//		cnt = 1;
	//	}
	//}

	//cout << change_cnt << endl;
	//for (int i = 0; i < n; ++i)
	//{
	//	cout << ans[i] << ' ';
	//}
	//cout << endl;
}
/*
2
3 3 5 8
2 9 2
*/
