#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;

void printv(vector<set<int> > &v) {
	for (int i = 0; i < v.size(); ++i) {
		cout << i << ": ";
		for (auto& el : v[i])
			cout << el << " ";
		cout << endl;
	}
}

int main() 
{
	cin.tie();
	cout.tie();
	ios_base::sync_with_stdio(false);

	int n, k;
	cin >> n >> k;
	if (1 == n) {
		cout << "YES" << endl;
		cout << 0 << endl;
		return 0;
	}
	if (k == n) {
		cout << "NO" << endl;
		return 0;
	}
	if (k == 1) {
		cout << "YES" << endl;
		cout << n - 1 << endl;
		for (int i = 1; i <= n; ++i) {
			cout << i << " " << (i) % n + 1 << endl;
		}
		return 0;
	}
	cout << "YES" << endl;
	
	vector<vector<int>> g(n);

	set<pll> s;

	for (int i = 0; i < k + 1; ++i) {
		if (i % 2 == 1)
			continue;
		for (int j = i + 1; j < k + 1; ++j) {
			s.emplace(i, j);
		}
	}

	for (int i = k + 1; i < n; ++i) {
		s.emplace(0, i);
	}
	
	cout << s.size() << endl;
	for (auto el : s) {
		cout << el.first + 1 << " " << el.second + 1 << endl;
	}
}
/*
2
3 3 5 8
2 9 2
*/
