#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
//    cout << n << '\n';
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }

    vector<int> y(n);
    for (int i = 0; i < n; ++i) {
        y[a[i]] = i;
    }

    vector<int> back_y(n);
    for (int i = 0; i < n; ++i) {
        back_y[y[i]] = i;
    }
//
//    for (int i = 0; i < n; ++i) {
//        cout << a[i] + 1 << ' ';
//    }
//    cout << '\n';


    vector<int> answer(n, -1);


    vector<vector<int>> ones;
    vector<vector<int>> twos;
    vector<vector<int>> cycles;

    vector<int> used(n);

    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        vector<int> cycle = {i};
        used[i] = 1;
        int x = y[i];
        while (!used[x]) {
            cycle.push_back(x);
            used[x] = 1;
            x = y[x];
        }
        if ((int)cycle.size() == 1) {
            ones.push_back(cycle);
        } else if ((int) cycle.size() == 2) {
            twos.push_back(cycle);
        } else {
            cycles.push_back(cycle);
        }
    }

    while ((int)twos.size() > 1) {
        auto first = twos.back();
        auto second = twos[twos.size() - 2];
        twos.pop_back(); twos.pop_back();

        answer[back_y[first[0]]] = second[0];
        answer[back_y[first[1]]] = second[1];
        answer[back_y[second[0]]] = first[0];
        answer[back_y[second[1]]] = first[1];
    }

    if (twos.size() == 1 && ones.size() > 1) {
        auto two = twos[0];
        twos.clear();
        auto first = ones.back()[0];
        auto second = ones[ones.size() - 2][0];
        ones.pop_back(); ones.pop_back();

        answer[back_y[two[0]]] = first;
        answer[back_y[two[1]]] = second;
        answer[back_y[first]] = two[0];
        answer[back_y[second]] = two[1];

    }

    while ((int)ones.size() > 1) {
        int m = ones.size();
        for (int i = 0; i < m; ++i) {
            int first = ones[i][0];
            int second = ones[(i + 1) % m][0];
            answer[back_y[first]] = second;
        }
        ones.clear();
    }



    for (auto& cycle : cycles) {
        int m = cycle.size();
        for (int i = 0; i < m; ++i) {
            answer[back_y[cycle[i]]] = cycle[(i + 2) % m];
        }
    }

    if (ones.size() + twos.size() > 0) {
        if (cycles.size() == 0) {
            cout << "Impossible\n";
            return;
        }

        auto cycle = cycles.back();
        int ind = 0;
        if (ones.size() > 0) {
            int x = ones[0][0];
            answer[back_y[x]] = answer[back_y[cycle[ind]]];
            answer[back_y[cycle[ind]]] = x;
            ++ind;
        }
        if (twos.size() > 0) {
            auto two = twos[0];
            answer[back_y[two[0]]] = answer[back_y[cycle[ind]]];
            answer[back_y[two[1]]] = answer[back_y[cycle[ind + 1]]];
            answer[back_y[cycle[ind]]] = two[0];
            answer[back_y[cycle[ind + 1]]] = two[1];
        }
    }

    for (int i = 0; i < n; ++i) {
        assert(answer[i] != -1);
    }

    cout << "Possible\n";


    vector<int> indd(n);
    for (int i = 0; i < n; ++i) {
        indd[answer[i]] = y[i];
    }

    for (int i = 0; i < n; ++i) {
        cout << indd[i] + 1 << ' ';
    }
    cout << '\n';
    for (int i = 0; i < n; ++i) {
        cout << answer[i] + 1 << ' ';
    }
    cout << '\n';



}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}