#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void print(vector<pair<int, int>>& vec)
{
	cout << "YES\n" << vec.size() << "\n";
	for (auto& p : vec)
	{
		cout << p.first << " " << p.second << "\n";
	}
}

int main() {

	int n, k;
	cin >> n >> k;
	if (k >= n - 1)
	{
		cout << "NO\n";
		return 0;
	}
	vector<pair<int, int>> res;
	for (int i = 1; i < n; ++i) res.push_back({ i, i + 1 });
	res.push_back({ n, 1 });

	int current = 3;
	int cnt = 1;
	for (int i = 2; i <= k; ++i)
	{
		int u = 1;
		for (int j = 0; j < cnt; ++j)
		{
			res.push_back({ u, current });
			u += 2;
		}
		++current;
		if (current & 1) cnt++;
	}

	print(res);
	return 0;
}
