#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;
int k;

void print(vector<pair<int, int>>& vec, int& n)
{
	vector<int> d(n + 1);
	cout << "YES\n" << vec.size() << "\n";
	for (auto& p : vec)
	{
		cout << p.first << " " << p.second << "\n";
		d[p.first]++;
		d[p.second]++;
	}
	sort(d.begin(), d.end());
	d.resize(unique(d.begin(), d.end()) - d.begin());
	assert(d.size() == k + 1);
}

int main() {

	int n;
	cin >> n >> k;

	if (n == 1)
	{
		cout << "YES\n0";
		return 0;
	}
	if (k == n - 1)
	{
		vector<pair<int, int>> res;
		for (int i = 1; i <= n; ++i)
		{
			if (i % 2 && i != n)
			{
				res.push_back({ i, i + 1 });
				continue;
			}
			for (int j = i + 1; j <= n; ++j)
			{
				res.push_back({ i, j });
			}
		}
		print(res, n);
		return 0;
	}
	if (k == n)
	{
		cout << "NO\n";
		return 0;
	}
	vector<pair<int, int>> res;
	for (int i = 1; i < n; ++i) res.push_back({ i, i + 1 });
	res.push_back({ n, 1 });

	int current = 3;
	int cnt = 1;
	for (int i = 2; i <= k; ++i)
	{
		int u = 1;
		for (int j = 0; j < cnt; ++j)
		{
			res.push_back({ u, current });
			u += 2;
		}
		++current;
		if (current & 1) cnt++;
	}

	print(res, n);
	return 0;
}
