#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
using namespace std;


using ll = long long;
using ull = unsigned long long;

void solve() {
	int n;
	cin >> n;
	vector<vector<int>> in(n);
	vector<int> all;
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		for (int j = 0; j < x; ++j) {
			int k;
			cin >> k;
			in[i].push_back(k);
			all.push_back(k);
		}
		
	}
	sort(all.begin(), all.end());
	map<int, int> indexes;
	for (int i = 0; i < all.size(); ++i) {
		indexes[all[i]] = i;
	}
	int count = 0;
	for (int i = 0; i < n; ++i) {
		int last = indexes[in[i][0]];
		for (int j = 1; j < in[i].size(); ++j) {
			if (indexes[in[i][j]] != last + 1) {
				++count;
			}
			last = indexes[in[i][j]];
		}
	}
	cout << count << ' ' << count + n - 1 << endl;
}

int main(int, char **) 
{
#ifdef _LOCAL_
	freopen("in.txt", "r", stdin);
#endif
	constexpr int mult = 0;
	int x = 1;
	if (mult) cin >> x;
	while (x --> 0) solve();
	return 0;
}