#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <map>
#include <random>
#include <vector>
#include <string>
using namespace std;


using ll = long long;
using ull = unsigned long long;

int counsst = 0;

string guess(int x, int y) {
	cout << x << ' ' << y << endl;
	string str;
	getline(cin, str);
	for (int i = 0; i < str.size(); ++i) {
		if (str[i] == '!') {
			exit(0);
		}
	}
	++counsst;
	if (counsst > 64) {
		throw 0;
	}
	return str;
}

string cold;
string hot;
string same;

bool is_hot(string s) {
	return s == hot or s == same;
}

bool is_cold(string s) {
	return s == cold or s == same;
}


void solve() {
	const int max_pos = 1000000;
	guess(0, 1);
	string guess1 = guess(0, 0);
	string guess2 = guess(1, 0);
	string guess3 = guess(1, 0);

	if (guess1 == guess2) {
		string guess4 = guess(max_pos - 1, max_pos);
		string guess5 = guess(max_pos, max_pos);
		string guess6 = guess(max_pos, max_pos - 1);
		if (guess5 == guess6) {
			guess(0, max_pos);
			guess(max_pos, 0);
		}
		else {
			cold = guess5;
			hot = guess6;
			same = guess3;
			if (guess1 != cold) {
				const int y_pos = 0;
				int left = 2;
				int right = max_pos;
				while (true) {
					guess(left, y_pos);
					if (is_cold(guess(right, y_pos))) {
						int mid = (left + right + 1) / 2;
						if (mid == right) {
							right = mid + 1;
						}
						else {
							right = mid;
						}
					}
					else {
						int mid = (left + right) / 2;
						if (mid == left) {
							left = mid - 1;
						}
						else {
							left = mid;
						}
					}
				}
			}
			else {
				const int x_pos = 0;
				int left = 2;
				int right = max_pos;
				while (true) {
					guess(x_pos, left);
					if (guess(x_pos, right) == cold) {
						right = (left + right + 1) / 2;
					}
					else {
						left = (left + right) / 2;
					}
				}
			}
		}
	}
	else {
		cold = guess1;
		hot = guess2;
		same = guess3;
		int left = 1, right = max_pos, down = 1, up = max_pos;
		while (true) {
			guess(left, up);
			string g1 = guess(left, down);
			string g2 = guess(right, down);
			int mid_x = (left + right) / 2;
			int mid_y = (down + up) / 2;
			if (is_cold(g1) && is_cold(g2)) {
				right = (left + right) / 2;
				down = (down + up + 1) / 2;
			}
			else if (is_cold(g1) && is_hot(g2)) {
				left = (left + right + 1) / 2;
				down = (down + up + 1) / 2;
			}
			else if (is_hot(g1) && is_cold(g2)) {
				right = (left + right) / 2;
				up = (down + up) / 2;
			}
			else {
				left = (left + right + 1) / 2;
				up = (down + up) / 2;
			}
		}
	}
}

int main(int, char **) 
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _LOCAL_
	// freopen("in.txt", "r", stdin);
#endif
	constexpr int mult = 0;
	int x = 1;
	if (mult) cin >> x;
	while (x --> 0) solve();
	return 0;
}