#include <iostream>
#include <algorithm>
#include <iso646.h>
#include <numeric>

int main() {
    int n;
    std::cin >> n;
    std::vector<std::vector<long long>> vec(n, std::vector<long long>{});
    std::vector<long long> sorted{};
    for (int i = 0; i < n; ++i) {
        int k;
        std::cin >> k;
        vec[i] = std::vector<long long>(k);
        for (int j = 0; j < k; ++j) {
            long long el;
            std::cin >> el;
            vec[i][j] = el;
            sorted.push_back(el);
        }
    }
    std::sort(sorted.begin(), sorted.end());
    std::vector<int> subseq_count(n);
    auto it = sorted.end();
    for (int i = 0; i < vec.size(); ++i) {  // vec is a vector of chunks
        it = sorted.end();
        auto v = vec[i];
        for (auto el : v) {  // v is a chunk
            if (it == sorted.end() or el != *it) {
                it = std::find(sorted.begin(), sorted.end(), el);
                subseq_count[i]++;
            }
            it++;
        }
    }
    long long sum_of_chunk_counts = std::accumulate(subseq_count.begin(), subseq_count.end(), 0);
    std::cout << sum_of_chunk_counts - n << ' ' << sum_of_chunk_counts - 1 << std::endl;
    return 0;
}
