#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <cstddef>
#include <iomanip>
#include <stack>
#include <deque>
#include <list>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>

using namespace std;


bool ifNotEqual(const vector<int>& a, const vector<int>& b) {
	bool answer = true;
	for (int i = 0; i < a.size(); ++i) {
		if (a[i] == b[i])
		{
			answer = false;
			break;
		}
	}
	return answer;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	int a;
	int b;
	cin >> n >> a >> b;
	vector<int> vec_a(n, 0);
	vector<int> vec_b(n, 0);

	while (a > 0 || b > 0) {
		//Case 1
		if (ifNotEqual(vec_a, vec_b) == false) {
			if (a > 0) {
				for (int i = 0; i < n; ++i) {
					if (vec_a[i] == vec_b[i]) {
						++vec_a[i];
						--a;
						break;
					}
				}
			}
			else {
				for (int i = 0; i < n; ++i) {
					if (vec_b[i] == vec_a[i]) {
						++vec_b[i];
						--b;
						break;
					}
				}
			}
		} //Case 2
		else {
			bool if_a_greater_b = false;
			for (int i = 0; i < n; ++i) {
				if (vec_a[i] > vec_b[i]) {
					if_a_greater_b = true;
				}
			}
			if (a > 0 && if_a_greater_b) {
				for (int i = 0; i < n; ++i) {
					if (vec_a[i] > vec_b[i]) {
						++vec_a[i];
						--a;
						break;
					}
				}
			}
	/*new*/	else if (a > 0) {
				for (int i = 0; i < n; ++i) {
					if (i == n - 1) {
						++vec_a[i];
						--a;
						break;
					}
					if (vec_a[i] + 1 != vec_b[i]) {
						++vec_a[i];
						--a;
						break;
					}
				}
			}
			else {
				bool a_is_abs_greater_b = true;
				for (int i = 0; i < n; ++i) {
					if (vec_a[i] < vec_b[i]) {
						a_is_abs_greater_b = false;
					}
				}
				if (a == 0 && a_is_abs_greater_b) {
					for (int i = 0; i < n; ++i) {
						if (i == n-1) {
							++vec_b[i];
							--b;
							break;
						}
						if (vec_b[i] + 1 != vec_a[i]) {
							++vec_b[i];
							--b;
							break;
						}
					}
				}
				else {
					for (int i = 0; i < n; ++i) {
						if (vec_b[i] > vec_a[i]) {
							++vec_b[i];
							--b;
							break;
						}
					}
				}
			}
		}
	}

	int draws = 0;
	for (int i = 0; i < n; ++i) {
		if (vec_a[i] == vec_b[i]) {
			++draws;
		}
	}
	cout << draws << endl;
	for (int i = 0; i < n; ++i) {
		cout << vec_a[i] << ":" << vec_b[i] << endl;
	}
	return 0;
}