#pragma optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;

mt19937 rng(time(0));

vector<int> apply(vector<int> a, vector<int> b)
{
    vector<int>res(a.size());
    for (int i = 0; i < a.size(); i++) {
        res[i] = a[b[i]];
    }
    return res;
}

vector<int> inv(vector<int> a, vector<int> b)
{
    vector<int> res(a.size()), pos(b.size());
    for (int i = 0; i < b.size(); i++) {
        pos[b[i]] = i;
    }
    for (int i = 0; i < a.size(); i++) {
        res[i] = pos[a[i]];
    }
    return res;
}

int main() {
    #ifdef zxc
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    ios_base::sync_with_stdio(0);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n), b(n), I(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            a[i]--;
            b[i] = i;
            I[i] = i;
        }
        auto ia = inv(I, a);
        int it = 0, lim = 80;
        while (it < lim) {
            it += 1;
            shuffle(b.begin(), b.end(), rng);
            auto c = inv(ia, b);
            int good = 1;
            for (int i = 0; i < n; i++) {
                if (b[i] == i || c[i] == i) {
                    good = 0;
                    break;
                }
            }
            if (!good) continue;
            //assert(apply(a, apply(b, c)) == I);
            cout << "Possible" << "\n";
            for (int x : b) cout << x + 1 << " ";
            cout << "\n";
            for (int x : c) cout << x + 1 << " ";
            cout << "\n";
            break;
        }
        if (it == lim) {
            cout << "Impossible\n";
        }
    }
}
