#pragma optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;

mt19937 rng(time(0));

vector<int> apply(vector<int> a, vector<int> b)
{
    vector<int>res(a.size());
    for (int i = 0; i < a.size(); i++) {
        res[i] = a[b[i]];
    }
    return res;
}

vector<int> inv(vector<int> a, vector<int> b)
{
    vector<int> res(a.size()), pos(b.size());
    for (int i = 0; i < b.size(); i++) {
        pos[b[i]] = i;
    }
    for (int i = 0; i < a.size(); i++) {
        res[i] = pos[a[i]];
    }
    return res;
}

int main() {
    #ifdef zxc
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    ios_base::sync_with_stdio(0);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n), b(n), I(n), p(n), q(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            a[i]--;
            I[i] = i;
        }
        auto f = inv(I, a);
        //for (int x : f) cout << x << " ";
        //cout << endl;
        set<int> s;
        for (int i = 0; i < n; i++) s.insert(i);
        for (int i = 4; i < n; i++) {
            for (int x : s){
                if (x == f[i] || x == i) continue;
                //cout << x << " " << f[i] << endl;
                p[x] = f[i];
                q[i] = x;
                s.erase(x);
                break;
            }
        }
        int rem = min(4, n);
        vector<int> ord(rem);
        for (int i = 0; i < rem; i++) {
            b[i] = *s.begin();
            ord[i] = i;
            s.erase(s.begin());
            //cout << b[i] << " " << f[i] << endl;
        }
        int good = 0;
        do {
            good = 1;
            for (int i = 0; i < rem; i++) {
                int x = b[ord[i]];
                if (x == f[i] || x == i) {
                    good = 0;
                    break;
                }
            }
            if (good) {
                for (int i = 0; i < rem; i++) {
                    int x = b[ord[i]];
                    //cout << x << " " << f[i] << " " << ord[i] << endl;
                    p[x] = f[i];
                    q[i] = x;
                }
            }
        } while (!good && next_permutation(ord.begin(), ord.end()));

        if (good) {
            //for (int x : p) cout << x + 1 << " "; cout << endl;
            //for (int x : q) cout << x + 1 << " "; cout << endl;
            assert(apply(a, apply(p, q)) == I);
            cout << "Possible\n";
            for (int x : p) cout << x + 1 << " ";
            cout << "\n";
            for (int x : q) cout << x + 1 << " ";
            cout << "\n";
        } else {
            cout << "Impossible\n";
        }
    }
}
