#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;
using li = long long;
using ld = long double;
using pii = pair<int, int>;


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n>> k;

    if(n == k) {
        cout << "NO" << endl;
        return 0;
    }

    if(k == 1) {
        cout << "YES" << endl;
        cout << n << endl;
        for(int i = 0; i < n; i++)
            cout << (i + 1) << ' ' << (i + 1) % n + 1 << endl;
        return 0;
    }

    vector<pii> e;
    vector<int> deg(n, 0);
    for(int i = k; i >= 0; i--) {
//        cout << i << ' ' << deg[i] << endl;
        if(deg[i] <= i) {
            for(int j = i - 1; j >= 0 && deg[i] <= i; j--) {
                if(deg[j] <= j) {
                    deg[j]++;
                    deg[i]++;
                    e.emplace_back(i, j);
                }
            }
        }
    }

    for(int i = k + 1; i < n; i++) {
//        e.emplace_back(i, i == k ? 0 : i - 1);
        e.emplace_back(i, k);
        deg[e.back().f]++;
        deg[e.back().s]++;
    }

//    assert(set<int>(deg.begin(), deg.end()).size() == k);

    cout << "YES" << endl;

    cout << e.size() << endl;
    for(auto ed : e)
        cout << ed.f + 1 << ' ' << ed.s + 1 << endl;

//    int t = 1;
//    cin >> t;
//
//    while(t--)
//        solve();
}
