#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using vi = vector<long long>;
#define int long long

#ifdef vstu
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x)
#endif // vstu

template<typename T>
ostream& operator<<(ostream& o, vector<T>& a){
    for(auto& el : a)
        o << el << " ";
    o << "\n";
    return o;
}

void fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

bool checker(vi a, vi p, vi q){
    for (int i = 0; i < a.size(); ++i){
        if (a[p[q[i] - 1] - 1] != i + 1)
            return 0;
    }
    return 1;
}

void solve(){
    int n; cin >> n;
    vector<int> a(n);
    for(int i = 0; i < n; ++i)
        cin >> a[i];

    //dbg(a);

    vector<pair<int,int>> v(n);
    for(int i = 0; i < n; ++i){
        v[i].first = a[i];
        v[i].second = i + 1;
    }

    sort(v.begin(), v.end());

    vector<int> b(n);
    for(int i = 0; i < n; ++i){
        b[i] = v[i].second;
    }

    set<int> ban;
    for(int i = 1; i < n; ++i){
        ban.insert(i);
    }

    for(int i = 0; i < n; ++i){
        int res = a[i] - (i + 1);
        if(a[i] < (i + 1)){
            res += n;
        }
        if(ban.count(res)) ban.erase(ban.find(res));
    }

    if(ban.empty()){
        cout << "Impossible" << "\n";
    }
    else{
            cout << "Possible" << "\n";
        vector<int> q(n);
        for(int i = 0; i < n; ++i){
            q[i] = i + 1;
        }
        int ind = *ban.begin();

        vector<int> p(n);

        for(int i = 0; i < n; ++i){
            p[i] = b[(n+ i - ind) % n];
        }

        for(int i = 0; i < n; ++i){
            q[i] += ind;
            q[i] %= n;
            if(q[i] == 0) q[i] = n;
        }

        if (!checker(a, p, q)){
            dbg(p); dbg(q);
            //exit(1);
        }
        cout << p;
        cout << q;

    }
    return;

}

signed main()
{
    #ifdef vstu
    //freopen("file.txt", "r", stdin);
    #endif // vstu
    //fast();
    int t = 1;
    cin >> t;

    vi a = {1, 2, 3, 4, 5};

    //do{
    //    dbg(a);
    //    solve(a);
    //}   while(next_permutation(a.begin(), a.end()));

    while(t--){
        solve();
    }


    return 0;
}
