#include<bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define X first
#define Y second
#define forn(i, n) for(int i = 0;i < n;i++)
#define For(i, a, b) for(int i = a;i < b;i++)
#define forr(i, a) for(auto & i : a)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;
using vpi = vector<pii>;

vector<vi> matr;
vi ans;
int n, k;
void calc(vi cur_pos, vector<map<int, int>>& rows, int parent){
    if (cur_pos.size() == 1){
        ans[cur_pos[0]] = parent;
        return;
    }
    int root = -1;
    
    forr(i, cur_pos) {
        if (rows[i].size() == 2){
            int qq = -1, ww = -1;
            forr(j, rows[i]) {
                if (qq == -1){
                    qq = j.X;
                } else {
                    ww = j.X;
                }
            }
            if (qq != k - ww){
                continue;
            }
            root = i;
            break;
        }
    }
    if (root == -1) forr(i, cur_pos) {
        if (rows[i].size() == 1){
            root = i;
            break;
        }
    }
    ans[root] = parent;
    // exit(0);
    map<int, vi> mp;
    forr(i, cur_pos) if (i != root ){
        mp[matr[root][i]].pb(i);
    }

    forr(i, cur_pos){
        if (root != i){
            int index = matr[i][root];
            rows[i][index]--;
            if (rows[i][index] == 0){
                rows[i].erase(index);
            }
        }
    }


    vi left, right;
    if (mp.size() == 1){
        vi cur = mp.begin() -> Y;
        
        forn(i, cur.size() / 2){
            left.pb(cur[i]);
        }
        For(i, cur.size() / 2, cur.size()){
            right.pb(cur[i]);
        }
    } else {
        forr(i, mp){
            if (left.size() == 0){
                left = i.Y;
            } else {
                right = i.Y;
            }
        }
    }
    
    forr(i, left){
        forr(j, right){
            int index = matr[i][j];
            rows[i][index]--;
            if (rows[i][index] == 0){
                rows[i].erase(index);
            }
        }
    }
    calc(left, rows, root);
    forr(i, left){
        forr(j, right){
            int index = matr[i][j];
            rows[i][index]++;
        }
    }


    forr(i, right){
        forr(j, left){
            int index = matr[i][j];
            rows[i][index]--;
            if (rows[i][index] == 0){
                rows[i].erase(index);
            }
        }
    }
    calc(right, rows, root);
    forr(i, right){
        forr(j, left){
            int index = matr[i][j];
            rows[i][index]++;
        }
    }



    forr(i, cur_pos){
        if (root != i){
            int index = matr[i][root];
            rows[i][index]++;
        }
    }
}

void solve(){
    
    cin >> n >> k;
    matr.resize(n, vi(n));
    forn(i, k){
        vi b(n);
        forn(j, n){
            cin >> b[j];
        }
        forn(j1, n){
            For(j2, j1 + 1, n){
                matr[b[j2] - 1][b[j1] - 1]++;
            }
        }
    }

    
    vi cur_pos;
    forn(i, n) cur_pos.pb(i);
    vector<map<int, int>> rows(n);
    forn(i, n){
        forn(j, n) if (i != j){
            rows[i][matr[i][j]]++;
        }
    }
    ans.resize(n, -1);
    calc(cur_pos, rows, -1);
    forn(i, n){
        if (ans[i] == -1) cout << ans[i] << ' ';
        else cout << ans[i] + 1 << ' ';
    }
    cout << endl;
}

signed main(){
    cin.tie(0) -> sync_with_stdio(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while(t--) solve();   
    return 0;
}