#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int main()
{
	int n;
	cin >> n;
	vector<int> all;
	all.reserve(10'000);
	vector<vector<int>> towers(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		towers[i].resize(k);
		for (int& j : towers[i]) {
			cin >> j;
			all.push_back(j);
		}
		sort(towers[i].begin(), towers[i].end());
	}
	sort(all.begin(), all.end());
	int k = 0;
	for (int i = 0; i < n; ++i) {
		auto st = lower_bound(all.begin(), all.end(), towers[i].front());
		for (int j : towers[i]) {
			if (*st == j) {
				++st;
			}
			else {
				st = lower_bound(all.begin(), all.end(), j);
				++k;
			}
		}
	}
	cout << k << " " << n + k - 1 << endl;
}