#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int main()
{
	int n, k;
	cin >> n >> k;

	if (k >= n) 
	{
		cout << "NO";
		return 0;
	}

	vector<vector<int>> vv(n);

	for (int i = 0; i < n; ++i)
	{
		vv[i] = vector<int>(n);
		for (int j = i+1; j < n; ++j)
		{
			vv[i][j] = 1;
		}
	}

	for (int i = 1; i <= k - 1; ++i)
	{
		int l = 1;
		int r = 1 + i;
		while (l < r)
		{
			vv[l][r] = 0;
			++l;
			--r;
		}
	}

	cout << "YES" << endl;
	
	vector<pair<int, int>> result;

	for (int i = 0; i < n; ++i)
	{
		for (int j = i + 1; j < n; ++j)
		{
			if (vv[i][j] == 1)
				result.push_back(pair<int, int>(i, j));
		}
	}

	cout << result.size() << endl;
	for (auto p : result)
		cout << p.first+1 << " " << p.second+1 << endl;

}