
#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <unordered_set>

using namespace std;

int a[100][1000];
int p[1000];
int n, k;

void rec(int l, int r, int pr = -1) {
    if (l == r) {
        p[a[0][l]] = pr;
        return;
    }

    for (int rooti = l + 1; rooti < r; ++rooti) {
        int root = a[0][rooti];
        unordered_set<int> le, ri;
        for (int j = l; j < rooti; ++j) {
            le.insert(a[0][j]);
        }
        for (int j = rooti + 1; j <= r; ++j) {
            ri.insert(a[0][j]);
        }

        bool fl = 0;

        for (int i = 1; i < k; ++i) {
            int cur_root_i;
            for (int j = l; j <= r; ++j) {
                if (a[i][j] == root) {
                    cur_root_i = j;
                    break;
                }
            }

            for (int j = l; j < cur_root_i; ++j) {
                if (bool(le.find(a[i][j]) == le.end()) != bool(le.find(a[i][l]) == le.end())) {
                    fl = 1;
                    break;
                }
            }
            for (int j = cur_root_i + 1; j <= r; ++j) {
                if (bool(ri.find(a[i][j]) == ri.end()) != bool(ri.find(a[i][r]) == ri.end())) {
                    fl = 1;
                    break;
                }
            }
            if (fl) {
                break;
            }
        }

        if (!fl) {
            for (int i = 1; i < k; ++i) {
                vector<int> vle, vri;
                int cur_root_i = -1;
                for (int j = l; j <= r; ++j) {
                    if (a[i][j] == root) {
                        cur_root_i = j;
                        break;
                    }
                }

                if (cur_root_i == -1) {
                    exit(2);
                }

                for (int j = l; j < cur_root_i; ++j)
                    vle.push_back(a[i][j]);
                for (int j = cur_root_i + 1; j <= r; ++j)
                    vri.push_back(a[i][j]);
                if (le.find(vle[0]) == le.end()) {
                    swap(vle, vri);
                }

                bool kek = 0;
                int it = 0;
                int jt = 0;
                for (int j = l; j <= r; ++j) {
                    if (j == le.size()) {
                        kek = 1;
                        continue;
                    }
                    if (!kek) {
                        a[i][j] = vle[it++];
                    } else {
                        a[i][j] = vri[jt++];
                    }
                }
            }

            p[root] = pr;
            rec(l, rooti - 1, root);
            rec(rooti + 1, r, root);
            return;
        }
    }
}

int main() {
    cin >> n >> k;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
            --a[i][j];
        }
    }
    for (int i = 0; i < n; ++i) {
        p[i] = INT_MAX;
    }
    rec(0, n - 1, -2);
    for (int i = 0; i < n; ++i) {
        cout << p[i] + 1 << ' ';
    }
    cout << '\n';
}