#include<bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using D = double;
using vi = vector<int>;
using ii = pair<int, int>;
using vii = vector<ii>;
using vl = vector<ll>;

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define re return
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) x.size()

const int inf = 2e9 + 10;

bool fix(vi &a, vi &b) {
    int n = sz(a);
    for (int i = 0; i < n; i++) {
        if (a[b[i]] == b[i] || b[i] == i) {
            bool done = false;
            for (int lim = 0; lim < n * 6; lim++) {
                int ch = rand() % n;
                if (b[i] != a[b[ch]] && b[ch] != a[b[i]] && ch != b[i] && i != b[ch]) {
                    swap(a[b[i]], a[b[ch]]);
                    swap(b[i], b[ch]);
                    done = true;
                    break;
                }
            }
            if (!done) {
                for (int ch = 0; ch < n; ch++) {
                    if (b[i] != a[b[ch]] && b[ch] != a[b[i]] && ch != b[i] && i != b[ch]) {
                        swap(a[b[i]], a[b[ch]]);
                        swap(b[i], b[ch]);
                        done = true;
                        break;
                    }
                }
            }
            if (!done) {
                return false;
            }
        }
    }
    return true;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;

    while(t--) {
        int n;
        cin >> n;
        vi v(n);
        for (int i = 0; i < n; i++) {
            cin >> v[i];
            v[i]--;
        }
        if (n == 1 || (n == 2 && v[0] == 1)) {
            cout << "Impossible\n";
        } else {
            vi per(n);
            for (int i = 0; i < n; i++) {
                per[v[i]] = i;
            }
            vi a(n), b(n);
            for (int i = 0; i < n; i++) {
                a[i] = per[n - 1 - i];
                b[i] = n - 1 - i;
            }
            auto res = fix(a, b);
            if (!res) {
                cout << "Impossible\n";
            } else {
                cout << "Possible\n";
                for (auto x : a) {
                    cout << x + 1 << ' ';
                }

                cout << "\n";

                for (auto x : b) {
                    cout << x + 1 << ' ';
                }
                cout << "\n";
            }
        }

    }


    return 0;
}
