#include<bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using D = double;
using vi = vector<int>;
using vvi = vector<vi>;
using ii = pair<int, int>;
using vii = vector<ii>;
using vl = vector<ll>;

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define re return
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) x.size()

const int inf = 2e9 + 10;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;

    vvi tow(n);
    vvi fir(n);
    vvi lst(n);

    bool init = true;

    set<pair<int, ii>> s;

    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        tow[i].resize(k);
        fir[i].resize(k);
        lst[i].resize(k);
        fir[i][0] = 1;
        lst[i][k - 1] = 1;
        for (int j = 0; j < k; j++) {
            cin >> tow[i][j];
            s.insert({tow[i][j], {i, j}});
        }
    }

    auto cur = (--s.end())->first;

    auto spl = 0;
    auto com = 0;

    for (int i = 0; i < s.size(); i++) {
        auto v = *(--s.end());
        s.erase(v);
        int k = v.se.fi;
        int idx = v.se.se;
        if (!lst[k][idx]) {
            spl++;
            if (idx < sz(tow[k])) {
                fir[k][idx + 1] = 1;
            }
        }
        while (idx > 0 && !s.empty() && tow[k][idx - 1] == (--s.end())->first) {
            idx--;
            s.erase((--s.end()));
        }

        if (spl || !init) {
            com++;
        }
        init = false;

        if (!fir[k][idx]) {
            spl++;
            if(idx > 0) {
                lst[k][idx - 1] = 1;
            }
        }

    }
    cout << spl << ' ' << com;
    return 0;
}
