#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n;
	cin >> n;
	vector<vector<int>> a(n);
	vector<int> all;

	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		for (int j = 0; j < k; j++) {
			int x;
			cin >> x;
			a[i].push_back(x);
			all.push_back(x);
		}
	}

	map<int, int> pos;

	sort(all.begin(), all.end());

	for (int i = 0; i < all.size(); i++) {
		pos[all[i]] = i;
	}

	int p = 0, q = 0;

	for (int i = 0; i < n; i++) {
		int k = a[i].size();
		int cur = 0;
		for (int j = 0; j < k - 1; j++) {
			if (pos[a[i][j + 1]] - pos[a[i][j]] != 1) {
				cur++;
			}
		}
		p += cur;
		q += (cur + 1);
	}

	cout << p << ' ' << q - 1 << '\n';


	return 0;
}