#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <cstdlib>

using namespace std;

using ll = long long;

int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

#endif

	int n, k;
	cin >> n >> k;

	vector<vector<int>> g(n + 1, vector<int>(n + 1, 1));
	for (int i = 0; i <= n; i++)
	{
		g[i][i] = 0;
	}

	for (int i = n; i > 0 && k > 0; i--)
	{
		int step = 0;
		for (int j = 1; j <= n; j++)
			step += g[i][j];
		int need = i - 1;
		int toRemove = max(0, step - need);
		for (int j = i - 1; j > 0 && toRemove > 0; j--)
		{
			if (g[i][j])
			{
				g[i][j] = 0;
				g[j][i] = 0;
				toRemove--;
			}
		}
		if (toRemove <= 0)
			k--;
	}

	//for (int i = 1; i <= n; i++)
	//{
	//	for (int j = 1; j <= n; j++)
	//		cout << g[i][j] << " ";
	//	cout << "\n";
	//}
	//cout << "==============\n";
	//for (int i = 1; i <= n; i++)
	//{
	//	int res = 0;
	//	for (int j = 1; j <= n; j++)
	//		res += g[i][j];
	//	cout << res << " ";
	//}
	//cout << "\n";

	if (k > 0)
	{
		cout << "NO\n";
		return 0;
	}

	int edges = 0;
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= i; j++)
		{
			edges += g[i][j];
		}
	}
	cout << "YES\n";
	cout << edges << "\n";
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= i; j++)
		{
			if (g[i][j])
				cout << i << " " << j << "\n";
		}
	}
	return 0;
}