#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define f first
#define s second
#define all(x) (x).begin(), (x).end()
using namespace std;

void K () {
    int n, k; cin >> n >> k;
    vector<set<int>> adj(n + 1);
    if (k != n) {
        cout << "YES" << endl;
        if (k == 1) {
            cout << n << endl;
            for (int i = 1; i <= n; ++i) {
                if (i == n)
                    cout << i << ' ' << 1 << endl;
                else
                    cout << i << ' ' << i + 1 << endl;
            }
            return;
        }

        if (k == 2) {
            for (int i = 1; i < n; ++i) {
                cout << i << ' ' << i + 1 << endl;
            }
            return;
        }

        for (int i = 1; i < n; ++i) {
            adj[1].insert(i + 1);
            adj[i + 1].insert(1);
        }
        
        int digits = k - 2;
        int last = n;
        for (int i = 2; i <= n && digits > 0; ++i) {
            if (digits > 1) {
                for (int j = i + 1; j < last; ++j) {
                    adj[i].insert(j);
                    adj[j].insert(i);
                }
                --last; digits -= 2;
            } else {
                adj[i].insert(i + 1);
                adj[i + 1].insert(i);
                break;
            }
        }

        set<pair<int, int>> s;
        for (int i = 1; i <= n; ++i) {
            for (auto e : adj[i]) {
                int a = i, b = e;
                if (a > b) swap(a, b);
                if (s.count({a, b})) continue;
                s.insert({a, b});
            }
        }

        cout << s.size() << endl;
        for (auto [x, y] : s) cout << x << ' ' << y << endl;

    }
    else{
        cout << "NO\n";
    }
}

int test = 0;

void solve(){
    int n;
    cin >> n;
    set<pii>st;
    vector<int>pos(n + 1), cnt(n + 1, n - 1);
    for(int i = 1; i <= n; i++){
        int x;
        cin >> x;
        pos[x] = i;
        cnt[pos[x]] -= pos[x] != x;
    }
    for(int i = 1; i <= n; i++) {
        st.insert({cnt[i], i});
    }
    if(n < 3){
        cout << "Impossible\n";
        return;
    }
    vector<int>q(n + 1), p(n + 1);
    for(int i = 1; i + 3 <= n; i++) {
        for(auto it = st.begin(); it != st.end(); it++){
            if(it->second == pos[i] || it->second == i) continue;
            q[i] = it->second;
            st.erase(it);
            break;
        }
        if(st.count({cnt[pos[i]], pos[i]})){
            st.erase({cnt[pos[i]], pos[i]});
            cnt[pos[i]]++;
            st.insert({cnt[pos[i]], pos[i]});
        }
        if(st.count({cnt[i], i})){
            st.erase({cnt[i], i});
            cnt[i]++;
            st.insert({cnt[i], i});
        }
    }
    vector<int>b;
    for(auto [x, y]: st) b.push_back(y);
    sort(all(b));
    do{
        int ok = 1;
        for(int i = n - 2; i <= n; i++){
            ok &= (b[i - (n - 2)] != i) && (b[i - (n - 2)] != pos[i]);
        }
        if(ok){
            for(int i = n - 2; i <= n; i++){
                q[i] = b[i - (n - 2)];
            }
            break;
        }
    } while(next_permutation(all(b)));
    for(int i = 1; i <= n; i++){
        if(q[i] == 0){
            cout << "Impossible\n";
            cout << test << '\n';
            exit(0);
            return;
        }
        p[q[i]] = pos[i];
    }
    cout << "Possible\n";
    for(int i = 1; i <= n; i++) cout << p[i] << ' ';
    cout << '\n';
    for(int i = 1; i <= n; i++) cout << q[i] << ' ';
    cout << '\n';
    for(int i = 1; i <= n; i++){
        assert(p[q[i]] == pos[i]);
        assert(p[i] != i);
        assert(q[i] != i);
    }
}

void another_K(){
    int n, k;
    cin >> n >> k;
    if(k == n){
        cout << "NO\n";
    }
    else{
        cout << "YES\n";
        if(k == 1){
            cout << n << '\n';
            for(int i = 1; i < n; i++){
                cout << i << ' ' << i + 1 << '\n';
            }
            cout << n << ' ' << 1 << '\n';
            return;
        }

    }
}

void gen(int n){
    vector<int>a(n);
    int tot = 1;
    for(int i = 1; i <= n; i++){
        tot *= i;
    }
    cout << tot << '\n';
    iota(all(a), 1);
    do{
        cout << n << "\n";
        for(auto x: a) cout << x << ' ';
        cout << '\n';
    } while(next_permutation(all(a)));
}

int32_t main() {
   ios_base::sync_with_stdio(0); cin.tie(0);
   //gen(89);
   /*
   int t;
   cin >> t;
   while(t--){
       test++;
       solve();
   }
   */

   K();
}
