import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class K {
    static BufferedReader br;
    static PrintWriter pw;
    static StringTokenizer st;

    static String nextToken() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return st.nextToken();
    }

    static int nextInt() {
        return Integer.parseInt(nextToken());
    }

    static long nextLong() {
        return Long.parseLong(nextToken());
    }

    static String nextLine() {
        try {
            return br.readLine();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    static char next() {
        try {
            return (char) br.read();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    public static void main(String[] args) {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        int t = 1;
        for (int i = 0; i < t; i++) {
            solve();
        }
        pw.close();
    }

    private static void solve() {
        int n = nextInt();
        int k = nextInt();
        if (n == 1 && k == 0) {
            pw.println("YES");
            pw.println(0);
            return;
        }
        if (n == 2 && k == 1) {
            pw.println("YES");
            pw.println(1);
            pw.println("1 2");
            return;
        }
        if (k >= n || k == 0) {
            pw.println("NO");
            return;
        }

        if (k == 1) {
            pw.println("YES");
            pw.println(n);
            for (int i = 1; i < n; i++) {
                pw.printf("%d %d\n", i, i + 1);
            }
            pw.printf("%d %d\n", 1, n);
        } else {
            pw.println("YES");
            int count = n - 1;

            for (int i = 3; i <= k; i++) {
                if (i == 3) {
                    count++;
                } else {
                    for (int j = 3; j < i; j++) {
                        if (j != 4) {
                            count++;
                        }
                    }
                }
            }
            pw.println(count);
            for (int i = 2; i <= n; i++) {
                pw.printf("%d %d\n", 1, i);
            }
            for (int i = 3; i <= k; i++) {
                if (i == 3) {
                    pw.printf("%d %d\n", 2, 3);
                } else {
                    for (int j = 3; j < i; j++) {
                        if (j != 4) {
                            pw.printf("%d %d\n", j, i);
                        }
                    }
                }
            }
        }
    }
}