#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define all(v) v.begin(), v.end()

void solve()
{
	int n, a, b;
	cin >> n >> a >> b;
	
	if (n == 1)
	{
		cout << (int)(a == b) << '\n' << a << ':' << b;
	}
	else if (a + b <= n)
	{
		cout << n - a - b << '\n';
		for (int i = 0; i < a; i++)
		{
			cout << "1:0\n";
		}
		for (int i = 0; i < b; i++)
		{
			cout << "0:1\n";
		}
		for (int i = 0; i < n-a-b; i++)
		{
			cout << "0:0\n";
		}
	}
	else
	{
		cout << "0\n";
		bool agreater = a >= b;
		if (agreater)
		{
			swap(a, b);
		}
		while (n > 1 && a > 0)
		{
			n--; a--;
			if (agreater)
			{
				cout << "0:1\n";
			}
			else
			{
				cout << "1:0\n";
			}
		}
		while (n > 1)
		{
			n--; b--;
			if (!agreater)
			{
				cout << "0:1\n";
			}
			else
			{
				cout << "1:0\n";
			}
		}
		
		if (agreater)
		{
			swap(a, b);
		}
		cout << a << ':' << b;
	}
}

int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(false);
#ifdef _DEBUG
	FILE* fin;
	freopen_s(&fin, "../input.txt", "r", stdin);
#endif
	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
		cout << '\n';
	}
}
