#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <unordered_set>
#include <numeric>

using namespace std;

#define all(v) v.begin(), v.end()
using ld = long double;
using ll = long long;
typedef vector<int> vi;

void solve()
{
	int n, k;
	cin >> n >> k;

	if (k == 1)
	{
		cout << "YES\n";
		if (n != 1)
		{
			if (n != 2)
			{
				cout << n << '\n';
				for (int i = 1; i < n; i++)
				{
					cout << i << ' ' << i + 1 << '\n';
				}
				cout << n << " 1\n";
			}
			else
			{
				cout << "1\n1 2";
			}
		}
		else
		{
			cout << 0;
		}
	}
	else
	{
		if (k > n - 1) {
			cout << "NO\n";
			return;
		}

		vi cnt(n + 1, 1);
		cnt[0] = cnt[1] = n - 1;
		vector<vi> m(n + 1, vi(n + 1));
		for (int i = 2; i <= n; i++) {
			m[1][i] = 1;
			m[i][1] = 1;
		}

		{
			if (2 == k)
			{
				cout << "YES\n";
				int sum = accumulate(++cnt.begin(), cnt.end(), 0);
				cout << sum / 2 << "\n";
				for (int i = 1; i <= n; i++) {
					for (int j = i + 1; j <= n; j++) {
						if (m[i][j])
							cout << i << " " << j << "\n";
					}
				}
				return;
			}
		}

		for (int i = 2; i < n; i++)
		{
			for (int j = i + 1; j <= n - i + 1; j++)
			{
				cnt[i]++;
				cnt[j]++;
				m[i][j] = m[j][i] = 1;
				unordered_set<int> uset(all(cnt));
				if (uset.size() == k)
				{
					cout << "YES\n";
					int sum = accumulate(++cnt.begin(), cnt.end(), 0);
					cout << sum / 2 << "\n";
					for (int i = 1; i <= n; i++) {
						for (int j = i + 1; j <= n; j++) {
							if (m[i][j])
								cout << i << " " << j << "\n";
						}
					}
					return;
				}
			}
		}
		cout << "NO\n";
	}
}

int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(false);
#ifdef _DEBUG
	FILE* fin;
	freopen_s(&fin, "../input.txt", "r", stdin);
#endif
	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
		cout << '\n';
	}
}
