
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <stack>
#include <queue>
#include <bitset>
#include <list>
#include <fstream>
#include <ctime>

#define vll vector<ll>
#define vvll vector<vll>
using ll = long long;
using LL = long long;
#define forn(i,n) for(ll i = 0;i< n; i++)
#define foran(i,a,n) for(ll i = a;i< n; i++)

using namespace std;



void solve() {
	ll n; cin >> n;
	ll k; cin >> k;

	ll sumN = 2;
	foran(i, 1, k) {
		sumN += i;
	}
	if (sumN > n) {
		cout << "NO\n";
		return;
	}
	

	if (k == 1 and n > 2) {
		cout << "YES\n";
		cout << n << '\n';
		forn(i, n - 1) {
			cout << i + 1 << " " << i + 2 << '\n';
			
		}
		cout << n << " " << 1 << '\n';
		return;
	}

	cout << "YES\n";

	vvll G;
	G.push_back(vll());


	ll ost = n - 1;

	ll ans = 0;
	forn(i, k) {
		ll cur = G.size() - 1;
		forn(j, i + 1) {
			ans++;

			G[cur].push_back(G.size());
			G.push_back(vll());
			ost--;
		}
	}

	ans += ost;

	while (G.size() != n) {
		G[G.size() - 1].push_back(G.size());
		G.push_back(vll());
	}
	

	cout << ans << '\n';
	vector<bool> used(n, 0);
	queue<ll> Q;
	Q.push(0);
	used[0] = 1;
	while (!Q.empty())
	{
		ll cur = Q.front();
		Q.pop();

		for (auto x : G[cur]) {
			if (!used[x]) {
				used[x] = 1;
				Q.push(x);
				cout << cur + 1 << " " << x + 1 << '\n';
			}
		}
	}


}

int main() {

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 

	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(2);

	int t = 1;
	//cin >> t;5

	while (t--) {
		solve();
	}

	return 0;
}