#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef set<ll> si;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	ll n, k;
	cin >> n >> k;

	if (n == 1)
	{
		cout << "NO\n";
		return 0;
	}
	if (k == 3 && n == 4)
	{
		cout << "YES\n4\n";
		cout << 1 << ' ' << 2 << '\n';
		cout << 1 << ' ' << 3 << '\n';
		cout << 2 << ' ' << 3 << '\n';
		cout << 3 << ' ' << 4 << '\n';
		return 0;
	}
	if (k == 2 && n == 3)
	{
		cout << "YES\n2\n";
		cout << 1 << ' ' << 2 << '\n';
		cout << 2 << ' ' << 3 << '\n';
		return 0;
	}
	if (k > n - 2)
	{
		cout << "NO";
		return 0;
	}

	vvi g(n + 1);
	for (int i = 1; i < n; i++)
	{
		g[i].push_back(i + 1);
	}
	if (k == 1 && n > 2)
		g[n].push_back(1);
	else if (n > 2)
	{
		k -= 2;
		ll lb = 2, ub = n - 2;

		for (int i = 1; k > 0 && ub != lb - 1 && i < n; i += 2)
		{
			ll possible = ub - lb;
			if (i == 1)
				possible++;
			for (int j = i + 2; j < n && possible > 0; j++)
			{
				g[i].push_back(j);
				possible--;
			}
			ub--; lb++;
			k -= 2;
		}

		if (k == -1 && (n != 5 && k != 3))
			g[n].push_back(2);
	}

	cout << "YES\n";
	ll siz = 0;
	for (int i = 1; i <= n; i++)
		siz += g[i].size();
	cout << siz << '\n';
	for (int i = 1; i <= n; i++)
	{
		for (int j = 0; j < g[i].size(); j++)
			cout << i << ' ' << g[i][j] << '\n';
	}

	return 0;
}