#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <random>

using namespace std;

#define int long long
#define fi first
#define se second


void solve() {
	int n;
	cin >> n;
	vector<int> a(n), p(n), q(n);
	bool found = false;
	for (int i = 0; i < n; ++i) cin >> a[i], --a[i];
	for (int j = 0; j < n; ++j) {
		for (int i = 0; i < n; ++i) {
			q[a[i]] = (i + j) % n;
			p[(i + j) % n] = i;
		}
		bool ok = true;
		for (int i = 0; i < n; ++i) {
			if (p[i] == i || q[i] == i && a[p[q[i]]] != i) {
				ok = false;
				break;
			}
		}
		if (!ok) continue;
		found = true;
		break;
	}
	if (found) {
		cout << "Possible\n";
		for (int i = 0; i < n; ++i) {
			cout << p[i] + 1 << ' ';
		}
		cout << '\n';
		for (int i = 0; i < n; ++i) {
			cout << q[i] + 1 << ' ';
		}
		cout << '\n';
	}
	else cout << "Impossible\n";
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(nullptr);

	int tt = 1;
	cin >> tt;
	while (tt--) solve();

}