#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <random>

using namespace std;

#define int long long
#define fi first
#define se second


void solve() {
	int n;
	cin >> n;
	vector<vector<int>> blocks;

	int splits = 0, combines = 0;

	for (int i = 0; i < n; ++i) {
		int size = 0;
		cin >> size;
		vector<int> block(size);
		for (int j = 0; j < size; ++j) {
			cin >> block[j];
		}
		vector<int> incr;
		incr.push_back(block[0]);
		for (int j = 1; j < size; ++j) {
			if (block[j] > block[j - 1]) {
				incr.push_back(block[j]);
			}
			else {
				blocks.push_back(incr);
				incr.clear();
				incr.push_back(block[j]);
				++splits;
			}
		}
		if (incr.size() > 0) {
			blocks.push_back(incr);
			incr.clear();
		}
	}

	sort(blocks.begin(), blocks.end());

	int curr_pos = 0;
	while (blocks.size()>1) {
		if (blocks[0][blocks[0].size() - 1] > blocks[1][0]) {
			while (blocks[0][curr_pos] < blocks[1][0]) ++curr_pos;
			int skolko = 0;
			if (blocks[1].size() == 1) --splits;
			while (blocks[1].size()>0 && blocks[1][0] < blocks[0][curr_pos]) {
				blocks[0].insert(blocks[0].begin() + curr_pos + skolko, blocks[1][0]);
				blocks[1].erase(blocks[1].begin());
				++curr_pos;
			}
			if (blocks[1].size() == 0) blocks.erase(blocks.begin() + 1);
			combines += 2;
			splits += 2;
		}
		else {
			for (auto i : blocks[1]) {
				blocks[0].push_back(i);
			}
			blocks.erase(blocks.begin() + 1);
			++combines;
		}
		
	}
	cout << splits << ' ' << combines;
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(nullptr);

	int tt = 1;
	while (tt--) solve();

}