#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <random>

using namespace std;

#define int long long
#define fi first
#define se second


void solve() {
	int n, k;
	cin >> n >> k;
	if (n == k) {
		cout << "NO\n";
		return;
	}
	if (n == 1 && k == 1) {
		cout << "YES\n";
		cout << "0\n";
		return;
	}
	if (n == 2 && k == 1) {
		cout << "YES\n";
		cout << "1\n1 2\n";
		return;
	}
	if (k == 1) {
		cout << "YES\n";
		cout << n << '\n';
		for (int i = 0; i < n; ++i) {
			cout << i + 1 << ' ' << ((i + 1) % n + 1) << '\n';
		}
		return;
	}
	if (k == 2) {
		cout << "YES\n";
		cout << n - 1 << '\n';
		for (int i = 0; i < n - 1; ++i) {
			cout << i + 1 << ' ' << i + 2 << '\n';
		}
		return;
	}
	vector<set<int>> g(n, set<int>());
	vector<pair<int, int>> ans;
	set<pair<int, int>> q = { {0, n - 1} };
	for (int i = 0; i < n - 1; ++i) {
		if (i == 0 || i == n - 2)
			q.insert({ 1, i });
		else q.insert({ 2, i });
		if (i != n - 2) {

			ans.push_back({ i, i + 1 });
			g[i].insert(i + 1);
			g[i + 1].insert(i);
		}
	}
	int cur = k;
	while (cur > 0) {
		auto s = *(q.rbegin());

		q.erase(s);
		int need = cur - s.first;
		while(need > 0){
			if (need == 0) break;
			for (auto elem : q) {
				if (!g[elem.second].count(s.se)) {

					auto k = elem;
					q.erase(k);
					k.first += 1;
					g[s.se].insert(elem.se);
					g[elem.se].insert(s.se);
					ans.push_back({ s.se, k.se });
					q.insert(k);
					need--;
					break;
				}
			}
		}
		cur--;
	}
	cout << "YES\n";
	int m = (int)ans.size();
	cout << m << '\n';
	for (int i = 0; i < m; ++i) {
		cout << ans[i].first + 1 << ' ' << ans[i].second + 1 << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(nullptr);

	int tt = 1;
	//cin >> tt;
	while (tt--) solve();

}