#include <iostream>
#include <string>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <list>

#define ll long long
#define ld long double

using namespace std;

int main() {
	int n;
	cin >> n;
	vector<vector<int>> a;
	vector<pair<int, int>> answers;
	ll split = 0, merge = 0;
	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		int value;
		cin >> value;
		a.push_back({ value });
		answers.push_back({ value, a.size() - 1 });
		for (int j = 1; j < t; j++) {
			cin >> value;
			if (a.back().back() < value) {
				a.back().push_back(value);
			}
			else {
				a.push_back({ value });
				split++;
			}
			answers.push_back({ value, a.size() - 1 });
		}
	}

	sort(answers.begin(), answers.end());

	priority_queue<pair<int, pair<int, int>>> q;

	int index = 1;
	int curCol = answers[0].second;
	for (int i = 1; i < answers.size(); i++, index++) {
		if (answers[i].second == curCol) {
			continue;
		}
		if (index < a[curCol].size()) {
			q.push({ -a[curCol][index], { curCol, index } });
			split++;
		}
		curCol = answers[i].second;
		if (!q.empty() && q.top().second.first == curCol) {
			index = q.top().second.second;
			q.pop();
		}
		else index = 0;
		merge++;
	}

	cout << split << " " << merge;

	return 0;
}

//for (int i = answers.size() - 1; i > 0; i--) {
//	if (answers[i].second == answers[i - 1].second) {
//		continue;
//	}
//	if (a[answers[i].second].size() > 1)
//	{
//		split++;
//		combine++;
//	}
//	combine++;
//}