#include <iostream>
#include <string>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <list>

#define ll long long
#define ld long double

using namespace std;


int main() {
	int n, k;
	cin >> n >> k;
	if (n == k) {
		cout << "NO";
		return 0;
	}
	if (k == 1) {
		cout << "YES" << endl;
		cout << n << endl;
		for (int i = 1; i <= n; i++) {
			if (i != n)
				cout << i << " " << i + 1 << endl;
			else 
				cout << i << " " << 1 << endl;
		}
		return 0;
	}
	vector<bool> visited(n, false);
	vector<vector<int>> g(n);
	int minn = 1;
	int maxx = n - 1;
	bool isMinn = true;
	int count = 0;
	int countOfEdges = 0;
	for (int i = 0; i < n; i++) {
		if (visited[i]) continue;
		count++;
		visited[i] = true;
		for (int j = 0; j < n && g[i].size() < (isMinn?minn:maxx); j++) {
			if (visited[j]) continue;
			g[i].push_back(j);
			g[j].push_back(i);
			countOfEdges++;
		}
		if (isMinn) minn++;
		else maxx--;
		isMinn = !isMinn;
		if (count == k) break;
	}

	visited.assign(n, false);

	cout << "YES" << endl;
	cout << countOfEdges << endl;
	for (int i = 0; i < n; i++) {
		if (visited[i]) continue;
		visited[i] = true;
		for (auto& dist : g[i]) {
			if (visited[dist]) continue;
			cout << i + 1 << " " << dist + 1 << endl;
		}
	}





	/*int t;
	cin >> t;
	while (t--)
	{
		int n;
		cin >> n;
		vector<int> a(n);
		vector<int> a_copy(n);
		vector<int> p(n);
		for (int i = 0; i < n; i++)
		{
			cin >> a[i];
			a_copy[i] = a[i];
			p[i] = i;
		}

		int prev = -1;
		int first = -1;
		for (int i = 0; i < n; i++)
		{
			if (a[i] != i + 1)
			{
				if (first == -1) first = i;
				if (prev != -1)
				{
					swap(a[i], a[prev]);
					swap(p[i], p[prev]);
				}
				prev = i;
			}
		}
		swap(a[prev], a[first]);
		swap(p[prev], p[first]);

		prev = -1;
		first = -1;
		for (int i = 0; i < n; i++)
		{
			if (a[i] == i + 1)
			{
				if (first == -1) first = i;
				if (prev != -1)
				{
					swap(a[i], a[prev]);
					swap(p[i], p[prev]);
				}
				prev = i;
			}
		}
		if (first != -1 && prev != -1)
		swap(a[prev], a[first]);
		swap(p[prev], p[first]);

		bool ans = true;

		for (int i = 0; i < n; i++)
		{
			if (a[i] == a_copy[i])
			{
				ans = false;
				for (int j = 0; j < n; j++)
				{
					if (a[i] != j + 1 && a[j] != i + 1 && i != j)
					{
						swap(a[i], a[j]);
						swap(p[i], p[j]);
						ans = true;
					}
				}
			}
		}

		if (ans)
		{
			cout << "Possible\n";
			for (int i = 0; i < n; i++)
			{
				cout << p[i] << " ";
			}
			cout << endl;
			for (int i = 0; i < n; i++)
			{
				cout << a[i] << " ";
			}
		}
		else
		{
			cout << "Impossible\n";
		}
		
	}*/

	return 0;
}