//#include <bits/stdc++.h>

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <string>

using namespace std;

//#define endl "\n"

const auto ready = []()
{
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	return true;
}();

struct super
{
	int cycle_num;
	vector<int> cycle;
	vector<int> indices;
};

pair<bool, vector<int>> find(const vector<int>& a)
{
	int n = a.size();
	vector<vector<int>> cycles;
	vector<int> used(n + 1);
	for (int i = 1; i <= n; ++i)
	{
		if (!used[i])
		{
			cycles.push_back({});
			cycles.back().push_back(i);
			used[i] = 1;
			if (a[i - 1] == i)
				continue;
			int next = a[i - 1];
			while (!used[next])
			{
				used[next] = 1;
				cycles.back().push_back(next);
				next = a[next - 1];
			}
		}
	}
	/*for (auto& el : cycles)
	{
		for (auto& elel : el)
		{
			cout << elel << " ";
		}
		cout << "\n";
	}*/

	int cnt1 = 0, cnt2 = 0, cntmore = 0;
	for (auto& el : cycles)
	{
		if (el.size() == 1) ++cnt1;
		if (el.size() == 2) ++cnt2;
		if (el.size() > 2) ++cntmore;
	}
	vector<super> tmp;

	for (int i = 0; i < cycles.size(); ++i)
	{
		tmp.push_back(super{ i, cycles[i], cycles[i] });
		auto& kek = tmp.back().cycle;
		if(kek.size() > 2)
			std::rotate(kek.begin(), kek.begin() + 2, kek.end());
	}

	std::sort(tmp.begin(), tmp.end(), [](auto& el1, auto& el2) {
		return el1.cycle.size() < el2.cycle.size();
		});

	if (n <= 2)
	{
		return { false, a };
	}

	if (n == 3 && cnt1 == 1 && cnt2 == 1)
	{
		return { false, a };
	}

	for (int i = 0; i < tmp.size() - 1; ++i)
	{
		if (tmp[i].cycle.size() > 2)
		{
			break;
		}
		if (tmp[i].cycle.size() == 1)
		{
			std::swap(tmp[i].cycle[0], tmp[i + 1].cycle[0]);
		}
		if (tmp[i].cycle.size() == 2)
		{
			std::swap(tmp[i].cycle[0], tmp[i + 1].cycle[0]);
			std::swap(tmp[i].cycle[1], tmp[i + 1].cycle[1]);
		}
	}

	if (cnt2 == 1)
	{
		for (int i = 0; i < tmp.size(); ++i)
		{
			if (tmp[i].cycle.size() == 2)
			{
				if (i == tmp.size() - 1)
				{
					std::swap(tmp[i].cycle[1], tmp[0].cycle[0]);
				}
				break;
			}
		}
	}
	vector<int> ans(n);
	std::sort(tmp.begin(), tmp.end(), [](auto& el1, auto& el2) {
	return el1.cycle_num < el2.cycle_num;
	});
	int ptr = 0;
	for (auto& el : tmp)
	{
		for (int i = 0; i < el.cycle.size(); ++i)
		{
			int index = el.indices[i];
			int to_put = el.cycle[i];
			ans[index - 1] = to_put;
		}
		
	}
	return { true, ans };
}

void solve()
{
	int n;
	cin >> n;
	vector<int> a(n);
	vector<pair<int, int> > c(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
		c[i] = { a[i], i + 1 };
	}
	sort(c.begin(), c.end());
	vector<int> d(n);
	for (int i = 0; i < n; ++i)
	{
		d[i] = c[i].second;
	}
	auto temp = find(d);
	bool ans = temp.first;
	if (!ans)
	{
		cout << "Impossible" << "\n";
		return;
	}
	vector<int> anss = temp.second;
	vector<int> q = anss;
	vector<int> p(n, -1);
	for (int i = 0; i < n; ++i)
	{
		p[q[i] - 1] = c[i].second;
	}
	cout << "Possible" << "\n";
	for (int i = 0; i < n; ++i)
	{
		cout << p[i] << " ";
	}
	cout << "\n";
	for (int i = 0; i < n; ++i)
	{
		cout << q[i] << " ";
	}
	cout << "\n";
}

int main()
{
	int t;
	cin >> t;
	while (t--)
	{
		solve();
	}
	return 0;
}
