#include <map>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

#define int long long

const bool MULTI_TEST = false;
map<string, int> ans;
int abs_is_same = 1;
// 0 if closer
// 1 is further
// 2 if same
// 3 if found
//


string ask1(int x, int y) {
    cout << x << " " << y << endl;
    string a;
    cin >> a;
    if (a.back() == '!') {
        // lucky found
        exit(0);
    }
    return a;
}


int ask(int x, int y) {
    cout << x << " " << y << endl;
    string a;
    cin >> a;
    if (a.back() == '!') {
        // lucky found
        exit(0);
//        return 3;
    }
    if (ans.count(a) == 0) {
        if (abs_is_same == 1) {
            return 3;
        } else {
            return 0;
        }
    }
    return ans[a];
}

void solve() {
    // determine what things mean
    int RMAX = 1000000;
    string s1 = ask1(0, RMAX - 1);
    string s2 = ask1(0, RMAX);
    string s3 = ask1(0, 1);
    string s4 = ask1(0, 0);
    // use only s2 s3 s4
    if (s2 != s3 && s3 == s4) {
        // close far far
        ans[s2] = 1;
        ans[s3] = 0;
    }
    if (s2 == s3 && s3 != s4) {
        ans[s2] = 0;
        ans[s3] = 1;
    }
    int lx = 0, rx = RMAX;
    int ly = 0, ry = RMAX;
    int beg = 0;
    if (s2 == s3 && s3 == s4) {
        // one more query and change lx/y
        ans[s2] = 1;
        string s5 = ask1(0, 0);
        ans[s5] = 2;
        abs_is_same = 0;
    }

    // search for quadrants

    while (rx - lx > 1 || ry - ly > 1) {
        // ask 3 questions
        int q1;
        if (beg == 0) {
            beg = 1;
            q1 = -1;
        } else {
            q1 = ask(lx, ly);
        }
        int midx = (lx + rx) / 2;
        int midy = (ly + ry) / 2;
        int q2 = ask(lx, ry);
        if (q2 == 3) {
            ly = ry = midy;
            continue;
        }
        int q3 = ask(rx, ry);
        if (q3 == 3) {
            lx = rx = midx;
        }
        // use only q2 and q3
        if (q2 == 1 && q3 == 1) {
            // quadr 1
            lx = lx;
            rx = midx;
            ly = ly;
            ry = midy;
        } else if (q2 == 0 && q3 == 1) {
            // quaddr 2
            lx = lx;
            rx = midx;
            ly = midy;
            ry = ry;
        } else if (q2 == 0 && q3 == 0) {
            // quaddr 3
            lx = midx;
            rx = rx;
            ly = midy;
            ry = ry;
        } else if (q2 == 1 && q3 == 0) {
            // quadr 4
            lx = midx;
            rx = rx;
            ly = ly;
            ry = midy;
        } else {
//            cout << "OH NO" << endl;
        }
    }
    int f = ask(lx, ly);
//    cout << "Terminated no success" << endl;
}

signed main() {
//#ifdef _DEBUG
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    if (MULTI_TEST) {
        cin >> t;
    }

    while (t--) {
        solve();
    }

    return 0;
}