import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class MainK {
    static class Reader
    {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st;

        String read()
        {
            if (st == null || !st.hasMoreElements()) {
                try {
                    st = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return st.nextToken();
        }

        int i()
        {
            return Integer.parseInt(read());
        }
    }

    static boolean check(int[] arr, int n, int k) {
        int[] checkArr = new int[n];

        int count = 0;
        for (int i = 0; i < n; ++i) {
            int nmb = arr[i];
            if (checkArr[nmb] == 0)
                ++count;

            ++checkArr[nmb];
        }

        return count == k;
    }

    public static void main(String[] args) {
        Reader r = new Reader();
        int n = r.i();
        int k = r.i();

        if (n == k) {
            System.out.println("NO");
            return;
        }

        if (k == 1) {
            System.out.println("YES");
            for (int i = 1; i <= n; ++i) {
                if (i == n)
                    System.out.println(i + " " + 1);
                else if (n > 2)
                    System.out.println(i + " " + (i + 1));
            }
            return;
        }

        int[] arr = new int[n];
        arr[0] = n - 1;
        for (int i = 1; i < n; ++i)
            arr[i] = 1;

        for (int i = 1; i < n; ++i) {
            if (check(arr, n, k))
                break;

            for (int j = i + 1; j < n - i; ++j) {
                if (check(arr, n, k))
                    break;

                ++arr[i];
                ++arr[j];
            }
        }

        System.out.println("YES");
        for (int i = 0; i < n; ++i) {

            for (int j = 0; j < arr[i] - i; ++j) {
                int v = i + 1;
                int u = i + 1 + j + 1;

                System.out.println(v + " " + u);
            }
        }
    }
}