#include <iostream>
#include <vector>
#include <string>
#include <unordered_set>

#define long long ll

using namespace std;

vector<pair<int, int>> cords;
vector<int> ans;
vector<vector<int>> seq;
int n, k;

void make_ans(int parent) {
	int r = cords[0].second, l = cords[0].first;
	if (r - l == 1) {
		ans[seq[0][l] - 1] = parent;
		return;
	}
	unordered_set<int> left, right;
	vector<int> indexes(k);
	left.insert(seq[0][l]);
	for (int i = l + 1; i < r; i++)
		right.insert(seq[0][i]);
	for (int i = 1; i < r - l - 1; i++) {
		right.erase(seq[0][l + i]);
		bool ok = true;
		for (int j = 0; j < k; j++) {
			int start_pos;
			if (seq[j][i + cords[j].first] == seq[0][i + cords[0].first])
				start_pos = i + cords[j].first;
			else if (seq[j][cords[j].second - 1 - i] == seq[0][i + cords[0].first])
				start_pos = cords[j].second - 1 - i;
			else {
				ok = false;
				break;
			}
			unordered_set<int>& leftSet = left.find(seq[j][start_pos - 1]) != left.end() ? left : right;
			unordered_set<int>& rightSet = left.find(seq[j][start_pos - 1]) != left.end() ? right : left;
			bool ok1 = true;
			for (int m = start_pos - 1; m >= cords[j].first; m--)
				if (leftSet.find(seq[j][m]) == leftSet.end()) {
					ok1 = false;
					break;
				}
			for (int m = start_pos + 1; m < cords[j].second; m++)
				if (rightSet.find(seq[j][m]) == rightSet.end()) {
					ok1 = false;
					break;
				}
			if (!ok1) {
				ok = false;
				break;
			}
			else {
				indexes[j] = start_pos;
			}
		}
		if (ok) {
			ans[seq[0][i + cords[0].first] - 1] = parent;
			vector<pair<int, int>> oldcords = cords;
			int contain = *left.begin();
			for (int j = 0; j < k; j++) {
				cords[j] = left.find(seq[j][cords[j].first]) != left.end() ? make_pair(cords[j].first, indexes[j]) : make_pair(indexes[j] + 1, cords[j].second);
			}
			make_ans(seq[0][indexes[0]]);
			cords = oldcords;
			for (int j = 0; j < k; j++) {
				cords[j] = left.find(seq[j][cords[j].first]) == left.end() ? make_pair(cords[j].first, indexes[j]) : make_pair(indexes[j] + 1, cords[j].second);
			}
			make_ans(seq[0][indexes[0]]);

			break;
		}
		left.insert(seq[0][i + cords[0].first]);
	}
}

int main()
{
	cin >> n >> k;
	seq.resize(k, vector<int>(n));
	cords.resize(k, { 0, n });
	ans.resize(n);
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < n; j++)
			cin >> seq[i][j];
	}
	make_ans(-1);
	for (int i = 0; i < n; i++)
		cout << ans[i] << " ";
	cout << endl;
	return 0;
}
