#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <unordered_map>

#define ll long long

using namespace std;

int main()
{
	int n;
	cin >> n;
	vector <vector<int>> t;
	vector <int> v;

	for (int i = 0; i < n; i++) 
	{
		int k;
		cin >> k;
		vector<int> cur(k);
		for (int j = 0; j < k; j++) 
		{
			cin >> cur[j];
			v.push_back(cur[j]);
		}
		t.push_back(cur);
	}

	sort(v.begin(), v.end());

	unordered_map <int, int> prev;

	prev[v[0]] = -1;
	for (int i = 1; i < v.size(); i++)
	{
		prev[v[i]] = v[i - 1];
	}

	int s = 0, c = 0;

	for (int i = 0; i < t.size(); i++)
	{
		int curPrev = -1;
		for (int j = 0; j < t[i].size(); j++)
		{
			if (curPrev == -1)
			{
				curPrev = t[i][j];
			}
			else
			{
				if (prev[t[i][j]] != curPrev)
				{
					s++;
					curPrev = t[i][j];
				}
				else
				{
					curPrev = t[i][j];
				}
			}
		}
	}

	c = n + s - 1;

	cout << s << " " << c << "\n";
	
	return 0;
}