#include <iostream>
#include <vector>
#include <string>
#include <unordered_set>
#include <unordered_map>

#define long long ll

using namespace std;

int main()
{
	int n, k;
	cin >> n >> k;

	if (n == k)
	{
		cout << "NO";
		return 0;
	}

	cout << "YES\n";

	if (n == 2)
	{
		cout << 1 << "\n";
		cout << "1 2\n";
		return 0;
	}

	if (k == 1)
	{
		cout << n << "\n";
		for (int i = 1; i <= n - 1; i++)
		{
			cout << i << " " << i + 1 << "\n";
		}
		cout << n << " " << 1 << "\n";

		return 0;
	}

	vector<vector<bool>> v(n, vector<bool>(n, 0));
	unordered_map<int, int> sizes;
	unordered_map<int, int> toSize;

	for (int i = 1; i < n; i++)
	{
		v[i][0] = 1;
		v[0][i] = 1;
	}

	toSize[0] = n - 1;
	for (int i = 1; i < n; i++) toSize[i] = 1;

	sizes[1] = n - 1;
	sizes[n - 1] = 1;

	int cur = 1;
	int next = 0;
	int maxSize = n - 2;
	int curSize = 1;

	while (1)
	{
		if (cur == next) next++;

		if (v[cur][next] == 0)
		{
			v[cur][next] = 1;
			v[next][cur] = 1;
			sizes[toSize[cur]]--;
			sizes[toSize[next]]--;

			toSize[cur]++;
			toSize[next]++;

			sizes[toSize[cur]]++;
			sizes[toSize[next]]++;

			next++;
			curSize++;
		}
		else
		{
			next++;
		}

		if (curSize == maxSize)
		{
			next = 0;
			cur++;
			curSize = 0;
			for (int i = 0; i < n; i++) if (v[cur][i] == 1) curSize++;
		}

		int sum = 0;
		for (auto i : sizes)
		{
			if (i.second > 0) sum++;
		}
		if (sum == k) break;
	}

	vector<pair<int, int>> res;
	unordered_map<int, unordered_set<int>> was;

	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if (v[i][j] == 1)
			{
				if (was[i].find(j) == was[i].end() && was[j].find(i) == was[j].end())
				{
					was[i].insert(j);
					was[j].insert(i);
					res.push_back({ i + 1,j + 1 });
				}
			}
		}
	}

	cout << res.size() << "\n";
	for (int i = 0; i < res.size(); i++)
	{
		cout << res[i].first << " " << res[i].second << "\n";
	}

	return 0;
}