#include <bits/stdc++.h>
#define ii pair < int, int >
#define vii vector < ii >
#define vec vector < bool >
#define vec2 vector < vec >
using namespace std;
int k;
void print(vii a) {
    cout << "YES\n";
    cout << a.size() << '\n';
    for(auto &[x, y] : a)
        cout << x << ' ' << y << '\n';
}
void showAnswer(vec2 a) {
    vii ans;
    for(int i = 0; i < a.size(); i ++) {
        for(int j = 0; j < a[i].size(); j ++)
            if(a[i][j])
                ans.push_back({i + 1, j + 1});
    }
    print(ans);
}
map < vec2, bool > mp;
bool isConnected(vec2 a) {
    queue < int > q;
    q.push(0);
    vec used(a.size());
    set < int > st;
    while(!q.empty()) {
        int v = q.front();q.pop();
        used[v] = true;
        st.insert(v);
        for(int i = 0; i < a[v].size(); i ++)
            if(a[v][i] && !used[a[v][i]])
                q.push(i);
    }
    return (int)st.size() == (int)a.size();
}
bool check(vec2 a) {
    set < int > st;
    for(int i = 0; i < a.size(); i ++) {
        int cnt = 0;
        for(int x : a[i])
            cnt += x;
        if(cnt)
            st.insert(cnt);
    }
    return (int)st.size() == k && isConnected(a);
}
void rec(vec2 a, int sz) {
    if(!sz)
        return;
    if(mp.count(a))
        return;
    if(check(a)) {
        showAnswer(a);
        exit(0);
    }
    mp[a] = 1;
    for(int i = 0; i < a.size(); i ++)
        for(int j = i + 1; j < a[i].size(); j ++)
            if(!a[i][j]) {
                a[i][j] = 1;
                if(!mp.count(a))
                    rec(a, sz - 1);
                a[i][j] = 0;
            }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n >> k;
    if(n == 1)
        return cout << "NO", 0;
    vii a;
    if(k == 1) {
        for(int i = 1; i < n; i ++)
            a.push_back({i, i + 1});
        a.push_back({1, n});
        print(a);
        return 0;
    } else if(k == 2) {
        for(int i = 2; i <= n; i ++)
            a.push_back({1, i});
        print(a);
        return 0;
    }
    vec2 arr(n, vec (n));
    rec(arr, n * (n - 1) / 2);
    cout << "NO";
}
