#include <bits/stdc++.h>

using namespace std;

int n, k;
const int N = 777;
set<int> adj[N];
int visited[777];
int locked[777];
void dfs(int u)
{
    visited[u] = 1;
    for(auto it : adj[u])
        if(!visited[it])
            dfs(it);
}

string isConnected()
{
    for(int i = 1; i <= 770; i ++)
        visited[i] = 0;
    dfs(1);
    for(int i = 1; i <= n; i ++)
        if(!visited[i])
            return "NOT CONNECTED";
    return "CONNECTED";
}


bool go(int x)
{
    int cur = x + k - 1;
    int cc = k;
    int up = x + k - 1;
    for(int i = 1; i <= n; i ++)
        adj[i].clear(), locked[i] = 0;
    for(int i = 1; i <= n; i ++)
    {
        int sz = adj[i].size();
        for(int j = 1; j <= n; j ++)
        {
            if(sz >= cur)
                break;
            if(i != j && adj[i].find(j) == adj[i].end() && adj[j].size() < up && !locked[j])
            {
                adj[i].insert(j);
                adj[j].insert(i);
                sz ++;
            }
        }
        if(sz == cur)
        {
            locked[i] = 1;
            cur --;
            cc --;
            if(cc == 0)
                break;
        }
    }
    if(cc != 0)
        return false;
    for(int i = 1; i <= n; i ++)
    {
        if(adj[i].size() < x)
        {
            for(int j = 1; j <= n; j ++)
            {
                if(adj[i].size() == x)
                    break;
                if(i != j && adj[i].find(j) == adj[i].end() && adj[j].size() < up && !locked[j])
                {
                    adj[i].insert(j);
                    adj[j].insert(i);
                }
            }
        }
        if(adj[i].size() < x)
            return false;
    }
    return true;
}

int main()
{
    cin >> n >> k;
    bool gotit = false;
//    for(int x = 1; x + k - 1 <= n; x ++) {
//        if (go(x) && isConnected() == "CONNECTED")
//        {
////            cerr << "Got " << x << '\n';
//            gotit = true;
//            break;
//        }
//    }
    if(k == 1)
    {
        cout << "YES\n";
        cout << n << '\n';
        for(int i = 2; i <= n; i ++)
            cout << i - 1 << ' ' << i << '\n';
        cout << n << ' ' << 1 << '\n';
        return 0;
    }
    if(!go(1))
    {
        cout << "NO\n";
        return 0;
    }
    cout << "YES\n";
    set<pair<int, int> > ans;
    for(int i = 1; i <= n; i ++)
    {
        for(auto it : adj[i])
        {
            int x = i, y = it;
            if(x > y)
                swap(x, y);
            ans.insert({x, y});
        }
    }
    cout << ans.size() << '\n';
    for(auto it : ans)
        cout << it.first << ' ' << it.second << '\n';

//    cerr << isConnected();
    if(isConnected() != "CONNECTED")
    {
        int x = 3;
        while(1 > 0)
            x ++;
    }

//        set<int> s;
//    for(int i = 1; i <= n; i ++)
//    {
//        s.insert(adj[i].size());
//    }
//    for(auto it : s)
//        cerr << it << ' ';
//    cerr << '\n';
//    cerr << s.size() <<'\n';
}