#include <bits/stdc++.h>

using namespace std;


set<int> adj[777];
int locked[777];
int visited[777];

void dfs(int u)
{
    visited[u] = 1;
    for(auto it : adj[u])
        if(!visited[it])
            dfs(it);
}

int n;
string isConnected()
{
    for(int i = 1; i <= 770; i ++)
        visited[i] = 0;
    dfs(1);
    for(int i = 1; i <= n; i ++)
        if(!visited[i])
            return "NOT CONNECTED";
    return "CONNECTED";
}
int k;
bool go(int x)
{
    for(int i = 1; i <= n; i ++)
    {
        for(int j = 1; j <= n; j ++)
        {
            if(i != j)
                adj[i].insert(j);
        }
    }
    for(int i = 1; i <= n; i ++)
        locked[i] = 0;
//cout << x << '\n';
    int cur = x;
    int cc = k;
    for(int i = 1; i <= n; i ++)
    {
        int iSz = adj[i].size();

        for(int j = n; j >= 1; j --)
        {
            if(iSz == cur)
                break;
            if(!locked[j] && j != i && adj[i].find(j) != adj[i].end())
            {
                adj[i].erase(adj[i].find(j));
                adj[j].erase(adj[j].find(i));

                iSz --;
            }
        }
        if(iSz == cur)
        {
            locked[i] = 1;
            cur --;
            cc --;
            if(cc == 0)
                break;
        }
    }

    return (cc == 0);
}

int main() {
    cin >> n >> k;

    if (n == 1) {
        cout << "YES\n";
        return 0;
    }
    int nice = 0;
    for (int t = n - 1; t >= 1; t--) {
        if (go(t)) {
//            cout << "nice " << t << '\n';
            nice = 1;
            break;
        }
    }
    if (nice == 0) {
        cout << "NO\n";
        return 0;
    }
    cout << "YES\n";
    set<pair<int, int> > ans;
    for (int i = 1; i <= n; i++) {
        for (auto it: adj[i]) {
            int x = i, y = it;
            if (x > y)
                swap(x, y);
            ans.insert({x, y});
        }
    }
    cout << ans.size() << '\n';
    for (auto it: ans)
        cout << it.first << ' ' << it.second << '\n';

//    cout << isConnected() << '\n';
//    set<int> s;
//    for(int i = 1; i <= n; i ++)
//    {
//        s.insert(adj[i].size());
//    }
//    for(auto it : s)
//        cout << it << ' ';
//    cout << '\n';
//    cout << s.size() <<'\n';
}
