#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define sz size
#define pb push_back
#define ppb pop_back
#define all(x) (x).begin(),(x).end()

void solve();
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--){
        solve();
        cout << '\n';
    }
}

void solve(){
    int n;
    cin >> n;

    vector<int> p(n+1), q(n+1), b(n);
    map<int,int> a;

    for (int i=0; i<n; ++i){
        cin >> b[i];
        a[b[i]]=i+1;
    }

    if (b.sz()==3){
        if (b==vector<int>({3,2,1}) || b==vector<int>({2,1,3}) || b==vector<int>({1,3,2})){
            cout << "Impossible";
            return;
        }
    }

    if (b.sz()<3){
        reverse(all(b));
        if (is_sorted(all(b))){
            cout << "Impossible";
            return;
        }
        reverse(all(b));
    }

    if (n%2==1 && is_sorted(all(b))){
        cout << "Possible\n";

        cout << n;
        for (int i=1; i<n; ++i) cout << " " << i;

        cout << endl;
        for (int i=2; i<=n; ++i) cout << i << " ";
        cout << 1;
        return;
    }

    vector<bool> up(n+1,0);

    int lp=1;
//    cerr << n << endl;
    for (int i=1; i<=n; ++i){
        int cp=lp;
        bool dp=1;

        while ((cp==i || cp==a[i] || up[cp]) && cp<n) cp++, dp=0;

        q[i]=cp;
        p[cp]=a[i];
        up[cp]=1;

//        cerr << cp << " " << a[i] << endl;

        while (dp && up[lp] && lp<n) lp++;
    }

    if (q[n]==n){
        for (int i=1; i<n; ++i){
            if (p[q[i]]!=n && p[q[n]]!=q[i]){
                int p1=q[n], p2=q[i];
                swap(q[n],q[i]);
                swap(p[p1],p[p2]);
                break;
            }
        }
    }
    cout << "Possible\n";
    for (int i=1; i<=n; ++i) cout << p[i] << " ";
    cout << '\n';
    for (int i=1; i<=n; ++i) cout << q[i] << " ";
    cerr << "\n\n";
}
/*
 4
 2
 2 1
 3
 1 2 3
 4
 2 1 4 3
 5
 5 1 4 2 3

 2
 4
 1 2 3 4
 5
 1 2 3 4 5

 3
 4
 3 4 1 2
 6
 1 3 4 5 6 2
 6
 2 3 4 5 6 1
 */