#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
vector<vector<int>> a;
void combine(int i,int b)
{
    a[i].insert(a[i].end(),a[b].begin(),a[b].end());
    a.erase(a.begin()+b);
}
int split(int i,int j)
{
    if(j==a[i].size())
        return 0;
    if(j<=0)
        return 0;
    vector<int> out;
    copy(a[i].begin()+j,a[i].end(),back_inserter(out));
    a[i].erase(a[i].begin()+j,a[i].end());
    a.insert(a.begin()+i+1, out);
    return 1;
}
int impact(int i,int j)
{
    if(a[i].back()<a[j].front())
        return 0;
    else if(a[j].back()<a[i].front())
        return 0;
    else if(a[i].back()>a[j].front() )
    {
        int m=0;
        for(auto l:a[i])
        {
            m++;
            if(l>a[j].front())
            {
                m=split(i,m-1);
                break;
            }
        }
        return m;
    }
    else if(a[j].back()>a[i].front() )
    {
        int m=0;
        for(auto l:a[j])
        {
            m++;
            if(l>a[i].front())
            {
                m=split(j,m-1);
                break;
            }
        }
        return m;
    }
    else
    {
        return 0;
    }
}
int main() {
   int n,t,buf,sum=0;
   cin>>n;

   for(int i=0;i<n;i++)
   {
        a.push_back({});
        cin>>t;
        for(int j=0;j<t;j++)
        {
            cin>>buf;
            a[i].push_back(buf);
        }
   }


   for(int i=0;i<a.size();i++)
   {
        sum+=split(i, is_sorted_until(a[i].begin(),a[i].end())-a[i].begin());
   }
   for(int i=0;i<a.size();i++)
   {
       for(int j=0;j<a.size();j++)
       {
           if(i==j)
               continue;
            sum+=impact(j,i);
       }
   }
    for(int i=0;i<a.size();i++)
    {
        for(int j=0;j<a.size();j++)
        {
            if(i==j)
                continue;
            sum+=impact(j,i);
        }
    }
   /*for(auto l:a)
   {
       for(auto g:l)
           cout<<g<<' ';
       cout<<'\n';
   }*/
   cout<<sum<<' '<<a.size()-1;
   return 0;
}
