#include <bits/stdc++.h>

using namespace std;

#define ILIKEGENTOO
#ifdef ILIKEGENTOO

void E() {}

template<class A, class...B>
void E(A $, B..._) {
    cerr << ' ' << $;
    E(_...);
}

#define E($...) E(#$,'=',$,'\n')
#else
#define E($...)
#endif

using ll = long long;

std::random_device rd;
std::mt19937 rng{rd()};
std::mt19937 randMT(rng);

vector<vector<int>> ks;
int ans[1010];
int dsu[1010];
int L[110][1010];
int R[110][1010];
int p[110][1010];

int getp(int v)
{
    return v != dsu[v] ? dsu[v] = getp(dsu[v]) : v;
}

int k, n;

void join(int u, int v)
{
    u = getp(u);
    v = getp(v);
    dsu[v] = u;
    for (int i = 0; i < k; i++)
    {
        //cout << p[i][u] << " " << p[i][v] << endl;
        L[i][p[i][u]] = min(L[i][p[i][u]], L[i][p[i][v]]);
        R[i][p[i][u]] = max(R[i][p[i][u]], R[i][p[i][v]]);
        //cout << L[i][p[i][u]] << " " << R[i][p[i][u]] << endl;
    }
}


map<int, set<int>> chl;
void update(int id, int x, int v1, int v2)
{
    int pos = p[id][x];
    int l = L[id][pos];
    int r = R[id][pos];

    if (l >= 0)
    {
        l = getp(ks[id][l]);
        chl[l].erase(v1);
        chl[l].erase(v2);
        chl[l].insert(x);
    }
    if (r < n)
    {
        r = getp(ks[id][r]);
        chl[r].erase(v1);
        chl[r].erase(v2);
        chl[r].insert(x);
    }
}

void solve() {
    memset(ans, -1, sizeof(ans));
    cin >> n >> k;
    for (int i = 0; i < k; i++)
    {
        ks.push_back({});
        for (int j = 0; j < n; j++)
        {
            int t;
            cin >> t;
            t--;
            ks.back().push_back(t);
            p[i][t] = j;
        }
    }
    for (int i = 0; i < k; i++)
    {
        for (int j = 0; j < n; j++)
        {
            L[i][j] = j - 1;
            R[i][j] = j + 1;
        }
    }
    for (int i = 0; i < n; i++)
    {
        dsu[i] = i;
    }

    int sz = n;
    for (int i =0; i < k; i++) {
        for (int it = 1; it + 1 < sz; it++) {
            chl[ks[i][it]].insert(ks[i][it - 1]);
            chl[ks[i][it]].insert(ks[i][it + 1]);
        }
    }
    while (sz > 1)
    {
        set<int> cand;
        for (int i = 0; i < k; i++)
        {
//            cout << getp(ks[i][0]) << " " << getp(ks[i][n - 1]) << endl;
            int r1 = R[i][p[i][getp(ks[i][0])]];
            int l1 = L[i][p[i][getp(ks[i][n - 1])]];
            cand.insert(getp(ks[i][r1]));
            cand.insert(getp(ks[i][l1]));
        }
        bool f = 0;
        for (auto x : cand)
        {
            auto pr = chl[x];
//            assert(pr.size() <= 2);
            if (pr.size() == 2)
            {
                int v1 = *pr.begin();
                int v2 = *pr.rbegin();

                ans[v1] = x;
                ans[v2] = x;

                join(x, v1);
                join(x, v2);

                for (int it = 0; it < k; it++) {
                    update(it, x, v1, v2);
                }

                sz -= 2;
                f = 1;
                break;
            }
        }
        assert(f);
    }
    for (int i = 0; i < n; i++)
    {
        if (ans[i] != -1)
            cout << ans[i] + 1 << " ";
        else cout << -1 << " ";
    }
}

int main() {
//    freopen("input.txt", "r", stdin);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    cout << setprecision(15) << fixed;

    int t = 1;
    // cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
