#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t;
	cin >> t;

	for (int tt = 0; tt < t; tt++) {
		int n;
		cin >> n;
		vector<int>a(n);
		vector<int>pos(n);
		for (int i = 0; i < n; i++) {
			cin >> a[i];
			a[i]--;
			pos[a[i]] = i;
		}

		set<int> leftn;
		for (int i = 0; i < n; i++) {
			leftn.insert(i);
		}

		vector<int>p(n);
		vector<int>q(n);

		bool all_ok = true;

		for (int i = 0; i < n; ++i) {
			bool ok = false;
			for (auto j : leftn) {
				if (j != i && j != pos[i]) {
					q[i] = j;
					ok = true;
					leftn.erase(j);
					break;
				}
			}
			if (ok) {
				continue;
			}
			for (int j = 0; j < i; ++j) {
				if (q[j] != i && q[j] != pos[i]) {
					for (auto jj : leftn) {
						if (jj != j && jj != pos[j]) {
							q[i] = q[j];
							q[j] = jj;
							ok = true;
							leftn.erase(jj);
							break;
						}
					}
				}
				if (ok) {
					break;
				}
			}
			if (!ok) {
				all_ok = false;
				break;
			}
		}

		if (!all_ok) {
			cout << "Impossible\n";
			continue;
		}
		else {
			cout << "Possible\n";
		}

		for (int i = 0; i < n; i++) {
			p[q[i]] = pos[i];
		}

		for (int i = 0; i < n; i++) {
			cout << p[i] + 1 << " ";
		}
		cout << endl;
		for (int i = 0; i < n; i++) {
			cout << q[i] + 1 << " ";
		}
		cout << endl;
	}

	return 0;
}