#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

bool is_good_permut(vector<int> *A, vector<int> *permut) {
    for (int i = 0; i < A->size(); ++i) {
        if (A->at(i) == permut->at(i)) return false;
    }
    return true;
}

void solve() {
    int n;
    cin >> n;

    vector<vector<int>> towers(n);
    vector<int> nums;

    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        vector<int> tower(k);

        for (int j = 0; j < k; ++j) {
            cin >> tower[j];
            nums.push_back(tower[j]);
        }

        towers[i] = tower;
    }

    sort(nums.begin(), nums.end());

    int split_count = 0;
    for (int i = 0; i < n; ++i) {
        auto it = std::lower_bound(nums.begin(), nums.end(), towers[i][0]);
        for (int j = 1; j < towers[i].size(); ++j) {
            it++;
            if (*it == towers[i][j]) continue;
            else {
                it = std::lower_bound(nums.begin(), nums.end(), towers[i][j]);
                split_count++;
            }
        }
    }

    cout << split_count << " " << n + split_count - 1;
}


int main() {
#ifdef DEBUG

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int test_count = 1;
    //scanf("%d", &test_count);

    for (int i = 0; i < test_count; ++i) {
        solve();
    }

    return 0;
}
