#include <bits/stdc++.h>

#include <random>
using namespace std;


void solve_A() {
    int n;
    cin >> n;
    vector<int> arr(n);
    for(auto &i : arr)cin >> i;
    vector<int> p(n);
    iota(p.begin(), p.end(), 1);
    vector<int> positions(n);
    for(int i = 0; i < n; i += 1){
        positions[arr[i] - 1] = i;
    }
    vector<int> posP(n);
    for(int attemp = 0; attemp < 50; attemp += 1){
        shuffle(p.begin(), p.end(), std::mt19937(std::random_device()()));
        int next = 0;
        for(int i = 0; i < n; i += 1){
            posP[p[i] - 1] = i;
        }
        for(int i = 0; i < n && next == 0; i += 1){
            if(p[i] == i + 1 || posP[positions[i]] == i)next = 1;
        }
        if(next)continue;

        cout << "Possible\n";
        for(auto i : p){
            cout << i << ' ';
        }
        cout << '\n';
        for(int i = 0; i < n; i += 1){
            cout << posP[positions[i]] + 1 << ' ';
        }
        cout << '\n';
        return;

    }
    cout << "Impossible\n";
}



int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve_A();
    }
    return 0;
}