#include <bits/stdc++.h>
using namespace std;
void solve_E() {
    int n;
    cin >> n;
    map<int, int> ind;
    vector<vector<int>> b(n);
    set<int, greater<>> st;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        b[i].resize(x);
        for (auto& j: b[i]) {
            cin >> j;
            st.insert(j);
        }
    }
    int cur = 0;
    for (auto i : st) {
        ind[i] = cur++;
    }

    int cnt_merge = n - 1, cnt_split = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 1; j < b[i].size(); j++) {
            if (ind[b[i][j]] != ind[b[i][j - 1]] - 1) {
                cnt_split++;
                cnt_merge++;
            }
        }
    }
    cout << cnt_split << ' ' << cnt_merge;
}

void solve_K() {
    int n, k;
    cin >> n >> k;
    if (k >= n) {
        cout << "NO\n";
        return;
    }
    if(k == 1 && n == 1){
        cout << "NO\n";
        return;
    }
    if(k == 1 && n == 2){
        cout << "YES\n1\n1 2\n";
        return;
    }
    if(k == 1){
        cout << "YES\n";
        cout << n << '\n';
        for(int i = 1; i <= n; i += 1){
            cout << i << ' ' << i % n + 1  << '\n';
        }
        return;
    }
    vector<pair<int, int>> edges;
    for (int i = 1; i <= k; i++) {
        int cnt = 0;
        for(int j = k; j >= max(k - i + 1, i + 1); j -= 1){
            edges.emplace_back(i, j);
            cnt += 1;
        }
        if(cnt != i){
            edges.emplace_back(i, k + 1);
        }
    }
    for(int i = n; i > k + 1; i -= 1){
        edges.emplace_back(i, i - 1);
    }
    cout << "YES\n";
    cout<<edges.size()<<'\n';
    for(auto i : edges){
        cout << i.first << ' ' << i.second <<'\n';
    }
}

int main() {
    int t = 1;
    // cin >> t;
    while (t--) {
        solve_K();
    }
}
