#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <unordered_map>
#include <string>
#include <queue>
#include <deque>
#include <cassert>

#define pb push_back
#define rep(i,n) for(int i = 0; i < (n); i++)
#define vi vector<int> 
#define ve vector
#define pii pair<int,int>
#define all(p) (p).begin(), (p).end()
#define mp make_pair
#define int long long

using namespace std;
using ull = unsigned long long;
using ll = long long;

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
}

bool check(vi& p, vi& t) {
	rep(i, p.size()) {
		if (p[i] == i)
			return false;
		if (p[i] == t[i])
			return false;
	}
	return true;
}

void solve1() {
	int n;
	cin >> n;
	vector<int>a(n);
	rep(i, n)cin >> a[i];
	if (n <= 2) {
		cout << "Impossible\n";
		return;
	}
	cout << "Possible\n";

	vector<int>p(n);
	vector<int>q(n);
	vi t(n);
	rep(i, n) {
		t[a[i] - 1] = i;
	}
	iota(all(p), 0);
	int cnt = 0;
	while (!check(p, t) && cnt < 500) {
		random_shuffle(all(p));
		cnt++;
	}
	assert(check(p, t));
	vi p_nums(n);
	rep(i, n) {
		p_nums[p[i]] = i;
	}
	rep(i, n) {
		q[i] = p_nums[t[i]];
	}
	for (int i = 0; i < n; i++) {
		cout << p[i] + 1 << ' ';
	}
	cout << '\n';
	for (int i = 0; i < n; i++) {
		cout << q[i] + 1 << ' ';
	}
	cout << '\n';
	/*for (int i = 0; i < n; i++) {
		cout << a[p[q[i] - 1] - 1] << " ";
	}
	cout << "\n";*/
}

void solve() {
	int n;
	cin >> n;
	vector<int>a(n);
	rep(i, n)cin >> a[i];
	if (n <= 2) {
		cout << "Impossible\n";
		return;
	}
	cout << "Possible\n";
	
	vector<int>p(n);
	vector<int>q(n);
	int val_p = 2;
	int val_q = n;
	for (int i = 0; i < n; i++) {
		q[i] = val_q;
		val_q++;
		if (val_q > n)
			val_q = 1;
		p[i] = val_p;
		val_p++;
		if (val_p > n)
			val_p = 1;
	}
	for (int i = 0; i < n; i++) {
		cout << p[i] << ' ';
	}
	cout << '\n';
	for (int i = 0; i < n; i++) {
		cout << q[i] << ' ';
	}
	cout << '\n';
	/*for (int i = 0; i < n; i++) {
		cout << a[p[q[i] - 1] - 1] << " ";
	}
	cout << "\n";*/
}

signed main()
{
#ifdef LOHI
	freopen("local1.txt", "r", stdin);
	//freopen("output1.txt", "w", stdout);
#endif
	fast();
	int t = 1;
	cin >> t;
	while (t--) {
		solve1();
	}
}
