#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <unordered_map>
#include <string>
#include <queue>
#include <deque>
#include <cassert>

#define pb push_back
#define rep(i,n) for(int i = 0; i < (n); i++)
#define vi vector<int> 
#define ve vector
#define pii pair<int,int>
#define all(p) (p).begin(), (p).end()
#define mp make_pair
#define int long long

using namespace std;
using ull = unsigned long long;
using ll = long long;

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
}

vector<vector<int>> v;

vi ans(1010, -1);

struct node {
	int predok;
	int start;
	int end;
};

node tree[110][10000];

void set_node(node&n, int pr, int s, int e) {
	n.predok = pr;
	n.start = s;
	n.end = e;
}

void solve() {
	int n, k;
	cin >> n >> k;
	v.resize(k);
	for (int i = 0; i < k; i++) {
		v[i].resize(n);
		for (int j = 0; j < n; j++) {
			cin >> v[i][j];
		}
	}

	for (int i = 0; i < k; i++) {
		set_node(tree[i][0], -1, 0, n - 1);
	}
	
	queue<int> q;
	q.push(0);

	while (!q.empty()) {
		int pod = q.front();
		node t = tree[0][q.front()];
		q.pop();

		if (t.end - t.start <= 1) {
			ans[v[0][t.start]-1] = t.predok;
			ans[v[0][t.end]-1] = t.predok;
			continue;
		}

		set<int> l;
		l.insert(v[0][t.start]);

		int sm;
		int center;

		for (int i = t.start + 1; i <= t.end - 1; i++) {
			l.insert(v[0][i]);
			sm = i - t.start;
			center = v[0][i];

			int flag = 1;

			for (int j = 1; j < k; j++) {
				if (v[j][tree[j][pod].start + sm] == center ||
					v[j][tree[j][pod].end - sm] == center) {

					set<int> new_left;

					for (int z = tree[j][pod].start; v[j][z] != center; z++) {
						new_left.insert(v[j][z]);
					}

					int cnt = 0;
					for (int i : new_left)
						cnt += l.count(i);

					if (cnt != 0 && cnt != l.size()) {
						flag = 0;
						break;
					}

				}
				else {
					flag = 0;
					break;
				}
			}

			if (flag) {
				break;
			}
		}

		//if (pod == 0)
		//	cout << center << "\n";

		ans[center - 1] = t.predok;

		for (int j = 0; j < k; j++) {
			set_node(tree[j][pod * 2 + 1], center - 1, t.start, t.start + sm - 1);
			q.push(pod * 2 + 1);
			set_node(tree[j][pod * 2 + 2], center - 1, t.end - sm + 1, t.end);
			q.push(pod * 2 + 2);
		}

	}

	for (int i = 0; i < n; i++) {
		if (ans[i] == -1)
			cout << "-1 ";
		else
			cout << ans[i] + 1 << " ";
	}

}

signed main()
{
#ifdef LOHI
	freopen("local1.txt", "r", stdin);
	freopen("output1.txt", "w", stdout);
#endif
	fast();
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
