#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <unordered_map>
#include <string>
#include <queue>
#include <deque>

#define pb push_back
#define rep(i,n) for(int i = 0; i < (n); i++)
#define vi vector<int> 
#define ve vector
#define pii pair<int,int>
#define all(p) (p).begin(), (p).end()
#define mp make_pair
#define int long long

using namespace std;
using ull = unsigned long long;
using ll = long long;

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
}

vi v[505];
int cnt[505];

void solve() {
	int n, k;
	cin >> n >> k;
	if (k == 1) {
		cout << "YES\n";
		cout << n * (n - 1) / 2 << "\n";
		for (int i = 1; i <= n; i++)
			for (int j = i + 1; j <= n; j++)
				cout << i << " " << j << "\n";
		return;
	}
	
	ve<pii> ans;
	for (int i = 1; i < n; i++) {
		//v[i].pb(i + 1);
		ans.pb({ i,i + 1 });
		cnt[i]++;
		cnt[i + 1]++;
	}

	int st = (n > 2 ? 2 : 1);

	for (int i = 1; i <= n; i++) {
		if (i <= k) {
			int u = i - cnt[i];
			for (int j = 2; j <= u + 1; j++) {
				if (i + j > n) {
					cout << "NO\n";
					return;
				}
				ans.pb({ i, i + j });
				cnt[i]++;
				cnt[i + j]++;
			}
		}
	}
	cout << "YES\n" << ans.size() << "\n";
	for (auto o : ans)
		cout << o.first << " " << o.second << "\n";
}

signed main()
{
	fast();

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
