#pragma warning (disable : 4996)

#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>

using namespace std;

using ll = long long;
using ld = long double;

int main()
{
	freopen("input.txt", "r", stdin);
	int n;
	cin >> n;
	int* counts = new int[n];
	int** towers = new int* [n];

	vector<int> vals;
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		counts[i] = k;

		towers[i] = new int[k];
		 
		for (int j = 0; j < k; j++) {
			cin >> towers[i][j];
			vals.push_back(towers[i][j]);
		}
	}

	sort(vals.begin(), vals.end());

	int splitCount = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 1; j < counts[i]; j++) {
			int leftVal = towers[i][j - 1];
			int rightVal = towers[i][j];

			int L = 0;
			int R = vals.size();
			while (L < R - 1) {
				int m = (L + R) / 2;
				if (vals[m] == leftVal) {
					L = m;
					R = m + 1;
					break;
				}
				else if (vals[m] < leftVal) {
					L = m + 1;
				}
				else {
					R = m;
				}
			}

			int pos = L;
			if ((pos == vals.size() - 1) || (vals[pos + 1] != rightVal)) {
				splitCount++;
			}
		}
	}

	int combineCount = (n - 1) + splitCount;
	cout << splitCount << " " << combineCount;
}



// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
