#pragma warning (disable : 4996)

#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>

using namespace std;

using ll = long long;

vector<ll> ve(20011);

void mult(vector<ll>& a, ll b, vector<ll>& res) {
	for (ll i = 0; i < 20000 / 9; i++) {
		ve[i] = a[i] * b;
	}
	for (ll j = 0; j < 20000 / 9; j++) {
		res[j] = ve[j] % 1000000000;
		ve[j + 1] += ve[j] / 10000000000;
	}
}

ll	get(vector<ll>& ve, ll i) {
	ll a = ve[i / 9];
	i %= 9;
	while (i--) {
		a /= 10;
	}
	return a % 10;
}

ll first(vector<ll>& ve) {
	for (ll j = 19999; j >= 0; j--) {
		if (get(ve, j) > 0) {
			return j;
		}
	}
}



int main()
{
	//freopen("input.txt", "r", stdin);

	int n, k;
	cin >> n >> k;

	int* arr = new int[n];
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}

	vector<pair<int, int>> changes;

	int incSize = 1;
	int decSize = 1;
	for (int i = 1; i < n; i++) {
		if (incSize == k - 2 && decSize == k - 2 && (changes.size() == 0 || changes[changes.size() - 1].second == -1)) {
			changes.push_back(make_pair(i, -1));
			incSize = decSize = 0;
			continue;
		}

		bool fillPrevMax = false;
		bool fillPrevMin = false;
		if (arr[i] >= arr[i - 1]) incSize++;
		else {
			if (incSize != 0) fillPrevMin = true;
			incSize = 1;
		}

		if (arr[i] <= arr[i - 1]) decSize++;
		else {
			if (decSize != 0) fillPrevMax = true;
			decSize = 1;
		}

		if (fillPrevMax) {
			for (int j = changes.size() - 1; j >= 0; j--) {
				if (changes[j].second != -1) break;
				changes[j].second = 100000;
			}
		}
		if (fillPrevMin) {
			for (int j = changes.size() - 1; j >= 0; j--) {
				if (changes[j].second != -1) break;
				changes[j].second = 0;
			}
		}

		if (incSize == k - 1 && decSize == k - 1) {
			changes.push_back(make_pair(i, -1));
			incSize = decSize = 0;
		}
		else {
			if (incSize == k) {
				/*for (int j = changes.size() - 1; j >= 0; j--) {
					if (changes[j].second != -1) break;
					changes[j].second = 100000;
				}*/
				changes.push_back(make_pair(i, 0));
				arr[i] = 0;
				incSize = 1;
				decSize = 1;
			}
			else if (decSize == k) {
				/*for (int j = changes.size() - 1; j >= 0; j--) {
					if (changes[j].second != -1) break;
					changes[j].second = 0;
				}*/
				changes.push_back(make_pair(i, 100000));
				arr[i] = 100000;
				incSize = 1;
				decSize = 1;
			}
		}
	}
	for (int j = changes.size() - 1; j >= 0; j--) {
		if (changes[j].second != -1) break;
		changes[j].second = 0;
	}


	cout << changes.size() << endl;
	for (int i = 0; i < changes.size(); i++) {
		arr[changes[i].first] = changes[i].second;
	}

	cout << arr[0];
	for (int i = 1; i < n; i++) {
		cout << ' ' << arr[i];
	}
	cout << endl;

	return 0;
}
