#include <iostream>
#include <algorithm>
#include <cmath>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <fstream>
#include <iomanip>
#include <string>

using namespace std;

#define all(x) (x).begin(), (x).end()

using ll = long long;
using ull= unsigned long long;

bool treasureFound = false;
struct Point {
	ll x{};
	ll y{};
};
struct Square {
	Square(Point p1, Point p2, Point p3):
		leftTop(p1), leftDown(p2), rightTop(p3){}
	Point leftTop{};
	Point leftDown{};
	Point rightTop{};
};
map<string, string> getTranslations() {
	map<string, string> translations;
	string curAnsw;
	std::cout << 1 << ' ' << 0 << endl;
	getline(cin, curAnsw, '\n');
	if (curAnsw.back() == '!') {
		treasureFound = true;
		return map<string, string>();
	}
	translations[curAnsw] = "Not found";
	///
	std::cout << 0 << ' ' << 1 << endl;
	getline(cin, curAnsw, '\n');
	if (curAnsw.back() == '!') {
		treasureFound = true;
		return map<string, string>();
	}
	std::cout << 1 << ' ' << 1 << endl;
	getline(cin, curAnsw, '\n');
	if (curAnsw.back() == '!') {
		treasureFound = true;
		return map<string, string>();
	}
	translations[curAnsw] = "Closer";
	std::cout << 0 << ' ' << 0 << endl;
	getline(cin, curAnsw, '\n');
	if (curAnsw.back() == '!') {
		treasureFound = true;
		return map<string, string>();
	}
	translations[curAnsw] = "Further";
	return translations;
}
void solve_h()
{
	const auto transl = getTranslations();
	if (treasureFound)
		return;

	Square square({0,0}, {0, (ll)1e6}, {(ll)1e6, 0});

	bool isFound = false;
	while (!isFound) {
		auto midLeftTop = Point{ (square.leftDown.x + square.rightTop.x) / 2,
			 (square.leftDown.y + square.rightTop.y) / 2 };
		auto midLeftDown = Point{ (square.leftDown.x + square.rightTop.x) / 2,
			 (square.leftDown.y + square.rightTop.y) / 2 + 1 };
		auto midRightTop = Point{ (square.leftDown.x + square.rightTop.x) / 2+1,
			 (square.leftDown.y + square.rightTop.y) / 2 };
		auto midRightDown = Point{ (square.leftDown.x + square.rightTop.x) / 2+1,
			 (square.leftDown.y + square.rightTop.y) / 2 + 1 };

		string curAnsw;
		std::cout << midLeftTop.x << ' ' << midLeftTop.y << endl;
		getline(cin, curAnsw, '\n');
	
		if (transl.count(curAnsw) && transl.at(curAnsw) == "Closer") {

		}
		//else if ()


	}

	


}

void solve_a()
{
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (auto& i : b)
		cin >> i;
	for (int i = 0; i < n; i++)
		a[i] = i + 1;
	int nesovp = 0;
	for (int i = 0; i < n; i++)
		if (a[i] != b[i]) {
			nesovp++;
		}
	if (nesovp == 2) {
		std::cout << "Impossible" << endl;
		return;
	}
	vector<int> c = b;
	for (int i = 0; i < n - 1; i++) {
		int temp = c[i];
		while (temp==a[i] || temp==b[i]) {
			int randind = rand() % (n - i - 1) + 1 + i;
			std::swap(c[i], c[randind]);
			temp = c[i];
		}
	}

	int fd = 0;
	while (c.back() == a.back() || c.back() == b.back()) {
		int v1 = n - 1;
		int v2 = rand() % (n - 1);
		if (c[v2] != a[v1] && c[v2] != b[v1] && c[v1] != a[v2] && c[v1] != b[v2]) {
			std::swap(c[v1], c[v2]);
			break;
		}
	}

	vector<int> q(n);
	vector<int> p(n);
	vector<int> inds(n);
	for (int i = 0; i < n; i++) {
		inds[b[i] - 1] = i;
	}

	for (int i = 0; i < n; i++) {
		q[c[i] - 1] = i + 1;
	}
	for (int i = 0; i < n; i++) {
		p[i] = inds[c[i] - 1] + 1;
	}

	// a = {5 1 4 2 3}
	// q = {}

	std::cout << "Possible" << std::endl;
	for (auto& i : q)
		std::cout << i << " ";
	std::cout << endl;
	for (auto& i : p)
		std::cout << i << " ";
	std::cout << endl;
}

int main()
{
	srand(1337);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	std::cout << fixed << setprecision(12);
	int t = 1;
	cin >> t;
	while (t--)
	{
		//solve_h();
		solve_a();
		//func_k();
	}
}