#include <iostream>
#include <algorithm>
#include <cmath>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <fstream>
#include <iomanip>

using namespace std;

#define all(x) (x).begin(), (x).end()

using ll = long long;
using ull= unsigned long long;

void solve_e()
{
	int n = 0, ks;
	cin >> ks;
	vector<vector<int>> a;
	while (ks--) {
		a.push_back({});
		int k;
		cin >> k;
		n += k;
		while (k--) {
			int temp;
			cin >> temp;
			a.back().push_back(temp);
		}
	}

	vector<pair<int, int>> c;
	int curr_color = 0;
	vector<bool> was(10007, false);
	int splits = 0, combs = 0;
	for (auto& i : a) {
		for (int j = 0; j < i.size(); j++) {
			c.push_back({ i[j], curr_color });
			if (j < i.size() - 1 && i[j] > i[j + 1]) {
				splits++;
				curr_color++;
			}
		}
		curr_color++;
	}

	sort(all(c), [](pair<int, int> a, pair<int, int> b) {
		return a.first < b.first;
		});
	was[c[0].second] = true;
	for (int i = 1; i < c.size(); i++) {
		if (was[c[i].second] && c[i].second != c[i - 1].second) {
			splits++;
			combs++;
		}
		else if (c[i].second != c[i - 1].second) {
			combs++;
		}
		was[c[i].second] = true;
	}

	int dummy = 228;

	cout << splits << " " << combs << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(12);
	int t = 1;
	while (t--)
	{
		solve_e();
	}
}