import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class Main {

    private static BufferedReader br=new BufferedReader(new InputStreamReader(System.in));
    private static StringTokenizer st=null;

    private static String readLine() throws IOException {
        st=null;
        return br.readLine();
    }

    private static String readToken() throws IOException {
        if(st==null||!st.hasMoreTokens())
            st=new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    private static int readInt() throws IOException {
        return Integer.parseInt(readToken());
    }

    private static long readLong() throws IOException {
        return Long.parseLong(readToken());
    }

    private static double readDouble() throws IOException {
        return Double.parseDouble(readToken());
    }

    public static void main(String[] args) throws IOException {
        int n=readInt();
        int a=readInt();
        int b=readInt();
        String[] matches=new String[n];
        int draws=0;
        if(n==1) {
            System.out.println(a==b?"1":"0");
            System.out.println(a+":"+b);
            return;
        }
        for(int i=0;i<n-2;i++) {
            if(a==0&&b==0) {
                draws++;
                matches[i]="0:0";
                continue;
            }
            if(a>b) {
                a-=1;
                matches[i]="1:0";
                continue;
            }
            b-=1;
            matches[i]="0:1";
        }
        if(a==0) {
            if(b==0) {
                draws+=2;
                matches[n-2]="0:0";
                matches[n-1]="0:0";
            } else if(b==1) {
                draws++;
                matches[n-2]="0:1";
                matches[n-1]="0:0";
            } else {
                matches[n-2]="0:1";
                b--;
                matches[n-1]="0:"+b;
            }
        } else if(b==0) {
            if(a==1) {
                draws++;
                matches[n-2]="1:0";
                matches[n-1]="0:0";
            } else {
                matches[n-2]="1:0";
                a--;
                matches[n-1]=a+":0";
            }
        } else {
            matches[n-2]=a+":0";
            matches[n-1]="0:"+b;
        }
        System.out.println(draws);
        for(int i=0;i<n;i++)
            System.out.println(matches[i]);
    }
}