import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Comparator;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class Main {

    private static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    private static StringTokenizer st = null;

    private static String readLine() throws IOException {
        st = null;
        return br.readLine();
    }

    private static String readToken() throws IOException {
        if (st == null || !st.hasMoreTokens())
            st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    private static int readInt() throws IOException {
        return Integer.parseInt(readToken());
    }

    private static long readLong() throws IOException {
        return Long.parseLong(readToken());
    }

    private static double readDouble() throws IOException {
        return Double.parseDouble(readToken());
    }


    public static void main(String[] args) throws IOException {
        int n, k;
        n = readInt();
        k = readInt();

        if (k == 1 && n == 1) {
            System.out.println("YES");
            System.out.println(0);
        } else if (k == n) {
            System.out.printf("NO");
        } else {
            System.out.println("YES");
            int sum = 0;
            for (int i = 0; i + i < k; i++) {
                for (int j = i + 1; j + i < k; j++) {
                    if (i == j) continue;
                    sum++;
                }
            }
            System.out.println((n * (n - 1) / 2) - sum);
            for (int i = 0; i < n - 1; i++) {
                for (int j = n - 1; j >= Math.max(k - i, i); j--) {
                    if (j == i) continue;
                    System.out.println((i + 1) + " " + (j + 1));
                }
            }
        }
    }
}