#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main(){
	vector<vector<int>> towers;
	set<int> s_blocks;
	int n_towers, n_blocks, block;
	long long combines = 0, splits = 0;
	cin >> n_towers;
	towers.resize(n_towers);

	for (int i = 0; i < n_towers; i++) {
		cin >> n_blocks;
		for (int j = 0; j < n_blocks; j++) {
			cin >> block;
			s_blocks.insert(block);
			towers[i].push_back(block);
		}
	}

	for (auto tower : towers) {
		for (int j = 0; j < tower.size(); j++) {
			if (j != tower.size()-1) {
				if (tower[j + 1] < tower[j]) {
					splits++;
					continue;
				}
				auto curr = s_blocks.find(tower[j]);
				curr++;
				if (tower[j + 1] != *curr) {
					splits++;
					continue;
				}
			}
		}
	}

	combines = splits + n_towers - 1;

	cout << splits << " " << combines << endl;
}
