// Exer.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <set>
#include <vector>
#include <iterator>

int main()
{
	
	std::set<int> ords;
	std::vector<std::vector<int>> inp;
	int splits, combines;

	splits = 0;
	combines = 0;

	int n;
	std::cin >> n;
	inp.resize(n);
	for (int i = 0; i < n; i++) {
		int k;
		std::cin >> k;
		inp[i].resize(k);
		for (int j = 0; j < k; j++) {
			int cinp;
			std::cin >> cinp;
			inp[i][j] = cinp;
			ords.insert(cinp);
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = inp[i].size()-1; j > 0; j--) {
			auto it = ords.find(inp[i][j]);
			if (it != ords.cbegin()) {
				it--;
			}
			if (*it != inp[i][j-1]) {
				splits++;
			}
		}
	}
	combines = splits + n - 1;

	std::cout << splits << ' ' << combines << std::endl;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
