#include <bits/stdc++.h>
using namespace std;
int t;

void solveFor2(vector<int> &a) {
    if(a[0] == 1) {
        cout << "Impossible\n";
    } else {
        cout << "Possible\n2 1\n 2 1\n";
    }
}

void printVec(const vector<int>& vec, int n) {
    for(int i = 0; i < n; ++i) {
        cout << vec[i] + 1;
        if(i != n - 1) {
            cout << ' ';
        }
    }
    cout << '\n';
}

void solve(vector<int> &a, int n) {
    if(n == 1) {
        cout << "Impossible\n";
        return;
    }
    if(n == 2) {
        solveFor2(a);
        return;
    }
    vector<int> pqs(n);
    for (int i = 0; i < n; ++i) {
        pqs[a[i]] = i;
    }
    vector<int> p(n);
    vector<int> q(n);
    set<int> used;
    for(int i = 0; i < n; ++i) {
        int val = (i + 1) % n;
        while(used.find(val) != used.end() || pqs[i] == val) {
            val = (val + 1) % n;
        }
        q[i] = val;
        used.insert(val);
    }

    for(int i = 0; i < n; ++i) {
        p[q[i]] = pqs[i];
    }
    cout << "Possible\n";
    printVec(p, n);
    printVec(q, n);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> t;
    while(t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (int i = 0; i < n; ++i) {
            int num; cin >> num;
            num--;
            a[i] = num;
        }
        solve(a, n);
    }
    return 0;
}