#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    map<int, int> mp;
    vector< vector<int> > towers;
    vector<int> totals;

    int n;
    cin >> n;
    for(int i = 0; i < n; i++) {
        int k;
        vector<int> tower;

        cin >> k;
        for(int j = 0; j < k; j++) {
            int a;

            cin >> a;
            tower.push_back(a);
            totals.push_back(a);
        }
        towers.push_back(tower);
    }

    sort(totals.begin(), totals.end());

    for (int i = 0; i < totals.size(); i++) {
        mp[totals[i]] = i;
    }

    int splits = 0;
    for(int i = 0; i < n; i++) {
        vector<int> tower = towers[i];
        for(int j = 0; j < tower.size() - 1; j++) {
            int curInd = mp[tower[j]];
            int nextInd = mp[tower[j + 1]];

            if(nextInd - curInd != 1) {
                splits++;
            }
        }
    }

    cout << splits << " " << n + splits - 1 << endl;


    return 0;
}