#include<bits/stdc++.h>

#define pb push_back

using namespace std;


void solve4() {
    int n = 4;
    vector<int> perm(5),a(5);
    for(int i = 1; i <= 4; i++) {
        int x;
        cin >> x;
        a[x]=i;
        perm[i] = i;
    }
    do{
        bool ind = true;
        for(int i = 1; i < 5; i++) {
            if(perm[i] == i) {
                ind = false;
                break;
            }
        }
        vector<int> q(5,0);
        for(int i = 1; i < 5; i++) {
            q[perm[i]] = a[i];
        }
        for(int i = 1; i < 5; i++) {
            if(q[i] == i) {
                ind = false;
                break;
            }
        }
        if(ind) {
            cout << "Possible" << endl;
            for(int i = 1; i < 5; i++) {
                cout << q[i] << " ";
            }
            cout << endl;
            for (int i = 1; i < 5; i++) {
                cout << perm[i] << " ";
            }
            cout << endl;
            return;
        }
    } while(next_permutation(perm.begin() + 1, perm.end()));
    cout << "Impossible" << endl;
}

void solve() {
    int n;
    cin >> n;
    if(n==4){
        solve4();
        return;
    }
    int a[n + 1], p[n + 1], q[n + 1];
    memset(a, 0, sizeof(a));
    memset(p, 0, sizeof(p));
    memset(q, 0, sizeof(q));
    for (int i = 1; i <= n; i++) {
        int x;
        cin >> x;
        a[x] = i;
    }
    if(n==1){
        cout << "Impossible" << endl;
        return;
    }
    set<int> st;
    for (int i = 1; i <= n; i++) {
        st.insert(-i);
    }
    for (int i = 1; i <= n - 2; i++) {
        int mx = *st.begin();
        st.erase(st.begin());
        mx = -mx;
        if (mx != i && mx != a[i]) {
            p[i] = mx;
            continue;
        }
        int mx2 = *st.begin();
        st.erase(st.begin());
        mx2 = -mx2;
        if (mx2 != i && mx2 != a[i]) {
            p[i] = mx2;
            st.insert(-mx);
            continue;
        }
        int mx3 = *st.begin();
        st.erase(st.begin());
        mx3 = -mx3;
        p[i] = mx3;
        st.insert(-mx2);
        st.insert(-mx);
    }
    int a1 = *st.begin();
    st.erase(st.begin());
    int a2 = *st.begin();
    a1 = -a1;
    a2 = -a2;
    if ((a[n - 1] != a1 && n - 1 != a1) && (a[n] != a2 && n != a2)) {
        p[n - 1] = a1;
        p[n] = a2;
    } else {
        p[n - 1] = a2;
        p[n] = a1;
    }
    for (int i = 1; i <= n; i++) {
        q[p[i]] = a[i];
    }
    for (int i = 1; i <= n; i++) {
        if (p[i] == i || q[i] == i) {
            cout << "Impossible" << endl;
            return;
        }
    }
    cout << "Possible" << endl;
    for (int k = 1; k <= n; k++) {
        cout << q[k] << " ";
    }
    cout << endl;
    for (int i = 1; i <= n; i++) {
        cout << p[i] << " ";
    }
    cout << endl;
}

int main() {
    int T;
    cin >> T;
    while (T--) {
        solve();
    }
}