#include <iostream>
#include <set>

using namespace std;

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, k;
	cin >> n >> k;

	if (k == n)
	{
		cout << "NO" << endl;
	}
	else if (k == 1)
	{
		if (n == 2)
		{
			cout << "YES" << endl << "1 2" << endl;
			return 0;
		}

		cout << "YES" << endl;
		cout << n << endl;
		for (int i = 1; i < n; i++) cout << i << " " << (i + 1) << endl;
		cout << "1 " << n << endl;
	}
	else if (k == 2)
	{
		cout << "YES" << endl;
		cout << (n - 1) << endl;
		for (int i = 2; i <= n; i++) cout << "1 " << i << endl;
	}
	else
	{
		cout << "YES" << endl;

		set<pair<int, int>> bridges;

		if (k + 2 <= n) 
		{
			bridges.insert({ 1, k + 2 });
			bridges.insert({ k + 2, 1 });
		}
		for (int i = k + 2; i < n; i++)
		{
			bridges.insert({ i, i + 1 });
			bridges.insert({ i + 1, i });
		}

		bridges.insert({ 1, 3 });
		bridges.insert({ 2, 3 });
		bridges.insert({ 3, 1 });
		bridges.insert({ 3, 2 });

		//cout << "Bridge has" << endl;
		//for (auto bridge : bridges) if(bridge.first < bridge.second) cout << bridge.first << " " << bridge.second << endl;

		for (int size = 3; size <= k; size++)
		{
			int bigIndex = size + 1;
			for (int i = 1; i < bigIndex; i++)
			{
				//cout << "Added " << i << " " << bigIndex << endl;
				bridges.insert({ i, bigIndex });
				bridges.insert({ bigIndex, i });
			}

			for (int eraseI = 2; (eraseI - 1) * 2 < bigIndex; eraseI++)
			{
				auto it = bridges.lower_bound({ eraseI, 0 });
				pair<int, int> reversed = {it->first, it->second };
				//cout << "Erasing " << eraseI << " at " << it->first << " " << it->second << endl;
				bridges.erase(it);
				bridges.erase(reversed);
			}
		}

		cout << bridges.size() / 2 << endl;
		for (auto bridge : bridges) if (bridge.first < bridge.second) cout << bridge.first << " " << bridge.second << "\n";
		cout << endl;
	}
}