#include <bits/stdc++.h>
#define FAST_READ ios_base::sync_with_stdio(0);

using namespace std;

vector<int>used;
vector<set<int> >adj;

void dfs(int v)
{
  used[v] = 1;
  for(auto to: adj[v])
  {
    if(used[to] == 0)
    {
      dfs(to);
    }
  }
}

int main(){
FAST_READ;
int n, k;
cin >> n >> k;
if(n == k)
{
  cout << "NO" << endl;
  return 0;
}
vector<int>degrees(n + 1, n - 1);

set<int>diff;
for(int i = 1; i <= n; i++)
{
  diff.insert(degrees[i]);
}


adj.resize(n + 1);

for(int i = 1; i <= n; i++)
{
  for(int j = i + 1; j <= n; j++)
  {
    adj[i].insert(j);
    adj[j].insert(i);
  }
}

int beg = n - k;
int f = 0;
while((int)diff.size() != k)
{
  vector<vector<int> >cnt(n + 1);

  for(int i = 1; i <= n; i++)
  {
    cnt[(int)adj[i].size()].push_back(i);
  }
  int sig = 0;
  for(int i = 1; i <= n; i++)
  {
    if((int)cnt[i].size() >= 2)
    {
      int a = cnt[i][0];
      int b = -1;
      for(auto j: adj[a])
      {
        if((int)adj[j].size() == 1)continue;
        if(f == 1 and (int)adj[j].size() == (int)adj[a].size())continue;
        b = j;
        break;
      }
      if(b != -1)
      {
         adj[a].erase(adj[a].find(b));
         adj[b].erase(adj[b].find(a));
         sig = 1;
         break;
      }

    }
  }

  if(sig == 0)
  {
      cout << "NO" << endl;
      return 0;
  }

  diff.clear();

  for(int i = 1; i <= n; i++)
  {
    diff.insert((int)adj[i].size());
  }
  f = 1;
}


if((int)diff.size() != k)
{
  cout << "NO" << endl;
  return 0;
}


used.resize(n + 1, 0);
int cnt = 0;
for(int i = 1; i <= n; i++)
{
  if(used[i] == 0)
  {
    cnt++;
    dfs(i);
    if(cnt >= 2)
    {
        cout << "NO" << endl;
        return 0;
    }

  }
}

vector<pair<int, int> >ans;

for(int i = 1; i <= n; i++)
{
  for(auto j: adj[i])
  {
    ans.push_back(make_pair(i, j));
    adj[j].erase(adj[j].find(i));
  }
}
cout << "YES" << endl;
cout << (int)ans.size() << endl;
for(auto i: ans)
{
  cout << i.first << " " << i.second << endl;
}




return 0;
}
