#include <bits/stdc++.h>
#define FAST_READ ios_base::sync_with_stdio(0); cin.tie(0);cout.tie(0);

using namespace std;

vector<int>used;
vector<set<int> >adj;

void dfs(int v)
{
  used[v] = 1;
  for(auto to: adj[v])
  {
    if(used[to] == 0)
    {
      dfs(to);
    }
  }
}

int main(){
FAST_READ;
int n, k;
cin >> n >> k;
if(n == k)
{
  cout << "NO" << endl;
  return 0;
}
int tmp = k;
adj.resize(n + 1);


for(int i = 1; i <= n; i++)
{
  for(int j = k + 1; j <= n; j++)
  {

    if(i != j)
    {
      adj[j].insert(i);
      //cout << i << " " << j << endl;
      adj[i].insert(j);
    }
  }
  if(k > 1)k--;
}
set<int>diff;
for(int i = 1; i <= n; i++)
{
    diff.insert((int)adj[i].size());
}

k = tmp;
if((int)diff.size() != k)
{
  cout << "NO" << endl;
  return 0;
}


used.resize(n + 1, 0);
int cnt = 0;
for(int i = 1; i <= n; i++)
{
  if(used[i] == 0)
  {
    cnt++;
    dfs(i);
    if(cnt >= 2)
    {
        cout << "NO" << endl;
        return 0;
    }

  }
}

vector<pair<int, int> >ans;

for(int i = 1; i <= n; i++)
{
  for(auto j: adj[i])
  {
    ans.push_back(make_pair(i, j));
    adj[j].erase(adj[j].find(i));
  }
}
cout << "YES" << endl;
cout << (int)ans.size() << endl;
for(auto i: ans)
{
  cout << i.first << " " << i.second << endl;
}




return 0;
}
