#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

void solve(){
    int n;
    cin >> n;
    vector<int> a(n+1),p(n+1,-1),q(n+1,-1);
    map<int,int> aind,pind,qind;
    for(int i = 1; i <= n; i++){
        cin >> a[i];
        aind[a[i]]=i;
    }
    if(n==1) {
        cout << "Impossible"<<endl;
        return;
    }
    // generate p
    int last_full_ind = 1;
    for(int i = n; i > n/2;i--){
        int cur_ind = last_full_ind;
        while(cur_ind==aind[i] || p[cur_ind]!=-1 || cur_ind == i){
            cur_ind++;
        } 
        p[cur_ind] = aind[i];
        if(cur_ind == last_full_ind) last_full_ind++;
    }
    for(int i = 1; i <= n/2;i++){
        int cur_ind = last_full_ind;
        while(cur_ind==aind[i] || p[cur_ind]!=-1 || cur_ind == i){
            cur_ind++;
        } 
        p[cur_ind] = aind[i];
        if(cur_ind == last_full_ind) last_full_ind++;
    }
    for(int i = 1; i <=n;i++){
        pind[p[i]] = i;
    }
    // generate q

    for(int i = 1; i <=n ; i++){
        q[i] = pind[aind[i]];
    }

    for(int i = 1; i<=n;i++){
        if(p[i] ==i || q[i] == i || q[i]==-1 || p[i] == -1){
            cout << "Impossible"<<endl;
            return;
        }
    }
    cout <<"Possible" <<endl;
    for(int i = 1; i <= n; i++){
        cout << p[i] << " ";
    } cout << endl;
    for(int i = 1; i <= n; i++){
        cout << q[i] << " ";
    } cout << endl;
}

int main(){
    int n;
    cin >> n;

    while(n--){
        solve();
    }

    return 0;
}