#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;

    vector <int> a(n + 1), w(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        w[a[i]] = i;
    }

    if (n <= 10) {
        vector <int> q(n + 1);
        iota(q.begin(), q.end(), 0);

        do {
            bool flag = 1;
            for (int i = 1; i <= n; i++) {
                if (q[i] == i) {
                    flag = 0;
                    break;
                }
            }
            if (!flag) continue;
            vector <int> p(n + 1);
            for (int i = 1; i <= n; i++) {
                p[ q[i] ] = w[i];
                if (p[q[i]] == q[i]) {
                    flag = 0;
                    break;
                }
            }
            if (flag) {
                cout << "Possible\n";
                for (int i = 1; i <= n; i++) {
                    cout << p[i] << " ";
                }
                cout << endl;
                for (int i = 1; i <= n; i++) {
                    cout << q[i] << " ";
                }
                cout << endl;
                return;
            }
        } while(next_permutation(q.begin() + 1, q.end()));
        cout << "Impossible\n";
        return;
    }

    vector <int> q(n + 1);
    iota(q.begin(), q.end(), 0);

    while (true) {
        random_shuffle(q.begin(), q.end());
        vector <int> p(n + 1);
        int flag = 1;
        for (int i = 1; i <= n; i++) {
            p[ q[i] ] = w[i];
            if (p[q[i]] == q[i] || q[i] == i) {
                flag = 0;
                break;
            }
        }
        if (flag) {
            cout << "Possible\n";
            for (int i = 1; i <= n; i++) {
                cout << p[i] << " ";
            }
            cout << endl;
            for (int i = 1; i <= n; i++) {
                cout << q[i] << " ";
            }
            cout << endl;
            return;
        }
    }
}

int main() {
    srand(time(NULL));
    int tt;
    cin >> tt;
    while (tt--) solve();
}
