#include <bits/stdc++.h>
using namespace std;
vector<int> sTower;

int binarySearch (int el, int a, int b) {
    int l = a - 1;
    int r = b + 1;
    while (true) {
        int mid = (r + l) / 2;
        if (sTower[mid] == el) {
            return mid;
        } else if (sTower[mid] < el){
            l = mid;
        } else {
            r = mid;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int n, splits = 0, combs = 0;
    cin>>n;
    vector<vector<int>> towers(n);
    for (int i = 0; i < n; ++i) {
        int k, prev = -1;
        cin>>k;
        for (int j = 0; j < k; ++j) {
            int a;
            cin>>a;
            sTower.push_back(a);
            towers[i].push_back(a);
        }
    }
    std::sort(sTower.begin(), sTower.end());
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < towers[i].size(); ++j) {
            if (j == towers[i].size() - 1) {
                combs ++;
                break;
            }
            int a = towers[i][j];
            int b = towers[i][j + 1];
            int pos = binarySearch(a, 0, sTower.size() - 1);
            int posNext = binarySearch(b, 0, sTower.size() - 1);
            if (pos == sTower.size() - 1 || posNext != pos + 1) {
                combs ++;
                splits ++;
            }
        }
    }

    cout<<splits<<" "<<combs - 1;




    return 0;
}