#include <stdlib.h>
#include <iostream>
#include <string>
#include <deque>
#include <vector>
#include <algorithm>

using namespace std;
#define ll long long
#define ull unsigned ll
#define forn(i, n) for (ll i = 1; i <= n; i++)
#define dforn(i, a, b) for (ll i = a; i <= b; i++)
#define rforn(i, n) for (ll i = n; i >= 1; i--)
#define rdforn(i, a, b) for (ll i = b; i <= a; i--)
const ll mod = 1e9 + 7;
const ll N = 1e5;
const ll inf = 1e17;
const double eps = 1e-7;

void solve() {
	ll n;
	cin >> n;
	vector<ll> vec;
	vector<vector<ll>> kek(n + 1);
	ll spl_cnt = 0, mrg_cnt = n;
	forn(i, n) {
		ll k;
		cin >> k;
		forn(j, k) {
			ll a;
			cin >> a;
			kek[i].push_back(a);
			vec.push_back(a);
		}
	}
	sort(vec.begin(), vec.end());
	forn(i, n) {
		dforn(j, 1, kek[i].size() - 1) {
			ll pos = lower_bound(vec.begin(), vec.end(), kek[i][j]) - vec.begin();
			pos--;
			if (pos == -1 || vec[pos] != kek[i][j - 1]) {
				spl_cnt++;
			}
		}
	}
	mrg_cnt += spl_cnt;
	cout << spl_cnt << " " << mrg_cnt - 1 << endl;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t = 1;
	//cin >> t;
	while (t) {
		t--;
		solve();
	}
	return 0;
}