#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair

#define f first
#define s second

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int N = (int) 1123;
const int MOD = (int) 1e9 + 7;
const int P1 = 1003;
const int P2 = 1234;

int p[105][1005];
int where[105][1005];
int n, k;
int par[1005];

pair<int,int> h[105][1005];

int pw1[N], pw2[N];

int add(int a, int b) {
    a += b;
    if(a >= MOD) a -= MOD;
    return a;
}

int mult(int a, int b) {
    return a * (ll)b % MOD;
}

pair<int,int> get(int l, int r, int ver) {
    if(l < 0 || r > n)
        return {-1, -1};
    int r1, r2;
    tie(r1, r2) = h[ver][r];
    int rem1, rem2;
    tie(rem1, rem2) = h[ver][l - 1];

    return {add(r1, MOD - rem1), add(r2, MOD - rem2)};
}

void go(int l, int r, int mySup = -1) {
    if(l == r) {
        par[p[1][l]] = mySup;
        return ;
    }

    for (int m = l + 1; m < r; ++m) {
        int super = p[1][m];
        int left_len = (m - l);
        int right_len = (r - m);
        auto left_hsh = get(l, m - 1, 1);
        auto right_hsh = get(m + 1, r, 1);
        bool bad = false;
//        cout << left_hsh.first << ' ' << right_hsh.first << '\n';
        for (int vv = 2; vv <= k; ++vv) {
            int p = where[vv][super];
//            cout << p << '\n';
//            cout << get(p - left_len, p - 1, vv).first << ' ';
//            cout << get(p + 1, p + right_len, vv).first << '\n';
            if(get(p - left_len, p - 1, vv) == left_hsh
                && get(p + 1, p + right_len, vv) == right_hsh) {
                continue;
            }

            if(get(p - right_len, p - 1, vv) == right_hsh
               && get(p + 1, p + left_len, vv) == left_hsh) {
                continue;
            }

            bad = true;
            break;
        }

        if(!bad) {
            par[super] = mySup;
            go(l, m - 1, super);
            go(m + 1, r, super);
            return;
        }
    }
//    cout << "ERR: " << l << ' ' << r << endl;
}

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> k;
    for (int i = 1; i <= k; ++i) {
        for (int j = 1; j <= n; ++j) {
            cin >> p[i][j];
            where[i][p[i][j]] = j;
        }
    }
    pw1[0] = pw2[0] = 1;
    for (int i = 1; i < N; ++i) {
        pw1[i] = pw1[i-1] * (ll)P1 % MOD;
        pw2[i] = pw2[i-1] * (ll)P2 % MOD;
    }


    for (int i = 1; i <= k; ++i) {
//        cout << "ver: " << i << '\n';
        for (int j = 1; j <= n; ++j) {
            int p1, p2;
            tie(p1, p2) = h[i][j-1];

            p1 = add(p1, pw1[p[i][j]]);
            p2 = add(p2, pw2[p[i][j]]);
//            cout <<j << " p: " << p1 << ' ' << p2 << '\n';
            h[i][j] = {p1, p2};
        }
    }

    go(1, n);
    for (int i = 1; i <= n; ++i) {
        cout << par[i] << " \n"[i == n];
    }


    return 0;
}