#include <bits/stdc++.h>

using namespace std;

#define forn(x, a, b) for (int x = a; x <= b; ++x)

const int N = 2e5 + 6;

int a[N], n;
int q[N], p[N];

void check() {
    int pos = -1;
    forn(i, 1, n) {
        if (q[i] == i || a[q[i]] == i) {
            pos = i;
            break;
        }
    }

//    cerr << pos << endl;
    if (pos == -1) return;

    forn(i, 1, n) {
        if (i == pos) continue;
        if (a[q[pos]] != i && a[q[i]] != pos && q[pos] != i && q[i] != pos) {
            swap(q[i], q[pos]);
            return;
        }
    }

    assert(0);
}

void solve() {
    cin >> n;
    forn(i, 1, n) {
        cin >> a[i];
    }

    if (n < 7) {
        forn(i, 1, n) {
            q[i] = i;
        }
        do {
            int ok = 1;
            forn(i, 1, n) {
                if (q[i] == i || a[q[i]] == i) {
                    ok = 0;
                    break;
                }
            }
            if (ok) break;
        } while (next_permutation(q + 1, q + n + 1));

        forn(i, 1, n) {
            if (q[i] == i || a[q[i]] == i) {
                cout << "Impossible" << endl;
                return;
            }
        }
    }
    else {

        q[1] = n;
        forn(i, 2, n) {
            q[i] = i - 1;
        }

        forn(i, 2, n) {
            if (a[q[i]] != i) continue;
//            cerr << i << endl;
            swap(q[i], q[1]);
        }

        check();
        check();
    }

    forn(i, 1, n) {
        p[a[q[i]]] = i;
    }

    cout << "Possible" << endl;
    forn(i, 1, n) {
        cout << q[i] << " ";
    }
    cout << endl;
    forn(i, 1, n) {
        cout << p[i] << " ";
    }
    cout << endl;
}

int main() {
#ifdef Local
    freopen(".in", "r", stdin);
#endif

    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }

    return 0;
}
