#include <bits/stdc++.h>

using namespace std;

int n, k;
vector<vector<int>> records;
int p[1010];
long long mod = (long long)1e11+77;

void restore(vector<vector<int>> cur, int par = -1) {
    if (cur[0].size() <= 2) {
        for (auto v : cur[0]) {
            p[v] = par;
        }
        return;
    }
    vector<vector<int>> pos;
    vector<vector<long double>> pref;
    pos.resize(cur.size());
    pref.resize(cur.size());
    for (int i = 0; i < cur.size(); ++i) {
        long double h = 0;
        pos[i].resize(n+1);
        for (int j = 0; j < cur[i].size(); ++j) {
            pos[i][cur[i][j]] = j;
            h += sqrt(cur[i][j]*1.0);
            pref[i].push_back(h);
        }
    }
    for (int v : cur[0]) {
        long double h1 = -1, h2 = -1;
        bool ok = 1;
        for (int i = 0; i < cur.size(); ++i) {
            int pp = pos[i][v];
            if (pp == 0 || pp == pos[i].size() - 1) {
                ok = 0;
                break;
            }
            long double hh1 = (pp > 0 ? pref[i][pp-1] : 0);
            long double hh2 = pref[i].back() - pref[i][pp];
            if (h1 == -1) {
                h1 = hh1;
                h2 = hh2;
            }
            if (!((h1 == hh1 && h2 == hh2) || (h2 == hh1 && h1 == hh2))) {
                ok = 0;
                break;
            }
        }
        if (ok) {
            p[v] = par;
            vector<vector<int>> left, right;

            for (int i = 0; i < cur.size(); ++i) {
                vector<int> curnxt;
                long double curh = 0;
                for (int ver : cur[i]) {
                    if (v == ver) {
                        if (curh == h1) {
                            left.push_back(curnxt);
                        } else {
                            right.push_back(curnxt);
                        }
                        curh = 0;
                        curnxt.clear();
                    } else {
                        curnxt.push_back(ver);
                        curh += sqrt(1.0*ver);
                    }
                }
                if (curh == h1) {
                    left.push_back(curnxt);
                } else {
                    right.push_back(curnxt);
                }
            }
            restore(left, v);
            restore(right, v);
            break;
        }
    }
}

int main() {
#ifdef Local
    freopen(".in", "r", stdin);
#endif
    cin >> n >> k;

    for (int i = 0; i < k; ++i) {
        vector<int> record;
        for (int j = 0; j < n; ++j) {
            int x; cin >> x;
            record.push_back(x);
        }
        records.push_back(record);
    }

    restore(records);

    for (int i = 1; i <= n; ++i) {
        cout << p[i] << ' ';
    }

    return 0;
}
