#include <bits/stdc++.h>
using namespace std;

#define f first
#define s second
#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

typedef long long ll;

const int N = 1e5;
const int M = N + 7;
const int MOD = 1e9 + 7;
const ll INF = 1e16 + 7;

int a[M], p[M], q[M];
int pos[M];
vector<int> cycle[M];
bool used[M];

void dfs(int v, int t) {
    cycle[t].pb(v);
    used[v] = true;
    if (!used[pos[v]]) {
        dfs(pos[v], t);
    }
}

void solve() {
    int n;
    scanf("%d", &n);
    for (int i = 1; i <= n; i++) {
        scanf("%d", &a[i]);
        pos[a[i]] = i;
        used[i] = false;
    }

//    if (n == 1 || (n == 2 && a[1] == 2)) {
//        printf("Impossible\n");
//        return;
//    }

    int cycles = 0;
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            cycle[++cycles].clear();
            dfs(i, cycles);
        }
    }

    sort(cycle + 1, cycle + 1 + cycles, [](vector<int> &a, vector<int> &b) {
        return sz(a) < sz(b);
    });

    int first = 0;
    for (int i = 1; i <= n; i++) {
        if (sz(cycle[i]) > 1) {
            first = i;
            break;
        }
    }

    for (int i = 1; i <= cycles; i++) {
        for (int j = 0; j < sz(cycle[i]); j++) {
            int val = cycle[i][j];
            if (j <= 1 && cycles != 1) {
                if (!j) {
                    q[val] = cycle[i % cycles + 1][0];
                } else {
                    q[val] = cycle[(i == cycles ? first : i + 1)][1];
                }
            } else {
                q[val] = cycle[i][(j + sz(cycle[i]) - 1) % sz(cycle[i])];
            }
        }
    }

    for (int i = 1; i <= n; i++) {
        p[q[i]] = pos[i];
    }

    for (int i = 1; i <= n; i++) {
        if (p[i] == i || q[i] == i || a[p[q[i]]] != i) {
            printf("Impossible\n");
            return;
        }
    }
    
    printf("Possible\n");
    for (int i = 1; i <= n; i++) {
        printf("%d ", p[i]);
    }
    printf("\n");
    for (int i = 1; i <= n; i++) {
        printf("%d ", q[i]);
    }
    printf("\n");
}

int main() {
    int TT = 1;
    scanf("%d", &TT);
    for (int i = 1; i <= TT; i++) {
        solve();
    }
    return 0;
}