#include <bits/stdc++.h>
using namespace std;

#define f first
#define s second
#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

typedef long long ll;

const int N = 1e3;
const int M = N + 7;
const int K = 100;
const int MOD = 1e9 + 7;
const ll INF = 1e16 + 7;

int a[M][K];
int lst[M][M], timer;
int cnt[M][M];
int cntt[M];

int par[M], deg[M];
int b[K], sz_b;
int used[M];

inline void add(int v, int u) {
    if (lst[v][u] != timer) {
        cnt[v][u] = cnt[u][v] = 1;
        lst[v][u] = timer;
    } else {
        cnt[v][u]++;
        cnt[u][v]++;
    }
}

int get(int v, int u) {
    if (lst[v][u] != timer)
        return 0;
    return cnt[v][u];
}

void solve() {
    int n, k;
    scanf("%d %d", &n, &k);
    for (int i = 1; i <= k; i++) {
        for (int j = 1; j <= n; j++) {
            scanf("%d", &a[i][j]);
        }
    }

    for (int i = 1; i <= n; i++)
        par[i] = -1;

    int need = n - 1;
    while (need) {
        ++timer;

        for (int i = 1; i <= k; i++) {
            sz_b = 0;
            for (int j = 1; j <= n; j++) {
                int v = a[i][j];
                if (par[v] == -1)
                    b[++sz_b] = v;
            }
            for (int j = 2; j <= sz_b; j++) {
                add(b[j], b[j - 1]);
            }
        }
        for (int i = 1; i <= 1; i++) { // can we do it with only first?
            sz_b = 0;
            for (int j = 1; j <= n; j++) {
                int v = a[i][j];
                if (par[v] == -1)
                    b[++sz_b] = v;
            }

            for (int j = 1; j <= sz_b; j++) {
                // only if first list is important
                if (deg[b[j]] == 1)
                    continue;
                
                int v = b[j];
                int vl = (j == 1 ? 0 : b[j - 1]);
                int vr = (j == sz_b ? 0 : b[j + 1]);
                
                if (get(v, vl) > get(v, vr)) {
                    par[v] = vl;
                    deg[vl]++;
                } else {
                    par[v] = vr;
                    deg[vr]++;
                }

                need--;
                break;
            }
        }
    }

    int roots = 0;
    for (int i = 1; i <= n; i++) {
        if (par[i] != -1) {
            cntt[par[i]]++;
        } else {
            roots++;
        }
    }

    assert(roots == 1);
    for (int i = 1; i <= n; i++) {
        assert(cntt[i] == 0 || cntt[i] == 2);
    }

    for (int i = 1; i <= n; i++) {
        printf("%d ", par[i]);
    }
    printf("\n");
}

int main() {
    int TT = 1;
    // scanf("%d", &TT);
    for (int i = 1; i <= TT; i++) {
        solve();
    }
    return 0;
}