#include <bits/stdc++.h>
using namespace std;

#define f first
#define s second
#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

typedef long long ll;

const int N = 1e1;
const int M = N + 7;
const int K = 70;
const int MOD = 1e9 + 7;
const ll INF = 1e16 + 7;

int X, Y;
ll last_dist = -1;

int timer;
string rep[K];
string closer, further, same;

ll dist(int x, int y) {
    return 1ll * (x - X) * (x - X) + 1ll * (y - Y) * (y - Y);
}

string ask(int x, int y) {
    cerr << "? " << timer + 1 << " | " << x << ' ' << y << "\n";
    assert(timer + 1 <= 64);
    if (x < 0 || x > 1e6 || y < 0 || y > 1e6) {
        cerr << "INVALID COORD\n";
        while (true) {
            cout << "0 0\n";
            fflush(stdout);
        }
    }

//    cout << x << ' ' << y << "\n";
    fflush(stdout);
//    getline(cin, rep[++timer]);
    ll d = dist(x, y);
    if (x == X && y == Y) {
        rep[++timer] = "Taptyn!";
    } else if (last_dist == -1) {
        rep[++timer] = "zhok";
    } else if (d < last_dist) {
        rep[++timer] = "zhakyn";
    } else if (d > last_dist) {
        rep[++timer] = "alys";
    } else {
        rep[++timer] = "birdey";
    }
    last_dist = d;

    if (rep[timer].back() == '!') {
        cerr << "OK!\ntries: " << timer << "\n";
        exit(0);
    }
    return rep[timer];
}

void solve() {
    ask(0, 0);
    ask(1, 1);
    ask(0, 0);

    if (rep[2] == rep[3]) {
        ask(0, 1);
        ask(1, 0);
        assert(false);
    }

    closer = rep[2];
    further = rep[3];

    int xl = -1, xr = 1e6;
    int yl = -1, yr = 1e6;

    while (xr - xl > 1 && yr - yl > 1) {
        int xm = (xl + xr) >> 1;
        int ym = (yl + yr) >> 1;

        ask(xm + 1, ym);
        string le = ask(xm, ym);
        string up = ask(xm, ym + 1);

        if (le == closer) {
            xr = xm;
        } else {
            xl = xm;
        }

        if (up == closer) {
            yl = ym;
        } else {
            yr = ym;
        }
        cerr << "+\n";
    }

    while (xr - xl > 1) {
        int xm = (xl + xr) >> 1;
        ask(xm + 1, yr);
        string le = ask(xm, yr);
        if (le == closer)
            xr = xm;
        else
            xl = xm;
        cerr << "+-\n";
    }

    while (yr - yl > 1) {
        int ym = (yl + yr) >> 1;
        ask(xr, ym);
        string up = ask(xr, ym + 1);
        if (up == closer)
            yl = ym;
        else
            yr = ym;
        cerr << "++\n";
    }

    ask(xr, yr);
    
    assert(false);
}

int main() {
    int TT = 1;
    // scanf("%d", &TT);
    cin >> X >> Y;
    for (int i = 1; i <= TT; i++) {
        solve();
    }
    return 0;
}