#include <bits/stdc++.h>
using namespace std;

#define f first
#define s second
#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

typedef long long ll;

const int N = 5e2;
const int M = N + 7;
const int MOD = 1e9 + 7;
const ll INF = 1e16 + 7;

vector<int> g[M];
bool used[M][M];

void add(int v, int u) {
    g[v].pb(u);
    g[u].pb(v);
    used[v][u] = used[u][v] = true;
}

void solve() {
    int n, k;
    scanf("%d %d", &n, &k); 
    if (k == 1) {
        if (n == 1) {
            printf("YES\n0\n");
        } else if (n == 2) {
            printf("YES\n1\n1 2\n");
        } else {
            printf("YES\n%d\n", n);
            for (int i = 1; i <= n; i++) {
                printf("%d %d\n", i, i % n + 1);
            }
        }
        return;
    }

    bool flag = false;
    for (int i = n - 1; i >= 1; i--) {
        int v = n - i;
        int need = i - sz(g[v]);
        for (int u = v + 1; u <= n; u++) {
            add(v, u);
            if (v == 1 && u < n)
                continue;
            
            unordered_set<int> s;
            for (int i = 1; i <= n; i++) {
                s.insert(sz(g[i]));
            }
        
            if (sz(s) == k) {
                flag = true;
                break;
            }

            if (sz(g[v]) == i)
                break;
        }

        if (flag)
            break;
    }

    if (!flag) {
        printf("NO\n");
        return;
    }

    unordered_set<int> s;
    for (int i = 1; i <= n; i++) {
        s.insert(sz(g[i]));
    }
    assert(sz(s) == k);

    vector<pair<int, int>> ans;
    for (int i = 1; i <= n; i++) {
        for (int j : g[i]) {
            if (i < j) {
                ans.pb({i, j});
            }
        }
    }

    printf("YES\n%d\n", sz(ans));
    for (auto &an : ans) {
        printf("%d %d\n", an.fi, an.se);
    }
}

int main() {
    int TT = 1;
    // scanf("%d", &TT);
    for (int i = 1; i <= TT; i++) {
        solve();
    }
    return 0;
}