#include <bits/stdc++.h>
using namespace std;

int cnt = 0;

string guess(int x, int y) {
    cnt++;
    cout << x << " " << y << endl;
    string s;
    cin >> s;

    assert(cnt <= 64);
    if (s.back() == '!') {
        exit(0);
    }
    return s;
}

const int MAX = 1000000;

void solve1(string close, string far, string same) {
    int l = 0, r = MAX;
    int X = -1;
    guess(0, 0);
    while (r - l > 3) {
        int m1 = l + (r - l) / 3;
        int m2 = r - (r - l) / 3;
        string L = guess(m1, 0);
        string R = guess(m2, 0);
        if (R == close) {
            l = m1;
        } else {
            r = m2;
        }
    }
    X = l;
    for (int j = l; j <= r; ++j) {
        string z = guess(j, 0);
        if (z == close) {
            X = j;
        }
    }
    guess(X, 0);
    l = 0, r = MAX;
    while (r - l > 3) {
        int m1 = l + (r - l) / 3;
        int m2 = r - (r - l) / 3;
        string L = guess(X, m1);
        string R = guess(X, m2);
        if (R == close) {
            l = m1;
        } else {
            r = m2;
        }
    }
    for (int j = l; j <= r; ++j) {
        guess(X, j);
    }
}

void solve2(string x, string y, string same) {
    int l = 0, r = MAX;
    int cnt = 1;
    guess(0, 0);
    while (r - l > 3) {
        int m1 = l + (r - l) / 3;
        int m2 = r - (r - l) / 3;
        string L = guess(m1, 0);
        string R = guess(m2, 0);
        if (R != x) {
            l = m1;
        } else {
            r = m2;
        }
    }
    for (int j = l; j <= r; ++j) {
        guess(j, 0);
    }
    guess(0, 0);
    l = 0, r = MAX;
    while (r - l > 3) {
        int m1 = l + (r - l) / 3;
        int m2 = r - (r - l) / 3;
        string L = guess(0, m1);
        string R = guess(0, m2);
        if (R != y) {
            l = m1;
        } else {
            r = m2;
        }
    }
    for (int j = l; j <= r; ++j) {
        guess(j, 0);
    }
}

int main() {
    guess(0, 0);
    string same = guess(0, 0);
    string x = guess(0, 1);
    guess(0, 0);
    string y = guess(1, 0);

    if (x == y) {
        solve1(x, y, same);
    } else {
        solve2(x, y, same);
    }
}
