#include <bits/stdc++.h>

using namespace std;

const int N = (int) 1e5 + 7;

int pos[N], a[N];
int n, q[N], p[N];

void solve(){
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pos[a[i]] = i;
    }
    unordered_set<int> good;
    for (int i = 1; i <= n; i++) {
        good.insert(i);
    }
    if (n <= 5) {
        vector<int> all;
        for (int i = 1; i <= n; i++) {
            all.push_back(i);
        }
        bool found = false;
        do {
            bool good = true;
            for (int i = 1; i <= n; i++) {
                int cur = all[i - 1];
                if (cur == i || cur == pos[i]) good = false;
            }
            if (good) {
                found = true;
                for (int i = 1; i <= n; i++) q[i] = all[i - 1];
                break;
            }
        } while (next_permutation(all.begin(), all.end()));
        if (!found) {
            cout << "Impossible" << '\n';
            return;
        }
    } else {
        for (int i = 1; i <= n; i++) {
            int y = pos[i];
            int found_value = -1;
            for (auto x: good) {
                if (x != i && x != y) {
                    found_value = x;
                    break;
                }
            }
            if (found_value == -1) {
                break;
            }
            q[i] = found_value;
            good.erase(found_value);
            // cout << "found_value " << i << " " << found_value << endl;
        }
        if (good.size() == 1) {
            // cout << "CASE1" << endl;
            int last = *good.begin();
            for (int i = 1; i <= n - 1; i++) {
                if (last != i && q[i] != n && last != pos[i]) {
                    q[n] = q[i];
                    q[i] = last;
                    break;
                }
            }
        } else if (good.size() == 2) {
            int last1 = *good.begin();
            good.erase(good.begin());

            for (int i = 1; i <= n - 2; i++) {
                if (last1 != i && q[i] != n - 1 && i != q[i] && last1 != pos[i]) {
                    // cout << "SWAP1" << endl;
                    q[n - 1] = q[i];
                    q[i] = last1;
                    break;
                }
            }

//            cout << "after first swap" << endl;
//            for (int i = 1; i <= n; i++) cout << q[i] << " ";
//            cout << endl;

            last1 = *good.begin();
            for (int i = 1; i <= n - 3; i++) {
                if (last1 != i && q[i] != n && i != q[i] && last1 != pos[i]) {
                    // cout << "SWAP2" << endl;
                    q[n] = q[i];
                    q[i] = last1;
                    break;
                }
            }
        }
    }
    cout << "Possible\n";
    for (int i = 1; i <= n; i++) {
        p[q[i]] = pos[i];
    }
    for (int i = 1; i <= n; i++) {
        cout << p[i] << " ";
    }
    cout << '\n';
    for (int i = 1; i <= n; i++) {
        cout << q[i] << " ";
    }
    cout << '\n';
}
/*
 * 6
1 3 2 4 6 5
 */

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
