#include <bits/stdc++.h>

using namespace std;

const int N = (int) 1e5 + 7;

int nxt[N];

void solve(){
    int n;
    cin >> n;
    vector<vector<int>> blocks(n);
    vector<int> all;
    for (int i = 0; i < n; i++) {
        int m;
        cin >> m;
        blocks[i].resize(m);
        for (int j = 0; j < m; j++) {
            cin >> blocks[i][j];
            all.push_back(blocks[i][j]);
        }
    }
    sort(all.begin(), all.end());
    for (int i = 0; i < all.size() - 1; i++) {
        nxt[all[i]] = all[i + 1];
    }
    int blocks_cnt = 0, splits = 0;
    for (int i = 0; i < n; i++) {
        int left = 0, m = (int) blocks[i].size(), total = 0;
        while (left < m) {
            int start = left;
            while (left + 1 < m && blocks[i][left] < blocks[i][left + 1]) {
                left++;
            }
            blocks_cnt++;
            splits++;
            for (int j = start; j <= left - 1; j++) {
                if (nxt[blocks[i][j]] != blocks[i][j + 1]) {
                    splits++;
                    blocks_cnt++;
                }
            }
            left++;
        }
        splits--;
    }
    cout << splits << " " << blocks_cnt - 1 << endl;
}

int main() {
    solve();
    return 0;
}
