#include<bits/stdc++.h>

using namespace std;
#define For(i,n) for(int i = 0; i < n; i++)
#define ll long long
#define vt vector
#define all(x) x.begin(), x.end()

template<typename T>
void print(vt<T> & a) {
    For(i, a.size()) {
        cout << a[i] << " ";
    }
    cout << endl;
}

const int K = 101;
const int N = 1001;

vt<int> PAR(N);

void rec(int p, vt<vt<int> > & a) {
    if (a[0].size() == 0) return;
    if (a[0].size() == 1) {
        PAR[a[0][0]] = p;
        return;
    }
    int k = a.size();
    int m = a[0].size();
    map<int, set<int> > freq;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < m; j++) {
            int x = a[i][j];
            freq[x].insert(j);
        }
    }

    int mn = 10000;
    for (auto x : freq) {
        if (x.second.size() < mn) {
            mn = x.second.size();
        }
    }
    vt<int> mns;
    for (auto x : freq) {
        if (x.second.size() == mn) {
            mns.push_back(x.first);
        }
    }
    int appeared = 0;
    int mid = -1;
    for (int j = 0; j < m; j++) {
        int x = a[0][j];
        if (freq[x].size() == mn) {
            if (appeared == mns.size() / 2) {
            mid = x;
            break;
            }
            appeared++;
        }
    }


   
    vt<vt<vt<int> > > halfs(2, vt<vt<int> > (k));
    
    int appear_first_half = a[0][0];
    for (int i = 0; i < k; i++) {
        int cur = 0;
        for (int j = 0; j < m; j++) {
            int x = a[i][j];
            if (x == appear_first_half) break;
            if (x == mid) {
                cur ^= 1;
                break;
            }
        }
        for (int j = 0; j < m; j++) {
            int x = a[i][j];
            if (x == mid) {
                cur ^= 1;
                continue;
            }
            halfs[cur][i].push_back(x);
        }
    }

    PAR[mid] = p;

    rec(mid, halfs[0]);
    rec(mid, halfs[1]);
}

void solve()
{
    int n, k; cin >> n >> k;
    
    vt<vt<int> > journal(k);

    For(kk, k) {
        vt<int> a(n);
        For(i, n) {
            cin >> a[i];
        }
        journal[kk] = a;
    }
    rec(-1, journal);
    For(i, n) {
        cout << PAR[i + 1] << " ";
    }
    cout << endl;
}


int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int T = 1;

    for(int i = 0; i < T; i++) solve();

    return 0;
}