#include <bits/stdc++.h>
#define sz(x) (int)(x).size()
#define pb push_back

using namespace std;
using ll = long long;

const int N = (int)1e5 + 3;
const ll mod = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int t; cin >> t;

    while(t--) {
        int n; cin >> n;

        vector<int> a(n+1), p(n+1), q(n+1);
        for(int i = 1; i <= n; i++) {
            cin >> a[i];
        }

        if(n == 2 && a[1] == 2 && a[2] == 1) {
            cout << "Impossible\n";
            continue;
        }

        for(int i = 1; i <= n; i++) {
            p[i] = i;
        }

        int _ = min(n, 10), res = n;

        while(_--) {
            rotate(p.begin()+1, p.begin()+2, p.end());

            bool ok = false;
            for(int i = 1; i <= n; i++) {
                if(p[i] == i) {
                    _++;
                    ok = true;
                    break;
                }
            }
            if(ok) continue;

            for(int x = 1; x <= n; x++) {
                int i = a[p[x]];
                q[i] = x;
            }

            vector<int> used(n+1);
            res = n;
            for(int i = 1; i <= n; i++) {
                if(q[i] == i) continue;
                if(!used[q[i]]) {
                    res--;
                    used[q[i]] = true;
                }
            }

            if(res == 0) break;
        }

        if(res) {
            cout << "Impossible\n";
        }
        else {
            cout << "Possible\n";
            for(int i = 1; i <= n; i++) {
                cout << p[i] << " ";
            }
            cout << "\n";
            for(int i = 1; i <= n; i++) {
                cout << q[i] << " ";
            }
            cout << "\n";
        }
    }

    return 0;
}
