#include <bits/stdc++.h>

// using namespace std;

const int N = 10100;

std::vector<int> a[N];

int main() {
	int n;
	scanf("%d", &n);

	std::vector<int> all;
	for (int i = 0; i < n; ++i) {
		int sz;
		scanf("%d", &sz);
		a[i].resize(sz);

		for (int j = 0; j < sz; ++j) {
			scanf("%d", &a[i][j]);
			all.push_back(a[i][j]);
		}
	}

	std::sort(all.begin(), all.end());

	auto get = [&](int x) {
		return std::lower_bound(all.begin(), all.end(), x) - all.begin();
	};

	int towers = n;
	int split = 0;
	int merge = 0;
	for (int i = 0; i < n; ++i) {
		int sz = (int)a[i].size();
		for (int j = 1; j < sz; ++j) {
			int pos1 = get(a[i][j - 1]);
			int pos2 = get(a[i][j]);

			if (pos1 + 1 == pos2) {
				continue;
			}
			++split;
			++towers;
		}
	}

	merge = towers - 1;

	printf("%d %d\n", split, merge);

	return 0;
}