#include <bits/stdc++.h>

const int N = 510;

// using namespace std;

bool used[N][N];
std::vector<int> g[N];

// TODO: n = 1
void build(int n) {
	for (int i = 0; i < n; ++i) {
		for (int j = n - i - 1; j < n; ++j) {
			if (!used[i][j] && i != j) {
				used[i][j] = true;
				used[j][i] = true;
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}

	// for (int i = 0; i < n; ++i) {
	// 	for (auto to : g[i]) {
	// 		if (i < to) {
	// 			std::cout << i << ' ' << to << std::endl;
	// 		}
	// 	}
	// }

	std::set<int> degs;
	for (int i = 0; i < n; ++i) {
		assert(!g[i].empty());
		degs.insert((int)g[i].size());
	}

	// std::cout << "DEGS:" << std::endl;
	// for (auto d : degs) {
	// 	std::cout << d << ' ';
	// }
	// std::cout << std::endl;

	assert((int)degs.size() == n - 1);
	// std::cout << n << std::endl;
}

void solve(int n, int k) {
	if (n == 1) {
		printf("YES\n");
		printf("0\n");
		return;
	}
	if (k == n) {
		printf("NO\n");
		return;
	}

	int restN = k + 1;
	assert(restN <= n);

	build(restN);

	for (int i = restN; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			assert(!used[i][j]);
			used[i][j] = true;
			used[j][i] = true;
			g[i].push_back(j);
			g[j].push_back(i);
		}
	}
	
	for (int i = 0; i < restN; ++i) {
		for (int j = restN; j < n; ++j) {
			assert(!used[i][j]);
			used[i][j] = true;
			used[j][i] = true;
			g[i].push_back(j);
			g[j].push_back(i);
		}
	}

	std::vector<std::pair<int, int>> edges;
	printf("YES\n");
	for (int i = 0; i < n; ++i) {
		for (auto to : g[i]) {
			if (i < to) {
				edges.emplace_back(i, to);
			}
		}
	}

	printf("%d\n", (int)edges.size());
	for (auto[from, to] : edges) {
		printf("%d %d\n", from + 1, to + 1);
	}

	// for (int n = 2; n <= 100; ++n) {
	// 	memset(used, false, sizeof(used));
	// 	for (int i = 0; i < n; ++i) {
	// 		g[i].clear();
	// 	}
	// 	build(n);
	// }

	std::set<int> degs;
	for (int i = 0; i < n; ++i) {
		assert(!g[i].empty());
		degs.insert((int)g[i].size());
	}

	assert((int)degs.size() == k);
}

int main() {
	int n, k;
	scanf("%d%d", &n, &k);

	// for (int n = 1; n <= 50; ++n) {
	// 	for (int k = 1; k <= n; ++k) {
	// 		memset(used, false, sizeof(used));
	// 		for (int i = 0; i < N; ++i) {
	// 			g[i].clear();
	// 		}
	// 		solve(n, k);
	// 	}
	// }

	solve(n, k);

	return 0;
}