#include <bits/stdc++.h>
#define int long long

using namespace std;

const int N = 1e3 + 7, K = 1007, INF = 1e6;
char f[N][N];
vector <int> g[N];
int pa[N];
bool vis[N];
int ign = -1;
vector <pair <int, int>> dxdy = {{-1, 0}, {1, 0}, {0, 1}, {0, -1}};

bool dfs(int v) {
    if (vis[v])
        return false;
    vis[v] = true;
    for (int u : g[v]) {
        if (pa[u] == -1 || dfs(pa[u])) {
            pa[u] = v;
            return true;
        }
    }
    return false;
}

void dfs2(int v) {
    if (vis[v])
        return;
    vis[v] = true;
    for (int u : g[v]) {
        if (u != ign)
            dfs2(pa[u]);
    }
}

int Kun(int n) {
    for (int i = 0; i < n; i++)
        pa[i] = -1;
    for (int i = 0; i < n; i++) {
        memset(vis, 0, sizeof(vis)); 
        //cout << i << endl;
        assert(dfs(i));
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        memset(vis, 0, sizeof(vis));
        ign = i;
        dfs2(pa[i]);
        int cnt = 0;
        for (int j = 0; j < n; j++) {
            if (vis[j])
                cnt++;
        }
        ans += n - cnt;
    }
    return ans;
}

signed main() {
    //freopen("input.txt", "r", stdin);
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    map <int, int> lcmp, rcmp;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> f[i][j];
            if (f[i][j] == '.') {
                int c = i * m + j;
                if ((i + j) % 2 == 0) {
                    lcmp[c] = lcmp.size();
                } else {
                    rcmp[c] = rcmp.size();
                }
            }
        }
    }
    int sz = lcmp.size();
    if (sz * (sz - 1) >= INF) {
        cout << INF << endl;
        return 0;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int c = i * m + j;
            if (f[i][j] == '#')
                continue;
            if ((i + j) % 2 == 0) {
                for (auto [dx, dy] : dxdy) {
                    int x = i + dx, y = j + dy;
                    int nc = x * m + y;
                    if (x >= 0 && y >= 0 && x < n && y < m && f[x][y] == '.') {
                        g[lcmp[c]].push_back(rcmp[nc]);
                    }
                }
            }
        }
    }
    int ans0 = sz * (sz - 1);
    cout << min(INF, ans0 + Kun(sz)) << endl;
    return 0;
}
