#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
#define y second
#define x first
#define pb push_back
#define mp make_pair

int main() {
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // HOME
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, k;
	cin >> n >> k;
	if (n == 1) {
		cout << "YES\n0\n";
		return 0;
	}
	if (n == k) {
		cout << "NO\n";
		return 0;
	}
	if (n == 2) {
		cout << "YES\n1\n1 2\n";
		return 0;
	}
	if (k == 1) {
		cout << "YES\n" << n << '\n';
		for (int i = 1; i <= n; ++i)
			cout << i << ' ' << i % n + 1 << '\n';
		return 0;
	}
	vpii v;
	int K = k + 1;
	for (int i = 1; i <= K; ++i)
		for (int j = i + 1; j <= K; ++j)
			if (i + j >= K + 1)
				v.emplace_back(i, j);
	int last = 1;
	for (int i = K + 1; i <= n; ++i) {
		v.emplace_back(last, i);
		last = i;
	}
	cout << v.size() << '\n';
	for (pii p : v)
		cout << p.x << ' ' << p.y << '\n';
	return 0;
}
