#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()
#define Time() clock() / (ld)CLOCKS_PER_SEC

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int MAXN = 1e5 + 10;

int a[MAXN], p[MAXN], q[MAXN], pq[MAXN];

int n;

bool check(int i, int j) {
    if (q[i] == j || q[i] == pq[j]) return false;
    return true;
}

mt19937 rnd(time(0));

int rand(int l, int r) {
    return l + (unsigned int) rnd() % (r - l + 1);
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
        pq[a[i]] = i;
    }
    iota(q, q + n, 0);
    if (n < 4) {
        bool fl = 0;
        do {
            for (int i = 0; i < n; i++) {
                p[q[i]] = pq[i];
            }
            fl = 1;
            for (int i = 0; i < n; i++) {
                if (q[i] == i || p[i] == i) fl = 0;
            }
            if (fl) break;
        } while (!fl && next_permutation(q, q + n));
        if (!fl) {
            cout << "Impossible\n";
            return;
        }
        for (int i = 0; i < n; i++) p[q[i]] = pq[i];
    } else {
        shuffle(q, q + n, rnd);
        set<int> incorrect;
        for (int i = 0; i < n; i++) {
            if (q[i] == pq[i] || q[i] == i) incorrect.insert(i);
        }
        while (sz(incorrect)) {
            int i = *incorrect.begin();
            int j = rand(0, n - 1);
            while (!check(i, j)) {
                j = rand(0, n - 1);
            }
            swap(q[i], q[j]);
            incorrect.erase(i);
            if (q[i] == pq[i] || q[i] == i) incorrect.insert(i);
            if (q[j] == pq[j] || q[j] == j) incorrect.insert(j);
        }
        for (int i = 0; i < n; i++) p[q[i]] = pq[i];
    }
    cout << "Possible\n";
    for (int i = 0; i < n; i++) cout << p[i] + 1 << ' ';
    cout << '\n';
    for (int i = 0; i < n; i++) cout << q[i] + 1 << ' ';
    cout << '\n';
    //for (int i = 0; i < n; i++) cout << a[p[q[i]]] + 1 << ' ';
    //cout << '\n';

}

int32_t main() {
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }

    return 0;
}
