#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

int n;
vector<int> v;

mt19937 rnd(31312);

void gen() {
    n = rand() % 100000 + 5;
    v.resize(n);
    iota(v.begin(), v.end(), 0);
    shuffle(v.begin(), v.end(), rnd);
}

void try_solve() {
    if (n <= 2) {
        cout << "Impossible\n";
        return;
    }
    vector<int> p(n), q(n);
    while (true) {
        iota(p.begin(), p.end(), 0);
        shuffle(p.begin(), p.end(), rnd);
        bool bad = true;
        vector<int> pos_a(n), pos_p(n);
        for (int i = 0; i < n; i++) {
            pos_a[v[i]] = i;
            pos_p[p[i]] = i;
        }
        for (int i = 0; i < n; i++) {
            if (p[i] == i) {
                bad = false;
            }
            q[i] = pos_p[pos_a[i]];
            if (q[i] == i) {
                bad = false;
            }
        }
        if (bad) {
            cout << "Possible\n";
            for (int &e : p) {
                cout << e + 1 << " ";
            }
            cout << "\n";
            for (int &e : q) {
                cout << e + 1 << " ";
            }
            cout << "\n";
            return;
        }
    }
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--) {
        cin >> n;
        v.resize(n);
        for (int &e : v) {
            cin >> e;
            e--;
        }
        try_solve();
    }
    return 0;
}
