#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

bool debug = true;

int vx, vy;
int quieries = 0;
int lx, ly;

void gen() {
    if (debug) {
        quieries = 0;
        vx = 539;
        vy = 266;
        //vx = rand() % ((int)1e6 + 1);
        //vy = rand() % ((int)1e6 + 1);
    } else {

    }
}

string ask(int x, int y) {
    if (debug) {
        cout << quieries << " " << x << " " << y << endl;
        quieries++;
        assert(quieries <= 64);
        if (x == vx && y == vy) {
            cout << "wow" << endl;
            exit(0);
        }
        if (quieries == 1) {
            lx = x; ly = y;
            return "unk";
        } else {
            ll dist1 = (lx - vx) * 1ll * (lx - vx) + (ly - vy) * 1ll * (ly - vy);
            ll dist2 = (x - vx) * 1ll * (x - vx) + (y - vy) * 1ll * (y - vy);
            lx = x; ly = y;
            if (dist1 == dist2) {
                return "same";
            } else if (dist1 < dist2) {
                return "sma";
            } else {
                return "big";
            }
        }
    } else {
        quieries++;
        assert(quieries <= 64);
        cout << x << " " << y << endl;
        string line;
        getline(cin, line);
        if (count(line.begin(), line.end(), '!')) {
            exit(0);
        }
        return line;
    }
}

map<string, int> gt_ans;

void find_x(int y, int l, int r) {
    while (l < r) {
        int w = (l + r) / 2;
        ask(l, y);
        string s1 = ask(r, y);
        if (gt_ans[s1] == 2) {
            ask(w, y);
        } else if (gt_ans[s1] == 1) {
            //t = 0;
            r = (l + r - 1) / 2;
        } else {
            //t = 1;
            l = (l + r) / 2 + 1;
        }
    }
    ask(l, y);
    /*for (int i = l; i <= r; i++) {
        ask(i, y);
    }*/
}

void find_y(int x, int l, int r) {
    int t = -1;
    while (l < r) {
        int w = (l + r) / 2;
        ask(x, l);
        string s1 = ask(x, r);
        if (gt_ans[s1] == 2) {
            ask(x, w);
        } else if (gt_ans[s1] == 1) {
            r = (l + r - 1) / 2;
        } else {

            l = (l + r) / 2 + 1;
        }
    }
    ask(x, l);
}

#define y1 Enkognit
void rec(int x1, int x2, int y1, int y2) {
    if (x1 == x2 && y1 == y2) {
        ask(x1, y1);
    }
    if (x1 == x2 || y1 == y2) {
        throw std::out_of_range("Errore");
    }
    ask(x1, y1);
    string s1 = ask(x2, y1);
    if (gt_ans[s1] == 1) {
        s1 = ask(x2, y2);
        if (gt_ans[s1] == 1) {
            rec(x1, (x1 + x2 - 1) / 2, y1, (y1 + y2 - 1) / 2);
        } else if (gt_ans[s1] == 2) {
            find_x((y1 + y2) / 2, x1, (x1 + x2) / 2);
        } else {
            rec(x1, (x1 + x2 - 1) / 2,(y1 + y2) / 2 + 1, y2);
        }
    } else if (gt_ans[s1] == 2) {
        find_y((x1 + x2) / 2, y1, y2);
    } else {
        s1 = ask(x2, y2);
        if (gt_ans[s1] == 1) {
            rec((x1 + x2) / 2 + 1, x2, y1, (y1 + y2 - 1) / 2);
        } else if (gt_ans[s1] == 2) {
            find_x((y1 + y2) / 2,(x1 + x2) / 2, x2);
        } else {
            rec((x1 + x2) / 2 + 1, x2,(y1 + y2) / 2 + 1, y2);
        }
    }
}

void solve() {
    ask(1, 1);
    string s1 = ask(1, 0);
    string s2 = ask(0, 1);
    string s3 = ask(1, 1);
    string s4 = ask(0, 0);
    string s5 = ask(0, 0);
    gt_ans[s4] = 1;
    gt_ans[s5] = 2;
    if (s1 == s3) {
        if (gt_ans[s1] == 1) {
            find_y(0, 2, 1e6);
        } else {
            find_x(0, 2, 1e6);
        }
    }
    rec(1, 1e6, 1, 1e6);
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    debug = false;
    gen();
    solve();

    return 0;
}
/*

*/