#include <bits/stdc++.h>
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define int long long

using namespace std;

const int N = 1010;
char a[N][N];

int n, m;
bool good(int i, int j) {
    return i >= 0 && j >= 0 && i < n && j < m && a[i][j] == '.';
}

int used[N][N];
vector<pair<int, int> > d = {{0, 1}, {0, -1}, {-1, 0}, {1, 0}};
vector<pair<int, int>> l[N];
vector<pair<int, int>> r[N];

int dfs(int i, int j, int c) {
    used[i][j] = c;
//    cout << c << ' ' << i << ' ' << j << endl;

    if ((i + j) % 2 == 0) {
        l[c].emplace_back(i, j);
    } else {
        r[c].emplace_back(i, j);
    }
    int size = 1;
    for (auto [di, dj] : d) {
        if (good(i + di, j + dj) && !used[i + di][j + dj]) {
            size += dfs(i + di, j + dj, c);
        }
    }
    return size;
}

int used2[N][N];
pair<int, int> match2[N][N];
pair<int, int> match[N][N];
int timer = 1;
bool dfs2(int i, int j) {
    used2[i][j] = timer;
    for (auto [di, dj] : d) {
        if (good(i + di, j + dj)) {
            int x = i + di, y = j + dj;
            if (match2[x][y].first == -1) {
                match[i][j] = {x, y};
                match2[x][y] = {i, j};
                return 1;
            } else {
                auto [ii, jj] = match2[x][y];
                if (used2[ii][jj] < timer && dfs2(ii, jj)) {
                    match[i][j] = {x, y};
                    match2[x][y] = {i, j};
                    return 1;
                }
            }
        }
    }
    return 0;
}

int dfs3(int i, int j) {
    used2[i][j] = timer;
    int res = 1;
    for (auto [di, dj] : d) {
        int x = i + di, y = j + dj;
        if (good(i + di, j + dj)) {
//            cout << match2[x][y].first << endl;
            auto [ii, jj] = match2[x][y];
            if (used2[ii][jj] < timer)
                res += dfs3(ii, jj);
        }
    }
    return res;
}

pair<int, int> get_ans(int c) {
//    cout << c << endl;
    for (auto [i, j] : l[c]) {
        if (used2[i][j] < timer) {
            timer++;
            dfs2(i, j);
        }
    }
    int ll = l[c].size();
    int rr = r[c].size();
    int ans = 0;
    for (auto [x, y] : r[c]) {
        timer++;
        auto [i, j] = match2[x][y];
        ans += (ll - dfs3(i, j));
    }

    return make_pair(ans + (ll * (ll - 1))/ 2 + (rr * (rr - 1)) / 2, ll + rr);
}

int main() {
    std::ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    forn(i, n) forn(j, m) cin >> a[i][j];
    int c = 0;
    vector<pair<int, int> > start;
    forn(i, n) forn(j, m) {
            match2[i][j] = {-1, -1};
        if (good(i, j) && !used[i][j] && dfs(i, j, ++c) > 3 * N) {
            cout << 1000 * 1000 << '\n';
            return 0;
        }
    }
    int ans = 0;
    int kk = 0;
    forn(i, c) {
        auto [res, k] = get_ans(c);
        ans += res;
        ans += kk * k;
        kk += k;
    }
    cout << min(ans, 1000 * 1000);
    return 0;
}
