#include <iostream>
#include <vector>
#include<random>
#include<set>
#include<algorithm>
#include<map>
using namespace std;

#define int long long

mt19937 rnd(71711);
void gen_v(vector<int>& p, int n) {
	p.assign(n, 0);
	vector<int>v(n);
	for (int i = 0; i < n; ++i) {
		v[i] = i;
	}
	for (int i = 0; i < n; ++i) {
		int x = rnd() % v.size();
		while (v[x] == i) {
			if (v.size() != 1) {
				x = rnd() % v.size();
			}
			else {
				gen_v(p, n);
				return;
			}
		}
		p[i] = v[x];
		swap(v[x], v.back());
		v.pop_back();
	}
}
const int tries = 25;
int32_t main() {
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		int n;
		cin >> n;
		vector<int>a(n), v(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i];
			a[i]--;
			v[i] = i;
		}
		if (n == 1) {
			cout << "Impossible\n";
			continue;
		}
		bool success = 0;
		for (int j = 0; j < tries; ++j) {
			vector<int>p;
			gen_v(p, n);
			vector<int>rev_a(n), rev_p(n);
			for (int i = 0; i < n; ++i) {
				rev_a[a[i]] = i;
				rev_p[p[i]] = i;
			}
			vector<int>q(n);
			bool f = 1;
			for (int i = 0; i < n; ++i) {
				q[i] = rev_p[rev_a[i]];
				if (q[i] == i) {
					f = 0;
					break;
				}
			}
			if (!f) {
				continue;
			}
			success = 1;
			cout << "Possible\n";
			for (int i = 0; i < n; ++i) {
				cout << p[i] + 1 << ' ';
			}
			cout << '\n';
			for (int i = 0; i < n; ++i) {
				cout << q[i] + 1 << ' ';
			}
			cout << '\n';
			for (int i = 0; i < n; ++i) {
				if (a[p[q[i]]] != i) {
					cout << "FUCK";
				}
			}
			break;
		}
		if (!success) {
			cout << "Impossible\n";
		}
	}
	return 0;
}