#include <iostream>
#include <vector>
#include<random>
#include<set>
#include<algorithm>
#include<map>
using namespace std;

#define int long long
vector<int>ans;
struct pos {
	int a = -1;
	int b = -1;
	void add_pos(int v) {
		if (a == -2) {
			return;
		}
		if (a == v || b == v) {
			return;
		}
		if (a == -1) {
			a = v;
			return;
		}
		if (b == -1) {
			b = v;
			return;
		}
		a = -2;
	}
	bool valid(int mx) {
		return a != 0 && b != 0 && a != -2 && a != -1 && a != mx && b != mx;
	}
};
int n, k;
void get_ans(vector<vector<int>> &graphs, int p) {
	if (graphs[0].size() == 1) {
		ans[graphs[0][0]] = p;
		return;
	}
	vector<pos>positions(n);
	for (int i = 0; i < graphs.size(); ++i) {
		for (int q = 0; q < graphs[i].size(); ++q) {
			positions[graphs[i][q]].add_pos(q);
		}
	}
	int ceo = -1;
	for (int i = 0; i < positions.size(); ++i) {
		if (positions[i].valid(positions.size() - 1)) {
			ceo = i;
		}
	}
	ans[ceo] = p;
	vector<vector<int>>gr_l(graphs.size()), gr_r(graphs.size());
	if (positions[ceo].b != -1) {
		for (int i = 0; i < graphs.size(); ++i) {
			if (graphs[i][positions[ceo].a] == ceo) {
				gr_l[i] = vector<int>(graphs[i].begin(), graphs[i].begin() + positions[ceo].a);
				gr_r[i] = vector<int>(graphs[i].begin() + positions[ceo].a + 1, graphs[i].end());
			} else {
				gr_r[i] = vector<int>(graphs[i].begin(), graphs[i].begin() + positions[ceo].b);
				gr_l[i] = vector<int>(graphs[i].begin() + positions[ceo].b + 1, graphs[i].end());
			}
		}
	} else {
		set<int>Ls;
		for (int i = 0; i < positions[ceo].a; ++i) {
			Ls.insert(graphs[0][i]);
		}
		for (int i = 0; i < graphs.size(); ++i) {
			if (Ls.find(graphs[i][0]) != Ls.end()) {
				gr_l[i] = vector<int>(graphs[i].begin(), graphs[i].begin() + positions[ceo].a);
				gr_r[i] = vector<int>(graphs[i].begin() + positions[ceo].a + 1, graphs[i].end());
			} else {
				gr_r[i] = vector<int>(graphs[i].begin(), graphs[i].begin() + positions[ceo].a);
				gr_l[i] = vector<int>(graphs[i].begin() + positions[ceo].a + 1, graphs[i].end());
			}
		}
	}
	get_ans(gr_l, ceo);
	get_ans(gr_r, ceo);
}
int32_t main() {
	cin >> n >> k;
	vector<vector<int>>graphs(k, vector<int>(n));
	for (int i = 0; i < k; ++i) {
		for (int q = 0; q < n; ++q) {
			cin >> graphs[i][q];
			--graphs[i][q];
		}
	}
	ans.assign(n, 0);
	get_ans(graphs, -2);
	for (int i = 0; i < n; ++i) {
		cout << ans[i] + 1 << ' ';
	}
	return 0;
}