#include <iostream>
#include <algorithm>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<int> all;
    vector<vector<int>> towers(n);

    for (auto &t: towers) {
        int k;
        cin >> k;
        t.resize(k);
        for (auto &x: t) {
            cin >> x;
            all.push_back(x);
        }
    }

    sort(all.begin(), all.end());

    int s, c;
    for (auto& t : towers) {
        for (int i = 0; i + 1 < t.size(); i++) {
            int cur = t[i];
            int nxt = t[i+1];

            auto pos = upper_bound(all.begin(), all.end(), cur);
            if (pos == all.end() || *pos != nxt) {
                s++;
            }
        }
    }

    c = n + s - 1;
    cout << s << ' ' << c;



    return 0;
}
