#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ALL(x) x.begin(), x.end()
#define RALL(x) x.rbegin(), x.rend()

using ld = long double;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (int& x : a) {
            cin >> x;
            --x;
        }
        vector<int> inv(n);
        for (int i = 0; i < n; ++i) {
            inv[a[i]] = i;
        }
        vector<int> cnt(n);
        for (int i = 0; i < n; ++i) {
            if (inv[i] >= i) {
                cnt[inv[i] - i]++;
            } else {
                cnt[n - i + inv[i]]++;
            }
        }
        int i = find(cnt.begin() + 1, cnt.end(), 0) - cnt.begin();
        if (i == n) {
            cout << "Impossible\n";
        } else {
            vector<int> p(n), q(n);
            for (int j = 0; j < n; ++j) {
                p[(j + i) % n] = inv[j];
                q[j] = (j + i) % n;
            }
            for (int i = 0; i < n; ++i) {
                assert(a[p[q[i]]] == i);
                assert(p[i] != i);
                assert(q[i] != i);
            }
            cout << "Possible\n";
            for (int &x : p) {
                cout << x + 1 << ' ';
            }
            cout << '\n';
            for (int &x : q) {
                cout << x + 1 << ' ';
            }
            cout << '\n';
        }
    }

    return 0;
}
