#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ALL(x) x.begin(), x.end()
#define RALL(x) x.rbegin(), x.rend()

using ld = long double;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    cin >> t;
    mt19937 gen(random_device{}());
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (int& x : a) {
            cin >> x;
            --x;
        }
        vector<int> inv(n);
        for (int i = 0; i < n; ++i) {
            inv[a[i]] = i;
        }
        vector<int> p(n), q(n);
        if (n < 4) {
            vector<int> cnt(n);
            for (int i = 0; i < n; ++i) {
                if (inv[i] >= i) {
                    cnt[inv[i] - i]++;
                } else {
                    cnt[n - i + inv[i]]++;
                }
            }
            int i = find(cnt.begin() + 1, cnt.end(), 0) - cnt.begin();
            if (i == n) {
                cout << "Impossible\n";
                continue;
            }
            for (int j = 0; j < n; ++j) {
                p[(j + i) % n] = inv[j];
                q[j] = (j + i) % n;
            }
        } else {
            while (true) {
                list<int> free;
                vector<int> c(n);
                iota(ALL(c), 0);
                shuffle(ALL(c), gen);
                for (int i : c) {
                    free.push_back(i);
                }
                bool good = true;
                for (int i = 0; i < n; ++i) {
                    int j = -1;
                    for (auto it = free.begin(); it != free.end(); ++it) {
                        int x = *it;
                        if (x == i || x == inv[i]) continue;
                        j = x;
                        q[i] = j;
                        p[j] = inv[i];
                        free.erase(it);
                        break;
                    }
                    if (j == -1) {
                        good = false;
                        break;
                    }
                }
                if (good) {
                    break;
                }
            }
        }
        cout << "Possible\n";
        for (int &x : p) {
            cout << x + 1 << ' ';
        }
        cout << '\n';
        for (int &x : q) {
            cout << x + 1 << ' ';
        }
        cout << '\n';
    }

    return 0;
}