#include <bits/stdc++.h>
using namespace std;

#define int long long

void f(vector<pair<int, int>> &a){
	cout << "YES\n";
	cout << a.size() << '\n';
	for(int i = 0; i < a.size(); i++)
		cout << a[i].first + 1 << ' ' << a[i].second + 1 << '\n';
}

void go_1(int l, int r, vector<pair<int, int>> &ans);
void go_2(int l, int r, vector<pair<int, int>> &ans);

void go_1(int l, int r, vector<pair<int, int>> &ans){
	if(abs(r - l) <= 1)
		return;

	for(int i = l; i <= r - 2; i++)
		ans.push_back({i, r});

	go_2(l + 1, r - 1, ans);
}

void go_2(int l, int r, vector<pair<int, int>> &ans){
	if(abs(r - l) <= 1)
		return;

	for(int i = l + 2; i <= r; i++)
		ans.push_back({l, i});

	go_1(l + 1, r - 1, ans);
}

bool check(vector<pair<int, int>> &edges, int k){
	map<int, int> deg;

	for(auto p : edges){
		int v = p.first;
		int u = p.second;
		deg[v + 1]++;
		deg[u + 1]++;
	}

	set<int> st;

	for(auto p : deg)
		st.insert(p.second);

	return st.size() == k;
}

void solve(){
	int n; cin >> n;
	int k; cin >> k;

	if(n <= k){
		cout << "NO\n";
		return;
	}else if(k == 1){
		vector<pair<int, int>> ans;

		for(int i = 0; i < n; i++){
			ans.push_back({i, (i + 1) % n});
		}

		f(ans);
	}else{
		vector<pair<int, int>> ans;

		for(int i = 0; i < n - 1; i++)
			ans.push_back({i, i + 1});

		go_1(0, k - 1, ans);

		f(ans);
	}
}

signed main(){
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);

	// freopen("input.txt", "r", stdin);

	solve();
}	