#include <iostream>
#include <vector>
#include <numeric>
#include <set>
using namespace ::std;
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
typedef long long ll;
typedef pair<int, int> pairInt;
typedef pair<ll, ll> pairLL;


set<int> st;

int countTower(const vector<int>& vect)
{
	int n = vect.size();
	int ans = 0;
	for (int i = 1; i < n; i++)
	{
		if (st.upper_bound(vect[i - 1]) == st.end() || *st.upper_bound(vect[i - 1]) != vect[i])
		{
			ans++;
		}
	}
	return ans;
}

void doWork()
{
	int n;
	cin >> n;
	vector<vector<int>> vect(n);
	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;
		vect[i] = vector<int>(k);
		for (int j = 0; j < k; j++)
		{
			cin >> vect[i][j];
			st.insert(vect[i][j]);
		}
	}
	int counter = 0;
	for (int i = 0; i < n; i++)
	{
		counter += countTower(vect[i]);
	}
	cout << counter << " " << counter + n - 1;
}

int main()
{
	int k = 1;
	//cin >> k;
	while (k--)
	{
		doWork();
	}
	return 0;
}