#include <iostream>
#include <vector>
#include <numeric>
using namespace ::std;
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
typedef long long ll;
typedef pair<int, int> pairInt;
typedef pair<ll, ll> pairLL;


void printAns(vector<pairInt>& vect)
{
	cout << accumulate(all(vect), 0, [](int a, pairInt p) { return a + (p.first == p.second); }) << "\n";
	for (auto it : vect)
	{
		printf("%d:%d\n", it.first, it.second);
	}
}

void doWork()
{
	int n;
	cin >> n;
	int a, b;
	cin >> a >> b;
	vector<pairInt> vect(n);
	if (n == 1)
	{
		vect[0].first = a;
		vect[0].second = b;
		printAns(vect);
		return;
	}
	int pos = 0;
	for (; pos < n-1 && a > 0; pos++)
	{
		vect[pos].first++;
		a--;
	}
	if (b == 0 && a == 0)
	{
		printAns(vect);
		return;
	}
	if (b == 0)
	{
		a--;
		vect[pos].first++;
		vect[0].first += a;
		printAns(vect);
		return;
	}

	for (; pos < n && b > 0; pos++)
	{
		vect[pos].second++;
		b--;
	}
	vect[0].first += a;
	vect[pos-1].second += b;
	printAns(vect);
}

int main()
{
	int k = 1;
	//cin >> k;
	while (k--)
	{
		doWork();
	}
	return 0;
}