#include <bits/stdc++.h>

int main() {
    int n;
    std::cin >> n;
    std::vector<std::vector<int>> towers (n);
    for (int i = 0; i < n; i++){
        int tower_len;
        std::cin >> tower_len;
        towers[i].resize(tower_len);
        for (int j = 0; j < tower_len; j++){
            std::cin >> towers[i][j];
        }
    }

    std::set<int> nums;
    for (auto &tow : towers) {
        for (int x : tow) {
            nums.insert(x);
        }
    }

    std::map<int, int> nmap;
    int top = 0;
    for (int x : nums) {
        nmap[x] = top++;
    }

    for (auto &tow : towers) {
        for (size_t i = 0; i < tow.size(); ++i) {
            tow[i] = nmap[tow[i]];
        }
    }

    int s = 0;
    for (auto &tow : towers) {
        int last = -1;
        for (int x : tow) {
            if (last >= 0 and x != last+1) {
                s++;
            }
            last = x;
        }
    }
    int c = (int)towers.size()-1 + s;

    std::cout << s << " " << c;

    return 0;
}
