#include "bits/stdc++.h"

using namespace std;

typedef long long ll;
typedef long double lld;
#define nn "\n"

void solve() {
    ll n; cin >> n;
    vector<ll> a(n), p(n), q(n);
    unordered_map<ll, ll> values_a, values_p;

    for (ll i = 0; i < n; i++) { cin >> a[i]; values_a[a[i]] = i+1; }

    for (ll s = 1; s < n; s++) {
        for (ll i = 0; i < n; i++) {
            p[i] = a[(i + s) % n];
            values_p[p[i]] = i;
        }

        if (n <= 2) {
            cout << "Impossible" << nn;
            return;
        }
        cout << s << nn;

        bool brk = false;
        for (ll i = 0; i < n; i++) {
            brk = i + 1 == p[i];
            if (brk) break;
        }
        for (ll i = 0; i < n; i++) {
            brk = i + 1 == q[i];
            if (brk) break;
        }
        if (brk) continue;

        cout << "Possible" << nn;
        for (auto &elem: p) cout << elem << " ";
        cout << nn;
        for (auto &elem: q) cout << elem << " ";
        cout << nn;

        break;
    }
}

int main() {
//    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    ll t = 1;
    cin >> t;
    while (t--) solve();
}
