#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <cmath>
#include <queue>
#include <stack>

using namespace std;

typedef long long ll;
typedef long double ld;

void start() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cout.precision(10); cout.setf(ios::fixed);

}

int main() {
	start();
	int n, m;
	cin >> n;
	vector<vector<int>>v(n);
	vector<int>dg;
	for (int i = 0; i < n; ++i) {
		cin >> m;
		v[i].resize(m);
		for (auto& u : v[i]) {
			cin >> u;
			dg.emplace_back(u);
		}
	}
	sort(dg.begin(), dg.end());
	map<int, int> dgr;
	for (int i = 0; i < dg.size(); ++i) {
		dgr[dg[i]] = i;
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < v[i].size(); ++j) {
			v[i][j] = dgr[v[i][j]];
		}
	}
	int ans1 = 0, tc = 0;
	for (auto t : v) {
		vector<vector<int>>tw;
		int prev = 0;
		for (int i = 1; i < t.size(); ++i) {
			if (t[i - 1] > t[i]) {
				tw.push_back({});
				ans1++;
				for (; prev < i; ++prev) {
					tw.back().push_back(t[prev]);
				}
			}
		}
		tw.push_back({});
		for (; prev < t.size(); ++prev) {
			tw.back().push_back(t[prev]);
		}
		for (auto t2 : tw) {
			prev = 0;
			int cnt = 0;
			for (int i = 1; i < t2.size(); ++i) {
				if (t2[i - 1] + 1 != t2[i]) {
					cnt++;
					ans1++;
				}
			}
			cnt++;
			tc += cnt;
		}
	}
	cout << ans1 << ' ' << tc - 1;
}