#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <cmath>
#include <queue>
#include <stack>

using namespace std;

typedef long long ll;
typedef long double ld;

void start() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cout.precision(10); cout.setf(ios::fixed);

}

ll L = -1, R = -1;
int aL = 90, aR = 0;

string gen_ans(ll l, ll r) {
	string hz = "Tabilmadi";
	string gr = "Dalej";
	string ls = "Daha yakin";
	string eq = "Sama distanco";
	string hh = "Znaydeno!";
	string ans;
	if (l == aL && r == aR)
		return hh;
	ll r1 = (aL - l) * (aL - l) + (aR - r) * (aR - r);
	ll r2 = (aL - L) * (aL - L) + (aR - R) * (aR - R);
	if (L == -1)
		ans = hz;
	else if (r1 == r2)
		ans = eq;
	else if (r1 < r2)
		ans = ls;
	else
		ans = gr;
	L = l, R = r;
	return ans;
}

string query(int x, int y) {
	cout << x << ' ' << y << '\n';
	cout.flush();
	string s;// = gen_ans(x, y);
	//cerr << s << '\n';
	getline(cin, s);
	if (s.back() == '!')
		exit(0);
	return s;
}

int bins(int ln, string less, string gr, bool isx) {
	int l = 0, r = 1e6 + 1;
	int prevl = 0, prevr = 1e6 + 1;
	bool flagl = true;
	while (r - l > 2) {
		int mid = (l + r) >> 1;
		string rs;
		if (isx)
			rs = query(mid, ln);
		else
			rs = query(ln, mid);
		if (rs != gr) {
			prevl = l, prevr = r;
			if (rs == less) {
				if (flagl)
					l = mid;
				else
					r = mid + 1;
			}
			else {
				if (!flagl)
					l = mid;
				else
					r = mid + 1;
			}
			if (l == mid)
				flagl = 1;
			else
				flagl = 0;
		}
		else if (rs == gr) {
			if (flagl) {
				l = (prevl + l) / 2;
				r = mid;
				flagl = 0;
			}
			else {
				l = mid + 1;
				r = (prevr + r) / 2 + 1;
				flagl = 1;
			}
		}
	}
	string rs;
	if (isx)
		query(l, ln);
	else
		query(ln, l);
	if (isx)
		rs = query(l + 1, ln);
	else
		rs = query(ln, l + 1);
	return (rs == less ? l + 1 : l);
}

int main() {
	start();
	query(0, 0);
	string f1 = query(1, 0);
	query(0, 0);
	string f2 = query(0, 1);
	string less, gr;
	if (f1 == f2) {
		less = f1;
		gr = query(0, 0);
		int x = bins(0, less, gr, true);
		query(0, 0);
		int y = bins(x, less, gr, false);
		query(x, y);
	}
	else {
		less = f1;
		gr = f2;
		int x = bins(0, f1, f2, true);
		query(x, 0);
		query(0, 0);
		int y = bins(0, f2, f1, false);
		query(0, y);
	}
}