#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <cmath>
#include <queue>
#include <stack>

using namespace std;

typedef long long ll;
typedef long double ld;

void start() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cout.precision(10); cout.setf(ios::fixed);

}

int main() {
	start();
	int n, k;
	cin >> n >> k;
	if (n == 1 && k == 1) {
		cout << "YES\n0";
		return 0;
	}
	if (n <= k) {
		return cout << "NO", 0;
	}
	cout << "YES\n";
	vector<vector<int>>g(n);
	for (int i = 0; i < k; ++i) {
		for (int j = i + 1; j <= k - i; ++j) {
			g[i].push_back(j);
		}
	}
	for (int i = k; i < n - 1; ++i) {
		g[i].push_back(i + 1);
	}
	vector<vector<int>>ans;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < g[i].size(); ++j) {
			ans.push_back({ i, g[i][j] });
		}
	}
	if (k == 1) {
		ans.push_back({ n - 1, 0 });
	}
	cout << ans.size() << '\n';
	for (auto& i : ans) {
		cout << i[0] + 1 << ' ' << i[1] + 1 << '\n';
	}

}