#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf = 1'000'000'007;
const ll llinf = 1'000'000'000'000'000'007LL;
const ld eps = 1e-9;
const ld pi = acos(-1.0);

int n;
int g[100005];
bool used[100005];

void dfs(int v, vector <int> & chain) {
    used[v] = true;
    chain.push_back(v);
    if (!used[g[v]]) {
        dfs(g[v], chain);
    }
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> g[i];
        --g[i];
        used[i] = false;
    }

    set <int> lens;
    vector <vector <int>> chains;
    vector <vector <int>> two;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            vector <int> chain;
            dfs(i, chain);
            if (chain.size() != 2) {
                chains.push_back(chain);
            }
            else {
                two.push_back(chain);
            }
            lens.insert(chain.size());
        }
    }
    if (n == 2 && lens.count(2)) {
        cout << "Impossible";
        return;
    }
    if (n == 3 && lens.count(2)) {
        cout << "Impossible";
        return;
    }

    if (n == 5 && lens.count(2) && lens.count(3)) {
        cout << "Impossible";
        return;
    }

    vector <int> q(n), p(n);
    if (lens.size() == 2 && lens.count(1) && lens.count(2) && chains.size() == 1) {
        for (int i = 0; i + 1 < two.size(); i++) {
            int a = two[i][0];
            int b = two[i][1];
            int c = two[i + 1][0];
            int d = two[i + 1][d];
            q[a] = c;
            q[c] = d;
            p[c] = a;
            p[d] = b;
        }
        int a = two[0][0];
        int b = two[0][1];
        int c = two.back()[0];
        int d = two.back()[1];
        int e = chains[0][0];

        q[c] = e;
        q[e] = a;
        q[d] = b;
        p[a] = e;
        p[b] = d;
        p[e] = c;
    }
    else {
        if (!two.empty()) {
            if (two.size() == 1) {
                int a = two[0][0];
                int b = two[0][1];
                int c = -1, d, e, f;
                for (int i = 0; i < chains.size(); i++) {
                    if (chains[i].size() >= 4) {
                        c = chains[i][0];
                        d = chains[i][1];
                        e = chains[i][2];
                        f = chains[i][3];
                        chains.erase(chains.begin() + i);
                        break;
                    }
                }
                assert(c != -1);
                q[a] = c;
                q[c] = d;
                q[d] = a;
                q[b] = e;
                q[e] = f;
                q[f] = b;

                p[d] = f;
                p[c] = b;
                p[a] = c;
                p[b] = e;
                p[e] = a;
                p[f] = d;
            }
            else {
                for (int i = 0; i < two.size(); i++) {
                    int a = two[i][0];
                    int b = two[(i + 1) % two.size()][1];
                    q[a] = b;
                    p[b] = two[i][1];
                    q[b] = a;
                    p[a] = two[(i + 1) % two.size()][0];
                }
            }
        }

        for (int i = 0; i < chains.size(); i++) {
            for (int j = 0; j + 1 < chains[i].size(); j++) {
                int a = chains[i][j];
                int b = chains[i][j + 1];
                int c = chains[i][(j - 1 + (int)chains[i].size()) % (int)chains[i].size()];
                q[a] = b;
                p[b] = c;

            }

            int a = chains[i].back();
            int b = chains[(i + 1) % (int)chains.size()][0];
            int c = chains[i][((int)chains[i].size() + (int)chains[i].size() - 2 ) % (int)chains[i].size()];
            q[a] = b;
            p[b] = c;
        }


    }


    cout << "Possible\n";
    for (auto &i : p) {
        cout << i + 1 << " ";
    }
    cout << "\n";
    for (auto &i : q) {
        cout << i + 1 << " ";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);
    cout.precision(20);
    srand(time(0));

    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
        cout << "\n";
    }
    return 0;
}
