#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf = 1'000'000'007;
const ll llinf = 1'000'000'000'000'000'007LL;
const ld eps = 1e-9;
const ld pi = acos(-1.0);

void solve() {
    int n;
    cin >> n;
    vector <vector <int>> arr;

    int splits = 0, merges = 0;
    for (int i = 0; i < n; i++) {
        vector <int> cur;
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            if (cur.empty() || cur.back() > x) {
                if (!cur.empty()) {
                    arr.push_back(cur);
                }
                cur.clear();
            }
            cur.push_back(x);
        }
        if (!cur.empty()) {
            arr.push_back(cur);
        }
    }

    splits = (int)arr.size() - n;
    merges = arr.size() - 1;
//    for (auto &i : arr) {
//        for (auto &j : i) {
//            cout << j << " ";
//        }
//        cout << "\n";
//    }
    set <pair <int, int>> pos;
    for (int i = 0; i < arr.size(); i++) {
        for (auto &j : arr[i]) {
            pos.insert({j, i});
        }
    }
    for (int i = 0; i < arr.size(); i++) {
        for (int j = 0; j + 1 < arr[i].size(); j++) {
            auto f = pos.upper_bound({arr[i][j], inf});
           if (f->second != i) {
                splits++;
                merges++;
            }
        }
    }
    cout << splits << " " << merges;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);
    cout.precision(20);
    srand(time(0));

    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
        cout << "\n";
    }
    return 0;
}
