#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf = 1'000'000'007;
const ll llinf = 1'000'000'000'000'000'007LL;
const ld eps = 1e-9;
const ld pi = acos(-1.0);

void solve() {
    int n, a, b;
    cin >> n >> a >> b;
    if (n == 1) {
        cout << (a == b ? 1 : 0) << '\n' << a << ':' << b << '\n';
        return;
    }
    vector<pair<int, int>> ans(n);
    int draw = 0;
    if (n > max(a, b)) {
        draw = max(n - a - b, 0);
        for (int i = 0; i < a; ++i) {
            ans[i].first = 1;
        }
        for (int i = a; i < n; ++i) {
            ans[i].first = 0;
        }
        int x = 1, ost = b;
        for (int i = 0; i < b; ++i) {
            if (ans[n - i - 1].first != 0) {
                ans[n - i].second += ost;
                ost = x = 0;
            }
            ans[n - i - 1].second = x;
            if (x) {
                --ost;
            }
        }
        for (int i = b; i < n; ++i) {
            ans[n - i - 1].second = 0;
        }
    }
    else {
        bool huj_a = false;
        if (a >= n) {
            huj_a = true;
            int ost = a;
            for (int i = 0; i < n - 1; ++i) {
                ans[i] = make_pair(1, 0);
                --ost;
            }
            ans.back() = make_pair(ost, b);
            if (ans.back().first == ans.back().second) {
                ++ans[n - 2].first;
                --ans.back().first;
            }
        }
        if (b >= n && !huj_a) {
            int ost = b;
            for (int i = 0; i < n - 1; ++i) {
                ans[i] = make_pair(0, 1);
                --ost;
            }
            ans.back() = make_pair(a, ost);
            if (ans.back().first == ans.back().second) {
                ++ans[n - 2].second;
                --ans.back().second;
            }
        }
        for (auto &i : ans) {
            if (i.first == i.second) {
                ++draw;
            }
        }
    }
    cout << draw << '\n';
    for (auto i : ans) {
        cout << i.first << ':' << i.second << '\n';
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);
    cout.precision(20);
    srand(time(0));

    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
        cout << "\n";
    }
    return 0;
}
