#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf = 1'000'000'007;
const ll llinf = 1'000'000'000'000'000'007LL;
const ld eps = 1e-9;
const ld pi = acos(-1.0);

void solve() {
    int n, k;
    cin >> n >> k;
    if (n == 1 && k == 1) {
        cout << "YES\n0";
        return;
    }
    if (n == k) {
        cout << "NO";
        return;
    }
    if (n == 2) {
        cout << "YES\n1\n1 2";
        return;
    }
    if (k == 1) {
        cout << "YES\n" << n << "\n";
        for (int i = 0; i < n; i++) {
            cout << i + 1 << " " << (i + 1) % n + 1 << "\n";
        }
        return;
    }
    vector <vector <int>> g(n);
    vector <pair <int, int>> ed;
    vector <int> pows(n);

    for (int i = 1; i < n; i++) {
        ed.push_back({0, i});
        g[0].push_back(i);
        pows[0]++;
        pows[i]++;
    }

    int cur_num = 2;
    int v = 1;
    while (cur_num + 2 <= k) {
        for (int j = v + 1; j < n - v; j++) {
            ed.push_back({v, j});
            g[v].push_back(j);
            g[j].push_back(v);
            pows[v]++;
            pows[j]++;
        }
        v++;
        cur_num += 2;
    }

    if (cur_num != k) {
        for (int j = 1; j + 1 < n; j++) {
            if (pows[j] == pows[j + 1]) {
                ed.push_back({j, j + 1});
                pows[j + 1]++;
                pows[j]++;
                g[j].push_back(j + 1);
                g[j + 1].push_back(j);
                break;
            }
        }
    }
    set <int> huj;
    vector <int> cur(n);
    for (auto &i : ed) {
        cur[i.first]++;
        cur[i.second]++;
    }
    for (auto &i : cur) {
        huj.insert(i);
    }
    assert(huj.size() == k);
    cout << "YES\n" << ed.size() << "\n";
    for (auto &i : ed) {
        cout << i.first + 1 << " " << i.second + 1 << "\n";
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);
    cout.precision(20);
    srand(time(0));

    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
        cout << "\n";
    }
    return 0;
}
