// C++
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>


using namespace std;
#pragma warning(disable: 4996)

using ll = long long;
using ld = long double;

const int INF = 1e9 + 1e8;
const ll LINF = 2000000000000000000;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define en '\n'
#define pii pair<int,int>
#define vec vector
#define pb push_back
#define szof(x) int((x).size())
#define pll pair<ll,ll>

//void solve() {
//  int n, k;
//  cin >> n >> k;
//
//  map<int, vector<int>> d;
//  
//  for (int i = 0; i < n; i++) {
//      d[n - 1].push_back(i);
//  }
//
//  int it = n - 1;
//  while (d.size() < k) {
//      while (it >= 2 && d[it].size() > 2) {
//          int u = d[it].back();
//          d[it].pop_back();
//          int v = d[it].back();
//          d[it].pop_back();
//
//          d[it - 1].push_back(u, v);
//      }
//  }
//}


void solve() {
	int n;
	cin >> n;
	vec<int>a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}
	vec<int> initA = a;

	vec<int> ans;
	if (n == 1) {
		cout << "Impossible" << en;
		return;
	}

	if (n <= 3) {
		vec<int>perm(n);
		iota(all(perm), 0);
		bool found = false;
		do {

			bool ok = true;
			for (int i = 0; i < n; i++) {
				if (perm[i] == i || perm[i] == a[i]) {
					ok = false;
					break;
				}
			}
			if (ok) {
				a = perm;
				found = true;
				break;
			}
		} while (next_permutation(all(perm)));

		if (!found) {
			cout << "Impossible" << en;
			return;
		}
	}
	else {
		vec<int>initA = a;

		vec<vec<int>>cycles;
		vec<int>cur;
		vec<bool>used(n);
		for (int i = 0; i < n; i++) {
			if (used[i]) {
				continue;
			}
			cur.clear();
			int j = i;
			while (!used[j]) {
				cur.pb(j);
				used[j] = true;
				j = a[j];
			}
			cycles.pb(cur);
			for (int j = 0; j < szof(cur); j++) {
				swap(a[cur[j]], a[cur[(j + 1) % szof(cur)]]);
			}
		}

		sort(all(cycles), [](const vec<int>& a, const vec<int>& b) {
			return szof(a) < szof(b);
			});

		for (int i = 0; i < szof(cycles) - 1; i++) {
			if (szof(cycles[i]) > 2) {
				break;
			}

			if (szof(cycles[i]) == 1) {
				swap(a[cycles[i][0]], a[cycles[i + 1][0]]);
			}
			if (szof(cycles[i]) == 2) {
				swap(a[cycles[i][0]], a[cycles[i + 1][0]]);
				swap(a[cycles[i][1]], a[cycles[i + 1][1]]);
			}
		}
	}

	vec<int>pos(n);
	for (int i = 0; i < n; i++) {
		pos[initA[i]] = i;
	}

	ans.resize(n);
	for (int i = 0; i < n; i++) {
		ans[i] = pos[a[i]];
	}

	cout << "Possible" << en;
	for (int i = 0; i < n; i++) {
		cout << ans[i] + 1 << ' ';
	}

	cout << en;

	for (int i = 0; i < n; i++) {
		pos[a[i]] = i;
	}
	for (int i = 0; i < n; i++) {
		cout << pos[i] + 1 << ' ';
	}
	cout << en;
}


int main() {
	srand(time(0));
	ios::sync_with_stdio(0);
	cin.tie(0);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	int tst = 1;
	cin >> tst;

	while (tst--) {
		solve();
	}

}