// C++
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>


using namespace std;


#pragma warning(disable: 4996)

using ll = long long;
using ld = long double;

const int INF = 1e9 + 1e8;
const ll LINF = 2000000000000000000;



#define all(x) (x).begin() (x).end()
#define en '\n'
#define pii pair<int,int>
#define vec vector
#define pb push_back
#define szof(x) int((x).size())

void solve() {
	int n;
	cin >> n;
	int a, b;
	cin >> a >> b;
	if (n == 1) {
		if (a == b) {
			cout << 1 << en;
		}
		else {
			cout << 0 << en;
		}

		cout << a << ":" << b;
		return;
	}

	vec<pii>ans1, ans2;
	for (int i = 0; i < a; i++) {
		ans1.pb({ 1,0 });
	}
	for (int i = 0; i < b; i++) {
		ans2.pb({ 0,1 });
	}
	while (szof(ans1) + szof(ans2) > n) {
		if (ans1.size() > 1) {
			auto t1 = ans1.back();
			ans1.pop_back();
			ans1.back().first += t1.first;
			ans1.back().second += t1.second;	
		}
		else {
			if (ans2.size() > 1) {
				auto t1 = ans2.back();
				ans2.pop_back();
				ans2.back().first += t1.first;
				ans2.back().second += t1.second;
			}
		}
	}
	int ans = n - szof(ans1) - szof(ans2);
	cout << ans << en;
	for (auto to : ans1) {
		cout << to.first << ":" << to.second << en;
	}
	for (auto to : ans2) {
		cout << to.first << ":" << to.second << en;
	}

	for (int i = 0; i < n - szof(ans1) - szof(ans2); i++) {
		cout << "0:0" << en;
	}

}

int main() {
	srand(time(0));
	ios::sync_with_stdio(0);
	cin.tie(0);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	int tst = 1;
	//cin >> tst

	while (tst--) {
		solve();
	}

}
