// C++
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>


using namespace std;
#pragma warning(disable: 4996)

using ll = long long;
using ld = long double;

const int INF = 1e9 + 1e8;
const ll LINF = 2000000000000000000;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define en '\n'
#define pii pair<int,int>
#define vec vector
#define pb push_back
#define szof(x) int((x).size())
#define pll pair<ll,ll>

//void solve() {
//	int n, k;
//	cin >> n >> k;
//
//	map<int, vector<int>> d;
//	
//	for (int i = 0; i < n; i++) {
//		d[n - 1].push_back(i);
//	}
//
//	int it = n - 1;
//	while (d.size() < k) {
//		while (it >= 2 && d[it].size() > 2) {
//			int u = d[it].back();
//			d[it].pop_back();
//			int v = d[it].back();
//			d[it].pop_back();
//
//			d[it - 1].push_back(u, v);
//		}
//	}
//}


void solve() {
	int n, k;
	cin >> n >> k;

	vector<int> d(n, n - 1);
	for (int i = 0; i < k; i++) {
		d[i] = d[i] - i;
	}
	
	for (int i = k; i < n; i++) {
		d[i] = d[i - 1];
	}

	ll sum = accumulate(all(d), 0LL);

	if (sum % 2 == 1) {
		d.back() += 1;
		sort(rall(d));
	}

	set<int> se(all(d));

	if (se.size() != k) {
		cout << "NO" << en;
		return;
	}

	vector<pair<int, int>> ans;

	while (1) {
		vector<pair<int, int>> temp(n);
		for (int i = 0; i < n; i++) {
			temp[i] = { d[i], i };
		}
		sort(rall(temp));

		if (temp[0].first == 0) {
			break;
		}

		int v = temp[0].second;

		for (int i = 1; i < n && d[v] > 0; i++) {
			int u = temp[i].second;
			
			if (d[u] > 0) {
				ans.push_back({ u, v });
				d[u]--;
				d[v]--;
			}
			else {
				cout << "NO" << en;
				return;
			}
		}
	}

	cout << ans.size() << en;
	for (auto to : ans) {
		cout << to.first + 1 << ' ' << to.second + 1 << en;
	}
}



int main() {
	srand(time(0));
	ios::sync_with_stdio(0);
	cin.tie(0);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	int tst = 1;
	//cin >> tst;

	while (tst--) {
		solve();
	}

}
