// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <numeric>
#include <algorithm>
#include<map>

using namespace std;
typedef long long ll;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	ll n;
	cin >> n;
	ll splits = 0;

	vector<vector<ll>> towers(n);
	vector<ll> allnum;

	for (ll t = 0; t < n; t++) {
		ll k;
		cin >> k;
		towers[t].resize(k);
		for (ll& a : towers[t]) {
			cin >> a;
			allnum.push_back(a);
		}
	}

	sort(allnum.begin(), allnum.end());
	map<ll, ll> index;
	for (int i = 0; i < allnum.size(); i++)
		index[allnum[i]] = i;

	for (ll t = 0; t < n; t++) {
		for (ll i = 0; i < towers[t].size() - 1; i++)
			if (index[towers[t][i]] + 1 != index[towers[t][i + 1]])
				++splits;
	}
	cout << splits << " " << n + splits - 1;

	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
