#include <bits/stdc++.h>
#define forab(i, a, b) for(long long i=a,i < b; ++i)
#define for0(i,n)for(int i = 0; i < n; ++i)
#define for1(i, n) for (int i = 1; i < n; ++i)
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define en '\n'
#define EPS 1e-9

#define vec vector
#define all(x) (x).begin(),(x).end()
#define allr(x) (x).rbegin(),(x).rend()


using namespace std;

typedef long long ll;
typedef long double ld;

typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef pair<int, ll> pil;
typedef pair<ld, int> pli;

typedef map<int ,int> mii;
typedef map<ll, ll> mll;

typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<vector<int>> vvi;
typedef vector<vector<ll>> vvll;

const int MAXN = 2 * 1e5;
const int INF = 1000000000;
const ll MOD = 1e9 + 7;

template<typename T>
istream& operator>>(istream& in, vector<T>& a){
    for (auto& i : a)
        cin >> i;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T> a){
    for (auto & i : a)
        cout << i << ' ' ;
    return out;
}

vector<int> g[555];
int mm = 0;
void add_edge(int u, int v)
{
    g[u].push_back(v);
    g[v].push_back(u);
    mm++;
}

void solve1() {
    int n,k ; cin >> n >> k;

    if (k == 1) {
        if (n == 1)
        {
            cout << "NO" << en;
            return;
        }
        else if (n == 2)
        {
            cout << "YES" << en;
            cout << 1 << en;
            cout << 1 << " " << 2 << en;
            return;
        }
        cout << "YES" << en;
        cout << n << en;
        for (int i = 0; i < n; i++)
        {
            cout << i+1<< " " << ((i+1) % n + 1) << en;
        }
    }
    else if (k == 2)
    {
        if (n < 3) {
            cout << "NO" << en;
            return;
        }

        cout << "YES" << en;
        cout << n-1 << en;

        for (int i = 2; i <= n; i++)
        {
            cout << 1 << " " << i << en;
        }
    }
    else
    {
        vector<int> prevs;
        int curk = 2;
        int curvx = 3;
        int nextvx = 2;
        add_edge(1,2);

        while (curk < k) {
            if (curvx > n) {
                cout << "NO" << en;
                return;
            }
            int nextnew = curvx++;

            add_edge(nextvx, nextnew);

            if (curvx > n) {
                cout << "NO" << en;
                return;
            }
            prevs.push_back(curvx++);

            for (auto u: prevs)
            {
                add_edge(u, nextvx);
            }

            nextvx = nextnew;
            curk++;
        }
        add_edge(nextvx, prevs[0]);

        int prv = prevs[0];
        while (curvx <= n)
        {
            add_edge(curvx++, prv);
            prv = curvx-1;
        }

        int mym = 0;
        for (int u = 1; u <= n; u++)
        {
            for (int v: g[u])
            {
                if (u < v)
                    mym++;
            }
        }
        cout << "YES" << en << mym << en;
        for (int u = 1; u <= n; u++)
        {
            for (int v: g[u])
            {
                if (u < v)
                    cout << u << " " << v << en;
            }
        }
    }
}

void solve2(){
    cout << 0 << ' ' << 0 << endl;
    string ignore;
    cin >> ignore;
    if(ignore[ignore.length()-1]=='!'){
        return;
    }
    cout << "1 1" << endl;
    string closer, father;
    cin >> closer;
    if(closer[closer.length()-1]=='!'){
        return;
    }
    cout << "0 1" << endl;
    string response;
    cin >> response;
    if(response[response.length()-1]=='!'){
        return;
    }
    cout << 0 << ' ' << 0 << endl;
    cin >> ignore;
    if(response!=closer)
        father=response;
    int l = 0, r=1e6;
    int x_res;
    while(true){
        int cur_x = (l+r)/2;
        cout << cur_x << ' ' << 0 << endl;
        cin >> ignore;
        cout << cur_x+2 << ' ' << 0 << endl;
        cin >> response;
        if(response!=father && response!=closer){
            x_res = cur_x+1;
            break;
        }
        if(response==father){
            r=cur_x;
        }
        else{
            l=cur_x;
        }
    }
    l=0, r=1e6;

    while(true){


    }

}

void solve(){
    int n;
    cin >> n;
    vi a(n);
    cin >> a;
    if(n==2){
        if(a[0]==1 && a[1]==2){
            cout << "Possible\n2 1\n2 1\n";
        }
        else{
            cout << "Impossible\n";
        }
        return;
    }
    vi preva=a;
    while(true){
        random_shuffle(all(a));
        bool ok=true;
        for0(i, n){
            if(a[i]==i+1 || a[i]==preva[i]){
                ok=false;
                break;
            }
        }
        if(ok)
            break;
    }
    vi pos(n+1);
    for0(i, n){
        pos[preva[i]]=i+1;
    }
    vi p(n);
    for0(i, n){
        p[i]=pos[a[i]];
    }

    cout << "Possible\n";
    cout << p << en;

    vi q(n);
    for0(i, n){
        pos[a[i]]=i+1;
    }
    for0(i, n){
        q[i]=pos[i+1];
    }
    cout << q << en;
}


int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //freopen("C:\\work\\untitled\\input.txt", "r", stdin);

    int tst = 1;
    cin >> tst;
    while (tst--)
        solve();
}