#include <bits/stdc++.h>
#define forab(i, a, b) for(long long i=a,i < b; ++i)
#define for0(i,n)for(int i = 0; i < n; ++i)
#define for1(i, n) for (int i = 1; i < n; ++i)
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define en '\n'
#define EPS 1e-9

#define vec vector
#define all(x) (x).begin(),(x).end()
#define allr(x) (x).rbegin(),(x).rend()


using namespace std;

typedef long long ll;
typedef long double ld;

typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef pair<int, ll> pil;
typedef pair<ld, int> pli;

typedef map<int ,int> mii;
typedef map<ll, ll> mll;

typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<vector<int>> vvi;
typedef vector<vector<ll>> vvll;

const int MAXN = 2 * 1e5;
const int INF = 1000000000;
const ll MOD = 1e9 + 7;

template<typename T>
istream& operator>>(istream& in, vector<T>& a){
    for (auto& i : a)
        cin >> i;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T> a){
    for (auto & i : a)
        cout << i << ' ' ;
    return out;
}

void solve(){
    int n; cin >> n;
    int a, b; cin >> a >> b;

    vector<pii> ms1, ms2;
    if (n == 1)
    {
        if (a == b) cout << 1 << en;
        cout << a << ":" << b << en;
        return;
    }

    while (a > 0)
    {
        ms1.push_back({1, 0});
        a--;
    }
    while (b > 0)
    {
        ms2.push_back({0, 1});
        b--;
    }

    while (ms1.size() + ms2.size() < n)
    {
        ms1.push_back({0,0});
    }

    while (ms1.size() + ms2.size() > n)
    {
        if (ms1.size() > 1) {
            auto p = ms1.back(); ms1.pop_back();
            auto p2 = ms1.back(); ms1.pop_back();
            ms1.push_back({p.first + p2.first, p.second + p2.second});
        }
        else if (ms2.size() > 1) {
            auto p = ms2.back();
            ms2.pop_back();
            auto p2 = ms2.back();
            ms2.pop_back();

            ms2.push_back({p.first + p2.first, p.second + p2.second});
        }
    }

    vector<pii> ans;
    for (auto p: ms1)
        ans.push_back(p);
    for (auto p: ms2)
        ans.push_back(p);

    int k = 0;
    for (auto p: ans)
    {
        if (p.first == p.second) k++;
    }

    cout << k << en;
    for (auto p: ans)
        cout << p.first << ":" << p.second << en;
}

int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //freopen("C:\\work\\untitled\\input.txt", "r", stdin);

    int tst = 1;
//    cin >> tst;
    while (tst--)
        solve();
}