#define ln '\n'
#define All(x) x.begin(), x.end()
#define Allf(x) x.begin() + 1, x.end()
#define Allr(x) x.rbegin(), x.rend()

#define fi(a, b) for(int i = a; i <= b; i++)
#define fj(a, b) for(int j = a; j <= b; j++)
#define fo(a, b) for(int o = a; o <= b; o++)

#define fri(a,b) for(int i = a; i >= b; i--)
#define frj(a,b) for(int j = a; j >= b; j--)
#define fro(a,b) for(int o = a; o >= b; o--)

#define fax(t) for(auto &x : t) 
#define fay(t) for(auto &y : t) 
#define faz(t) for(auto &z : t) 


#define ins insert
#define pb push_back
#define mt empty
#define mp make_pair
#define len(x) (int)x.size()
#define Len(x) (int)x.size()
#define sz(x) (int)x.size()

#include <bits/stdc++.h>
#include <chrono>
using namespace std;

#ifdef _DEBUG
#define LOCAL
#endif

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;

typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;

template<typename T>
ostream& operator<<(ostream& os, vector<T> v) {
	fi(0, sz(v) - 1) {
		os << v[i] << " ";
	}
	return os;
}
template<typename T1, typename T2>
ostream& operator<<(ostream& os, pair<T1, T2> x) {
	os << x.first << " " << x.second << " ";
	return os;
}


#ifdef LOCAL
#define dbg(x) {cerr << __LINE__ << "\t" << #x << ": " << (x) << endl;}
#else 
#define dbg(x) {}
#endif

ll n;
vll a;
ll next(ll A, ll B) {
	return rnd() % (B - A +1) + A;
}


void shf(vector<ll>&v) {
	fri(n, 1) {
		int j = next(1, i);
		swap(v[i], v[j]);
		if(v[i] == i || v[j] == j) {
			swap(v[i], v[j]);
		}
	}
}

bool has_fixed(vector<ll>&v) {
	fi(1, n) {
		if(v[i] == i) return true;
	}
	return false;
}


void solve() {
	if(n <= 2) {
		cout << "Impossible" << ln;
		return;
	}
	auto p = a;
	fi(1, n) {
		p[i] = i;
	}
	auto pos1 = vll(n+1);
	fi(1, n) {
		pos1[a[i]] = i;
	}
	while(1) {
		shf(p);
		if(has_fixed(p)) continue;
		auto q = vll(n+1);
		auto pos2 = vll(n+1);
		fi(1, n) {
			pos2[p[i]] = i;
		}
		fi(1, n) {
			q[i] = pos2[pos1[i]];
		}
		if(has_fixed(q)) continue;
		cout << "Possible" << ln;
		fi(1, n) {
			cout << p[i] << ' ';
		}
		cout << ln;
		fi(1, n) {
			cout << q[i] << ' ';
		}
		cout << ln;
		return;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif
	int tst;
	cin >> tst;
	fi(1, tst) {
		cin >> n;
		a = vll(n+1);
		fj(1, n) {
			cin >> a[j];	
		}
		solve(); 
	}
}