#define ln '\n'
#define All(x) x.begin(), x.end()
#define Allf(x) x.begin() + 1, x.end()
#define Allr(x) x.rbegin(), x.rend()

#define fi(a, b) for(int i = a; i <= b; i++)
#define fj(a, b) for(int j = a; j <= b; j++)
#define fo(a, b) for(int o = a; o <= b; o++)

#define fri(a,b) for(int i = a; i >= b; i--)
#define frj(a,b) for(int j = a; j >= b; j--)
#define fro(a,b) for(int o = a; o >= b; o--)

#define fax(t) for(auto &x : t) 
#define fay(t) for(auto &y : t) 
#define faz(t) for(auto &z : t) 


#define ins insert
#define pb push_back
#define mt empty
#define mp make_pair
#define len(x) (int)x.size()
#define Len(x) (int)x.size()
#define sz(x) (int)x.size()

#include <bits/stdc++.h>
using namespace std;

#ifdef _DEBUG
#define LOCAL
#endif

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;

typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;

template<typename T>
ostream& operator<<(ostream& os, vector<T> v) {
	fi(0, sz(v) - 1) {
		os << v[i] << " ";
	}
	return os;
}
template<typename T1, typename T2>
ostream& operator<<(ostream& os, pair<T1, T2> x) {
	os << x.first << " " << x.second << " ";
	return os;
}


#ifdef LOCAL
#define dbg(x) {cerr << __LINE__ << "\t" << #x << ": " << (x) << endl;}
#else 
#define dbg(x) {}
#endif
ll N;

ll get_digit(ll n, ll k) {
	k++;
	ll fact = 1;
	ll m = pow(10, k);

	fi(1, n) {
		fact = (fact * i) % m; 
	}
	m /= 10;
	ll res = fact / m;
	return res;
}

ll ask(ll x) {
	cout << "? "<< x << endl;
	ll res = 0;
	#ifdef LOCAL
		res = get_digit(N,x);
	#else
		cin >> res;
	#endif
	return res;
}
typedef __int128 i128;
ll mul(i128 a, i128 b, i128 m) {
	return (a * b) % m;
}
ll add(i128 a, i128 b, i128 m) {
	return(a+b)% m;
}

int maxq = 10;
void solve() {
	ll m = 1'000'000'000'000'000'000;
	ll nmax = 5982;
	vll fact(nmax+1);
	ll x = 1;
	fi(1, nmax) {
		x = mul(x, i, m);
		fact[i] = x;
	}
	ll history = 0;
	fri(maxq - 1, 0) {
		ll res = ask(i);

		history = add(mul(history,10, m), res, m);
	}
	fi(1, nmax) {
		if(history == fact[i]) {
			cout << "! " << i << endl;
			dbg(i);
			return;
		}
	}
}

int main() {
	int tst;
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
		cin >> tst;
	#else
		cin >> tst;
	#endif
	fi(1, tst) {
		#ifdef LOCAL
			cin >> N;
		#endif
		solve();
	}
}