#define ln '\n'
#define All(x) x.begin(), x.end()
#define Allf(x) x.begin() + 1, x.end()
#define Allr(x) x.rbegin(), x.rend()

#define fi(a, b) for(int i = a; i <= b; i++)
#define fj(a, b) for(int j = a; j <= b; j++)
#define fo(a, b) for(int o = a; o <= b; o++)

#define fri(a,b) for(int i = a; i >= b; i--)
#define frj(a,b) for(int j = a; j >= b; j--)
#define fro(a,b) for(int o = a; o >= b; o--)

#define fax(t) for(auto &x : t) 
#define fay(t) for(auto &y : t) 
#define faz(t) for(auto &z : t) 


#define ins insert
#define pb push_back
#define mt empty
#define mp make_pair
#define len(x) (int)x.size()
#define Len(x) (int)x.size()
#define sz(x) (int)x.size()

#include <bits/stdc++.h>
using namespace std;

#ifdef _DEBUG
#define LOCAL
#endif

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;

typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;

template<typename T>
ostream& operator<<(ostream& os, vector<T> v) {
	fi(0, sz(v) - 1) {
		os << v[i] << " ";
	}
	return os;
}
template<typename T1, typename T2>
ostream& operator<<(ostream& os, pair<T1, T2> x) {
	os << x.first << " " << x.second << " ";
	return os;
}


#ifdef LOCAL
#define dbg(x) {cerr << __LINE__ << "\t" << #x << ": " << (x) << endl;}
#else 
#define dbg(x) {}
#endif

int n;
int k;
vector<vll> e;
vll q;

void solve() {
	ll cur_k = 1;
	ll l = 1, r = 2;
	ll h;
	
	if(k >= n) {
		cout << "NO" << ln;
		return;
	}
	
	while(cur_k < k) {
		
		dbg(q);
		h = r / 2;
		fi(0, h - 1) {
			q[l + i]--;
			q[r - i]--;
		}
		r++;
		cur_k++;
		dbg(q);
	}
	
	if(cur_k != k) {
		cout << "NO" << ln;
		return;
	} else {
		cout << "YES" << ln;
		vector<pair<int,int> >ans;
		set<pair<int,int>>t;
		vector<int>w(n+1);
		fj(1, n) {
			int cnt = w[j];
			int y = n;
			while(cnt != q[j]) {
				if((!t.count({y,j}) && !t.count({j,y})) && y != j) {
					cnt++;
					t.ins({j,y});
					ans.pb({j,y});
					w[j]++;
					w[y]++;
				}
				y--;
			}
		}
		cout << sz(ans) << ln;
		faz(ans) {
			cout << z.first << ' ' << z.second << ln;
		}	
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif
	
	cin >> n >> k;
	e = vector<vll>(n + 1);
	
	q = vll(n + 1, n - 1);
	
	
	solve();
}