#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

template <typename T>
T read() {
    T tmp;
    cin >> tmp;
    return tmp;
}

int main() {
    int n = read<int>();
    vector<vector<int>> map(n);
    std::generate(map.begin(), map.end(),[] {
        int size = read<int>();
        vector<int> tmp(size);
        std::generate(tmp.begin(), tmp.end(),read<int>);
        return tmp;
    });

    int size = 0;
    for (const auto &item: map) size += item.size();
    vector<int> need(size);
    int index = 0;
    for (const auto &item: map) {
        for (const auto &item: item) {
            need[index] = item;
            index++;
        }
    }
    std::sort(need.begin(), need.end());
    int result = 0;
    for(int q = 0; q < map.size(); q++) {
        auto it = std::lower_bound(need.begin(), need.end(),map[q][0]);
        for (int i = 0; i < map[q].size(); i++) {
            if (*it != map[q][i]) {
                result++;
                it = std::lower_bound(need.begin(), need.end(),map[q][i]);
            }
            it++;
            if (it == need.end() and i + 1 < map[q].size()) {
                result++;
                it = std::lower_bound(need.begin(), need.end(),map[q][i + 1]);
            }
        }
    }

    cout << result << " " << result + n - 1;
    return 0;
}