#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <stack>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <string>
#include <utility>
#include <deque>
#include <queue>
#include <stack>
using namespace std;

int t;
int n;
vector < pair<int, int> > a;
set<int> sd;

void solve(){
	cin >> n;
	a.clear();
	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		a.push_back({ x, i });	
	}
	sort(a.begin(), a.end());
	sd.clear();
	for (int i = 0; i < n; i++) {
		int v = a[i].second;
		if (i <= v) {
			sd.insert(v - i);
		}
		else {
			sd.insert(n - i + v);
		}
	}
	int mn = -1;
	for (int i = 1; i < n; i++) {
		if (sd.find(i) == sd.end()) {
			mn = i;
			break;
		}
	}
	if (mn == -1) {
		cout << "Impossible" << '\n';
		return;
	}
	else {
		cout << "Possible" << '\n';
		int k = n - mn;
		vector <int> buff(n);
		for (int i = 0; i < n; i++) {
			buff[(i + mn) % n] = a[i].second;
		}
		for (int i = 0; i < n; i++) {
			cout << buff[i] + 1 << ' ';
		}
		cout << '\n';
		for (int i = 0; i < n; i++) {
			buff[(i + k) % n] = i;
		}
		for (int i = 0; i < n; i++) {
			cout << buff[i] + 1 << ' ';
		}
		cout << '\n';
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
}