#define _CRT_SECURE_NO_WARNINGS
#include <numeric>
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <bitset>
#include <regex>
#include <vector>
#include <map>
#include <queue>
#include <deque>
#include <set>
#include <cmath>
#include <cstdio>
#include <string.h>
#include <string>
#include <sstream>
#include <stack>
#include <limits>
#include <climits>
#include <iterator>
#include <random>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
#define LLONG_MAX
#define all(a) a.begin(), a.end()
#define mp make_pair
#define pb push_back
#define ve vector
#define sz(v) (ll)v.size()
#define fi first
#define se second
#define PI acos(-1)
#define FOR(i, s, e) for(ll i = s; i < e; ++i)
#define DEC(i, s, e) for(ll i = s; i >= e; --i)
#define fastio ios_base::sync_with_stdio(false); cin.tie(NULL);
#define rnd mt19937
#define rnd64 mt19937_64

void dfs(vll& a, vll& used, vll& topsort, ll v)
{
	used[v] = 1;
	if (!used[a[v]]) dfs(a, used, topsort, a[v]);
	topsort.pb(v);
}

int main()
{
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	ll _ = 1;
	cin >> _;
	while (_--) {
		ll n;
		cin >> n;
		vll c(n + 1);
		vll a(n + 1, 0);
		vll gg(n + 1, 0);
		FOR(i, 1, n + 1)
		{
			cin >> c[i];
			a[c[i]] = i;
		}
		vll used(n + 1, 0);
		vll topsort;
		FOR(i, 1, n + 1)
		{
			if (!used[i]) dfs(a, used, topsort, i);
		}
		reverse(all(topsort));

		if (n <= 5)
		{
			vll p1(n), q(n + 1), p(n + 1, 0);
			FOR(i, 0, n) p1[i] = i;
			bool flgl = false;
			do
			{
				bool fl = true;
				FOR(i, 0, n)
				{
					p[i + 1] = p1[i] + 1;
				}
				FOR(i, 1, n + 1)
				{
					if (p[i] == i || a[i] == p[i])
						fl = false;
				}
				if (fl)
				{
					flgl = true;
					FOR(i, 1, n + 1)
					{
						q[p[i]] = a[i];
					}
					cout << "Possible\n";
					FOR(i, 1, n + 1)
					{
						cout << q[i] << " ";
					}
					cout << endl;
					FOR(i, 1, n + 1)
					{
						cout << p[i] << " ";
					}
					cout << endl;
					break;
				}
			} while (next_permutation(all(p1)));
			if (!flgl) cout << "Impossible\n";
		}
		else
		{
			vll p(n + 1), q(n + 1);
			bool DA = false;
			//bool fl[10] = { true, true, true, true, true, true, true, true, true, true };
			FOR(k, 0, 10)
			{
				bool fl = true;
				FOR(i, 0, n)
				{
					if (topsort[i] == topsort[(i + k + 2) % n] || topsort[(i + 2 + k) % n] == a[topsort[i]])
						fl = false;
				}
				if (fl)
				{
					FOR(i, 0, n)
					{
						p[topsort[i]] = topsort[(i + 2 + k) % n];
						q[topsort[(i + 2 + k) % n]] = a[topsort[i]];
					}
					DA = true;
					break;
				}
			}
			if (DA)
			{
				cout << "Possible\n";
				FOR(i, 1, n + 1)
				{
					cout << q[i] << " ";
				}
				cout << endl;
				FOR(i, 1, n + 1)
				{
					cout << p[i] << " ";
				}
				cout << endl;
			}
			else
			{
				cout << "Impossible\n";
			}

		}
	}
}
