#define _CRT_SECURE_NO_WARNINGS
#include <numeric>
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <bitset>
#include <regex>
#include <vector>
#include <map>
#include <queue>
#include <deque>
#include <set>
#include <cmath>
#include <cstdio>
#include <string.h>
#include <string>
#include <sstream>
#include <stack>
#include <limits>
#include <climits>
#include <iterator>
#include <random>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
#define LLONG_MAX
#define all(a) a.begin(), a.end()
#define mp make_pair
#define pb push_back
#define ve vector
#define sz(v) (ll)v.size()
#define fi first
#define se second
#define PI acos(-1)
#define FOR(i, s, e) for(ll i = s; i < e; ++i)
#define DEC(i, s, e) for(ll i = s; i >= e; --i)
#define fastio ios_base::sync_with_stdio(false); cin.tie(NULL);
#define rnd mt19937
#define rnd64 mt19937_64

void dfs(vll& a, vll& used, vll& topsort, ll v)
{
	used[v] = 1;
	if (!used[a[v]]) dfs(a, used, topsort, a[v]);
	topsort.pb(v);
}

int main()
{
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	ll _ = 1;
	//cin >> _;
	while (_--) {
		ll n, k;
		cin >> n >> k;
		if (k == 1) {
			cout << "YES\n";
			cout << n << '\n';
			FOR(i, 1, n) {
				cout << i << ' ' << i + 1 << '\n';
			}
			cout << n << ' ' << 1 << '\n';
			continue;
		}
		vpll gr;
		FOR(i, 2, n + 1) {
			gr.pb({ 1, i });
		}
		set<ll> st = { n - 1, 1 };
		vll step(n + 1, 1);
		step[1] = n - 1;
		ll cur = 3;
		ll next = 2;
		bool flag = true;
		while (st.size() != k) {
			ll i = cur + 1;
			while (step[cur] != next) {
				gr.pb({ cur, i });
				step[cur]++;
				if (i > n) {
					flag = false;
					break;
				}
				step[i++]++;
			}
			st.insert(next);
			next++;
			cur++;
			if (!flag) {
				break;
			}
		}
		if (!flag) {
			cout << "NO\n";
			continue;
		}
		cout << "YES\n";
		cout << gr.size() << '\n';
		FOR(i, 0, gr.size()) {
			cout << gr[i].first << ' ' << gr[i].second << '\n';
		}
	}
}
