#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double lf;
typedef long double ld;
typedef pair<ll, ll> pll;

const ll N = 2e5 + 10;

vector<ll> g[N];

void solve() {
    ll t; cin >> t;
    while (t--) {
        ll n;
        cin >> n;
        vector<ll> a(n);
        for (auto &it: a)
            cin >> it;
        for (auto& it : a) --it;

        auto calc_rev = [&](vector<ll>& a, vector<ll>& reva) {
            for (int i = 0; i < n; ++i)
                reva[a[i]] = i;
        };

        vector<ll> reva(n);
        calc_rev(a, reva);
#ifdef DEBUG
        cout << "# ";
        for (auto it : reva)
            cout << it << " ";
        cout << endl;
#endif

        auto prod = [&](vector<ll> &p, vector<ll> &q, vector<ll>& dummy) {
            calc_rev(p, dummy);
            for (int i = 0; i < n; ++i)
                q[i] = dummy[reva[i]];
        };
        auto check = [&](vector<ll> &a) {
            for (int i = 0; i < n; ++i)
                if (a[i] == i)
                    return false;
            return true;
        };
        auto check2 = [&](vector<ll>& p, vector<ll>& q) {
            for (int i = 0; i < n; ++i)
                if (q[p[a[i]]] != i)
                    return false;
            return true;
        };

        set<ll> st;
        for (int i = 0; i < n; ++i)
            st.insert(i);
        for (int i = 0; i < n; ++i) {
            ll d = reva[i] - i;
            if (st.count((n + d) % n))
                st.erase((n + d) % n);
        }
        vector<ll> p(n), q(n), dummy(n);
        for (auto shift : st) {
            for (int i = 0; i < n; ++i)
                p[i] = reva[(shift + i) % n];
            prod(p, q, dummy);
            if (check(p) && check(q) && check2(p, q))
                break;
        }

        if (check(p) && check(q) && check2(p, q))
            goto possible;

        for (int i = 0; i < n; ++i)
            st.insert(i);
        for (int i = 0; i < n; ++i) {
            ll d = a[i] - i;
            if (st.count((n + d) % n))
                st.erase((n + d) % n);
        }
        for (auto shift : st) {
            for (int i = 0; i < n; ++i)
                p[i] = a[(shift + i) % n];
            prod(p, q, dummy);
            if (check(p) && check(q) && check2(p, q))
                break;
        }

        if (check(p) && check(q) && check2(p, q))
            goto possible;

        for (int i = 0; i < n; ++i)
            st.insert(i);
        for (auto shift : st) {
            for (int i = 0; i < n; ++i)
                p[i] = (shift + i) % n;
            prod(p, q, dummy);
            if (check(p) && check(q) && check2(p, q))
                break;
        }

        for (int i = 0; i < n; ++i)
            p[i] = i;
        while (next_permutation(p.begin(), p.end())) {
            if (check(p) && check(q) && check2(p, q))
                break;
        }

        if (check(p) && check(q) && check2(p, q))
            goto possible;
        else
            goto impossible;


        {
            possible:
            cout << "Possible" << endl;
            for (auto it: p)
                cout << it + 1 << " ";
            cout << endl;
            for (auto it: q)
                cout << it + 1 << " ";
            cout << endl;
            continue;
        }
        {
            impossible:
            cout << "Impossible" << endl;
            continue;
        }
    }
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
    return 0;
}
