#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double lf;
typedef long double ld;
typedef pair<ll, ll> pll;

const ll N = 2e5 + 10;

vector<ll> g[N];

void solve() {
    ll n,k;
    cin>>n >> k;

    if(k == 1){
        cout<<"YES\n"<<n<<'\n';
        for(int i=0;i<n;i++) {
            cout<< i + 1 <<' '<<(i + 1) % n + 1<<'\n';
        }
        return;
    }

    if (n == 1) {
        if (k == 1) {
            cout << "YES" << endl;
            cout << 0 << endl;
            return;
        } else {
            cout << "NO" << endl;
            return;
        }
    }

    auto foo = [&]() {
        vector<ll> r(n, 0);
        for (int i = 0; i < n; ++i)
            for (auto j : g[i])
                r[i]++, r[j]++;
        set<ll> st;
        for (auto it : r)
            st.insert(it);
        if (st.count(0))
            return -1ll;
        return ll(st.size());
    };

    ll l = 0, r = n;
    while (foo() != k) {
        if (r <= l)
            break;
        for (int i = l + 1; i < r; i++) {
            if (foo() == k)
                break;
            g[l].push_back(i);
        }
        ++l, --r;
    }

    if (k != foo()) {
        cout << "NO" << endl;
        return;
    }

    ll count = 0;
    for (auto& it : g) {
        count += it.size();
    }
    cout << "YES" << endl;
    cout << count << endl;
    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            cout << i + 1 << " " << j + 1 << endl;
        }
    }
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
    return 0;
}
