#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long double ld;
using ll = long long;

using vi = vector<int>;

const int INFi = 2e9;
const ll INF = 2e18;
const int maxN = 1e5;

bool solve(vector<int>& p, vector<int>& q) {
    int n; cin >> n;
    vector<int> a(n);
    for (int& x : a) cin >> x, --x;

    vector<vector<int>> cyc;
    vector<char> used(n);
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;

        vector<int> cur;
        int j = i;
        while (!used[j]) {
            used[j] = true;
            cur.push_back(j);
            j = a[j];
        }
        cyc.push_back(cur);
    }

    fill(used.begin(), used.end(), false);

    bool got = false;
    int ptri = -1, ptrj = -1;

    p.resize(n);
    q.resize(n);

    vector<int> len1, len2;
    for (int i = 0; i < cyc.size(); ++i) {
        // cout << "i=" << i << " => " << cyc[i].size() << endl;
        if (cyc[i].size() == 1) len1.push_back(i);
        if (cyc[i].size() == 2) len2.push_back(i);

        if (cyc[i].size() >= 3) {
            for (int j = 0; j < cyc[i].size(); ++j) {
                p[cyc[i][j]] = cyc[i][(j+1)%cyc[i].size()];
            }
            used[i] = true;
            ptri = cyc[i][0];
            ptrj = cyc[i][1];
            got = true;
            break;
        }
    }

    if (!got && len1.size() >= 2) {
        const int a = cyc[len1[0]][0], b = cyc[len1[1]][0];
        used[len1[0]] = used[len1[1]] = true;
        ptri = p[a] = b;
        ptrj = p[b] = a;
        got = true;
    }

    if (!got && len2.size() >= 2) {
        const int a = cyc[len2[0]][0], b = cyc[len2[0]][1];
        const int c = cyc[len2[1]][0], d = cyc[len2[1]][1];
        used[len2[0]] = true;
        used[len2[1]] = true;

        p[a] = c; p[c] = a;
        p[b] = d; p[d] = b;
        ptri = a;
        ptrj = b;
        got = true;
    }

    if (!got) return false;

    for (int i = 0; i < cyc.size(); ++i) {
        if (used[i]) continue;

        if (cyc[i].size() == 2) {
            const int a = cyc[i][0], b = cyc[i][1];
            p[a] = a; p[b] = b;
            swap(p[a], p[ptri]);
            swap(p[b], p[ptrj]);
        } else if (cyc[i].size() == 1) {
            const int a = cyc[i][0];
            p[a] = a;
            swap(p[a], p[ptri]);
        } else {
            for (int j = 0; j < cyc[i].size(); ++j) {
                p[cyc[i][j]] = cyc[i][(j + 1) % cyc[i].size()];
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        q[a[p[i]]] =i;
    }

//    for (int i = 0; i < n; ++i) {
//        assert(a[p[q[i]]] == i);
//        assert(p[i] != i);
//        assert(q[i] != i);
//    }

    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1; cin >> t;
    for(int i = 0; i < t; ++i) {
        vector<int> p, q;
        if (solve(p, q)) {
            cout << "Possible" << '\n';
            for (int x : p) cout << x+1 << ' '; cout << '\n';
            for (int x : q) cout << x+1 << ' '; cout << '\n';
        } else {
            cout << "Impossible" << '\n';
        }


    }
    return 0;
}

/*
1
5
5 1 4 2 3
 */