#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

using namespace std;

typedef long double ld;
using ll = long long;

using vi = vector<int>;

const int INFi = 2e9;

const int N = 1000;
const int K = 100;

int n, k, ord[K][N], par[N];
uint64_t kek[N], ps[K][N+1];


void realize(const vector<int>& l, const vector<int>& r, int pp) {
    if (l[0] + 1 == r[0]) {
        par[ord[0][l[0]]] = pp;
        return;
    }

    const int n = r[0] - l[0];
    for (int i = 0; i < n/2; ++i) {
        int j = i % 2 == 0 ? l[0] + i + 1 : r[0] - i - 1; j -= l[0];
        assert((j - l[0]) % 2 != 0);

        const int sz_a = j;
        const int sz_b = n - j - 1;
        const uint64_t h_a = ps[0][l[0]+sz_a] ^ ps[0][l[0]];
        const uint64_t h_b = ps[0][r[0]-sz_b] ^ ps[0][r[0]];

        vector<int> swp(k);

        bool ok = true;

        for (int j = 0; j < k; ++j) {
            bool cur = false;

            const uint64_t p_a = ps[j][l[j]+sz_a] ^ ps[j][l[j]];
            const uint64_t p_b = ps[j][r[j]-sz_b] ^ ps[j][r[j]];
            if (p_a == h_a && p_b == h_b) {
                swp[j] = 0; cur = true;
            }

            const uint64_t q_b = ps[j][l[j]+sz_b] ^ ps[j][l[j]];
            const uint64_t q_a = ps[j][r[j]-sz_a] ^ ps[j][r[j]];
            if (q_a == h_a && q_b == h_b) {
                swp[j] = 1; cur = true;
            }

            if (!cur) {
                ok = false;
                break;
            }
        }

        if (!ok) continue;

        const int root = ord[0][l[0]+j];
        par[root] = pp;
        vector<int> al, ar, bl, br;

        for (int i = 0; i < k; ++i) {
            if (!swp[i]) {
                al.push_back(l[i]);
                ar.push_back(l[i]+sz_a);
                bl.push_back(r[i]-sz_b);
                br.push_back(r[i]);
            } else {
                bl.push_back(l[i]);
                br.push_back(l[i]+sz_b);
                al.push_back(r[i]-sz_a);
                ar.push_back(r[i]);
            }
        }

//        for (int x : al) cout << x << ' '; cout << endl;
//        for (int x : ar) cout << x << ' '; cout << endl;

        realize(al, ar, root);
        realize(bl, br, root);
        return;
    }

    assert(false);
}

void solve() {
    cin >> n >> k;

    mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
    for (int i = 0; i < n; ++i) {
        kek[i] = rng();
    }

    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> ord[i][j];
            --ord[i][j];
            ps[i][j+1] = kek[ord[i][j]] ^ ps[i][j];
        }
    }

//    cout << "A" << endl;

    vector<int> l0(k, 0), r0(k, n);
    realize(l0, r0, -1);
    for (int i = 0; i < n; ++i) {
        cout << (par[i] == -1 ? -1 : par[i]+1) << ' ';
    }
    cout << '\n';

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    for(int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}

/*
3 2
1 2 3
3 2 1

 */