#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long double ld;
using ll = long long;

using vi = vector<int>;

int n, m, md;

inline int add(const int &a, const int &b) {
    return a + b >= md ? a + b - md : a + b;
}

inline int sub(const int &a, const int &b) {
    return a - b < 0 ? a - b + md : a - b;
}

inline int mul(const int &a, const int &b) {
    return (1ll * a * b) % md;
}

int pw(int a, int b) {
    int r = 1;
    for(; b; b >>= 1, a = mul(a, a)) if (b & 1) r = mul(r, a);
    return r;
}

int rev(int a) {
    return pw(a, md - 2);
}

vector<vi> trees;

const int maxN = 1e3 + 5;
int h[maxN];
vector<pair<int, int>> g[maxN];
vector<pair<int, int>> kek;
pair<int, int> up[maxN];
int pe[maxN];
int pv[maxN];

int inT[maxN];
vi ord;
vector<pair<int, int>> g2[maxN];

void dfs(int v, int pred) {
    up[v] = {h[v], -1};
    pe[v] = pred;
    for(auto &[u, i] : g[v]) {
        if (i == pred) continue;
        if (h[u]) {
            if (h[u] > h[v]) continue;
            kek.push_back({i, pred});
            up[v] = min(up[v], {h[u], i});
            continue;
        }
        g2[v].emplace_back(u, i);
        h[u] = h[v] + 1;
        pv[u] = v;
        inT[i] = 1;
        dfs(u, i);
        up[v] = min(up[v], up[u]);
    }
    ord.push_back(v);
}

int x[maxN];
int X = -1;

pair<int, int> dfs2(int v) {
    int szv = 1;
    int sumv = (pv[v] == 0 ? 0 : x[pe[v]]);
    for(auto &[u, i] : g2[v]) {
        auto [sz, sum] = dfs2(u);
        if (up[u].first >= h[v]) {
            sz = add(sz, 1);
            if (sz != 1) {
                int y = mul(sum, rev(sub(sz, 1)));
                if (X == -1) X = y;
                if (X != y) {
                    cout << "-1\n";
                    exit(0);
                }
            }
        } else {
            szv = add(szv, sz);
            sumv = add(sumv, sum);
        }
    }
    return {szv, sumv};
}

void solve() {
    cin >> n >> m >> md;
    rep(i, m) {
        int u, v; cin >> u >> v >> x[i];
        g[u].emplace_back(v, i);
        g[v].emplace_back(u, i);
    }
    h[1] = 1;
    dfs(1, -1);
    for(auto &[i, j] : kek) {
        vi edges;
        int r = x[i];
        edges.push_back(r);
        rep(e, m) {
            if (e == j) continue;
            if (inT[e] || e == i) {
                x[e] = sub(x[e], r);
                edges.push_back(e);
            }
        }
        assert(edges.size() == n);
        trees.push_back(edges);
    }
    for(auto &[i, j] : kek) assert(x[i] == 0);
    {
        auto [sz, sum] = dfs2(1);
        if (sz != 1) {
            int y = mul(sum, rev(sub(sz, 1)));
            if (X == -1) X = y;
            if (X != y) {
                cout << "-1\n";
                exit(0);
            }
        }
    }
    if (X == -1) X = 0;
    if (X != 0) {
        vi edges;
        edges.push_back(X);
        rep(i, m) if (inT[i]) {
            edges.push_back(i);
            x[i] = sub(x[i], X);
        }
        assert(edges.size() == n);
        trees.push_back(edges);
    }
    for(auto &v : ord) {
        if (up[v].first >= h[v] - 1) continue;
        int i = pe[v];
        int j = pe[pv[v]];
        int e = up[v].second;
        int r = x[i];
        {
            vi edges;
            edges.push_back(r);
            edges.push_back(e);
            rep(t, m) {
                if (inT[t]) {
                    if (t == j) continue;
                    edges.push_back(t);
                    x[t] = sub(x[t], r);
                }
            }
            assert(edges.size() == n);
            trees.push_back(edges);
        }
        r = sub(0, r);
        {
            vi edges;
            edges.push_back(r);
            edges.push_back(e);
            rep(t, m) {
                if (inT[t]) {
                    if (t == i) continue;
                    edges.push_back(t);
                    x[t] = sub(x[t], r);
                }
            }
            assert(edges.size() == n);
            trees.push_back(edges);
        }
    }
    rep(i, m) {
        if (x[i] != 0) {
            cout << "-1\n";
            return;
        }
    }
    cout << trees.size() << '\n';
    for(auto &edges : trees) {
        for(auto &v : edges) cout << v << ' ';
        cout << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    for(int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}