#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long double ld;
using ll = long long;

using vi = vector<int>;

void solve() {
    int n, k;
    cin >> n >> k;
    if (k == 1) {
        cout << "YES\n";
        cout << n * (n - 1) / 2 << '\n';
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                cout << i + 1 << " " << j + 1 << '\n';
            }
        }
        return;
    }
    if (n == k) {
        cout << "NO\n";
        return;
    }
    vector<pair<int, int>> e;
    int m = k + 1;
    for (int i = 1; i < n; i++) {
        e.push_back({0, i});
    }
    int l = 1, r = m - 1;
    while (r - l + 1 >= 3) {
        for (int i = l + 1; i < r; i++) {
            e.push_back({l, i});
        }
        l++, r--;
    }
    vector<int> p(n);
    for (auto [x, y] : e) {
        p[x]++, p[y]++;
    }
    set<int> st;
    for (auto x : p) st.insert(x);
    assert((int) st.size() == k);
    cout << "YES\n";
    cout << (int) e.size() << '\n';
    for (auto [x, y] : e) {
        cout << x + 1 << " " << y + 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    for(int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}