#include <bits/stdc++.h>
#define rep(i, n) for (int i = 0; i < (n); ++i)
typedef long long ll;
using namespace std;
typedef pair<int, int> pii;

vector<set<int>> g;
vector<set<int>> g2;
vector<int> tin, tout, up, tup, need;
int ct;

void dfs(int v, int p) {
    up[v] = p;
    tup[v] = tin[v] = ++ct;
    for (int u : g[v]) {
        if (u == p)
            continue;
        if (tin[u]) {
            tup[v] = min(tup[v], tin[u]);
            continue;
        }

        dfs(u, v);
        tup[v] = min(tup[v], tup[u]);
    }
    tout[v] = ct;
}

int isp(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}


void del(int v) {
    if (g[v].size() != 1)
        return;
    int u = *g[v].begin();
    g[u].erase(v);
    g[v].erase(u);
    del(u);
}
int n, m;

void del2(int v) {
    if (g2[v].size() != 1 || need[v])
        return;
    int u = *g2[v].begin();
    g2[u].erase(v);
    g2[v].erase(u);
    del2(u);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    while (1) {
        cin >> n >> m;
        int e = 0;
        if (!n)
            break;
        g = vector<set<int>>(n);
        ct = 0;
        tin = vector<int>(n);
        tout = vector<int>(n);
        tup = vector<int>(n);
        up = vector<int>(n);
        rep(i, m) {
            int k;
            cin >> k;
            int u, v;
            cin >> u;
            --u;
            rep(j, k - 1) {
                cin >> v;
                --v;
                e++;
                g[u].insert(v);
                g[v].insert(u);
                u = v;
            }
        }
        rep(i, n)
            del(i);
        int start = 0;
        while (start < n && g[start].empty())
            start++;
        if (start == n) {
            cout << "Yes\n";
            continue;
        }
        dfs(start, -1);
        int ok = 1;
        g2 = vector<set<int>>(n + e);
        need = vector<int>(n + e);
        int cc = 0;
        rep(i, n)
            for (int j : g[i]) {
//                cout << i << ' ' << up[i] << ' ' << j << ' ' << up[j] << endl;
                if (j == up[i] || i == up[j]) {
                    if (j == up[i] && tup[i] > tin[j]) {
                        g2[n + cc].insert(i);
                        g2[i].insert(n + cc);
                        g2[n + cc].insert(j);
                        g2[j].insert(n + cc);
                        cc++;
                    }
                    continue;
                }
                int u = i, v = j;
                if (u > v)
                    continue;
//                cout << u << ' ' << v << endl;
                while (!isp(v, u)) {
                    g2[n + cc].insert(v);
                    g2[v].insert(n + cc);
                    v = up[v];
                }
                while (!isp(u, v)) {
                    g2[n + cc].insert(u);
                    g2[u].insert(n + cc);
                    u = up[u];
                }
                assert(u == v);
                g2[n + cc].insert(v);
                g2[v].insert(n + cc);
                cc++;
            }
        int ccom = 0;
        rep(i, cc) {
            int ff = 0;
            for (int j : g2[n + i])
                if (g2[j].size() > 1)
                    ff++;
            if (ff > 1)
                ccom++;
        }
        if (ccom <= 1) {
            cout << "Yes\n";
            continue;
        }
        rep(i, n)
            if (g2[i].size() > 1) {
                need[i] = 1;
                cout << i << '\n';
            }
        rep(i, n + e)
            del2(i);
        ok = 1;
        rep(i, n + e)
            if (g2[i].size() > 2)
                ok = 0;
        if (ok)
            cout << "Yes\n";
        else
            cout << "No\n";
    }
    return 0;
}
//9 4
//4 1 2 3 1
//4 1 4 5 1
//4 2 6 7 2
//4 3 8 9 3
//4 9 10 11 9
//0 0