#include <bits/stdc++.h>
#define rep(i, n) for (int i = 0; i < (n); ++i)
typedef long long ll;
using namespace std;

typedef pair<int, int> pii;

const int N = 1005;
char a[N][N];
int num[N][N];
int cn[2];
vector<int> g[N], g2[N * 2];
int used[N * 2], pr[N], inp[N];
int ans = 0;

bool dfs(int v) {
    used[v] = 1;
    for (int u : g[v]) {
        if (pr[u] == -1 || !used[pr[u]] && dfs(pr[u])) {
            pr[u] = v;
            inp[v] = 1;
            return 1;
        }
    }
    return 0;
}

void dfs2(int v) {
//    cout << v << endl;

    used[v] = 1;
    if (v < N)
        ans--;
    for (int u : g2[v])
        if (!used[u])
            dfs2(u);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    int cnt = 0;
    rep(i, n) {
        cin >> a[i];
        rep(j, m)
            if (a[i][j] == '.')
                cnt++;
    }
    if (cnt >= 2002) {
        cout << 1000000;
        return 0;
    }
    rep(i, n) {
        rep(j, m) {
            if (a[i][j] == '#') {
                num[i][j] = -1;
                continue;

            }
            num[i][j] = cn[(i + j) % 2]++;
            assert(num[i][j] < N);
        }
    }
    rep(i, n)
        rep(j, m) {
            if (j < m - 1 && a[i][j] == '.' && a[i][j + 1] == '.') {
                int x = num[i][j];
                int y = num[i][j + 1];
                if ((i + j) % 2 == 0)
                    g[x].push_back(y);
                else
                    g[y].push_back(x);
            }
            if (i < n - 1 && a[i][j] == '.' && a[i + 1][j] == '.') {
                int x = num[i][j];
                int y = num[i + 1][j];
                if ((i + j) % 2 == 0)
                    g[x].push_back(y);
                else
                    g[y].push_back(x);
            }
        }
    rep(i, N)
        pr[i] = -1;
    rep(i, N) {
        int ch = 0;
        rep(j, cn[0])
            used[j] = 0;
        rep(j, cn[0]) {
            if (inp[j] || used[j])
                continue;
            if (dfs(j))
                ch = 1;
        }
        if (!ch)
            break;
    }
    rep(i, N)
        for (int j : g[i]) {
            if (pr[j] == i)
                g2[N + j].push_back(i);
            else
                g2[i].push_back(N + j);
        }
        int nn = cn[0] + cn[1];
    ans = nn * (nn - 1) / 2;
        assert(cn[0] == cn[1]);
        rep(i, cn[1]) {
            assert(pr[i] != -1);
        }
    rep(i, cn[0]) {
        rep(j, N * 2)
            used[j] = 0;
//        cout << i << ":\n";
        dfs2(i);
     }
     ans = min(ans, 1000000);
     cout << ans << '\n';

    return 0;
}
