#include <bits/stdc++.h>
#define rep(i, n) for (int i = 0; i < (n); ++i)
typedef long long ll;
using namespace std;
typedef pair<int, int> pii;

const int N = 1001;
vector<pair<int, int>> g[N], h[N], e;
int n, m, p, cnt[N], min_edge[N], sum[N], pr[N], start[N], pedge[N], x[N], used[N], tin[N], f[N], timer = 0;
vector<tuple<int, int, int>> trees;
bool ok = true;
int main_tree = -1;
int add_main = 0;
vector<int> main_edges;
int fast_pow(int a, int n) {
    int res = 1;
    while (n > 0) {
        if (n & 1) res = res * 1ll * a % p;
        a = a * 1ll * a % p;
        n >>= 1;
    }
    return res;
}
void dfs(int v) {
    used[v] = 1;
    f[v] = tin[v] = timer++;
    min_edge[v] = -1;
    if (v != 0) {
        cnt[v] = 1;
        main_edges.push_back(pedge[v]);
    }
    for (auto to : g[v]) {
        int u = to.first;
        if (!used[u]) {
            pr[u] = v; pedge[u] = to.second;
            h[v].push_back(to);
            dfs(u);
            if (f[u] >= tin[v]) start[u] = 1;
            else sum[v] = (sum[v] + sum[u]) % p, cnt[v] += cnt[u];
            if (f[u] < f[v]) {
                min_edge[v] = min_edge[u];
                f[v] = f[u];
            }
        } else {
            if (to.second == pedge[v] || tin[u] > tin[v]) continue;
            if (tin[u] < f[v]) {
                f[v] = tin[u];
                min_edge[v] = to.second;
            }
            x[pedge[v]] = (x[pedge[v]] + x[to.second]) % p;
            trees.emplace_back(to.second, pedge[v], x[to.second]);
            x[to.second] = 0;
        }
    }
    if (v != 0) sum[v] = (sum[v] + x[pedge[v]]) % p;
    if (v != 0 && f[v] >= tin[pr[v]]) {
        if (cnt[v] % p == 0) {
            if (sum[v] % p != 0) {
                ok = false;
                return;
            }
        } else {
            int tmp = sum[v] * 1ll * fast_pow(cnt[v], p - 2) % p;
            if (main_tree != -1 && tmp != main_tree) {
                ok = false;
                return;
            }
            main_tree = tmp;
        }
    }
}
vector<vector<int>> ans;
void add_ans(int e_new, int e_old, int add) {
    ans.emplace_back(n);
    ans.back()[0] = add;
    rep(i, n - 1) {
        if (main_edges[i] == e_old) ans.back()[i + 1] = e_new;
        else ans.back()[i + 1] = main_edges[i];
    }
    add_main = (add_main - add + p) % p;
}
void dfs2(int v) {
    for (auto to : h[v]) {
        dfs2(to.first);
    }
    if (v == 0) return;
    if (x[pedge[v]] != 0) {
        assert(pr[v] > 0);
        add_ans(min_edge[v], pedge[pr[v]], x[pedge[v]]);
        add_ans(min_edge[v], pedge[v], (p - x[pedge[v]]) % p);
        x[pedge[pr[v]]] = (x[pedge[pr[v]]] + x[pedge[v]]) % p;
        x[pedge[v]] = 0;
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> p;
    rep(i, m) {
        int v, u;
        cin >> v >> u >> x[i];
        --v; --u;
        g[v].emplace_back(u, i);
        g[u].emplace_back(v, i);
        e.emplace_back(v, u);
    }
    pr[0] = pedge[0] = -1;
    dfs(0);
    if (!ok) {
        cout << -1 << '\n';
        return 0;
    }
    if (main_tree != -1) {
        for (auto i : main_edges) {
            x[i] = (x[i] - main_tree + p) % p;
        }
        add_main += main_tree;
    }
    for (auto t : trees) add_ans(get<0>(t), get<1>(t), get<2>(t));
    dfs2(0);
    ans.emplace_back(n);
    ans.back()[0] = add_main;
    rep(i, n - 1) ans.back()[i + 1] = main_edges[i];
    cout << (int)ans.size() << '\n';
    for (const auto& v : ans) {
        cout << v[0] << ' ';
        rep(i, n - 1) cout << v[i + 1] + 1 << ' ';
        cout << '\n';
    }
    return 0;
}
