#include <bits/stdc++.h>
#define rep(i, n) for (int i = 0; i < (n); ++i)
typedef long long ll;
using namespace std;
typedef pair<int, int> pii;

bool mat[500][500];
bool used[500];
int n;
void dfs(int v) {
    used[v] = true;
    for (int u = 0; u < n; u++) {
        if (used[u]) continue;
        if (mat[v][u]) {
            dfs(u);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int k;
    cin >> n >> k;
    vector<pii> edges;
    if (k == 1) {
        if (n == 1) {

        } else if (n == 2) {
            edges.emplace_back(0, 1);
        } else {
            for (int i = 0; i < n; i++) {
                edges.emplace_back(i, (i + 1) % n);
            }
        }
    } else if (k == 2) {
        if (n <= 2) {
            cout << "NO" << endl;
            return 0;
        }
        for (int i = 0; i < n - 1; i++) {
            edges.emplace_back(i, i + 1);
        }
    } else {
        if (k >= n) {
            cout << "NO" << endl;
            return 0;
        }
        vector<int> deg;
        int par = 0;
        for (int i = 1; i <= k; i++) {
            deg.push_back(i);
            if (i % 2 != 0) {
                par++;
            }
        }
        vector<int> cur = deg;
        par = (par % 2);
        int D = -1;
        for (int d = 1; d <= k && D == -1; d++) {
            if ((d & 1) == (par & 1)) {
                deg = cur;
                deg.push_back(d);
                while (deg.size() < n) {
                    deg.push_back(2);
                }
                sort(deg.begin(), deg.end());

//                for (int i = 0; i < deg.size(); i++) {
//                    cout << deg[i] << " ";
//                }
//                cout << endl;
                bool fail = false;
                for (int i = n - 1; i >= 0; i--) {
                    {
                        for (int j = i - 1; j >= 0; j--) {
                            if (deg[j] > 0 && deg[i] > 0) {
//                                edges.emplace_back(i, j);
                                deg[j]--;
                                deg[i]--;
                            }
                        }
                    }
                    if (deg[i] != 0) {
                        fail = true;
                        break;
                    }
                    if (fail) break;
                }
                if (!fail) {
                    D = d;
                    break;
                }
            }
        }
        assert(D != -1);
        deg = cur;
        deg.push_back(D);
        while (deg.size() < n) {
            deg.push_back(2);
        }
        sort(deg.begin(), deg.end());

//                for (int i = 0; i < deg.size(); i++) {
//                    cout << deg[i] << " ";
//                }
//                cout << endl;
//        bool fail = false;
        for (int i = n - 1; i >= 0; i--) {
            {
                for (int j = i - 1; j >= 0; j--) {
                    if (deg[j] > 0 && deg[i] > 0) {
                        edges.emplace_back(i, j);
                        deg[j]--;
                        deg[i]--;
                    }
                }
            }
            assert(deg[i] == 0);
        }
    }
    for (pii e : edges) {
        mat[e.first][e.second] = mat[e.second][e.first] = true;
    }
    dfs(0);
    bool inv = false;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            inv = true;
            break;
        }
    }
    vector<pii> rez;
    if (inv) {
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (!mat[i][j]) {
                    rez.emplace_back(i, j);
                }
            }
        }
    } else {
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (mat[i][j]) {
                    rez.emplace_back(i, j);
                }
            }
        }
    }
    cout << "YES" << endl;
    cout << rez.size() << endl;
    for (pii e : rez) {
        cout << e.first + 1 << " " << e.second + 1 << "\n";
    }
    return 0;
}
