#include <bits/stdc++.h>
using namespace std;
#define pb push_back
//#define x first
//#define y second

vector<int> dx = {0, 1, 0, -1};
vector<int> dy = {1, 0, -1, 0};

vector<int> inLeft;
vector<vector<int>> gr;
vector<bool> used, used1;

bool dfs(int v) {
    if (used[v]) return false;
    used[v] = true;
    for (int u : gr[v]) {
        if (inLeft[u] == -1 || dfs(inLeft[u])) {
            inLeft[u] = v;
            return true;
        }
    }
    return false;
}

void dfs2(int v) {
    if (used[v]) return;
    used[v] = true;
    for (int u : gr[v]) {
        used1[u] = true;
        if (inLeft[u] == -1) continue;
        dfs2(inLeft[u]);
    }
}

int main() {
    //freopen("../input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> field(n, vector<int>(m, 0));
    int bl = 0, wh = 0;
    map<pair<int, int>, int> renum;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c;
            cin >> c;
            if (c == '.') {
                field[i][j] = 1;
                if ((i + j) % 2) {
                    renum[{i, j}] = bl++;
                } else {
                    renum[{i, j}] = wh++;
                }
            }
        }
    }
    assert(bl == wh);
    if (bl > 1000) {
        cout << "1000000\n";
        return 0;
    }
    int res = bl * (bl - 1);
    gr.assign(wh, {});
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if ((i + j) % 2 || !field[i][j]) continue;
            for (int d = 0; d < 4; ++d) {
                int x = i + dx[d], y = j + dy[d];
                if (x < 0 || x >= n || y < 0 || y >= m || !field[x][y]) continue;
                gr[renum[{i, j}]].pb(renum[{x, y}]);
                //cout << i << " " << j << " " << x << " " << y << " " << renum[{i, j}] << " " << renum[{x, y}] << endl;
            }
        }
    }
    inLeft.assign(wh, -1);
    for (int i = 0; i < wh; ++i) {
        used.assign(wh, false);
        assert(dfs(i));
    }
    for (int i = 0; i < wh; ++i) {
        used.assign(wh, false);
        used1.assign(wh, false);
        dfs2(i);
        for (int k = 0; k < wh; ++k) {
            res += !used1[k];
        }
    }

    cout << min(res, 1000000) << "\n";
}
