#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define int long long
//#define x first
//#define y second

const int N = 1000000;

#ifdef LOCAL
    int RX, RY;
    int prvx = -1;
    int prvy = -1;
#endif
int qr_cnt = 0;
int dst(int a, int b, int c, int d) {
    return (a - c) * (a - c) + (b - d) * (b - d);
}

string ask(int x, int y) {
    qr_cnt++;
    assert(qr_cnt <= 64);
    assert(x >= 0 && x <= N);
    assert(y >= 0 && y <= N);
#ifdef LOCAL
    cout << x << ' ' << y << endl;
    string res;
    if (x == RX && y == RY) {
        cout << "GJ!" << endl;
        exit(0);
    }
    if (prvx == -1) {
        res = "NF";
    } else {
        int prv_dst = dst(prvx, prvy, RX, RY);
        int cur_dst = dst(x, y, RX, RY);
        if (prv_dst < cur_dst) {
            res = "Fur";
        } else if (prv_dst > cur_dst) {
            res = "Close";
        } else {
            res = "Same dst";
        }
    }
    cout << res << endl;
    prvx = x;
    prvy = y;
    return res;
#else
    cout << x << ' ' << y << endl;
    string res;
    getline(cin, res, '\n');
    if (res.back() == '!') {
        exit(0);
    }
    return res;
#endif
}

void solve() {
#ifdef LOCAL
    cin >> RX >> RY;
#endif

    ask(0, 0);
    string same_dist = ask(0, 0);
    string kek = ask(1, 1);
    if (kek == same_dist) {
        ask(1, 0);
        ask(0, 1);
        assert(0);
    }
    string closer = kek;

    int lx = 0;
    int ly = 0;
    int rx = N + 1;
    int ry = N + 1;
    while (rx - lx > 0 && ry - ly > 0) {
        if ((rx - lx) % 2 == 0)
            rx++;
        if ((ry - ly) % 2 == 0)
            ry++;
        int cx = (lx+rx)/2;
        int cy = (ly+ry)/2;
        ask(cx, cy);
        string r1 = ask(cx, cy + 1);
        string r2 = ask(cx + 1, cy + 1);
        if (r1 == closer) {
            ly = cy;
        } else {
            ry = cy;
        }
        if (r2 == closer) {
            lx = cx;
        } else {
            rx = cx;
        }
    }
    ask(lx, ly);
    assert(0);
}

signed main() {
    //freopen("../input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
