#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define x first
#define y second

set<pair<int, int> > s;
const int N = 1e3 + 1;
void No() {
    cout << "NO\n";
    exit(0);
}
int cnt[N];
void add(int a, int b) {
    if (a == b || s.find({a, b}) != s.end()) {
        exit(1);
    }
    s.insert({a, b});
    ++cnt[a];
    ++cnt[b];
}
int st[N];
bool use[N];
vector<int> e[N];

int dfs(int u) {
    if (use[u]) {
        return 0;
    }
    use[u] = 1;
    int ans = 1;
    for (auto v : e[u]) {
        ans += dfs(v);
    }
    return ans;
}

void check(int n) {
    for (auto [a, b] : s) {
        e[a].push_back(b);
        e[b].push_back(a);
    }
    int x = dfs(0);
    if (x != n) {
        cout << x << endl;
        exit(3);
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    if (k == n) {
        if (n > 1) {
            No();
        }
    } else if (k == 1) {
        if (n == 2) {
            add(0, 1);
        } else {
            for (int i = 0; i < n; ++i) {
                add(i, (i + 1) % n);
            }
        }
    } else if (k == n - 1) {
        for (int i = 0; i < n / 2; ++i) {
            for (int j = i + 1; j < n - i; ++j)
                add(i, j);
        }

    } else {
        int sum = 0;
        for (int i = 0; i < n; ++i)
            if (i < k) {
                st[i] = n - i - 1;
                sum += st[i];
            } else {
                st[i] = max(n - k, (k + 1) / 2);
                sum += st[i];
            }
        if (sum % 2 == 1) {
            ++st[n - 1];
        }
        set<pair<int, int> > ss;
        for (int i = 0; i < n; ++i)
            if (st[i] > 0) {
                ss.insert({st[i], i});
            }
        while (ss.size() > 0) {
            if (ss.size() == 1) {
                exit(1);
            }
            auto mx1 = ss.end();
            --mx1;
            auto [st1, i1] = *mx1;
            ss.erase(mx1);
            vector<int> v;
            for (int l = 0; st[i1] > 0; ++l) {
                auto mx2 = ss.end();
                --mx2;
                auto [st2, i2] = *mx2;
                ss.erase(mx2);
                add(i1, i2);
                --st[i1];
                --st[i2];
                v.push_back(i2);
            }
            for (auto i2 : v)
                if (st[i2] != 0) {
                    ss.insert({st[i2], i2});
                }
        }
    }
    set<int> f;
    for (int i = 0; i < n; ++i) {
        f.insert(cnt[i]);
    }
    if (f.size() != k) {
        exit(2);
    }
    check(n);
    cout << "YES\n";
    cout << s.size() << "\n";
    for (auto [a, b] : s) {
        cout << a + 1 << ' ' << b + 1 << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
