#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> A(n);
    for (int i = 0; i < n; ++i) {
        cin >> A[i];
        --A[i];
    }
    if (n == 1) {
        cout << "Impossible\n";
        return;
    }
    if (n == 2) {
        if (A[0] == 0) {
            cout << "Possible\n";
            cout << "2 1\n2 1\n";
        } else {
            cout << "Impossible\n";
        }
        return;
    }
    vector<int> anti(n);
    for (int i = 0; i < n; ++i)
        anti[A[i]] = i;
    vector<int> cycles;
    int mx_len = 0;
    vector<bool> used(n, false);
    for (int i = 0; i < n; ++i) {
        if (used[i])
            continue;
        int cur = i;
        int len = 0;
        while (!used[cur]) {
            used[cur] = true;
            cycles.emplace_back(cur);
            ++len;
            cur = anti[cur];
        }
        mx_len = max(mx_len, len);
    }
    if (n == 3 && mx_len == 2) {
        cout << "Impossible\n";
        return;
    }
    cout << "Possible\n";
    int shift = 2;
    if (mx_len == n - 1)
        shift = 3;
    vector<int> p(n);
    vector<int> q(n);
    for (int i = 0; i < n; ++i) {
        q[cycles[i]] = cycles[(i + shift) % n];
        p[cycles[(i + shift) % n]] = anti[cycles[i]];
    }
    cout << '\n';
    for (int x : p)
        cout << x + 1 << ' ';
    cout << '\n';
    for (int x : q)
        cout << x + 1 << ' ';
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
