#include <bits/stdc++.h>

using namespace std;

int A[100][1000];
int id[100][1000];
int tmp1[100];
int tmp2[100];

bool prep_same(int j, int l1, int r1) {
    copy(A[j] + l1, A[j] + r1, tmp1);
    sort(tmp1, tmp1 + r1 - l1);
}

bool are_same(int k, int l2, int r2) {
    copy(A[k] + l2, A[k] + r2, tmp2);
    sort(tmp2, tmp2 + r2 - l2);
    for (int i = 0; i < r2 - l2; ++i) {
        if (tmp1[i] != tmp2[i])
            return false;
    }
    return true;
}

int ans[1000];

int solve(vector<pair<int, int>> &segms) {
    if (segms[0].first + 1 == segms[0].second)
        return A[0][segms[0].first];
    vector<int> candidates;
    for (int i = segms[0].first; i < segms[0].second; ++i) {
        int j = A[0][i];
        int len = i - segms[0].first;
        len = min(len, segms[0].second - segms[0].first - 1 - len);
        bool pos = true;
        for (int l = 0; l < segms.size(); ++l) {
            int len1 = id[l][j] - segms[l].first;
            len1 = min(len1, segms[l].second - segms[l].first - 1 - len1);
            if (len1 != len)
                pos = false;
        }
        if (pos && len) {
            candidates.emplace_back(j);
        }
    }
    int root = candidates[0];
    if (candidates.size() > 1) {
        random_shuffle(candidates.begin(), candidates.end());
        for (int var : candidates) {
            bool ok = true;
            int other_one = A[0][segms[0].first] == var ? A[0][segms[0].first + 1] : A[0][segms[0].first];
            pair<int, int> segm1 = id[0][other_one] > id[0][var] ? make_pair(id[0][var] + 1, segms[0].second) : make_pair(segms[0].first,id[0][var]);
            prep_same(0, segm1.first, segm1.second);
            for (int j = 1; j < segms.size(); ++j) {
                pair<int, int> cur_segm = id[j][other_one] > id[j][var] ? make_pair(id[j][var] + 1, segms[j].second) : make_pair(segms[j].first, id[j][var]);
                ok = ok && are_same(j, cur_segm.first, cur_segm.second);
            }
            if (ok) {
                root = var;
                break;
            }
        }
    }
    int other_one = A[0][segms[0].first] == root ? A[0][segms[0].first + 1] : A[0][segms[0].first];
    vector<pair<int, int>> tmp(segms.size());
    for (int i = 0; i < segms.size(); ++i) {
        tmp[i] = make_pair(id[i][root] + 1, segms[i].second);
        segms[i].second = id[i][root];
        if (id[i][other_one] > id[i][root])
            swap(tmp[i], segms[i]);
    }
    ans[solve(segms)] = root;
    for (int i = 0; i < segms.size(); ++i) {
        swap(segms[i], tmp[i]);
    }
    ans[solve(segms)] = root;
    return root;
}

int main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int n, k;
    cin >> n >> k;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> A[i][j];
            --A[i][j];
            id[i][A[i][j]] = j;
        }
    }
    vector<pair<int, int>> segms(k);
    for (int i = 0; i < k; ++i)
        segms[i] = make_pair(0, n);
    ans[solve(segms)] = -2;
    for (int i = 0; i < n; ++i)
        cout << ans[i] + 1 << ' ';
    cout << '\n';
    return 0;
}
