#include <bits/stdc++.h>

using namespace std;

int A[100][1000];
int id[100][1000];
int tmp1[1000];
int tmp2[1000];

void prep_same(int j, int l1, int r1) {
    for (int i = l1; i < r1; ++i)
        tmp1[i - l1] = A[j][i];
    sort(tmp1, tmp1 + r1 - l1);
}

bool are_same(int k, int l2, int r2) {
    for (int i = l2; i < r2; ++i)
        tmp2[i - l2] = A[k][i];
    sort(tmp2, tmp2 + r2 - l2);
    for (int i = 0; i < r2 - l2; ++i) {
        if (tmp1[i] != tmp2[i])
            return false;
    }
    return true;
}

int ans[1000];
vector<pair<int, int>> segms[1001];

int solve(int kek) {
    int length = segms[kek][0].second - segms[kek][0].first;
    if (length == 1)
        return A[0][segms[kek][0].first];
    vector<int> candidates;
    for (int i = segms[kek][0].first; i < segms[kek][0].second; ++i) {
        int j = A[0][i];
        int len = i - segms[kek][0].first;
        len = min(len, length - 1 - len);
        bool pos = true;
        for (int l = 1; l < segms[kek].size(); ++l) {
            int len1 = id[l][j] - segms[kek][l].first;
            len1 = min(len1, length - 1 - len1);
            if (len1 != len)
                pos = false;
        }
        if (pos && len)
            candidates.emplace_back(j);
    }
    int root = candidates[0];
    if (candidates.size() > 1) {
        for (int var : candidates) {
            bool ok = true;
            int other_one = A[0][segms[kek][0].first] == var ? A[0][segms[kek][0].first + 1] : A[0][segms[kek][0].first];
            pair<int, int> segm1 = id[0][other_one] > id[0][var] ? make_pair(id[0][var] + 1, segms[kek][0].second) : make_pair(segms[kek][0].first,id[0][var]);
            prep_same(0, segm1.first, segm1.second);
            for (int j = 1; j < segms[kek].size(); ++j) {
                pair<int, int> cur_segm = id[j][other_one] > id[j][var] ? make_pair(id[j][var] + 1, segms[kek][j].second) : make_pair(segms[kek][j].first, id[j][var]);
                ok = ok && cur_segm.second - cur_segm.first == segm1.second - segm1.first && are_same(j, cur_segm.first, cur_segm.second);
            }
            if (ok) {
                root = var;
                break;
            }
        }
    }
    int other_one = A[0][segms[kek][0].first] == root ? A[0][segms[kek][0].first + 1] : A[0][segms[kek][0].first];
    vector<pair<int, int>> tmp(segms[kek].size());
    segms[kek + 1].resize(segms[kek].size());
    for (int i = 0; i < segms[kek].size(); ++i) {
        segms[kek + 1][i] = make_pair(segms[kek][i].first, id[i][root]);
        segms[kek][i].first = id[i][root] + 1;
        if (id[i][other_one] > id[i][root])
            swap(segms[kek + 1][i], segms[kek][i]);
    }
    int lol = solve(kek + 1);
    ans[lol] = root;
    lol = solve(kek);
    ans[lol] = root;
    return root;
}

int main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int n, k;
    cin >> n >> k;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> A[i][j];
            --A[i][j];
            id[i][A[i][j]] = j;
        }
    }
    segms[0].resize(k);
    for (int i = 0; i < k; ++i)
        segms[0][i] = make_pair(0, n);
    ans[solve(0)] = -2;
    for (int i = 0; i < n; ++i)
        cout << ans[i] + 1 << ' ';
    cout << '\n';
    return 0;
}