#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 1000 + 10;
const int K = 100 + 10;
int par[N];
int a[K][N];

bool check(int l, int r, int k, int x) {
    set<int> lef, rig;
    for (int j = l, flag = 0; j <= r; j++) {
        if (a[1][j] == x) {
            flag = 1;
        }
        else if (flag == 0) {
            lef.insert(a[1][j]);
        }
        else {
            rig.insert(a[1][j]);
        }
    }
    if (lef.empty() || rig.empty()) {
        return false;
    }
    if (*lef.begin() > *rig.begin()) {
        swap(lef, rig);
    }
    for (int i = 1; i <= k; i++) {
        set<int> clef, crig;
        for (int j = l, flag = 0; j <= r; j++) {
            if (a[i][j] == x) {
                flag = 1;
            }
            else if (flag == 0) {
                clef.insert(a[i][j]);
            }
            else {
                crig.insert(a[i][j]);
            }
        }
        if (clef.empty() || crig.empty()) {
            return false;
        }
        if (*clef.begin() > *crig.begin()) {
            swap(clef, crig);
        }
        if (lef != clef || rig != crig) {
            return false;
        }
    }
    return true;
}

void solve(int l, int r, int k, int p) {
    if (l == r) {
        par[a[1][l]] = p;
        return;
    }
    int root = 0;
    for (int j = l; j <= r; j++) {
        if (check(l, r, k, a[1][j])) {
            assert(root == 0);
            root = a[1][j];
        }
    }
    int pos = 0;
    for (int i = 1; i <= k; i++) {
        set<int> clef, crig;
        for (int j = l, flag = 0; j <= r; j++) {
            if (a[i][j] == root) {
                flag = 1;
            }
            else if (flag == 0) {
                clef.insert(a[i][j]);
            }
            else {
                crig.insert(a[i][j]);
            }
        }
        assert(!clef.empty() && !crig.empty());
        if (*clef.begin() > *crig.begin()) {
            swap(clef, crig);
            reverse(a[i] + l, a[i] + r + 1);
        }
        pos = l + clef.size();
    }
    par[a[1][pos]] = p;
    solve(l, pos - 1, k, a[1][pos]);
    solve(pos + 1, r, k, a[1][pos]);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    int n, k;
    cin >> n >> k;
    for (int i = 1; i <= k; i++) {
        for (int j = 1; j <= n; j++) {
            cin >> a[i][j];
        }
    }

    solve(1, n, k, -1);

    for (int i = 1; i <= n; i++) {
        cout << par[i] << " ";
    }
    cout << "\n";
}
