#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    int n, k;
    cin >> n >> k;
    if (n == 1) {
        cout << "YES\n";
        cout << "0\n";
    }
    else if (k == 1) {
        cout << "YES\n";
        cout << n << "\n";
        for (int i = 1; i <= n; i++) {
            cout << i << " " << (i == n ? 1 : i + 1) << "\n";
        }
    }
    else if (k <= n - 1) {
        cout << "YES\n";
        vector<pair<int, int>> ans;
        for (int i = 1; i <= k; i++) {
            ans.emplace_back(i, k + 1);
        }
        int x = k / 2 + 1;
        for (int i = x; i <= k; i++) {
            for (int j = i + 1; j <= k; j++) {
                ans.emplace_back(i, j);
            }
        }
        for (int i = 1; i <= k / 2; i++) {
            for (int j = 1; j <= i - 1; j++) {
                ans.emplace_back(i, x + j - 1);
            }
        }
        for (int i = k + 2; i <= n; i++) {
            ans.emplace_back(i == k + 2 ? 1 : i - 1, i);
        }
        cout << ans.size() << "\n";
        for (auto [u, v] : ans) {
            cout << u << " " << v << "\n";
        }
        vector<int> deg(n + 1, 0);
        for (auto [u, v] : ans) {
            deg[u]++;
            deg[v]++;
        }
        set<int> s;
        for (int i = 1; i <= n; i++) {
            s.insert(deg[i]);
        }
        assert(s.size() == k);
    }
    else {
        cout << "NO\n";
    }
}
