#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define vin(a) for (auto& i : a) cin >> i
#define all(a) (a).begin(), (a).end()
#define pbc push_back
#define mp make_pair

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline void chkmin(T1& x, const T2& y) {
    if (y < x) x = y;
}

template<typename T1, typename T2>
inline void chkmax(T1& x, const T2& y) {
    if (x < y) x = y;
}

void solve() {
    int n;
    cin >> n;
    vector<int> arr(n), rarr(n);

    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        --arr[i];
        rarr[arr[i]] = i;
    }
    if (n == 1) {
        cout << "Impossible\n";
        return;
    }
    if (n == 2) {
        if (arr[0] == 0) {
            cout << "Possible\n";
            cout << "2 1\n2 1\n";
            return;
        } else {
            cout << "Impossible\n";
            return;
        }
    }
    vector<int> used(n);
    vector<vector<int>> cycles;
    vector<int> cycle;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            vector<int> a;
            int cur = i;
            while (!used[cur]) {
                a.push_back(cur);
                used[cur] = 1;
                cur = arr[cur];
            }
            // reverse(all(a));
            cycles.push_back(a);
        }
    }
    sort(all(cycles), [&](const auto &a, const auto &b) {
        return a.size() > b.size();
    });
    for (auto &c : cycles) {
        if (c.size() != 2 || cycle.empty()) {
            for (int el : c) {
                cycle.push_back(el);
            }
        } else {
            int x = cycle.back();
            cycle.pop_back();
            cycle.push_back(c[0]);
            cycle.push_back(x);
            cycle.push_back(c[1]);
        }
    }
    vector<int> q(n);
    for (int i = 0; i < n; ++i) {
        int j = i + 1;
        if (j == n) {
            j = 0;
        }
        q[cycle[i]] = cycle[j];
    }
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        p[q[i]] = rarr[i];
    }
    cout << "Possible\n";
    for (int el : p) {
        cout << el + 1 << " ";
    }
    cout << '\n';
    for (int el : q) {
        cout << el + 1 << " ";
    }
    cout << '\n';
#ifdef LOCAL
    cout.flush();
#endif
    for (int i = 0; i < n; ++i) {
        assert(p[i] != i);
        assert(q[i] != i);
        assert(arr[p[q[i]]] == i);
    }
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    cout.precision(20), cout.setf(ios::fixed);
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}