#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define vin(a) for (auto& i : a) cin >> i
#define all(a) (a).begin(), (a).end()
#define pbc push_back
#define mp make_pair

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline void chkmin(T1& x, const T2& y) {
    if (y < x) x = y;
}

template<typename T1, typename T2>
inline void chkmax(T1& x, const T2& y) {
    if (x < y) x = y;
}

const int N = 1e3 + 10;
const int K = 110;

int n, k;
int a[K][N];
int pa[K][N];
ull pref[K][N];
ull coord[N];

ull getPref(int id, int l, int r) {
    return pref[id][r] ^ (l > 0 ? pref[id][l - 1] : 0);
}

void build() {
    for (int i = 0; i < N; ++i) coord[i] = rnd();
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < n; ++j) {
            pref[i][j] = coord[a[i][j]];
            if (j > 0) pref[i][j] ^= pref[i][j - 1];
        }
    }
}

int par[N];

bool isIn(int l, int r, int x) {
    return l <= x && x <= r;
}

void dfs(const vector<pair<int, int>>& has, int v = -1) {
    if (has[0].second == has[0].first) {
        par[a[0][has[0].first]] = v;
        return;
    }
    int root = -1;
    for (int cur_v = 0; cur_v < n; ++cur_v) {
        if (!isIn(has[0].first, has[0].second, pa[0][cur_v])) continue;
        // cerr << "cur_v = " << cur_v << endl;
        int min_val = n + 1;
        pair<ull, ull> hash;
        for (int i = 0; i < k; ++i) {
            int pos = pa[i][cur_v];
            // cerr << "i = " << i << endl;
            assert(isIn(has[i].first, has[i].second, pos));
            int cur_min_val = n + 1;
            chkmin(cur_min_val, pos - has[i].first);
            chkmin(cur_min_val, has[i].second - pos);
            pair<ull, ull> cur_hash(getPref(i, has[i].first, pos - 1), getPref(i, pos + 1, has[i].second));
            if (cur_hash.first > cur_hash.second) swap(cur_hash.first, cur_hash.second);
            // cerr << "cur_v = " << cur_v << " cur_min_val = " << cur_min_val << " min_val = " << min_val << endl;
            if (i == 0) {
                min_val = cur_min_val;
                hash = cur_hash;
            } else if (min_val != cur_min_val || hash != cur_hash) {
                min_val = 0;
                break;
            }
        }
        // cerr << "cur_v = " << cur_v << " root = " << root << " min_val = " << min_val << endl;
        if (min_val) {
            // assert(root == -1);
            root = cur_v;
        }
    }
    assert(root != -1);
    par[root] = v;
    // cerr << "root = " << root << endl;
    vector<pair<int, int>> left, right;

    for (int i = 0; i < k; ++i) {
        int pos = pa[i][root];
        int valL = a[0][has[0].first];
        // cerr << valL << " ";
        // cerr << pa[i][valL] << "\n";
        if (pa[i][valL] < pos) {
            // cerr << 0;
            left.push_back({has[i].first, pos - 1});
            right.push_back({pos + 1, has[i].second});
        } else {
            // cerr << 1;
            right.push_back({has[i].first, pos - 1});
            left.push_back({pos + 1, has[i].second});
        }
    }
    // cerr << endl;

    dfs(left, root + 1);
    dfs(right, root + 1);
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    cout.precision(20), cout.setf(ios::fixed);
    cin >> n >> k;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
            --a[i][j];
            pa[i][a[i][j]] = j;
        }
    }
    build();
    vector<pair<int, int>> has(k, mp(0, n - 1));
    dfs(has);
    for (int i = 0; i < n; ++i) {
        cout << par[i] << ' ';
    }
    cout << endl;
    return 0;
}