#include <bits/stdc++.h>
#define int long long
using ld = long double;
#define all(x) (x).begin(), (x).end()
#define pii pair<int, int>
#define pb push_back
#define ff first
#define ss second
using ull = unsigned long long;

using namespace std;

mt19937_64 rnd(228);

int const N = 1002, X = 1000000;
char mp[N][N];
int id[N][N];
int mt[N];
bool wasr[N];
vector<int> gr[N];

int C_n_2(int x) {
	return x * (x - 1) / 2;
}

bool try_kuhn(int v) {
	for (int to : gr[v]) {
		if (wasr[to]) {
			continue;		
		}	
		wasr[to] = true;
		if (mt[to] == -1 || try_kuhn(mt[to])) {
			mt[to] = v;
			return true;
		}
	}
	return false;
}

int dfs(int v) {
	int ans = 0;
	for (int to : gr[v]) {
		if (wasr[to]) {
			continue;
		}
		wasr[to] = true;
		++ans;
		ans += dfs(mt[to]);
	}
	return ans;
}

int solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> mp[i][j];
        }
    }
    int cnt[2] = {};
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
       		if (mp[i][j] == '#') {
       			continue;
       		}
       		int c = (i + j) & 1;
       		id[i][j] = cnt[c];
       		int cid = id[i][j];
       		++cnt[c];
       		if (cnt[c] >= 1001) {
       		 	return X;
       		}       		
       		if (i > 0 && mp[i - 1][j] == '.') {
       			int pid = id[i - 1][j];
       			//cerr << cid << ' ' << pid << '\n';
       			gr[c ? pid : cid].push_back(c ? cid : pid); 
       		}
       		if (j > 0 && mp[i][j - 1] == '.') {
       			int pid = id[i][j - 1];
       			//cerr << cid << ' ' << pid << '\n';
       			gr[c ? pid : cid].push_back(c ? cid : pid);
       		}
        }
    }
    //assert(cnt[0] == cnt[1]);
    int b = cnt[0];
    int hv = b * (b - 1);
    fill(mt, mt + b, -1);
    for (int i = 0; i < b; ++i) {
    	fill(wasr, wasr + b, false);
    	//assert(try_kuhn(i));
    	try_kuhn(i);
    }
    for (int banr = 0; banr < b; ++banr) {
   		fill(wasr, wasr + b, false);
   		wasr[banr] = true;
   		int good = dfs(mt[banr]);
   		int bad = b - 1 - good;
   		hv += bad;
   		if (hv >= X) {
   			break;
   		}
    }
    return min(hv, X);
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    //freopen("../out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    cout << solve() << '\n';
    return 0;
}
