//
// Created by nef on 07.12.2022.
//
//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef int ll;

const ll SZ = 1010;
ll n, m;
array<array<char, SZ>, SZ> grid;
vector<vector<ll>> gr;
array<ll, SZ*SZ> good, mt, mt2, used;
int col = 1;
ll khun(ll v) {
    if (used[v] == col) return 0;
    used[v] = col;

    for (auto to : gr[v]) {
        if (mt[to] == -1 || khun(mt[to]) == 1) {
            mt2[v] = to;
            mt[to] = v;

            return 1;
        }
    }

    return 0;
}

ll ind(pair<ll, ll> pr) {
    return (pr.first * m) + pr.second;
}

vector<pair<ll, ll>> dir = {{0, 1}, {1, 0}, {-1, 0}, {0, -1}};
set<ll> usd;

ll find_dfs(int v) {
    if (used[v] == col) return 0;

    used[v] = col;

    for (auto to : gr[v]) {
        usd.insert(to);
        find_dfs(mt[to]);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;

    pair<ll, ll> wb = {0, 0};
    ll calc = 0;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            grid[i][j] = s[j];
            if (grid[i][j] == '.') {
                calc++;
                if ((i + j) % 2) {
                    wb.first++;
                } else {
                    wb.second++;
                }
            }
        }
    }

    if (calc >= 2010) {
        cout << "1000000";
        return 0;
    }

    if (abs(wb.first - wb.second) >= 3) {
        cout << calc * (calc - 1) / 2 << "\n";
        return 0;
    }

    if(abs(wb.first - wb.second) == 1) {
        cout << calc * (calc - 1) / 2 << "\n";
        return 0;
    }

    gr.resize(n * m);

    if (abs(wb.first - wb.second) == 0) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                mt2[ind({i, j})] = -1;
                mt[ind({i, j})] = -1;
                if (grid[i][j] == '.') {

                    good[ind({i, j})] = 1;
                    for (auto c : dir) {
                        pair<ll, ll> tor = {i + c.first, j + c.second};

                        if (tor.first >= 0 && tor.second >= 0 && tor.first < n && tor.second < m) {
                            if (grid[tor.first][tor.second] == '.' && (tor.first + tor.second) % 2) {
                                gr[ind({i, j})].push_back(ind(tor));
                            }
                        }
                    }
                }
            }
        }

        ll ans = 0;
        for (int i = 0; i < n * m; i++) {
            if (good[i]) {
                col++;
                ans += khun(i);
            }
        }

        if (ans <= calc / 2 - 2) {
            cout << calc * (calc - 1) / 2 << "\n";
            return 0;
        }

        set<ll> unmatched;
        for (int i = 0; i < n * m; i++) {
            if (good[i] && mt[i] == -1 && mt2[i] == -1) {
                unmatched.insert(i);
            }
        }

        if (ans == calc / 2) {
            ll ttr = 0;

            for (int i = 0; i < n * m; i++) {
                if (good[i]) {
                    usd.clear();
                    col++;
                    find_dfs(i);
                    ttr += (usd.size());
                }
            }

            cout << calc * (calc - 1) / 2 - ttr << "\n";
        } else {
            ll ttr = 0;

            ll v = (*unmatched.begin());

            usd.clear();
            find_dfs(v);

            ttr += usd.size();

            cout << calc * (calc - 1) / 2 - ttr << "\n";
        }
    } else {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (grid[i][j] == '.') {
                    good[ind({i, j})] = 1;
                    for (auto c : dir) {
                        pair<ll, ll> tor = {i + c.first, j + c.second};

                        if (tor.first >= 0 && tor.second >= 0 && tor.first < n && tor.second < m) {
                            if ((wb.first > wb.second && (i + j) % 2 == 1) || (wb.second > wb.first && (i + j) % 2 == 0)) {
                                gr[ind({i, j})].push_back(ind(tor));
                            }
                        }
                    }
                }
            }
        }

        set<ll> unmatched;
        ll ans = 0;
        for (int i = 0; i < n * m; i++) {
            if (good[i]) {
                mt2[i] = -1;
                col++;
                ans += khun(i);
                if (mt2[i] == -1) unmatched.insert(i);
            }
        }

        if (ans <= calc / 2 - 2) {
            cout << calc * (calc - 1) / 2 << "\n";
            return 0;
        }

        for (int i = 0; i < n * m; i++) {
            if (good[i]) {
                find_dfs(i);
            }
        }

        ll a = usd.size();
        usd.clear();

        ll v = (*unmatched.begin());

        if (gr[v].size() != 0) {
            mt2[v] = gr[v][0];
            mt2[mt[gr[v][0]]] = -1;
            mt[gr[v][0]] = v;

            usd.clear();
            find_dfs(*unmatched.rbegin());

            a += usd.size();
        }

        cout << n * (n - 1) / 2 - a << "\n";
    }

    return 0;
}