#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define X first
#define Y second
#define pb push_back
#define sz(a) (int)a.size()

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}

const int N = 1e5;

int check[N];

int st[N];
multiset<int> ms;
int n, k;
bool opa = false;

void print_ans(vector<pair<int, int>>& ans) {
    set<pair<int, int>> s1;
    for (int i = 1; i <= n; ++i) {
        check[i] = 0;
    }
    for (auto t : ans) {
        int f = t.first;
        int s  = t.second;
        check[f]++;
        check[s]++;
        assert(f != s);
        if (s < f) {
            swap(f, s);
        }
        s1.insert(t);
    }
    set<int> lol;
    for (int i = 1; i <= n; ++i) {
        lol.insert(check[i]);
    }
    assert(lol.size() == k);
    assert(s1.size() == ans.size());

    cout << "YES\n";
    cout << ans.size() << '\n';
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i].first << ' ' << ans[i].second;
        if (i % 100 == 0) {
            cout << endl;
        } else {
            cout << '\n';
        }
    }
    cout << endl;
    opa = true;
}
vector<pair<int, int>> ans;

void print_no() {
    cout << "NO\n";
//    cout.flush();
    opa = true;
}
set<int> kek;
void add(int a) {
    if (ms.find(a) == ms.end()) {
        kek.insert(a);
    }
}
void ers(int a) {
    if (ms.find(a) == ms.end()) {
        kek.erase(a);
    }
}

void add_edge(int a, int b) {
//    cout << a << ' ' << b << '\n';
    ms.erase(ms.find(st[a]));
    ers(st[a]);
    ms.erase(ms.find(st[b]));
    ers(st[b]);
    ++st[a];
    ++st[b];
    add(st[a]);
    ms.insert(st[a]);
    add(st[b]);
    ms.insert(st[b]);
    ans.emplace_back(a, b);
    if (kek.size() == k && *ms.begin() > 0) {
        print_ans(ans);
    }
}

void solve() {
    cin >> n >> k;
//    freopen("output.txt", "w", stdout);

    if (k == 1) {
        for (int i = 1; i < n; ++i) {
            ans.emplace_back(i, i + 1);
        }
        ans.emplace_back(n, 1);
        print_ans(ans);
        return;
    }
    if (k == n) {
        print_no();
        return;
    }

    for (int i = 1; i <= n; ++i) {
        st[i] = 0;
        ms.insert(st[i]);
        kek.insert(0);
    }
    for (int i = 2; i <= n; ++i) {
        add_edge(1, i);
        if (opa)
            return;
    }

    int l = 2;
    int r = n;
    while (l < r) {
        for (int i = l + 1; i < r; ++i) {
            add_edge(l, i);
            if (opa)
                return;
        }
        ++l;
        --r;
    }
}