#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define LF '\n'
#define SP ' '
#define rep(i, a, b) for (int i = a; i < (b); i++)
#define all(x) begin(x), end(x)

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    vector<pair<int, int>> g;
    if (n == k) {
        cout << "NO";
        return 0;
    }
    if (k == 1) {
        if (n == 1) {
            cout << "YES\n0\n";
            return 0;
        } else if (n == 2) {
            cout << "YES\n1 2\n";
            return 0;
        }
        cout << "YES\n" << n << LF;
        for (int i = 0; i < n; i++) {
            cout << (i + 1) << SP << ((i + 1) % n + 1) << LF;
        }
        return 0;
    } else if (k == 2) {
        cout << "YES" << LF;
        cout << n - 1 << LF;
        for (int i = 1; i < n; i++) {
            cout << 1 << SP << i + 1 << LF;
        }
        return 0;
    } else if (k == 3) {
        cout << "YES" << LF;
        if (n == 4) {
            cout << 4 << LF;
            cout << "1 2\n1 3\n1 4\n2 3\n";
            return 0;
        }
        cout << (2*n - 3) << LF;
        for (int i = 1; i < n; i++) {
            cout << 1 << SP << i + 1 << LF;
        }
        for (int i = 2; i < n; i++) {
            cout << 2 << SP << i + 1 << LF;
        }
        return 0;
    }

    vector<int> cnt(n);

    // 0..k+1 - need k distinct
    vector<pair<int, int>> edges;
    for (int i = 0; i < k + 1; i += 2) {
        for (int j = i + 1; j < k + 1; j++) {
            edges.push_back({i + 1, j + 1});
            cnt[i]++;
            cnt[j]++;
        }
    }
    // k+1..n - just a loop
    for (int i = k + 1; i < n - 1; i++) {
        edges.push_back({i + 1, i + 2});
        cnt[i]++;
        cnt[i + 1]++;
    }
    if (k + 2 == n) {
        edges.push_back({1, k + 2});
        cnt[0]++;
        cnt[k + 1]++;
    } else if (k + 3 < n) {
        edges.push_back({k + 2, n});
        cnt[k + 1]++;
        cnt[n - 1]++;
        edges.push_back({1, k + 2});
        cnt[0]++;
        cnt[k + 1]++;
    }

    set<pair<int, int>> edges_check;
    for (auto [u, v]: edges) {
        if (u > v)
            swap(u, v);
        edges_check.insert({u, v});
    }
    assert(edges_check.size() == edges.size());

    cout << "YES" << LF;
    cout << edges.size() << LF;
    for (auto [u, v]: edges) {
        cout << u << SP << v << LF;
    }
//    cout << "dbg: ";
//    for (auto i: cnt)
//        cout << i << SP;
//    cout << LF;
//    cout << "dbg: " << set<int>(cnt.begin(), cnt.end()).size() << LF;
}