#include <bits/stdc++.h>

#define gsize(x) (int)((x).size())

using namespace std;

typedef long long ll;

const bool local = true;
const char nl = '\n';

mt19937 rng(time(0));

void solve() {
    int n;
    cin >> n;
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        b[a - 1] = i;
    }

    if (n == 1) {
        cout << "Impossible" << nl;
        return;
    }

    if (n == 2) {
        if (b[1] == 1) {
            cout << "Possible" << nl;
            cout << 2 << ' ' << 1 << nl;
            cout << 1 << ' ' << 2 << nl;
            return;
        } else {
            cout << "Impossible" << nl;
            return;
        }
    }

    vector<int> ans(n);
    for (int i = 0; i < n; i++) {
        ans[i] = i;
    }

    while (true) {
        bool gd = true;
        for (int i = 0; i < n; i++) {
            if (ans[i] == i || ans[i] == b[i]) {
                gd = false;
                break;
            }
        }
        if (!gd) {
            shuffle(ans.begin(), ans.end(), rng);
        }
        break;
    }

    cout << "Possible" << nl;
    vector<int> q(n);
    for (int i = 0; i < n; i++) {
        q[ans[i]] = b[i];
        cout << ans[i] + 1 << ' ';
    }
    cout << nl;
    for (int x: q) cout << x + 1 << ' ';
    cout << nl;
}

int main() {
   ios::sync_with_stdio(0); cin.tie(0);

   int t;
   cin >> t;
   while (t--) solve();
}
