#include <bits/stdc++.h>

#define gsize(x) (int)((x).size())

using namespace std;

typedef long long ll;

const bool local = false;

ll ttx = 0, tty = 0;
int ptx = -1, pty = -1;

string query(ll x, ll y) {
    cout << x << ' ' << y << endl;
    if (local) {
        if (x == ttx && y == tty) {
            cout << "Znaydeno!" << endl;
            return "Znaydeno!";
        }
        if (ptx == -1) {
            ptx = x; pty = y;
            cout << "Tabilmadi" << endl;
            return "Tabilmadi";
        }
        ll d1 = (ptx - ttx) * (ptx - ttx) + (pty - tty) * (pty - tty);
        ll d2 = (x - ttx) * (x - ttx) + (y - tty) * (y - tty);
        ptx = x;
        pty = y;
        if (d1 > d2) {
            cout << "Closer" << endl;
            return "Closer";
        } else if (d1 < d2) {
            cout << "Further" << endl;
            return "Further";
        } else {
            cout << "Sama distanco" << endl;
            return "Sama distanco";
        };
    } else {
        string s;
        getline(cin >> ws, s);
        return s;
    }
}

int main() {
    string s;
    s = query(0, 0);

    map<string, int> ts;
    {
        if (s.back() == '!') {
            return 0;
        }
        s = query(0, 0);
        ts[s] = 0;

        s = query(1, 0);
        if (s.back() == '!') {
            return 0;
        }

        string s2 = query(0, 0);
        string s3 = query(0, 1);
        if (s3.back() == '!') {
            return 0;
        }

        if (s == s3) {
            ts[s] = 1;
            ts[s2] = -1;

        } else {
            s3 = query(0, 0);
            s3 = query(1, 1);
            ts[s3] = 1;
            s3 = query(0, 0);
            ts[s3] = -1;
        }
    }
    s = query(0, 0);
    int tx = 0;
    {
        int px = 0;
        int lb = 0, ub = 1000000;
        while (lb <= ub) {
            int t = lb;
            if (px <= lb) {
                t = ub;
            }
           // cout << lb << ' ' << ub << ' ' << px << ' ' << t << endl;
            s = query(t, 0);
            if (s.back() == '!') {
                return 0;
            }
            if (ts[s] == 0) {
                tx = (px + t) / 2;
                break;
            } else if (ts[s] == 1) {
                if (t == lb) {
                    ub = (t + px - 1) / 2;
                    tx = ub;
                } else {
                    lb = (t + px + 1) / 2;
                    tx = lb;
                }
            } else {
                if (t == ub) {
                    ub = (t + px - 1) / 2;
                    tx = ub;
                } else {
                    lb = (t + px + 1) / 2;
                    tx = lb;
                }
            }
            px = t;
        }
    }
  //  cout << "HI" << endl;
    s = query(tx, 0);
    if (s.back() == '!') {
        return 0;
    }
    int ty = 0;
    {
        int py = 0;
        int lb = 0, ub = 1000000;
        while (lb <= ub) {
            int t = lb;
            if (py <= lb) {
                t = ub;
            }
            s = query(tx, t);
            if (s.back() == '!') {
                return 0;
            }
            if (ts[s] == 0) {
                ty = (py + t) / 2;
                break;
            } else if (ts[s] == 1) {
                if (t == lb) {
                    ub = (t + py - 1) / 2;
                    ty = ub;
                } else {
                    lb = (t + py + 1) / 2;
                    ty = lb;
                }
            } else {
                if (t == ub) {
                    ub = (t + py - 1) / 2;
                    ty = ub;
                } else {
                    lb = (t + py + 1) / 2;
                    ty = lb;
                }
            }
            py = t;
        }
    }


    for (int i = max(0, tx - 1); i <= min(1000000, tx + 1); i++) {
        for (int j = max(0, ty - 1); j <= min(1000000, ty + 1); j++) {
            s = query(i, j);
            if (s.back() == '!') {
                return 0;
            }
        }
    }

    return 0;
}
