#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

int good_rand() {
    cout << (rand() << 15) + rand();
}

const int SZ = 2e5;
int p[SZ], q[SZ], a[SZ];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
        p[i] = i;
    }

    vector<int> inv_a(n);
    for (int i = 0; i < n; ++i) {
        inv_a[a[i]] = i;
    }

    for (int c = 0; c < 1000; ++c) {
        random_shuffle(p, p + n);
        bool ok = true;
        for (int i = 0; i < n; ++i) {
            if (p[i] == i || p[i] == inv_a[i]) {
                ok = false;
                break;
            }
        }
        if (ok) {
            cout << "Possible\n";
            for (int i = 0; i < n; ++i) {
                q[a[p[i]]] = i;
            }
            for (int i = 0; i < n; ++i) {
                cout << p[i]  + 1 << " ";
            }
            cout << "\n";
            for (int i = 0; i < n; ++i) {
                cout << q[i] + 1 << " ";
            }
            cout << "\n";
            for (int i = 0; i < n; ++i) {
                if (p[i] == i || q[i] == i || a[p[q[i]]] != i) {
                    //cout << "bad\n";
                    exit(1);
                }
            }
            return;
        }

    }
    cout << "Impossible\n";
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int t;
    cin >> t;

    for (int itr = 0; itr < t; ++itr) {
        solve();
    }

    return 0;
}
