#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

vector<vector<int>> blocks;

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    vector<int> all;

    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        vector<int> cur;
        for (int itr = 0; itr < k; ++itr) {
            int val;
            cin >> val;
            cur.push_back(val);
            all.push_back(val);
        }
        blocks.push_back(cur);
    }

    sort(all.begin(), all.end());
    map<int, int> idx;
    for (int i = 0; i < all.size(); ++i) {
        idx[all[i]] = i;
        //cout << all[i] << " " << i << endl;
    }

    int cntblocks = blocks.size();
    int splits = 0;

    for (const vector<int> &block : blocks) {
        for (int i = 0; i < (int)block.size() - 1; ++i) {
            if (idx[block[i]] + 1 != idx[block[i + 1]]) {
                ++splits;
                ++cntblocks;
            }
        }
    }

    cout << splits << " " << cntblocks - 1 << endl;

    return 0;
}
