#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cassert>
#include <utility>

using namespace std;

const int SZ = 1000;

vector<int> g[SZ];
int sz[SZ];
int lft[SZ];
vector<pair<int, int>> edges;

void add_left(int v) {
    lft[v]--;
    edges.emplace_back(lft[v], v);
    ++sz[v];
    ++sz[lft[v]];
    //cout << v << " " << lft[v] << endl;
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int n, k;
    cin >> n >> k;
    if (k == 1 && n == 1) {
        cout << "YES" << endl;
        cout << 0 << endl;
        return 0;
    } else if (k == 1 && n == 2) {
        cout << "YES" << endl;
        cout << 1 << endl;
        cout << 1 << " " << 2 << endl;
        return 0;
    } else if (n == k) {
        cout << "NO" << endl;
        return 0;
    } else if (k == 1) {
        cout << "YES\n";
        cout << n << endl;
        for (int i = 1; i <= n - 1; ++i) {
            cout << i << " " << i + 1 << endl;
        }
        cout << 1 << " " << n << endl;
        return 0;
    }


    for (int i = 1; i <= n - 1; ++i) {
        edges.emplace_back(i, n);
        ++sz[i];
        ++sz[n];
        lft[i] = i;
    }

    int cur = 2;
    while (cur < k) {
        add_left(n - 1);
        int v = n - 2;
        while (true) {
            if (sz[v] >= sz[v + 1] - 1) {
                break;
            }
            add_left(v);
            --v;
        }
        ++cur;
    }
    cout << "YES" << endl;
    cout << edges.size() << endl;
    for (auto edge : edges) {
        cout << edge.first << " " << edge.second << endl;
    }

    return 0;
}
