#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    map<int, int> a, pq, p, q;
    for (int i = 1; i <= n; ++i) {
        int tmp;
        cin >> tmp;
        a[i] = tmp;
    }

    for (int i = 1; i <= n; ++i) {
        pq[a[i]] = i;
    }

    set<int> banned;
    for (auto &[ind, val]: pq) {
        if (val >= ind) banned.insert(val - ind);
        else banned.insert(n - (ind - val)); //??
    }

    int dist = -1;
    for (int i = 1; i < n; ++i) {
        if (banned.count(i) == 0) {
            dist = i;
            break;
        }
    }

    if (dist == -1) {
        cout << "Impossible" << endl;
        return;
    }


    int curval = dist + 1;
    for (int i = 1; i <= n; ++i) {
        q[i] = curval;
        curval++;
        if (curval > n) curval -= n;
    }

    int curpqind = 1;
    for (int i = dist + 1; i <= n; ++i) {
        p[i] = pq[curpqind];
        curpqind++;
    }
    for (int i = 1; i <= dist; ++i) {
        p[i] = pq[curpqind];
        curpqind++;
    }

    bool flag = true;
    for (int i = 1; i <= n; ++i) {
        if (!(1 <= p[i] && p[i] <= n)) flag = false;
        if (!(1 <= q[i] && q[i] <= n)) flag = false;
        if (p[i] == i) flag = false;
        if (q[i] == i) flag = false;
        if (a[p[q[i]]] != i) flag = false;
    }
    if (!flag) {
        cout << "Impossible" << endl;
        return;
    }

    cout << "Possible" << endl;
    for (int i = 1; i <= n; ++i) {
        cout << p[i] << ' ';
    }
    cout << endl;
    for (int i = 1; i <= n; ++i) {
        cout << q[i] << ' ';
    }
    cout << endl;

//    cout << "VALIDATION" << endl;
//    for (int i = 1; i <= n; ++i) {
//        cout << a[p[q[i]]] << ' ';
//    }
//    cout << endl << "----" << endl;
}

int main() {
    //freopen("input.txt", "r", stdin);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
