#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    map<int, int> a, pq;
    for (int i = 1; i <= n; ++i) {
        int tmp;
        cin >> tmp;
        a[i] = tmp;
    }
     for (int i = 1; i <= n; ++i) {
        pq[a[i]] = i;
    }
    if (n <= 7) {
        vector<int> as_q;
        for (int i = 0; i < n; ++i)
            as_q.push_back(i);
        do {
            bool ok = true;
            for (int i = 0; i < n; ++i)
                if (as_q[i] == i)
                    ok = false;
            if (!ok)
                continue;

            map<int, int> q;
            for (int i = 0; i < n; ++i)
                q[i + 1] = as_q[i] + 1;
            map<int, int> p;
            for (int i = 1; i <= n; ++i) {
                p[q[i]] = pq[i];
            }

            for (int i = 1; i <= n; ++i)
                if (p[i] == i)
                    ok = false;
            if (!ok)
                continue;

            cout << "Possible" << endl;
            for (int i = 1; i <= n; ++i) {
                cout << p[i] << ' ';
            }
            cout << endl;
            for (int i = 1; i <= n; ++i) {
                cout << q[i] << ' ';
            }
            cout << endl;
            return;
        } while (next_permutation(as_q.begin(), as_q.end()));
        cout << "Impossible\n";
        return;
    }
    map<int, int> p, q;


    set<int> banned;
    for (auto &[ind, val]: pq) {
        if (val >= ind) banned.insert(val - ind);
        else banned.insert(n - (ind - val)); //??
    }

    int dist = -1;
    for (int i = 1; i < n; ++i) {
        if (banned.count(i) == 0) {
            dist = i;
            break;
        }
    }

    if (dist == -1) {
        cout << "Impossible" << endl;
        return;
    }


    int curval = dist + 1;
    for (int i = 1; i <= n; ++i) {
        q[i] = curval;
        curval++;
        if (curval > n) curval -= n;
    }

    int curpqind = 1;
    for (int i = dist + 1; i <= n; ++i) {
        p[i] = pq[curpqind];
        curpqind++;
    }
    for (int i = 1; i <= dist; ++i) {
        p[i] = pq[curpqind];
        curpqind++;
    }

    bool flag = true;
    for (int i = 1; i <= n; ++i) {
        if (!(1 <= p[i] && p[i] <= n)) flag = false;
        if (!(1 <= q[i] && q[i] <= n)) flag = false;
        if (p[i] == i) flag = false;
        if (q[i] == i) flag = false;
        if (a[p[q[i]]] != i) flag = false;
    }
    if (!flag) {
        cout << "Impossible" << endl;
        return;
    }

    cout << "Possible" << endl;
    for (int i = 1; i <= n; ++i) {
        cout << p[i] << ' ';
    }
    cout << endl;
    for (int i = 1; i <= n; ++i) {
        cout << q[i] << ' ';
    }
    cout << endl;

//    cout << "VALIDATION" << endl;
//    for (int i = 1; i <= n; ++i) {
//        cout << a[p[q[i]]] << ' ';
//    }
//    cout << endl << "----" << endl;
}

int main() {
    //freopen("input.txt", "r", stdin);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
