#include <bits/stdc++.h>

using namespace std;

vector<int> ans;
vector<set<int>> cnt;

void cler(set<int> &id) {
    for (auto v : id)
        cnt[v].clear();
}

int find_root(vector<vector<int>>& v) {
    set<int> actual_v;
    for (auto x : v[0])
        actual_v.insert(x);
    for (auto& vect : v) {
        int timer = 0;
        for (auto el: vect) {
            cnt[el].insert(timer);
            ++timer;
        }
    }
    int find_1 = -1;
    for (auto x : actual_v)
        if (cnt[x].size() == 1)
            find_1 = x;
    if (find_1 != -1) {
        cler(actual_v);
        return find_1;
    }
    int find_2 = -1;
    for (auto x : actual_v)
        if (cnt[x].size() == 2)
            find_2 = x;
    if (find_2 != -1) {
        cler(actual_v);
        return find_2;
    }
    assert(false);
}

void solver(vector<vector<int>> v, int anc) {
    int nw = find_root(v);
    ans[nw] = anc;
    if (v[0].size() == 1)
        return;
    vector<vector<int>> one_part;
    vector<vector<int>> other_part;
    vector<int> as_left, as_right;
    {
        bool fl = false;
        for (auto x: v[0]) {
            if (x == nw) {
                fl = true;
            } else if (fl) {
                as_right.push_back(x);
            } else {
                as_left.push_back(x);
            }
        }
    }
    sort(as_left.begin(), as_left.end());
    sort(as_right.begin(), as_right.end());
    for (auto& row : v) {
        vector<int> l_p;
        vector<int> r_p;
        bool fl = false;
        for (auto x: row) {
            if (x == nw) {
                fl = true;
            } else if (fl) {
                r_p.push_back(x);
            } else {
                l_p.push_back(x);
            }
        }
        vector<int> s_l = l_p;
        sort(s_l.begin(), s_l.end());
        if (s_l == as_left) {
            one_part.push_back(l_p);
            other_part.push_back(r_p);
        } else {
            one_part.push_back(r_p);
            other_part.push_back(l_p);
        }
    }

    solver(one_part, nw);
    solver(other_part, nw);
}

void solve() {
    int n, k;
    cin >> n >> k;
    ans.resize(n);
    cnt.resize(n);
    vector<vector<int>> v(k, vector<int>(n));
    for (int i = 0; i < k; ++i)
        for (int j = 0; j < n; ++j) {
            cin >> v[i][j];
            --v[i][j];
        }
    solver(v, -2);
    for (int i = 0; i < n; ++i)
        cout << ans[i] + 1 << ' ';
    cout << '\n';
}

int main() {
    //freopen("input.txt", "r", stdin);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1; // cin >> t;
    while (t--)
        solve();
    return 0;
}
