#include <iostream>
#include <cassert>

using namespace std;

string not_found;
string same_dist;
string closer;

int y = 0, x = 0;

int qcounter = 0;
string ask_x(int q) {
	assert(qcounter <= 64);
	qcounter++;
	cout << q << " " << y << endl;
	string res;
	getline(cin, res);
	if (res.back() == '!') {
		exit(0);
	}
	return res;
}
string ask_y(int q) {
	assert(qcounter <= 64);
	qcounter++;
	cout << x << " " << q << endl;
	string res;
	getline(cin, res);
	if (res.back() == '!') {
		exit(0);
	}
	return res;
}

int search(int l, int r, decltype(ask_x) ask) {
	if (r-l < 3) {
		string r1 = ask(l);
		string r2 = ask(r);
		if (r2 == same_dist) {
			return (r+l)/2;
		} else if (r2 == closer) {
			return r;
		} else {
			return l;
		}
	}
	int m = (r+l)/2;
	string _ = ask(m);
	string r1 = ask(m+1);
	if (r1 == closer) {
		l = m+1;
		string r2 = ask(r);
		if (r2 == closer) {
			return search((l+r+2)/2, r, ask);
		} else if (r2 == same_dist) {
			return (r+l)/2;
		} else {
			return search(l, (l+r-1)/2, ask);
		}
	} else {
		r = m+1;
		string r2 = ask(l);
		if (r2 == closer) {
			return search(l, (l+r-1)/2, ask);
		} else if (r2 == same_dist) {
			return (r+l)/2;
		} else {
			return search((l+r+2)/2, r, ask);
		}
	}
}

int main() {
	cout << "0 0" << endl;
	qcounter++;
	getline(cin, not_found);
	if (not_found.back() == '!') {
		return 0;
	}

	cout << "0 0" << endl;
	qcounter++;
	getline(cin, same_dist);
	if (same_dist.back() == '!') {
		return 0;
	}

	cout << "1 1" << endl;
	qcounter++;
	getline(cin, closer);
	if (closer.back() == '!') {
		return 0;
	}
	if (closer == same_dist) {
		cout << "0 1" << endl;
		qcounter++;
		string res;
		getline(cin, res);
		if (res.back() == '!') {
			return 0;
		}
		cout << "1 0" << endl;
		qcounter++;
		getline(cin, res);
		if (res.back() == '!') {
			return 0;
		}
	}

	const int MXCOORD = 1e6;
	x = search(0, MXCOORD, ask_x);
	y = search(0, MXCOORD, ask_y);

	cout << x << " " << y << endl;

	return 0;
}
