import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.StringTokenizer;

public class Main {
    private static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    private static StringTokenizer st = null;

    private static String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    private static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int[][] towers = new int[n][];
        for (int i = 0; i < n; i++) {
            int m = nextInt();
            towers[i] = new int[m];
            for (int j = 0; j < m; j++) {
                towers[i][j] = nextInt();
            }
        }
        long cm = n, sp = 0;
        for (int i = 0; i < n; i++) {
            int isp = 0;
            int m = towers[i].length;
            for (int j = 0; j < m - 1; j++) {
                if (towers[i][j] > towers[i][j + 1]) {
                    isp += 1;
                    cm += 1;
                }
            }
            sp += isp;
        }
        System.out.println(sp + " " + (cm - 1));
    }
}