import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.StringTokenizer;

public class Main {
    private static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    private static StringTokenizer st = null;

    private static String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    private static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int[][] towers = new int[n][];
        int s = 0;
        for (int i = 0; i < n; i++) {
            int m = nextInt();
            s += m;
            towers[i] = new int[m];
            for (int j = 0; j < m; j++) {
                towers[i][j] = nextInt();
            }
        }
        int[] all = new int[s];
        int k = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < towers[i].length; j++) {
                all[k++] = towers[i][j];
            }
        }
        Arrays.sort(all);
        long splits = 0;
        for (int i = 0; i < n; i++) {
            int m = towers[i].length;
            for (int j = 0; j < m - 1; j++) {
                int ai = Arrays.binarySearch(all, towers[i][j]);
                //int bi = Arrays.binarySearch(all, towers[i][j + 1]);
                if ((ai == s - 1) || towers[i][j + 1] != all[ai + 1]) splits += 1;
            }
        }
        System.out.println(splits + " " + (splits + n - 1));
    }
}