#include <bits/stdc++.h>

#ifdef ONPC
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimiez("O3")
#pragma unroll
#endif

typedef long long ll;

using namespace std;
vector<int> p, ip;
vector<int> used;
vector<vector<int> > a;
vector<vector<int> > ia;

bool try_kuhn(int n1) {
//    cerr << n
    used[n1] = 1;
    for (int i = 0; i < a[n1].size(); i++) {
        int z = p[a[n1][i]];
        if (z == -1 || (!used[z] && try_kuhn(z))) {
            p[a[n1][i]] = n1;
            return true;
        }
    }
    return false;
}

int n;

void Read() {
    int nn, mm;
    cin >> nn >> mm;
    vector<string> table(nn);
    map<pair<int, int>, int> left;
    int cntl = 0;
    int cntr = 0;
    map<pair<int, int>, int> right;
    for (int i = 0; i < nn; ++i) {
        string row;
        cin >> row;
        for (int j = 0; j < mm; ++j) {
            if (row[j] == '.') {
                if ((i + j) % 2 == 0) {
                    left[{i, j}] = cntl++;
                } else {
                    right[{i, j}] = cntr++;
                }
            }
        }
    }
    n = cntl;
    a.resize(n);
    ia.resize(n);
    used.resize(n);
    for (int i = 0; i < nn; ++i) {
        for (int j = 0; j < mm; ++j) {
            if ((i + j) % 2 == 0) {
                int l = left[{i, j}];
                vector<pair<int, int>> nxt = {{0,  1},
                                              {1,  0},
                                              {0,  -1},
                                              {-1, 0}};
                for (auto [dx, dy]: nxt) {
                    pair<int, int> nt = {i + dx, j + dy};
                    if (right.count(nt) >= 1) {
                        int r = right[nt];
                        a[l].push_back(r);
                        ia[r].push_back(l);
//                        cout << l << " " <<  right[nt] << "\n";
                    }
                }
            }
        }
    }
}

int cnt = 0;

void dfs(int vert) {
    cnt++;
    used[vert] = 1;
    int r = ip[vert];
    for (int next: ia[r]) {
        if (!used[next]) {
            dfs(next);
        }
    }
}

void Solve() {
    Read();
    if (n > 1005) {
        cout << "1000000\n";
        return;
    }
    p.resize(n);
    for (int i = 0; i < n; i++)
        p[i] = -1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++)
            used[j] = 0;
        try_kuhn(i);
    }
    ip.resize(n);
    for (int i = 0; i < n; i++)
        ip[p[i]] = i;
    //exit(0);

//    for (int i = 0; i < n; i++) {
//        cout << i << ' ' << ip[i] << endl;
//    }
    ll ans = n * (n - 1);
//    cout << ans << "\n";
    for (int vert = 0; vert < n; ++vert) {
        for (int j = 0; j < n; ++j) {
            used[j] = 0;
        }
        cnt = 0;
        dfs(vert);
        ans += n - cnt;
//        cout << n - cnt << "\n";
    }
    cout << min(ans, 1'000'000ll) << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef ONPC
    freopen("../input.txt", "r", stdin);
#endif

    Solve();

    return 0;
}
