#include <bits/stdc++.h>

#ifdef ONPC
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimiez("O3")
#pragma unroll
#endif

using namespace std;

void Solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);

    int nw, nl;
    cin >> nw >> nl;

    if (n == 1) {
        cout << (nw == nl ? "1" : "0") << "\n" << nw << ":" << nl << "\n";
        return;
    }

    if (nw == 0 || nl == 0) {
        int nd{n};
        for (int i = 0; i < n; ++i) {
            if (nw > 0 || nl > 0) {
                if (nw > 0) {
                    ++a[i];
                    --nw;
                } else {
                    ++b[i];
                    --nl;
                }
                --nd;
            }
        }
        a[0] += nw;
        b[0] += nl;
        cout << nd << "\n";
        for (int i = 0; i < n; ++i) {
            cout << a[i] << ":" << b[i] << "\n";
        }
        return;
    }

    int nd{n};
    for (int i = 0; i < n - 1 && nw > 0; ++i) {
        ++a[i];
        --nw;
        --nd;
    }
    for (int i = n - 1; a[i] == 0 && nl > 0; --i) {
        ++b[i];
        --nl;
        --nd;
    }
    a[0] += nw;
    b[n - 1] += nl;

    cout << nd << "\n";
    for (int i = 0; i < n; ++i) {
        cout << a[i] << ":" << b[i] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef ONPC
    freopen("../input.txt", "r", stdin);
#endif

    Solve();

    return 0;
}
