#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
using ull = unsigned long long;

template<class T, class U> inline void umin(T& a, const U b) { if (b < a) a = b; }
template<class T, class U> inline void umax(T& a, const U b) { if (b > a) a = b; }

void solve() {
    int n, a, b;
    cin >> n >> a >> b;
    if (n == 1) {
        cout << int(a == b) << '\n' <<
            a << ':' << b << '\n';
        return;
    }
    if (a == 0) {
        cout << max(0, n - b) << '\n';
        for (int i = 0; i < n; ++i) {
            cout << "0:" << (b < n ? (i < b ? 1 : 0) :
                (i ? 1 : b - n + 1)) << '\n';
        }
        return;
    }
    if (b == 0) {
        cout << max(0, n - a) << '\n';
        for (int i = 0; i < n; ++i) {
            cout << (a < n ? (i < a ? 1 : 0) :
                             (i ? 1 : a - n + 1)) << ":0\n";
        }
        return;
    }
    vector<pii> u;
    while (n > 2 && a > 1) u.emplace_back(1, 0), --a, --n;
    while (n > 2 && b > 1) u.emplace_back(0, 1), --b, --n;
    int ans = 0;
    while (n > 2) --n, u.emplace_back(0, 0), ++ans;
    u.emplace_back(0, b);
    u.emplace_back(a, 0);
    cout << ans << '\n';
    for (auto [a, b] : u) cout << a << ':' << b << '\n';
}

signed main() {
    cout.precision(15);
#ifdef KEK
//    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(0);
    ios::sync_with_stdio(false);
#endif
    solve();
}