// 100

#include <bits/stdc++.h>

using namespace std;

#define sz(a) int32_t(a.size())
#define pb push_back
#define F first
#define S second

const int inf = 1e9 + 7;
const int N = 1e5 + 100;

vector <int> g[N];
int uk, S, M;
unordered_map < int, pair < int, int > > mp;

void split(int i, int pos) {
    if (sz(g[i]) < pos + 1) return;
    S++;
    for(int j = pos; j < g[i].size(); j++) {
        mp[g[i][j]] = {uk, sz(g[uk])};
        g[uk].pb(g[i][j]);
    }
    while (sz(g[i]) > pos) {
        g[i].pop_back();
    }
    uk++;
}

void merge(int i, int j) {
    M++;
    for(auto to: g[j]) {
        mp[to] = {i, sz(g[i])};
        g[i].pb(to);
    }
    g[j].clear();
    g[j].shrink_to_fit();
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    vector<int> ve;
    int n;
    cin >> n;
    for(int i = 0; i < n; i++) {
        int m;
        cin >> m;
        for(int j = 0; j < m; j++) {
            int x;
            cin >> x;
            ve.pb(x);
            g[i].pb(x);
        }
        reverse(g[i].begin(), g[i].end());
        for(int j = 0; j < m; j++)
        mp[g[i][j]] = {i, j};
    }
    sort(ve.rbegin(), ve.rend());
    int fix;
    uk = n;
    for(int i = 0; i < n; i++) {
        int pos = -1;
        for(int j = 0; j < sz(g[i]); j++) {
            if (g[i][j] == ve[0]) {
                pos = j;
                break;
            }
        }
        if (pos == -1) continue;
        if (pos != 0) {
            split(i, pos);
            fix = uk - 1;
        }
        else fix = i;
    }
    for(int l = 1; l < sz(ve); l++) {
        if (sz(g[fix]) >= l + 1 && g[fix][l] == ve[l]) continue;
        split(fix, l);
        pair < int, int > p = mp[ve[l]];
        if (p.F == fix) {
            split(uk - 1, p.S - l);
            merge(fix, uk - 1);
            continue;
        }
        if (p.S) {
            split(p.F, p.S);
            merge(fix, uk - 1);
        } else {
            merge(fix, p.F);
        }
    }
    cout << S << " " << M;
}

