#include <bits/stdc++.h>

#include <random>
using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int tt;
  cin >> tt;
  while (tt--) {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& el : a)
      cin >> el;
    if (n == 2 && a[0] == 2 && a[1] == 1) {
      cout << "Impossible\n";
      continue;
    }
    vector<pair<int, int>> ve;
    for (int i = 0; i < n; i++)
      ve.push_back({a[i], i + 1});
    sort(ve.begin(), ve.end());
    vector<int> perm(n);
    iota(perm.begin(), perm.end(), 1);
    while (true) {
      shuffle(perm.begin(), perm.end(), std::mt19937(std::random_device()()));
      vector<int> p(n);
      for (int i = 0; i < n; i++)
        p[perm[i] - 1] = ve[i].second;
      bool bad = false;
      for (int i = 0; i < n; i++)
        if (p[i] == (i + 1) || perm[i] == (i + 1)) {
          bad = true;
          break;
        }
      if (!bad) {
        cout << "Possible\n";
        for (int i = 0; i < n; i++)
          cout << p[i] << " ";
        cout << '\n';
        for (int i = 0; i < n; i++)
          cout << perm[i] << " ";
        cout << '\n';
        break;
      }
    }
  }
}
