//#include <iostream>
#include <bits/stdc++.h>

using namespace std;

int cnt;

vector<int> GenPermutation(int n) {
    vector<int> res(n);
    for (int i = 0; i < n; ++i) {
        res[i] = i;
    }

    while (true) {
        ++cnt;
        random_shuffle(res.begin(), res.end());

        bool ok = true;
        for (int i = 0; i < n; ++i) {
            ok &= res[i] != i;
        }
        if (ok) {
            return res;
        }
    }
}

int cnt2 = 0;

vector<int> TryPermute(const vector<int>& a) {

    for (int i = 0; i < 100; ++i) {
        ++cnt2;
        const auto& b = GenPermutation(a.size());
        bool ok = true;
        for (int i = 0; i < a.size(); ++i) {
            ok &= i != a[b[i]];
        }
        if (ok) {
            return {};
        }
    }
    return {};
}

void Solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }
    if (n == 1) {
        cout << "Impossible" << '\n';
        return;
    }

    auto b = GenPermutation(n);
    bool global_ok = false;
    for (int i = 0; i < 100; ++i) {
        bool ok = true;
        for (int i = 0; i < n; ++i) {
            ok &= i != a[b[i]];
        }
        if (ok) {
//            for (int i = 0; i < n; ++i) {
//                cout << b[i] << ' ';
//            }
//            cout << endl;
            global_ok = true;
            break;
        }

        b = GenPermutation(n);
    }
//    cout << global_ok << endl;
    if (!global_ok) {
        cout << "Impossible" << '\n';
        return;
    }

    auto c = a;
    for (int i = 0; i < n; ++i) {
        c[a[b[i]]] = i;
    }

//    cerr << "----------" << endl;
//    for (int i = 0; i < n; ++i) {
//        cerr << a[i] << ' ';
//    }
//    cerr << endl;
//    for (int i = 0; i < n; ++i) {
//        cerr << b[i] << ' ';
//    }
//    cerr << endl;
//    for (int i = 0; i < n; ++i) {
//        cerr << c[i] << ' ';
//    }
//    cerr << endl;
//    for (int i = 0; i < n; ++i) {
//        cerr << a[b[i]] << ' ';
//    }
//    cerr << endl;
//    for (int i = 0; i < n; ++i) {
//        cerr << a[b[c[i]]] << ' ';
//    }
//    cerr << endl;

    for (int i = 0; i < n; ++i) {
        assert(c[i] != i);
        assert(a[b[c[i]]] == i);
    }

    cout << "Possible" << '\n';
    for (int i = 0; i < n; ++i) {
        cout << b[i] + 1 << ' ';
    }
    cout << '\n';
    for (int i = 0; i < n; ++i) {
        cout << c[i] + 1 << ' ';
    }
    cout << '\n';
}

int main() {
//    freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    srand(0);

    int q;
    cin >> q;
    while (q--) {
        Solve();
    }

//    for (int i = 0; i < 10000; ++i) {
//        TryPermute(GenPermutation(1e3));
//    }
//    cout << cnt << ' ' << cnt2 << endl;
}
