#include <bits/stdc++.h>
using namespace std;

mt19937 gen(time(0));

void solve() {
    int n;
    cin >> n;
    std::vector<int> a(n);
    std::vector<int> pos(n);
    std::vector<int> order(n);
    std::vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        pos[a[i]] = i;
        order[i] = i;
    }
    for (int it = 0; it < 111; ++it) {
        std::shuffle(order.begin(), order.end(), gen);
        bool ok = true;
        for (int i = 0; i < n; ++i) {
            if (order[i] == i) {
                ok = false;
                break;
            }
            p[order[i]] = pos[i];
            if (p[order[i]] == order[i]) {
                ok = false;
                break;
            }
        }
        if (ok) {
            cout << "Possible\n";
            for (int i = 0; i < n; ++i) {
                cout << p[i] + 1 << ' ';
            }
            cout << "\n";
            for (int i = 0; i < n; ++i) {
                cout << order[i] + 1 << ' ';
            }
            cout << "\n";
//            for (int i = 0; i < n; ++i) {
//                assert(a[p[order[i]]] == i);
//            }
            return;
        }
    }
    cout << "Impossible\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "rt", stdin);
    freopen("output.txd", "wt", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) solve();
    return 0;
}
