#include <bits/stdc++.h>

using namespace std;

mt19937 gen(time(0));

string guess(int x, int y) {
    cout << x << ' ' << y << endl;
    string s;
    cin >> s;
    if (s.back() == '!') {
        exit(0);
    }
    return s;
}

string guessX(int x) {
    return guess(x, 0);
}
string guessY(int y) {
    return guess(0, y);
}

const int N = 1e6;
string father;
string closer;
string middle;

int GetX() {
    int l = 0, r = N;
    while (true) {
        int mid = (l + r) / 2;
        guessX(l);
        string ans = guessX(r);
        if (ans == father) {
            r = mid;
        } else if (ans == closer) {
            l = mid;
        } else {
            return (l + r) / 2;
        }
    }
}
int GetY() {
    int l = 0, r = N;
    while (true) {
        int mid = (l + r) / 2;
        guessY(l);
        string ans = guessY(r);
        if (ans == father) {
            r = mid;
        } else if (ans == closer) {
            l = mid;
        } else {
            return (l + r) / 2;
        }
    }
}

void solve() {
    string z = guess(0, 0);
    string a = guess(1, 0);
    string b = guess(0, 0);
    string c = guess(0, 1);
    if (a == c) {
        father = b;
        closer = a;
    } else {
        guess(0, N);
        guess(N, 0);
        string z2 = guess(N, N);
        string a2 = guess(N - 1, N);
        string b2 = guess(N, N);
        closer = a2;
        father = b2;
        if (a == closer) {
            int x = GetX();
            guess(x, 0);
            return;
        } else {
            int y = GetY();
            guess(0, y);
            return;
        }
    }
    int lx = 0, rx = N;
    int ly = 0, ry = N;
    bool gx = false;
    bool gy = false;
    int x, y;
    while (!gx || !gy) {
        int mx = (lx + rx) / 2;
        int my = (ly + ry) / 2;
        string a_ = guess(lx, ly);
        string ay = guess(lx, ry);
        string ax = guess(rx, ry);
        if (!gy) {
            if (ay == father) {
                ry = my;
            } else if (ay == closer) {
                ly = my;
            } else {
                gy = true;
                y = (ly + ry) / 2;
            }
        }
        if (!gx) {
            if (ax == father) {
                rx = mx;
            } else if (ax == closer) {
                lx = mx;
            } else {
                gx = true;
                x = (lx + rx) / 2;
            }
        }
    }
    guess(x, y);
}

int main() {
//#ifdef LOCAL
//    freopen("input.txt", "rt", stdin);
//    freopen("output.txd", "wt", stdout);
//#endif
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
    solve();
    return 0;
}

//YES
//6
//3 4
//2 4
//1 4
//4 5
//2 3
//3 5
