#include <bits/stdc++.h>

using namespace std;

mt19937 gen(time(0));

int deg[502];  // from 1

void solve(int n, int k) {
    if (n == 1 && k == 1) {
        cout << "YES\n0\n";
        return;
    }
    if (k == n) {
        cout << "NO\n";
        return;
    }
    if (k == 1) {
        cout << "YES\n";
        if (n > 2) {
            cout << n << "\n";
        } else {
            cout << n - 1 << '\n';
        }
        for (int i = 0; i + 1 < n; ++i) {
            cout << i + 1 << ' ' << i + 2 << "\n";
        }
        if (n > 2) {
            cout << 1 << ' ' << n << "\n";
        }
        return;
    }
    if (k == 2) {
        cout << "YES\n";
        cout << n - 1 << "\n";
        for (int i = 1; i < n; ++i) {
            cout << 1 << ' ' << i + 1 << "\n";
        }
        return;
    }

    fill(deg, deg + n + 1, 0);


    std::vector<pair<int, int>> edges;
    int nxt_free = k + 1;

    for (int cur = k; cur >= 1; --cur) {
        for (int v = cur - 1; v >= 1; --v) {
            if (deg[v] < v) {
                ++deg[cur];
                ++deg[v];
                edges.push_back({v, cur});
            }
        }

        while (deg[cur] != cur) {
            if (deg[nxt_free] == k) {
                cout << "NO\n";  // !!! TODO:
                return;
            }

            ++deg[cur];
            ++deg[nxt_free];
            edges.push_back({cur, nxt_free});

            ++nxt_free;
            if (nxt_free > n) {
                nxt_free = k + 1;
            }
        }
    }

    if (deg[nxt_free] == 0) {
        if (nxt_free == k + 1) {
            exit(11);
        }
        for (int v = nxt_free; v + 1 <= n; ++v) {
            edges.push_back({v, v + 1});
            ++deg[v];
            ++deg[v + 1];
        }
        edges.push_back({k + 1, nxt_free});
        ++deg[k + 1];
        ++deg[nxt_free];
    }

    cout << "YES\n";
    cout << edges.size() << '\n';
    for (const auto &edge: edges) {
        cout << edge.first << ' ' << edge.second << '\n';
    }

//    set<int> check;
//    for (int i = 1; i <= n; ++i) {
//        check.insert(deg[i]);
//    }
//    assert(check.size() == k);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "rt", stdin);
    freopen("output.txd", "wt", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    for (int n = 1; n <= 500; ++n) {
//        for (int k = 1; k <= n; ++k) {
//            cerr << n << ' ' << k << '\n';
    int n, k;
    cin >> n >> k;
    solve(n, k);
//        }
//    }
    return 0;
}

//YES
//6
//3 4
//2 4
//1 4
//4 5
//2 3
//3 5
