#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define sz(x) ((int)(x).size())
#define em_back emplace_back

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

const int N = 1e5 + 4;

int n, a[N], p[N], q[N], inv[N];

void write() {
    for (int i = 1; i <= n; ++i) {
        p[q[i]] = inv[i];
    }
    for (int i = 1; i <= n; ++i) {
        if (q[i] == i) {
            cout << "err Q\n";
            return;
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (p[i] == i) {
            cout << "err P\n";
            return;
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (a[p[q[i]]] != i) {
            cout << "err A\n";
            return;
        }
    }

    cout << "Possible\n";
    for (int i = 1; i <= n; ++i) {
        cout << p[i] << " ";
    }
    cout << "\n";
    for (int i = 1; i <= n; ++i) {
        cout << q[i] << " ";
    }
    cout << "\n";
}

void read() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        inv[a[i]] = i;
    }
}

mt19937 eng(4);

void mread() {
    n = 1e5;//eng() % 5 + 6;
    iota(a + 1, a + 1 + n, 1);
    shuffle(a + 1, a + 1 + n, eng);
}

void solve() {
    read();

    for (int i = 1; i <= n; ++i) {
        inv[a[i]] = i;
    }

    if (n < 6) {
        iota(q + 1, q + 1 + n, 1);
        do {
            bool good = true;
            for (int i = 1; i <= n; ++i) {
                if (q[i] == i || q[i] == inv[i]) {
                    good = false;
                    break;
                }
            }
            if (good) {
                write();
                return;
            }
        } while(next_permutation(q + 1, q + 1 + n));

        cout << "Impossible\n";
        return;
    }

    vector<int> vars;
    for (int i = 1; i <= n; ++i) {
        vars.em_back(i);
    }

    for (int i = 1; i <= n - 6; ++i) {
        int it = -1;
        for (int j = 0; j < sz(vars); ++j) {
            int x = vars[j];
            if (x == i || x == inv[i]) {
                continue;
            }
            it = j;
            break;
        }
        q[i] = vars[it];
        swap(vars[it], vars.back());
        vars.pop_back();
    }

    sort(all(vars));
    do {
        bool good = true;
        for (int i = 0; i < 6; ++i) {
            q[n - 5 + i] = vars[i];
            if (q[n - 5 + i] == n - 5 + i ||
                q[n - 5 + i] == inv[n - 5 + i]) {
                good = false;
                break;
            }
        }
        if (!good) {
            continue;
        }
        write();
        return;
    } while (next_permutation(all(vars)));
}

int main() {
    ios::sync_with_stdio(0);
    cout.tie(0), cin.tie(0);

    int z = 1;
    cin >> z;

    while (z--) {
        solve();
    }
    return 0;
}
