#include <iostream>
#include <vector>
#include <map>
#include <iterator>
#include <string>
#include <cassert>

using namespace std;

const int M = 1e6;

string read() {
	string s;
	getline(cin, s);
	while (s.size() > 0 && (s.back() == '\n' || s.back() == ' '))
		s.pop_back();
	return s;
}

int main() {
	string closer, further;

	cout << "0 0" << endl;

	string s = read();
	if (s.back() == '!')
		return 0;

	cout << "0 1" << endl;
	s = read();
	if (s.back() == '!')
		return 0;

	string x = s;

	cout << "0 0" << endl;

	s = read();
	if (s.back() == '!')
		return 0;

	string y = s;


	cout << "1 0" << endl;

	s = read();
	if (s.back() == '!')
		return 0;

	string z = s;

	if (x == z) {
		closer = z;
		further = y;
	}
	else {
		closer = z;
		further = x;
	}

	int lx = 0, rx = M, ly = 0, ry = M;

	while (true) {
		int mx = (lx + rx) / 2;
		int my = (ly + ry) / 2;

		cout << mx << " " << my << endl;

		s = read();
		if (s.back() == '!')
			return 0;

		int xdir = (lx == rx ? 0 : (mx == 0 ? +1 : -1));
		if (xdir != 0) {
			cout << mx + xdir << " " << my << endl;

			s = read();
			if (s.back() == '!')
				return 0;

			if (xdir == -1) {
				if (s == closer)
					rx = mx - 1;
				else
					lx = mx;
			}
			else {
				if (s == closer)
					lx = mx + 1;
				else
					rx = mx;
			}
		}

		int ydir = (ly == ry ? 0 : (my == 0 ? +1 : -1));
		if (ydir != 0) {
			cout << mx + xdir << " " << my + ydir << endl;

			s = read();
			if (s.back() == '!')
				return 0;

			if (ydir == -1) {
				if (s == closer)
					ry = my - 1;
				else
					ly = my;
			}
			else {
				if (s == closer)
					ly = my + 1;
				else
					ry = my;
			}
		}
	}

	return 0;
}