#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <numeric>
#include <queue>
#include <cassert>
#include <unordered_set>

#define ff first
#define ss second
using namespace std;
using pii = pair<int, int>;

void Solve() {
  int n, k;
  cin >> n >> k;

  if (k == n) {
    cout << "NO\n";
    return;
  }

  if (k == 1) {
    std::cout << "YES\n";
    std::cout << n << "\n";
    for (int i = 1; i < n; ++i) {
      std::cout << i << " " << i + 1 << "\n";
      std::cout << 1 << " " << n << "\n";
    }
  } else {
    std::vector <std::pair <int, int>> edges;
    int l = 1, r = n;
    while (k > 0) {
      for (int i = r - 1; i >= l; --i) {
        edges.emplace_back(r, i);
      }
      if (k == 1) {
        edges.emplace_back(r, l - 1);
      }
      k -= 2;
      ++l; --r;
    }

    cout << "YES\n" << edges.size() << "\n";
    for (const auto& [u, v] : edges) {
      cout << u << " " << v << "\n";
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    Solve();
  }
  return 0;
}
