#include<vector>
#include<iostream>
#include<algorithm>

struct cube {
	int v;
	int l;
};

bool operator<(cube a, cube b) {
	return a.v < b.v;
}

int main() {
	int n;
	std::cin >> n;

	std::vector<cube> mas;

	for (int i = 0; i < n; i++) {
		int c;
		std::cin >> c;
		std::vector<cube> buff(c);
		for (auto& el : buff)
			std::cin >> el.v;
		std::reverse(buff.begin(), buff.end());
		buff.front().l = -1;
		for (int r = 1; r < buff.size(); r++)
			buff[r].l = buff[r - 1].v;
		for (auto& el : buff)
			mas.push_back(el);
	}
	std::sort(mas.rbegin(), mas.rend());
	
	int cuts = 0, last = -1;
	for (int i = 0; i < mas.size(); i++) {
		if (mas[i].l != last && mas[i].l != -1)
			cuts++;
		last = mas[i].v;
	}
	std::cout << cuts << ' ' << n + cuts - 1;
}