#include <iostream>
#include <vector>

using namespace std;

#define N 10000

vector<int> num;

int get_index(int number){
    for(int i = 0; i < num.size(); i++){
        if(number == num[i]) return i;
    }
    return -1;
}

int main() {
    int n, k, a, splits = 0, combines;
    cin >> n;
    combines = n - 1;
    vector<vector<int>> towers;

    int t = 0;
    for(int i = 0; i < n; i++){
        cin >> k;
        vector<int> temp;
        for(int j = 0; j < k; j++){
            cin >> a;
            temp.push_back(a);
            num.push_back(a);
            t++;
        }
        towers.push_back(temp);
    }


    sort(num.begin(), num.end());

//    for(int i = 0 ; i < num.size() ; i++)
//        cout << num[i] << " ";
//    cout << endl;


    for(int i = 0; i < n; i++){
        auto tower = towers[i];
        int startIndex = get_index(tower[0]);
        int offset = 0;
        while(offset < tower.size() - 1){
            int j = 1;
            for(; offset + j < tower.size(); j++){
                //cout << tower[offset + j] << " " << num[startIndex + j] << " " << j << " " << startIndex << endl;
                if(tower[offset + j] != num[startIndex + j]){
                    splits++;
                    combines++;
                    startIndex = get_index(tower[offset + j]);
                    break;
                }
            }
            offset += j;
        }
    }

    cout << splits << " " << combines << endl;

    return 0;
}
