#include <vector>
#include <iostream>
#include <algorithm>
#include <bits.h>
#include <map>

int main()
{
	int n;
	std::cin >> n;
	std::vector<std::vector<int>>a(n);
	std::vector<int>sorted;
	for (int i = 0; i < n; i++) {
		int k; std::cin >> k;
		a[i].resize(k);
		for (int j = 0; j < k; j++) {
			std::cin >> a[i][j];
			sorted.push_back(a[i][j]);
		}
	}
	sort(sorted.begin(), sorted.end());
	std::map<int, int>mapping;
	for (int i = 0; i < sorted.size(); i++) {
		mapping[sorted[i]] = i;
	}

	int split = 0, comb = n - 1;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j + 1 < a[i].size(); j++)
		{
			if (mapping[a[i][j]] > mapping[a[i][j + 1]])
			{
				split++;
				comb++;
			}
		}
	}
	std::cout << split << " " << comb;


}
