#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <string>
#include <stdlib.h>
#include <set>

using namespace std;
using ll = long long;
using vll = vector<ll>;
using vvll = vector<vector<ll>>;

#define deb(x) cout << #x << " = " << x << "\n";

void E() {
    vvll v;
    vll vec, temp;
    ll n, k, a, s = 0, c = 0;
    cin >> n;
    for (ll i = 0; i < n; i++) {
        cin >> k;
        for (ll j = 0; j < k; j++) {
            cin >> a;
            temp.push_back(a);
            vec.push_back(a);
        }
        v.push_back(temp);
        temp.clear();
    }
    sort(vec.begin(), vec.end());
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < v[i].size()-1; j++) {
            auto x = find(vec.begin(), vec.end(), v[i][j]);
            if (v[i].size()>1 && *(x+1) != v[i][j+1]) {
                s++;
                c++;
            }
        }
    }
    c+=n-1;
    cout << s << " " << c;
    return;
}

void F(){
    ll a, b, n, dows=0;
    cin >> n >> a >> b;
    vector <string> m;
    if (n!=1){
            if (a < b){
                for (int i = 0; i<n-1; i++){
                    if (a>0){
                        m.push_back("1:0\n");
                        a-=1;
                    }
                    else if (b>0){
                        m.push_back("0:1\n");
                        b-=1;
                    }
                    else {
                        m.push_back("0:0\n");
                        dows+=1;
                    }
                }
            }
            else {
                    for (int i = 0; i<n-1; i++){
                if (b>0){
                    m.push_back("0:1\n");
                    b-=1;
                }
                else if (a>0){
                    m.push_back("1:0\n");
                    a -= 1;
                }
                else {
                    m.push_back("0:0\n");
                    dows+=1;
                }
            }
        }
            if (a==b) dows+=1;
        cout << dows << "\n";
        for (int i = 0; i < n-1; i++){
            cout << m[i];
        }
        cout << a << ':' << b;
    }
    else {
        if (a==b) {
            cout << "1\n";
        }
        else cout << "0\n";
        cout << a << ":" << b;
    }
}

void A() {
    ll n, m, t;
    vll a;
    cin >> n;
    for (ll i = 0; i < n; i++) {
        cin >> m;
        vll p(m), q(m);
        ll x;
        bool solved = false;
        a.push_back(-1);
        for (ll j = 1; j <= m; j++) {
            cin >> t;
            a.push_back(t);
        }
        //
        for (ll j = 1; j <= m; j++) {
            x = (j-1+1)%m+1;
            deb(x);
            if (x != a[j]) {
                p[x] = j;
                q[a[j]] = x;
            } else {
                break;
            }
            if (j == m) solved = true;
        }
        if (!solved) {
            for (ll j = 1; j <= m; j++) {
                x = a[j]%m+1;
                deb(x);
                if (x != j) {
                    p[x] = j;
                    q[a[j]] = x;
                } else {
                    break;
                }
                if (j == m) solved = true;
            }
        }
        if (solved) {
            cout << "Possible\n";
        } else {
            cout << "Impossible\n";
        }
        //
        a.clear();
        p.clear();
        q.clear();
    }
}

void K() {
    vll l, r, count;
    ll n, k;
    set<ll> s;
    cin >> n >> k;
    if (n == 1 && k == 1) {
        cout << "YES\n0";
        return;
    }
    for (ll i = 1; i <= n-1; i++) {
        for (ll j = i + 1; j <= n; j++) {
            l.push_back(i);
            r.push_back(j);
//            cout << l.back() << " " << r.back() << "\n";
        }
    }
    ll max = n*(n-1)/2;
    for (ll i = 0; i < n; i++) {
        count.push_back(n-1);
    }
    while (l.size() > 0) {
        for (ll i = 0; i < count.size(); i++) {
            s.insert(count[i]);
//            cout << count[i] << " ";
        }
//        cout << "\n";
        if (s.size() == k) {
            break;
        }
        count[l.back()-1]--;
        count[r.back()-1]--;
        l.pop_back();
        r.pop_back();
        s.clear();
    }
    if (l.empty()) {
        cout << "NO";
    } else {
        cout << "YES\n" << l.size() << "\n";
        for (ll i = 0; i < l.size(); i++) {
            cout << l[i] << " " << r[i] << "\n";
        }
    }
    return;
}

void A1() {
    int n, t, temp;
    bool pos = true;
    cin >> t;
    for (int l = 0; l < t; l++) {
        cin >> n;
        int a[100002], p[100002], q[100002];
        for (int i = 1; i <= n; i++) {
            cin >> temp;
            a[temp] = i;
            p[i] = 0;
            q[i] = 0;
        }
        int x = 1, er = 0;
        for(int i = 1; i <= n; i++) {
            while ((p[x] != 0) || (x == i) || (x == a[i])) {
                x++;
                if (x > n) {
                    er ++;
                    x = 1;
                }
                if ( (er == 2) || (n < 3)) {
                    cout << "Impossible\n";
                    pos = false;
                    break;
                }
            }
            if (! pos) {
                break;
            }
            q[i] = x;
            p[x] = a[i];
        }
        if (! pos) {
            pos = true;
        } else {
            cout << "Possible\n";
            for (int i = 1; i <= n; i++) {
                cout << p[i] << " ";
            }
            cout << "\n";
            for (int i = 1; i <= n; i++) {
                cout << q[i] << " ";
            }
            cout << "\n";
        }

    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    A1();
    return 0;
}
