#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cassert>
#include <random>
#include <map>
using namespace std;
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second
#define m_p make_pair
const int N = 100005;

int n;
int a[N];

int u[N];
bool c[N];

int p[N], q[N];

void solv()
{
	cin >> n;
	for (int i = 1; i <= n; ++i)
		cin >> a[i];

	for (int i = 1; i <= n; ++i)
		u[a[i]] = i;

	for (int i = 1; i <= n; ++i)
		c[i] = false;
	vector<int> v;
	for (int i = 1; i <= n; ++i)
	{
		if (c[i])
			continue;
		int x = i;
		while (!c[x])
		{
			c[x] = true;
			v.push_back(x);
			x = u[x];
		}
	}
	assert(sz(v) == n);

	for (int i = 0; i < n; ++i)
	{
		q[v[i]] = v[(i + 2) % n];
	}
	for (int i = 1; i <= n; ++i)
	{
		p[q[i]] = u[i];
	}

	for (int i = 1; i <= n; ++i)
	{
		assert(a[p[q[i]]] == i);
	}

	for (int i = 1; i <= n; ++i)
	{
		if (p[i] == i || q[i] == i)
		{
			cout << "Impossible\n";
			return;
		}
	}
	cout << "Possible\n";
	for (int i = 1; i <= n; ++i)
		cout << p[i] << ' ';
	cout << "\n";
	for (int i = 1; i <= n; ++i)
		cout << q[i] << ' ';
	cout << "\n";
}

int main()
{
#ifdef BOMB
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	int tt = 1;
	cin >> tt;
	while (tt--)
	{
		solv();
	}
	return 0;
}