#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cassert>
#include <random>
#include <map>
#include <set>
using namespace std;
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second
#define m_p make_pair
const int N = 1003;

int n, k;

int p[N];
int rec(vector<vector<int> > vv)
{
	set<int> s;
	for (int i = 0; i < sz(vv); ++i)
	{
		for (int j = 0; j < sz(vv[i]); ++j)
		{
			s.insert(vv[i][j]);
		}
	}
	if (sz(s) != sz(vv[0]))
		return 0;

	int n = sz(s);

	if (n == 1)
	{
		return vv[0][0];
	}
	
	for (auto it = s.begin(); it != s.end(); ++it)
	{
		int x = *it;
		int y;
		for (auto jt = s.begin(); jt != s.end(); ++jt)
		{
			y = *jt;
			if (x != y)
				break;
		}

		vector<int> u;
		u.assign(sz(vv), 0);
		for (int i = 0; i < sz(vv); ++i)
		{
			for (int j = 0; j < n; ++j)
			{
				if (vv[i][j] == x)
				{
					u[i] = j;
					break;
				}
			}
		}
		bool z = true;
		for (int i = 0; i < sz(vv); ++i)
		{
			if (u[i] != u[0] && u[i] != n - u[0] - 1)
			{
				z = false;
				break;
			}
		}
		if (z)
		{
			vector<vector<int> > vvl, vvr;
			for (int i = 0; i < sz(vv); ++i)
			{
				bool z = false;
				for (int j = 0; j < u[i]; ++j)
				{
					if (vv[i][j] == y)
					{
						z = true;
						break;
					}
				}
				vector<int> vl, vr;
				for (int j = 0; j < u[i]; ++j)
					vl.push_back(vv[i][j]);
				for (int j = u[i] + 1; j < n; ++j)
					vr.push_back(vv[i][j]);
				if (z)
					swap(vl, vr);
				vvl.push_back(vl);
				vvr.push_back(vr);
			}
			int l = rec(vvl);
			if (!l)
				continue;
			int r = rec(vvr);
			if (!r)
				continue;
			p[l] = x;
			p[r] = x;
			return x;
		}
	}
	return 0;
}

void solv()
{
	cin >> n >> k;
	vector<vector<int> > vv;
	for (int i = 0; i < k; ++i)
	{
		vector<int> v;
		for (int j = 0; j < n; ++j)
		{
			int x;
			cin >> x;
			v.push_back(x);
		}
		vv.push_back(v);
	}

	int r = rec(vv);
	p[r] = -1;

	for (int i = 1; i <= n; ++i)
		cout << p[i] << ' ';
	cout << "\n";
}

int main()
{
#ifdef BOMB
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif

	int tt = 1;
	//cin >> tt;
	while (tt--)
	{
		solv();
	}
	return 0;
}