#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cassert>
#include <random>
#include <map>
#include <cstring>
using namespace std;
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second
#define m_p make_pair
const int N = 503;

int n, k;
int q[N];

void solv()
{
	cin >> n >> k;

	if (k == 1)
	{
		cout << "YES\n";
		if (n == 1)
		{
			cout << "0\n";
			return;
		}
		cout << n << "\n";
		for (int i = 1; i <= n; ++i)
		{
			cout << i << ' ' << i % n + 1 << "\n";
		}
		return;
	}

	for (int x = 1; x <= n; ++x)
	{
		vector<pair<int, int> > ans;
		memset(q, 0, sizeof q);

		for (int i = 1; i <= x; ++i)
		{
			for (int j = i + 1; j <= x; ++j)
			{
				++q[i];
				++q[j];
				ans.push_back(m_p(i, j));
			}
		}

		for (int i = x + 1; i <= n; ++i)
		{
			for (int j = 1; j <= min(i - x, x); ++j)
			{
				++q[i];
				++q[j];
				ans.push_back(m_p(i, j));
			}
			int qq = 0;
			if (i < n)
			{
				++q[x + 1];
				++q[i + 1];
				ans.push_back(m_p(x + 1, i + 1));
				for (int j = i + 2; j <= n; ++j)
				{
					++q[j - 1];
					++q[j];
					ans.push_back(m_p(j - 1, j));
					++qq;
				}
			}

			bool c[N] = {};
			for (int i = 1; i <= n; ++i)
				c[q[i]] = true;
			int t = 0;
			for (int i = 1; i <= n; ++i)
				t += c[i];
			if (t == k)
			{
				cout << "YES\n";
				cout << sz(ans) << "\n";
				for (int i = 0; i < sz(ans); ++i)
				{
					cout << ans[i].first << ' ' << ans[i].second << "\n";
				}
				return;
			}

			while (qq--)
			{
				--q[ans.back().first];
				--q[ans.back().second];
				ans.pop_back();
			}
		}
	}
	cout << "NO\n";
}

int main()
{
#ifdef BOMB
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif

	int tt = 1;
	//cin >> tt;
	while (tt--)
	{
		solv();
	}
	return 0;
}