#include <algorithm>
#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
using namespace std;
typedef pair<int, int> pii;
int a[100010], b[100010], c[100010];
int pos[100010];

int n;
set<int> s;
bool rec(int ind) {
    if (ind == n + 1) {
        cout << "Possible" << endl;
        for (int i = 1; i <= n; ++i) {
            cout << c[i] << ' ';
        }
        cout << endl;
        for (int i = 1; i <= n; ++i) {
            cout << b[i] << ' ';
        }
        cout << endl;
        return true;
    }
    for (auto it = s.begin(); it != s.end(); ++it) {
        int i = *it;
        if (i != ind && pos[ind] != i) {
            s.erase(it++);
            b[ind] = i;
            c[i] = pos[ind];
            if (rec(ind + 1)) {
                return true;
            }
            it = s.insert(i).first;
        }
    }
    return false;
}

void solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        pos[a[i]] = i;
    }
    s.clear();
    for (int i = 1; i <= n; ++i) s.insert(i);
    if (!rec(1)) {
        cout << "Impossible" << endl;
        return;
    }
}

int main() {
#ifdef YSUX
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) solve();
    return 0;
}
