#include <algorithm>
#include <iostream>
#include <cstdio>
#include <vector>
#include <queue>
#include <set>
using namespace std;
typedef pair<int, int> pii;
/*
int a[100010], b[100010];
int pos[100010];


char c[1010][1010];
int comp[1010][1010];
bool used[1010][1010];
int dx[] = {-1, 0, 1, 0};
int dy[] = {0, -1, 0, 1};
int n, m;
int cnt[1000010];
int k;
int decr[1000010];
int z[1000010][2];

void dfs(int x, int y) {
    cnt[k]++;
    comp[x][y] = k;
    used[x][y] = true;
    for (int i = 0; i < 4; ++i) {
        int nxtx = x + dx[i];
        int nxty = y + dy[i];
        if (nxtx < 0 || nxty < 0 || nxtx >= n || nxty >= m) {
            continue;
        }
        if (c[nxtx][nxty] == '#' || used[nxtx][nxty]) continue;
        dfs(nxtx, nxty);
    }
}
void solve() {
    cin >> n >> m;
    int all = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> c[i][j];
            if (c[i][j] == '.') all++;
        }
    }
    int sum = 0;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (c[i][j] == '.' && !used[i][j]) {
                dfs(i, j);
                if (sum * 1ll * cnt[k] + ans > 1000000) {
                    cout << 1000000 << endl;
                    return;
                }
                ans += sum * cnt[k];
                sum += cnt[k];
                k++;
            }
        }
    }
    queue<pii> q;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (c[i][j] == '#') continue;
            int cntN = 0;
            for (int l = 0; l < 4; ++l) {
                int nxtx = i + dx[l];
                int nxty = j + dy[l];
                if (nxtx < 0 || nxty < 0 || nxtx >= n || nxty >= m) {
                    continue;
                }
                if (c[nxtx][nxty] == '#') continue;
                cntN++;
            }
            if (cntN == 1) {
                q.push(pii(i, j));
            }
        }
    }
    while (!q.empty()) {
        pii p = q.front();
        q.pop();
        if (c[p.first][p.second] == '#') continue;
        c[p.first][p.second] = '#';
        int new_cnt = comp[p.first][p.second] - decr[comp[p.first][p.second]] - 2;
        decr[comp[p.first][p.second]] += 2;
        z[comp[p.first][p.second]][(p.first + p.second) % 2]++;
        if (ans + new_cnt > 1000000) {
            cout << 1000000 << endl;
            return;
        }
        ans += new_cnt;
        for (int l = 0; l < 4; ++l) {
            int nxtx = p.first + dx[l];
            int nxty = p.second + dy[l];
            if (nxtx < 0 || nxty < 0 || nxtx >= n || nxty >= m) {
                continue;
            }
            if (c[nxtx][nxty] == '#') continue;
            c[nxtx][nxty] = '#';
            for (int o = 0; o < 4; ++o) {
                int new_x = nxtx + dx[o];
                int new_y = nxty + dy[o];
                if (new_x < 0 || new_y < 0 || new_x >= n || new_y >= m) continue;
                if (c[new_x][new_y] == '#') continue;
                q.push(pii(new_x, new_y));
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            z[comp[i][j]][(i + j) % 2]++;
        }
    }
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < 2; ++j) {
            long long cnt = z[i][j] * 1ll * (z[i][j] - 1) / 2;
            if (ans + cnt > 1000000) {
                cout << 1000000 << endl;
                return;
            }
            ans += cnt;
        }
    }
    cout << ans << endl;
}
*/


string ask(int x, int y) {
    cout << x << ' ' << y << endl;
    string res;
    cin >> res;
    if (res.back() == '!') exit(0);
    return res;
}
int f[40];

void solve() {
    string s01 = ask(0, 1), s10 = ask(1, 0), s00 = ask(0, 0), s11 = ask(1, 1);
    string closer = s11, further = "", equal = "";
    set<string> s = {s10, s00};
    s.erase(closer);
    if (s.size() == 1) {
        further = *s.begin();
    } else {
        further = s00;
        equal = s10;
    }
    int mx = 1000000;
    int l = 0, r = mx, tox;
    ask(l, 0);
    bool start = true;
    while (true) {
        if (start) {
            int m = r - (r - l) / 3;
            string result = ask(m, 0);
            if (result == further) {
                ask(l, 0);
                r = l + ((r - l) / 3);
            } else if (result == closer) {
                string res2 = ask(m - 1, 0);
                if (res2 == further) {
                    l = m - 1;
                } else if (res2 == closer) {
                    l = l + (r - l) / 3;
                    r = m - 1;
                    start = false;
                } else {
                    tox = (l + m - 1) / 2;
                    break;
                }
            } else {
                tox = (l + m) / 2;
                break;
            }
        } else {
            int m = l + (r - l) / 3;
            string result = ask(m, 0);
            if (result == further) {
                ask(r, 0);
                l = r - ((r - l) / 3);
            } else if (result == closer) {
                string res2 = ask(m + 1, 0);
                if (res2 == further) {
                    r = m + 1;
                } else if (res2 == closer) {
                    l = m + 1;
                    r = r - (r - l) / 3;
                    start = false;
                } else {
                    tox = (l + m + 1) / 2;
                    break;
                }
            } else {
                tox = (l + m) / 2;
                break;
            }
        }
    }
    ///////////////////////////////////////
    l = 0;
    r = mx;
    int syun;
    ask(tox, 0);
    start = true;
    while (true) {
        if (start) {
            int m = r - (r - l) / 3;
            string result = ask(tox, m);
            if (result == further) {
                ask(tox, l);
                r = l + ((r - l) / 3);
            } else if (result == closer) {
                string res2 = ask(tox, m - 1);
                if (res2 == further) {
                    l = m - 1;
                } else if (res2 == closer) {
                    l = l + (r - l) / 3;
                    r = m - 1;
                    start = false;
                } else {
                    tox = (l + m - 1) / 2;
                    break;
                }
            } else {
                tox = (l + m) / 2;
                break;
            }
        } else {
            int m = l + (r - l) / 3;
            string result = ask(tox, m);
            if (result == further) {
                ask(tox, r);
                l = r - ((r - l) / 3);
            } else if (result == closer) {
                string res2 = ask(tox, m + 1);
                if (res2 == further) {
                    r = m + 1;
                } else if (res2 == closer) {
                    l = m + 1;
                    r = r - (r - l) / 3;
                    start = false;
                } else {
                    tox = (l + m + 1) / 2;
                    break;
                }
            } else {
                tox = (l + m) / 2;
                break;
            }
        }
    }
}


int main() {
#ifdef YSUX
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
