#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;

int main() 
{
	cin.tie();
	cout.tie();
	ios_base::sync_with_stdio(false);

	int n, k;
	cin >> n >> k;
	if (k >= n - 1) {
		cout << "NO" << endl;
		return 0;
	}
	cout << "YES" << endl;
	set<pll> s;
	for (int i = 0; i < n; ++i) {
		int u = min(i, (i + 1) % n);
		int v = max(i, (i + 1) % n);
		s.emplace(u, v);
	}

	for (int i = 1; i < k; ++i) {
		s.emplace(0, i + 1);
	}

	cout << s.size() << endl;
	for (auto el : s) {
		cout << el.first + 1 << " " << el.second + 1 << endl;
	}


	//int n, k;
	//cin >> n >> k;
	//vector<int> vec(n);
	//vector<int> ans(n);
	//for (int i = 0; i < n; ++i)
	//{
	//	cin >> vec[i];
	//}

	//int asc = 0;
	//int cnt = 1;
	//int change_cnt = 0;
	//ans[0] = vec[0];
	//for (int i = 1; i < n; ++i)
	//{
	//	ans[i] = vec[i];

	//	if (asc == 0)
	//	{
	//		if (vec[i] > vec[i - 1])
	//			asc = 1;
	//		else if (vec[i] < vec[i - 1])
	//			asc = -1;
	//		cnt++;
	//	}

	//	else if (asc == 1)
	//	{
	//		if (vec[i] >= vec[i - 1])
	//			cnt++;
	//		else
	//		{
	//			cnt = 0;
	//			for (int j = 1; j < k; ++j)
	//			{
	//				if (vec[i - j] != vec[i - 1])
	//				{
	//					break;
	//				}
	//				else
	//				{
	//					cnt++;
	//				}
	//			}

	//			asc = -1;
	//		}
	//	}

	//	else if (asc == -1)
	//	{
	//		if (vec[i] <= vec[i - 1])
	//			cnt++;
	//		else
	//		{
	//			cnt = 0;
	//			for (int j = 1; j < k; ++j)
	//			{
	//				if (vec[i - j] != vec[i - 1])
	//				{
	//					break;
	//				}
	//				else
	//				{
	//					cnt++;
	//				}
	//			}
	//			asc = 1;
	//		}
	//	}

	//	if (cnt >= k)
	//	{
	//		change_cnt++;
	//		bool lava = false;
	//		for (int j = 1; j < k; ++j)
	//		{
	//			if (vec[i - j] != vec[i - 1])
	//			{
	//				lava = true;
	//			}
	//		}
	//		if (!lava)
	//			asc = 0;

	//		if (asc == 1)
	//		{
	//			if (i >= n - 2)
	//			{
	//				vec[i] = 0;
	//			}
	//			else
	//			{
	//				if (vec[i + 1] < vec[i + 2])
	//				{
	//					vec[i] = vec[i - 1] - 1;
	//				}
	//				else if (vec[i + 1] > vec[i + 2])
	//				{
	//					vec[i] = 0;
	//				}
	//				else
	//				{
	//					if (vec[i + 1] >= vec[i - 1] - 1 || i + k - 1 >= n)
	//					{
	//						vec[i] = 0;
	//					}
	//					else
	//					{
	//						vec[i] = 0;
	//						for (int j = i + 1; j <= i + k - 1; ++j)
	//						{
	//							if (vec[j] < vec[j - 1])
	//							{
	//								vec[i] = 0;
	//								break;
	//							}

	//							if (vec[j] > vec[j - 1])
	//							{
	//								vec[i] = vec[i - 1] - 1;
	//								break;
	//							}
	//						}
	//					}
	//				}
	//			}
	//		}

	//		if (asc == -1)
	//		{
	//			if (i >= n - 2)
	//			{
	//				vec[i] = 100000;
	//			}
	//			else
	//			{
	//				if (vec[i + 1] > vec[i + 2])
	//				{
	//					vec[i] = vec[i - 1] - 1;
	//				}
	//				else if (vec[i + 1] < vec[i + 2])
	//				{
	//					vec[i] = 100000;
	//				}
	//				else
	//				{
	//					if (vec[i + 1] >= vec[i - 1] - 1 || i + k - 1 >= n)
	//					{
	//						vec[i] = 0;
	//					}
	//					else
	//					{
	//						vec[i] = 100000;
	//						for (int j = i + 1; j <= i + k - 1; ++j)
	//						{
	//							if (vec[j] > vec[j - 1])
	//							{
	//								vec[i] = 100000;
	//								break;
	//							}

	//							if (vec[j] > vec[j - 1])
	//							{
	//								vec[i] = vec[i - 1] + 1;
	//								break;
	//							}
	//						}
	//					}
	//				}
	//			}
	//		}

	//		if (asc == 0)
	//		{
	//			--i;
	//			if (i >= n - 2)
	//			{
	//				vec[i] = 100000;
	//			}
	//			else
	//			{
	//				if (vec[i + 1] > vec[i + 2])
	//				{
	//					vec[i] = 0;
	//				}
	//				else if (vec[i + 1] < vec[i + 2])
	//				{
	//					vec[i] = 100000;
	//				}
	//				else
	//				{
	//					if (i + k - 1 >= n)
	//					{
	//						vec[i] = 0;
	//					}
	//					else
	//					{
	//						vec[i] = 100000;
	//						for (int j = i + 1; j <= i + k - 1; ++j)
	//						{
	//							if (vec[j] > vec[j - 1])
	//							{
	//								vec[i] = 100000;
	//								break;
	//							}

	//							if (vec[j] > vec[j - 1])
	//							{
	//								vec[i] = 0;
	//								break;
	//							}
	//						}
	//					}
	//				}
	//			}
	//		}

	//		asc = 0;
	//		cnt = 1;
	//	}
	//}

	//cout << change_cnt << endl;
	//for (int i = 0; i < n; ++i)
	//{
	//	cout << vec[i] << ' ';
	//}
	//cout << endl;
}
/*
2
3 3 5 8
2 9 2
*/
