#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

//void print(vector<pair<int, int>>& vec)
//{
//	cout << "YES\n" << vec.size() << "\n";
//	for (auto& p : vec)
//	{
//		cout << p.first << " " << p.second << "\n";
//	}
//}

int main() {

	/*int n, k;
	cin >> n >> k;
	if (k >= n - 1)
	{
		cout << "NO\n";
		return 0;
	}
	vector<pair<int, int>> res;
	for (int i = 1; i < n; ++i) res.push_back({ i, i + 1 });
	res.push_back({ n, 1 });

	print(res);
	return 0;*/

	int n;
	cin >> n;
	vector<vector<int>> towers(n);
	towers.reserve(10005);
	int split = 0, combine = 0;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		towers[i].resize(k);
		for (int j = 0; j < k; ++j) {
			cin >> towers[i][j];
		}
	}
	int sz = towers.size();
	for (int i = 0; i < sz; ++i) {
		auto& tower = towers[i];
		for (int j = tower.size() - 1; j > 0; --j) {
			int t = j;
			while (t > 0 && tower[t] > tower[t - 1]) {
				--t;
			}
			if (t == 0) break;
			++split;
			towers.emplace_back(j - t + 1);
			for (int x = 0; x < j - t + 1; ++x) {
				towers.back()[x] = tower[t + x];
			}
			for (int x = 0; x < j - t + 1; ++x) {
				tower.pop_back();
			}
			j = t;
		}
	}
	vector<int> s;
	for (auto& tower : towers) {
		for (int elem : tower) {
			s.push_back(elem);
		}
	}
	sort(s.begin(), s.end());
	int arr_ind = 0;
	vector<int> ind(towers.size());
	combine += towers.size() - 1;
	for (int i = 0; i < s.size(); ++i) {
		for (int j = 0; j < towers.size(); ++j) {
			auto& tower = towers[j];
			if (ind[j] == tower.size()) continue;
			int t = ind[j];
			while (t < tower.size() && tower[t] == s[arr_ind]) {
				++t;
				++arr_ind;
			}
			if (t == ind[j]) {
				continue;
			}
			ind[j] = t;
			if (ind[j] == tower.size()) {
				continue;
			}
			++combine;
			++split;
		}
	}

	cout << split << ' ' << combine;
}

/*
4
4 1 2 4 3
8 5 10 11 6 8 7 14 9
1 13
2 12 15
*/

// 1492