#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <map>
#include <random>
#include <vector>
using namespace std;


using ll = long long;
using ull = unsigned long long;

void shuf(vector<pair<int, int> >& v)
{
	std::random_device rd;
	std::mt19937 g(rd());

	std::shuffle(v.begin(), v.end(), g);
}


void solve()
{
	int n; cin >> n;
	vector<pair<int, int> > v(n);
	vector<pair<int, int> > w(n);
	for (size_t i = 0; i < n; i++)
	{
		v[i].first = i + 1;
		w[i].first = i + 1;
		cin >> v[i].second;
	}

	if (n == 1)
	{
		cout << "Impossible\n";
		return;
	}
	if (n == 2 && v[0].second == 2)
	{
		cout << "Impossible\n";
		return;
	}
	/*if (n == 3)
	{
		if (v[0].second == 2 && v[1].second == 1)
		{
			cout << "Impossible\n";
			return;
		}
		if (v[0].second == 1 && v[1].second == 3)
		{
			cout << "Impossible\n";
			return;
		}
		if (v[0].second == 3 && v[1].second == 2)
		{
			cout << "Impossible\n";
			return;
		}
	}*/


	sort(v.begin(), v.end(), 
		[](pair<int, int> const& a, pair<int, int> const& b) {return a.second < b.second; });
	
	
	for (size_t i = 0; i < 80; i++)
	{
		shuf(w);
		bool fail = 0;

		for (size_t j = 0; j < n; j++)
		{
			if (w[j].first == j + 1 || w[j].first == v[j].first)
			{
				fail = 1;
				break;
			}
		}
		if (fail) continue;

		cout << "Possible\n";
		
		for (size_t j = 0; j < n; j++)
		{
			w[j].second = v[j].first;
			v[j].second = w[j].first;
		}
		sort(w.begin(), w.end()
			);
		for (size_t j = 0; j < n; j++)
		{
			cout << w[j].second << ' ';
		}
		cout << '\n';
		for (size_t j = 0; j < n; j++)
		{
			cout << v[j].second << ' ';
		}
		cout << '\n';
		return;
	}
	
	cout << "Impossible\n";
};


int main(int, char **) 
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _LOCAL_
	freopen("in.txt", "r", stdin);
#endif
	constexpr int mult = 0;
	int x = 1;
	if (mult) cin >> x;
	while (x --> 0) solve();
	return 0;
}