#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <map>
#include <random>
#include <vector>
using namespace std;


using ll = long long;
using ull = unsigned long long;

void shuf(vector<pair<int, int> >& v)
{
	std::random_device rd;
	std::mt19937 g(rd());

	std::shuffle(v.begin(), v.end(), g);
}


void solve()
{
	int n; cin >> n;
	vector<pair<int, int> > v(n);
	vector<pair<int, int> > w(n);
	for (size_t i = 0; i < n; i++)
	{
		v[i].first = i + 1;
		w[i].first = i + 1;
		cin >> v[i].second;
	}
	sort(v.begin(), v.end(), 
		[](pair<int, int> const& a, pair<int, int> const& b) {return a.second < b.second; });
	
	for (size_t i = 0; i < 1000; i++)
	{
		shuf(w);
		bool fail = 0;

		for (size_t j = 0; j < n; j++)
		{
			if (w[j].first == j + 1 || w[j].first == v[j].first)
			{
				fail = 1;
				break;
			}
		}
		if (fail) continue;

		cout << "Possible\n";
		auto xx = w;
		
		for (size_t j = 0; j < n; j++)
		{
			w[j].second = v[j].first;
		}
		sort(w.begin(), w.end()
			);
		for (size_t j = 0; j < n; j++)
		{
			cout << w[j].second << ' ';
		}
		cout << '\n';
		for (size_t j = 0; j < n; j++)
		{
			cout << xx[j].first << ' ';
		}
		cout << '\n';
		return;
	}
	if (n > 3) throw 0;
	cout << "Impossible\n";
};



int main(int, char **) 
{
#ifdef _LOCAL_
	freopen("in.txt", "r", stdin);
#endif
	constexpr int mult = 1;
	int x = 1;
	if (mult) cin >> x;
	while (x --> 0) solve();
	return 0;
}