#pragma optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;

mt19937 rng(time(0));

vector<int> apply(vector<int> a, vector<int> b)
{
    vector<int>res(a.size());
    for (int i = 0; i < a.size(); i++) {
        res[i] = a[b[i]];
    }
    return res;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(0);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n), b(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            a[i]--;
            b[i] = i;
        }
        int it = 0, lim = 5000;
        while (it < lim) {
            it += 1;
            shuffle(b.begin(), b.end(), rng);
            auto c = apply(a, b);
            int good = 1;
            for (int i = 0; i < n; i++) {
                if (b[i] == i || c[i] == i) {
                    good = 0;
                    break;
                }
            }
            if (!good) continue;
            vector<int> d(n);
            for (int i = 0; i < n; i++) {
                d[c[i]] = i;
            }
            c = apply(c, d);
            for (int i = 0; i < n; i++) assert(i == c[i]);
            cout << "Possible" << "\n";
            for (int x : b) cout << x + 1 << " ";
            cout << "\n";
            for (int x : d) cout << x + 1 << " ";
            cout << "\n";
            break;
        }
        if (it == lim) {
            cout << "Impossible\n";
        }
    }
}
