#pragma optimize("Ofast")

#include <bits/stdc++.h>

const int N = 1001;

using namespace std;

int n, k;

mt19937 rng(time(0));
int a[102][N];
int h[N];
int s[102][N];

int p[N][N];
bitset<N> d[N];
bitset<N> L[N];
bitset<N> R[N];
int res[N];

int solve(int l, int r)
{
    if (l == r){
        return a[1][l];
    }
    int m = p[l][r];
    res[solve(l, m - 1)] = a[1][m];
    res[solve(m + 1, r)] = a[1][m];
    return a[1][m];
}

int main() {
    #ifdef zxc
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    ios_base::sync_with_stdio(0);

    cin >> n >> k;

    for (int i = 0; i <= n + 1; i++) {
        h[i] = rng();
    }

    for (int i = 1; i <= k; i++) {
        for (int j = 1; j <= n; j++) {
            cin >> a[i][j];
            s[i][j] = s[i][j - 1] ^ h[a[i][j]];
        }
    }

    unordered_map<int, int> c;
    for (int len = 1; len <= n; len++) {
        c.clear();
        for (int i = 0, cur; i + len <= n; i++) {
            // i + 1, i + len
            cur = s[1][i + len] ^ s[1][i];
            c[cur] = 1;
        }
        for (int i = 0, cur; i + len <= n; i++) {
            // i + 1, i + len
            for (int j = 2; j <= k; j++) {
                cur = s[j][i + len] ^ s[j][i];
                if (c.find(cur) != c.end()) {
                    c[cur] += 1;
                }
            }
        }
        for (int i = 0, cur; i + len <= n; i++) {
            // i + 1, i + len
            cur = s[1][i + len] ^ s[1][i];
            if (c[cur] == k) {
                R[i + 1][i + len + 1] = 1;
                L[i + len][i] = 1;
                //cout << i + 1 << " " << i + len << endl;
            }
        }
    }
    bitset<N> bs;
    for (int i = n; i >= 1; i--) {
        for (int j = R[i]._Find_next(i + 1); j <= n + 1; j = R[i]._Find_next(j)) {
            // R[i] & L[j]
            bs = R[i] & L[j - 1];
            if (bs.count()) {
                p[i][j - 1] = bs._Find_first();
            } else {
                R[i][j] = 0;
                //L[j - 1][i - 1] = 0;
            }
        }
    }
    for (int i = 1; i <= n; i++) res[i] = -1;
    solve(1, n);
    for (int i = 1; i <= n; i++) {
        cout << res[i] << " ";
    }
}
