#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;
using li = long long;
using ld = long double;
using pii = pair<int, int>;

void solve()
{
    int n;
    cin >> n;

    vector <int> a(n);

    for(int i = 0; i < n; i++)
        cin >> a[i], a[i]--;

    if(n == 2 && a[0] == 1 && a[1] == 0)
    {
        cout << "Impossible\n";
        return;
    }

    vector <int> rp(n), ra(n), used(n);

    for(int i = 0; i < n; i++)
        ra[a[i]] = i;

    vector <int> v1, v2;

    for(int i = 0; i < n; i++)
    {
        int cur = i;
        int k = 0;

        while(used[cur] == 0)
        {
            used[cur] = 1;
            rp[cur] = ra[cur];
            k++;
            cur = a[cur];
        }

        for(int j = 0; j < k; j++)
        {
            used[cur] = k;
            cur = a[cur];
        }

        if(k == 1)
            v1.push_back(i);

        if(k == 2)
            v2.push_back(i);
    }

//    for(int i = 0; i < n; i++)
//        cout << rp[i] + 1 << ' ';
//
//    cout << endl;
//
//    for(int i = 0; i < n; i++)
//        cout << used[i] << ' ';
//
//    cout << endl;
//
//    cout << v1.size() << ' ' << v2.size() << endl;

    if(v2.size() >= 2)
    {
        for(int i = 1; i < v2.size(); i++)
            rp[v2[i - 1]] = v2[i];

        rp[v2.back()] = a[v2[0]];

        for(int i = 1; i < v2.size(); i++)
            rp[a[v2[i - 1]]] = a[v2[i]];

        rp[a[v2.back()]] = v2[0];
    }

    for(int i = 0; i < n; i++)
        used[i] = 0;

    for(int i = 0; i < n; i++)
    {
        int cur = i;
        int k = 0;

        while(used[cur] == 0)
        {
            used[cur] = 1;
            k++;
            cur = rp[cur];
        }

        for(int j = 0; j < k; j++)
        {
            used[cur] = k;
            cur = rp[cur];
        }
    }

    if(v1.size() == 1)
    {
        bool F = 0;

        for(int i = 0; i < n; i++)
            if(used[i] >= 3 && !F)
            {
                F = 1;
                rp[v1[0]] = rp[i];
                rp[i] = v1[0];
            }

        if(!F)
        {
            cout << "Impossible\n";
            return;
        }
    }
    else
    {
        for(int i = 0; i < v1.size(); i++)
            rp[v1[i]] = v1[(i + 1) % v1.size()];
    }

    for(int i = 0; i < n; i++)
        used[i] = 0;

    for(int i = 0; i < n; i++)
    {
        int cur = i;
        int k = 0;

        while(used[cur] == 0)
        {
            used[cur] = 1;
            k++;
            cur = rp[cur];
        }

        for(int j = 0; j < k; j++)
        {
            used[cur] = k;
            cur = rp[cur];
        }
    }

//    for(int i = 0; i < n; i++)
//        cout << used[i] << ' ';
//
//    cout << endl;

    if(v2.size() == 1)
    {
        bool F = 0;

        for(int i = 0; i < n; i++)
            if(i != v2[0] && i != a[v2[0]] && !F)
            {
                F = 1;

                int A = i, B = rp[i], C = rp[rp[i]];

                rp[v2[0]] = B;
                rp[B] = a[v2[0]];
                rp[a[v2[0]]] = C;
                rp[A] = v2[0];
            }
    }

    cout << "Possible\n";

//    for(int i = 0; i < n; i++)
//        cout << rp[i] + 1 << ' ';
//
//    cout << endl;

    for(int i = 0; i < n; i++)
        assert(rp[i] != i);

    vector <int> p(n), q(n);

    for(int i = 0; i < n; i++)
        p[rp[i]] = i;

    for(int i = 0; i < n; i++)
        q[i] = rp[ra[i]];

    for(int i = 0; i < n; i++)
        assert(a[p[q[i]]] == i);

    for(int i = 0; i < n; i++)
        cout << p[i] + 1 << ' ';

    cout << "\n";

    for(int i = 0; i < n; i++)
        cout << q[i] + 1 << ' ';

    cout << "\n";
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    cin >> t;

    while(t--)
        solve();
}
