#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using vi = vector<long long>;
#define int long long

#ifdef vstu
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x)
#endif // vstu

template<typename T>
ostream& operator<<(ostream& o, vector<T>& a){
    for(auto& el : a)
        o << el << " ";
    o << "\n";
    return o;
}

void fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

void solve(){
    int n; cin >> n;

    vi a(n + 1);
    vi obr(n + 1);
    for (int i = 1; i <= n; ++i){
        cin >> a[i];
        obr[a[i]] = i;
    }

    if (n == 2){
        if (a[1] == 1){
            cout << "Possible\n";
            cout << "2 1\n";
            cout << "2 1\n";
        }   else{
            cout << "Impossible\n";
        }
        return;
    }

    if (n == 1){
        cout << "Impossible\n";
        return;
    }

    vi p(n + 1), q(n + 1);

    set<int> good_p;
    for (int i = 1; i <= n; ++i){
        good_p.insert(i);
    }

    for (int i = 1; i <= n - 3; ++i){
        if (*good_p.rbegin() != i && a[*good_p.rbegin()] != i){
            p[i] = *good_p.rbegin();
            good_p.erase(*good_p.rbegin());
        }   else if (*good_p.begin() != i && a[*good_p.begin()]  != i){
            p[i] = *good_p.begin();
            good_p.erase(*good_p.begin());
        }   else{
            auto elem = good_p.begin();
            elem++;
            p[i] = *elem;
            good_p.erase(*elem);
        }
    }

    vi val(3);

    for (int i = 0; i <= 2; ++i){
        val[i] = *good_p.begin();
        good_p.erase(*good_p.begin());
    }

    for (int i1 = 0; i1 <= 2; ++i1){
        for (int i2 = 0; i2 <= 2; ++i2){
            if (i1 == i2){
                continue;
            }
            for (int i3 = 0; i3 <= 2; ++i3){
                if (i1 == i3 || i2 == i3){
                    continue;
                }

                if (n - 2 == val[i1] || n - 2 == a[val[i1]]){
                    continue;
                }

                if (n - 1 == val[i2] || n - 1 == a[val[i2]]){
                    continue;
                }

                if (n - 0 == val[i3] || n - 0 == a[val[i3]]){
                    continue;
                }

                p[n - 2] = val[i1];
                p[n - 1] = val[i2];
                p[n] = val[i3];
            }
        }
    }

    for (int i = 1; i <= n; ++i){
        if (p[i] == 0){
            cout << "Impossible\n";
            return;
        }
    }

    /*vector<pair<int, int>> vct;

    for (int i = 1; i <= n; ++i){
        vct.push_back({p[i], a[i]});
    }

    sort(vct.begin(), vct.end());

    for (int i = 0; i < n; ++i){
        q[i + 1] = vct[i].second;
    }*/
//    for (int i = 1; i <= n; ++i){
//        q[p[i]] = i;
//    }

    vector<ll> obr_p(n + 1);

    for(ll i = 1; i <= n; i++){
        obr_p[p[i]] = i;
    }

    for(ll i = 1; i <= n; i++){
        //cout << i <<" "<< obr[i] <<" "<<obr_p[obr[i]] <<"\n";
        q[i] = obr_p[obr[i]];
    }

    cout << "Possible\n";

    for (int i = 1; i <= n; ++i){
        cout << p[i] << " ";
    }
    cout << "\n";
    for (int i = 1; i <= n; ++i){
        cout << q[i] << " ";
    }
    cout << "\n";
}

signed main()
{
    #ifdef vstu
    //freopen("file.txt", "r", stdin);
    #endif // vstu
    fast();
    int t = 1;
    cin >> t;

    while(t--){
        solve();
    }


    return 0;
}
