#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using vi = vector<long long>;
#define int long long

#ifdef vstu
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x)
#endif // vstu

template<typename T>
ostream& operator<<(ostream& o, vector<T>& a){
    for(auto& el : a)
        o << el << " ";
    o << "\n";
    return o;
}

void fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

set<int> st;

int next_num(int val){
    if (st.upper_bound(val) == st.end()){
        return -1;
    }
    return *st.upper_bound(val);
}

void solve(){
    int n; cin >> n;
    dbg(n);

    int k1 = 0, k2 = n - 1;

    vector<vector<int>> vals(n);
    for (int i = 0; i < n; ++i){
        int k; cin >> k;
        dbg(k);
        vals[i].resize(k);
        for (int j = 0; j < k; ++j){
            dbg(i);
            cin >> vals[i][j];
            st.insert(vals[i][j]);
        }
    }

    for (int i = 0; i < n; ++i){
        for (int j = 1; j < vals[i].size(); ++j){
            dbg(k1);
            dbg(k2);
            if (next_num(vals[i][j - 1]) != vals[i][j]){
                k1++;
                k2++;
            }
        }
    }

    cout << k1 << " " << k2 << '\n';
}

signed main()
{
    #ifdef vstu
    freopen("file.txt", "r", stdin);
    #endif // vstu
    fast();
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }


    return 0;
}
