#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using vi = vector<long long>;
#define int long long

#ifdef vstu
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x)
#endif // vstu

template<typename T>
ostream& operator<<(ostream& o, vector<T>& a){
    for(auto& el : a)
        o << el << " ";
    o << "\n";
    return o;
}

void fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

void solve(){
    int n, a, b; cin >> n >> a >> b;

    if (n == 1){
        if (a == b) cout << "1\n"; else cout << "0\n";

        cout << a << ":" << b << "\n";
        return;
    }

    vector<pair<int, int>> res(n);

    int kol = 0;

    while (n > a + b){
        n--;
        kol++;
    }

    while(n > 2){
        if (a > 1){
            res[n - 1] = {1, 0};
            a--;
            n--;
        }   else{
            res[n - 1] = {0, 1};
            b--;
            n--;
        }
    }

    if (n == 2){
        if (b == 0){
            res[1] = {1, 0};
            a--;
        }
        else if (a == 0){
            res[1] = {0, b - 1};
            b = 1;
        }
        else{
            res[1] = {0, b};
            b = 0;
        }
        n--;
    }

    if (n == 1){
        res[0] = {a, b};
        n--;
    }

    cout << kol << "\n";
    for (auto elem: res){
        cout << elem.first << ":" << elem.second << "\n";
    }
    return;
}

signed main()
{
    #ifdef vstu
    freopen("file.txt", "r", stdin);
    #endif // vstu
    fast();
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }


    return 0;
}
