#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &x: a) {
        cin >> x;
    }
    set<int, greater<int>> s;
    vector<int> permutation(n);
    for (int i = 0; i < n; ++i) {
        s.insert(i + 1);
    }
    vector<int> on_delete;
    for (int i = 0; i < n; ++i) {
        on_delete.clear();
        if (s.find(i + 1) != s.end()) {
            s.erase(i + 1);
            on_delete.push_back(i + 1);
        }
        if (s.find(a[i]) != s.end()) {
            s.erase(a[i]);
            on_delete.push_back(a[i]);
        }
        auto jt = s.begin();
        if (jt == s.end()) {
            cout << "Impossible\n";
            return;
        }
        permutation[i] = *jt;
        s.erase(jt);
        for (auto x: on_delete) {
            s.insert(x);
        }
    }
    cout << "Possible\n";
    for (int i = 0; i < n; ++i) {
        cout << permutation[i] << ' ';
    }
    cout << '\n';

    for (int i = 0; i < n; ++i) {
        cout << permutation[i] << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
