#include <bits/stdc++.h>

#define pii pair<int,int>
#define int long long

using namespace std;

int32_t main() {
    int n, k;
    cin >> n >> k;
    if (k == 1) {
        if (n == 1) {
            cout << "YES\n0";
        } else if (n == 2) {
            cout << "YES\n1\n1 2";
        } else {
            cout << "YES\n";
            cout << n << '\n';
            for (int i = 0; i < n; i++) {
                cout << i + 1 << " " << (i + 1) % n + 1 << '\n';
            }
        }
        return 0;
    }
    vector<int> v(n);
    vector<vector<int>> g(n);
    set<pii, greater<>> order;
    vector<pii > edges;
    for (int i = 0; i < k; i++) {
        order.insert({i + 1, i});
        v[i] = i + 1;
    }
    for (int i = k; i < n; i++) {
        order.insert({-1, i});
        v[i] = -1;
    }
    vector<vector<int>> used(n, vector<int>(n));
    bool flag = true;
    for (int i = 0; i < k && flag; i++) {
        if (v[i] == 0) {
            continue;
        }
        order.erase({v[i], i});
        vector<int> to_add;
        while (v[i] && !order.empty()) {
            auto p = order.begin();
            int need = p->first;
            int index = p->second;
            order.erase(p);
            if (used[i][index]) {
                flag = false;
                break;
            }
            edges.push_back({i, index});
            used[i][index] = 1;
            used[index][i] = 1;
            g[i].push_back(index);
            g[index].push_back(i);
            v[i]--;
            v[index]--;
            to_add.push_back(index);
        }
        for (int index: to_add) {
            if (v[index]) {
                order.insert({v[index], index});
            }
        }
    }
    for (int i = k; i < n; i++) {
        if (v[i] == -1) {
            edges.push_back({k - 1, i});
            g[k - 1].push_back(i);
            g[i].push_back(k - 1);
        }
    }
    set<int> check;
    for (int i = 0; i < n; i++) {
        check.insert(g[i].size());
    }
    if (check.size() != k) {
        cout << "NO";
    } else {
        cout << "YES\n";
        cout << edges.size() << '\n';
        for (auto p: edges) {
            cout << p.first + 1 << " " << p.second + 1 << '\n';
        }
    }
}
