#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int sz[10000];
vector<vector<int>> a;
vector<int> res;

int find(int x) {
    if (res[0] == x)
        return 0;

    int le = 0, ri = res.size() - 1;
    while (ri - le > 1) {
        int mi = (le + ri) / 2;
        if (res[mi] < x)
            le = mi;
        else
            ri = mi;
    }

    return ri;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> sz[i];
        a[i].resize(sz[i]);
        for (int j = 0; j < sz[i]; ++j) {
            cin >> a[i][j];
            res.push_back(a[i][j]);
        }
    }

    int ans1 = 0;
    int gr = n;

    sort(res.begin(), res.end());
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < sz[i] - 1; ++j) {
            int it = find(a[i][j]);
            if (it == (int)res.size() - 1 || a[i][j + 1] != res[it + 1]) {
                ans1++;
                gr++;
            }
        }
    }

    cout << ans1 << ' ' << gr - 1 << '\n';
}
