import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class Main {
    public static void main(String[] args) {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        run();
        pw.close();

    }

    static ArrayList<Integer>[] graph;

    private static void run() {
        int n = nextInt();
        int k = nextInt();
        if (n == 1) {
            if (k == 1) {
                pw.println("YES");
                pw.println(0);
                return;
            } else {
                pw.println("NO");
                return;
            }
        }
        if (k == 1) {

            pw.println("YES");
            if (n == 2) {
                pw.println(1);
            } else {
                pw.println(n);
            }
            for (int i = 0; i < n - 1; i++) {
                pw.println((i + 1) + " " + ((i + 2)));
            }
            if (n > 2) {
                pw.println((n) + " " + (1));
            }
            return;
        }
        graph = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            graph[i] = new ArrayList<>();
        }
        int last = -1;
        int sum = 0;
        for (int i = 1; i <= k; i++) {
            int si = graph[i - 1].size();
            for (int j = si; j < i; j++) {
                if (i + j - si >= n) {
                    pw.println("NO");
                    return;
                }
                graph[i + j - si].add(i - 1);
                sum++;
                last = Math.max(last, i + j - si);
            }
        }
        for (int i = last + 1; i < n; i++) {
            graph[i].add(i - 1);
            sum++;
        }
        if (sum > n * (n - 1) / 2) {
            pw.println("NO");
            return;
        }
        pw.println("YES");
        pw.println(sum);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < graph[i].size(); j++) {
                pw.println((i + 1) + " " + (graph[i].get(j) + 1));
            }
        }
    }

    static PrintWriter pw;
    static StringTokenizer st;
    static BufferedReader br;

    static String nextToken() {
        try {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(br.readLine());
            }
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        return st.nextToken();
    }

    static int nextInt() {
        return Integer.parseInt(nextToken());
    }
}