#include <bits/stdc++.h>

/*
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt,tune=native")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("-O3")
/**/

using namespace std;

typedef long long int ll;
typedef unsigned long long int ull;
typedef long double ld;

#define pll pair<ll, ll>
#define f first
#define s second
#define x first
#define y second
#define all(a) a.begin(), a.end()

mt19937 gen(2281337);

ll n, m;

void solve() {
    cin >> n;
    vector<ll> a(n), pq(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        pq[a[i]] = i;
    }

    //cout << "debug" << endl;

    if (n == 2 && a[0] == 1 && a[1] == 0) {
        cout << "Impossible\n";
        return;
    }
    cout << "Possible\n";
    vector<ll> q(n), p(n);
    iota(q.begin(), q.end(), 0);

    while (true) {
        shuffle(q.begin(), q.end(), gen);
        for (int i = 0; i < n; ++i) {
            p[q[i]] = pq[i];
        }
        bool ok = true;
        for (int i = 0; i < n; ++i) {
            if (q[i] == i || p[i] == i) {
                ok = false;
                break;
            }
        }
        if (ok) {
            break;
        }
    }

    bool ok = true;
    for (int i = 0; i < n; ++i) {
        if (a[p[q[i]]] != i) {
            ok = false;
        }
    }


    for (int i = 0; i < n; ++i) {
        cout << p[i] + 1 << " ";
    }
    cout << "\n";
    for (int i = 0; i < n; ++i) {
        cout << q[i] + 1 << " ";
    }
    cout << "\n";
    //cout << (ok ? "ok" : "not ok") << endl;
}

void kek() {
    freopen("input.txt", "w", stdout);
    cout << "1\n";
    n = 1e5;
    cout << n << endl;
    vector<ll> v(n);
    iota(v.begin(), v.end(), 1);
    for (int i = 0; i < n; ++i) {
        cout << v[i] << " ";
    }
    cout << endl;
    exit(0);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    //kek();
    //freopen("input.txt", "r", stdin);

    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
