#include <bits/stdc++.h>

//*
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt,tune=native")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("-O3")
/**/

using namespace std;

typedef long long int ll;
typedef unsigned long long int ull;
typedef long double ld;

#define pll pair<ll, ll>
#define f first
#define s second
#define x first
#define y second
#define all(a) a.begin(), a.end()

ll n, m;

void solve() {
    cin >> m;
    vector<vector<ll>> v(m);
    vector<ll> vals;
    map<ll, ll> nev;
    for (int i = 0; i < m; ++i) {
        cin >> n;
        v[i].resize(n);
        for (int j = 0; j < n; ++j) {
            cin >> v[i][j];
            vals.push_back(v[i][j]);
        }
    }
    sort(vals.begin(), vals.end());
    for (int i = 0; i < vals.size(); ++i) {
        nev[vals[i]] = i;
    }
    for (int i = 0; i < m; ++i) {
        n = v[i].size();
        for (int j = 0; j < n; ++j) {
            v[i][j] = nev[v[i][j]];
        }
    }

    ll pieces = 0;
    ll cuts = 0;
    n = vals.size();

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < v[i].size(); ++j) {
            ++pieces;
            while (j + 1 < v[i].size() && v[i][j + 1] == v[i][j] + 1) {
                ++j;
            }
            if (j + 1 != v[i].size()) {
                ++cuts;
            }
        }
    }
    cout << cuts << " " << pieces - 1 << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
