#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <cstdlib>

using namespace std;

using ll = long long;

int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

#endif

	int q;
	cin >> q;

	while (q--)
	{
		int n;
		cin >> n;
		vector<int> a(n), ap(n);

		if (n == 1)
		{
			cout << "Impossible\n";
			continue;
		}

		for (int i = 0; i < n; ++i)
		{
			cin >> a[i];
			a[i]--;
			ap[a[i]] = i;
		}

		vector<set<int>> ql(n);

		for (int i = 0; i < n; ++i)
		{
			ql[i].insert(i);
			ql[i].insert(ap[i]);
		}

		set<int> svar;

		for (int i = 0; i < min(2, n); ++i)
		{
			svar.insert(i);
			svar.insert(n - 1 - i);
			svar.insert(ap[i]);
			svar.insert(ap[n - 1 - i]);
		}

		vector<int> arr(n);
		iota(arr.begin() + 1, arr.end(), 1);

		vector<int> var(svar.begin(), svar.end());

		vector<int> u(n);
		vector<int> q(n);
		bool ans = false;

		auto check = [&](int c)
		{
			set<int> pool(arr.begin(), arr.end());

			//if (c == 259)
			//{
			//	cout << ' ';
			//}

			int ind = n - 1;
			while (ind >= 0 && u[ind] == c)
			{
				if (ql[ind].find(q[ind]) != ql[ind].end() || pool.find(q[ind]) == pool.end())
					return;

				pool.erase(q[ind]);
				--ind;
			}

			for (int i = 0; i <= ind; ++i)
			{
				if (u[i] == c)
				{
					if (ql[i].find(q[i]) != ql[i].end() || pool.find(q[i]) == pool.end())
					{
						return;
					}
					pool.erase(q[i]);
					continue;
				}

				for (auto& j : pool)
				{
					if (ql[i].find(j) == ql[i].end())
					{
						q[i] = j;
						u[i] = c;
						pool.erase(j);
						break;
					}
				}
			}

			if (!pool.empty())
			{
				return;
			}

			ans = true;
		};

		//{
		//	q = {2, 0, -1, 4, 1};
		//	u = { 1, 1, 0, 1, 1 };
		//	check(1);
		//}

		int c = 0;
		for (int i = 0; i < var.size(); ++i)
		{
			for (int ii = 0; ii < var.size(); ++ii)
			{
				for (int iii = 0; iii < var.size(); ++iii)
				{
					for (int iiii = 0; iiii < var.size(); ++iiii)
					{
						if (ans)
						{
							continue;
						}

						c++;
						q[0] = i;
						q[1] = ii;
						q[n - 2] = iii;
						q[n - 1] = iiii;
						u[0] = c;
						u[1] = c;
						u[n - 2] = c;
						u[n - 1] = c;

						check(c);
					}
				}
			}
		}

		if (!ans)
		{
			cout << "Impossible\n";
			continue;
		}

		vector<int> p(n);
		for (int i = 0; i < n; ++i)
		{
			p[q[i]] = ap[i];
		}

		cout << "Possible\n";

		for (auto& i : p)
		{
			cout << i + 1 << ' ';
		}
		cout << '\n';
		for (auto& i : q)
		{
			cout << i + 1 << ' ';
		}
		cout << '\n';
	}

	return 0;
}