#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <cstdlib>

using namespace std;

using ll = long long;

int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

#endif

	int n;
	cin >> n;

	vector<vector<int>> towers(n);
	vector<int> nums;
	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;
		while (k--)
		{
			int x;
			cin >> x;
			towers[i].push_back(x);
			nums.push_back(x);
		}
	}
	sort(nums.begin(), nums.end());

	for (int i = 0; i < n; i++)
	{
		for (auto& vals : towers[i])
		{
			vals = lower_bound(nums.begin(), nums.end(), vals) - nums.begin();
		}
	}

	int cnt = n;
	int splits = 0;
	for (auto& tower : towers)
	{
		for (int i = 0; i + 1 < tower.size(); i++)
		{
			if (tower[i] + 1 != tower[i + 1])
			{
				cnt++;
				splits++;
			}
		}
	}
	
	cout << splits << " " << cnt - 1;

	return 0;
}