#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <cstdlib>

using namespace std;

using ll = long long;

int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

#endif

	int n, a, b;
	cin >> n >> a >> b;
	vector<vector<int>> res(n, vector<int>(2));

	{
		res[0][0] = a;
		res[n - 1][1] = b;
		for (int i = 0; i < n; i++)
		{
			if (res[0][0] > 1 && res[i][0] == 0 && res[i][1] == 0)
			{
				res[0][0]--;
				res[i][0]++;
			}
		}
		for (int i = n - 1; i >= 0; i--)
		{
			if (res[n - 1][1] > 1 && res[i][0] == 0 && res[i][1] == 0)
			{
				res[n - 1][1]--;
				res[i][1]++;
			}
		}
	}
	int ans = 0;
	for (auto& match : res)
	{
		if (match[0] == match[1])
			ans++;
	}
	cout << ans << "\n";
	for (auto& match : res)
	{
		cout << match[0] << ":" << match[1] << "\n";
	}

	return 0;
}