#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <cstdlib>

using namespace std;

using ll = long long;

int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

#endif

	int n, k;
	cin >> n >> k;

	int posible = (n + 1) / 2;
	if (posible < k) {
		cout << "NO";
		return 0;
	}

	vector<vector<int>> g(n, vector<int>(n, 1));
	for (int i = 0; i < n; i++)
	{
		g[i][i] = 0;
	}

	int steps = 1;
	int last_i = n - 1;
	while (steps < k)
	{
		for (int i = 0, j = last_i; i < n && j < n; i++, j++)
			g[i][j] = 0;
		for (int i = last_i, j = 0; i < n && j < n; i++, j++)
			g[i][j] = 0;
		steps++;
		last_i--;
	}

	int cnt = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < i; j++)
		{
			cnt += g[i][j];
		}
	}

	//for (int i = 0; i < n; i++)
	//{
	//	int c = 0;
	//	for (int j = 0; j < n; j++)
	//	{
	//		c += g[i][j];
	//	}
	//	cout << c << " ";
	//}
	//cout << "\n";

	cout << "YES\n";
	cout << cnt << "\n";
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < i; j++)
		{
			if (g[i][j]) {
				cout << i + 1 << " " << j + 1 << "\n";
			}
		}
	}

	return 0;
}