#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <cstdlib>
#include <random>
#include <utility>

using namespace std;

using ll = long long;

int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

#endif

	int n, k;
	cin >> n >> k;

	if (n == 1)
	{
		if (k == 1)
		{
			cout << "YES\n0";
		}
		else
		{
			cout << "NO\n";
		}
		return 0;
	}

	if (n == k)
	{
		cout << "NO";
		return 0;
	}

	vector<vector<int>> g(n + 1, vector<int>(n + 1, 0));
	for (int i = n; i > 0; i--)
	{
		for (int j = n; j > n - i; j--)
		{
			if (i == j) 
				continue;
			g[i][j] = 1;
			g[j][i] = 1;
		}
	}

	int steps = n - 1;
	int over = steps - k;
	for (int i = 1; i <= over + 1; i++)
	{
		for (int j = 1; j <= over + 1; j++)
		{
			if (i == j)
				continue;
			g[i][j] = 1;
			g[j][i] = 1;
		}
	}

	//for (int i = 1; i <= n; i++)
	//{
	//	for (int j = 1; j <= n; j++)
	//	{
	//		cout << g[i][j] << " ";
	//	}
	//	cout << "\n";
	//}

	cout << "YES\n";
	int sum = 0;
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j < i; j++)
		{
			sum += g[i][j];
		}
	}
	cout << sum << "\n";
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j < i; j++)
		{
			if (g[i][j])
				cout << i << " " << j << "\n";
		}
	}

	return 0;
}