#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define f first
#define s second
#define all(x) (x).begin(), (x).end()
using namespace std;

void solve(){
    int n;
    cin >> n;
    set<int>st;
    vector<int>pos(n + 1);
    for(int i = 1; i <= n; i++){
        int x;
        cin >> x;
        pos[x] = i;
        st.insert(i);
    }
    if(n < 3){
        cout << "Impossible\n";
        return;
    }
    vector<int>q(n + 1), p(n + 1);
    for(int i = 1; i + 3 <= n; i++) {
        for(auto it = st.begin(); it != st.end(); it++){
            if(*it == pos[i] || *it == i) continue;
            q[i] = *it;
            st.erase(it);
            break;
        }
    }
    vector<int>b(all(st));
    do{
        int ok = 1;
        for(int i = n - 2; i <= n; i++){
            ok &= (b[i - (n - 2)] != i) && (b[i - (n - 2)] != pos[i]);
        }
        if(ok){
            for(int i = n - 2; i <= n; i++){
                q[i] = b[i - (n - 2)];
            }
            break;
        }
    } while(next_permutation(all(b)));
    for(int i = 1; i <= n; i++){
        p[q[i]] = pos[i];
    }
    cout << "Possible\n";
    for(int i = 1; i <= n; i++) cout << p[i] << ' ';
    cout << '\n';
    for(int i = 1; i <= n; i++) cout << q[i] << ' ';
    cout << '\n';
    for(int i = 1; i <= n; i++){
        assert(p[q[i]] == pos[i]);
        assert(p[i] != i);
        assert(q[i] != i);
    }
}

int32_t main() {
   ios_base::sync_with_stdio(0);
   cin.tie(0);
   int t;
   cin >> t;
   while(t--){
       solve();
   }
}
