#include <bits/stdc++.h>
using namespace std;

const char nl = '\n';

vector<int> inverted(vector<int> &vec) {
    vector<int> result(vec.size());

    for (int i = 0; i < vec.size(); i++) {
        result[vec[i]] = i;
    }

    return result;
}

void solve()
{
    int n;
    cin >> n;

    vector<int> permutation(n);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;

        permutation[i] = x-1;
    }

    vector<int> answer(n), result(n);

    for (int i = 0; i < n; i++) {
        answer[i] = result[i] = i;
    }

    if (n >= 3) {
        int a = 0, b = 1, c = 2;
        while (true) {
            //cout << a << ' ' << b << ' ' << c << nl;
            if (permutation[a] == answer[a] || answer[a] == result[a]) {
                if (permutation[a] == answer[b] || answer[b] == result[a])
                    swap(answer[a], answer[c]);
                else
                    swap(answer[a], answer[b]);
            }


            a = b;
            b = c;

            if (c + 1 < n) c++;
            else break;

            while (c + 1 < n && !(permutation[c] == answer[c] || answer[c] == result[c])) //   
                c++;

            if (!(permutation[c] == answer[c] || answer[c] == result[c]) || b == c) //    
                break;
        }
        //cout << a << ' ' << b << nl;
        if ((permutation[a] == answer[b] || answer[b] == result[a]) && (permutation[b] == answer[a] || answer[a] == result[b])) { //  
            if (n == 3) {
                cout << "Impossible" << nl;
                return;
            }
            else {
                swap(answer[0], answer[a]);
                swap(answer[1], answer[b]);
            }
        }
        else {
            swap(answer[a], answer[b]);

            if (permutation[a] == answer[a] || answer[a] == result[a])
                swap(answer[0], answer[a]);
            else if (permutation[b] == answer[b] || answer[b] == result[b])
                swap(answer[0], answer[b]);
        }

        cout << "Possible" << nl;

        //DEBUG
        //==================================
//        cout << "DEBUG" << nl;
//        for (auto element : permutation) cout << element;
//        cout << nl;
//        for (auto element : answer) cout << element;
//        cout << nl;
//        for (auto element : result) cout << element;
//        cout << nl;
//        for (auto element : inverted(answer)) cout << element;
//        cout << nl;
//        cout << "DEBUG ENDS" << nl;
        //==================================

        auto temp = inverted(answer);
        for (int i = 0; i < n; i++) {
            cout << temp[permutation[i]] + 1 << ' ';
        }
        cout << nl;
        temp = inverted(result);
        for (int i = 0; i < n; i++) {
            cout << temp[answer[i]] + 1 << ' ';
        }
        cout << nl;
    }
    else if (n == 2) {
        if (permutation[0] == 0) {
            cout << "Possible" << nl;
            cout << "2 1\n2 1\n";
            return;
        }
        else {
            cout << "Impossible" << nl;
            return;
        }
    }
    else {
        cout << "Impossible" << nl;
        return;
    }
}

int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    cout << fixed << setprecision(20);
    int t = 1;
    cin >> t;
    while(t--)
        solve();
}
