#include <bits/stdc++.h>
using namespace std;

const char nl = '\n';

void solve()
{
    int n;
    cin >> n;

    int split = 0;
    int combine = n - 1;


    vector<vector<int>> towers(n);
    vector<int> all_numbers;

    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;

        towers[i].resize(k);

        for (int j = 0; j < k; j++) {
            cin >> towers[i][j];
            all_numbers.push_back(towers[i][j]);
        }
    }

    sort(all_numbers.begin(), all_numbers.end());

    for (int i = 0; i < n; i++) {
        int last = -1;

        for (int j = 0; j < towers[i].size(); j++) {
            int current = lower_bound(all_numbers.begin(), all_numbers.end(), towers[i][j]) - all_numbers.begin();
            //cout << last << ' ' << current << nl;

            if (last + 1 != current && last != -1) {
                split++;
                combine++;
            }

            last = current;
        }
    }

    cout << split << ' ' << combine << nl;
}

int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    cout << fixed << setprecision(20);
    int t = 1;
    //cin >> t;
    while(t--)
        solve();
}
