#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

int main() {

    int t; cin >> t;

    for (int _ = 0; _ < t; ++_) {
        int n; cin >> n;
        vector<int> a(n);
        vector<int> q(n);
        vector<int> p(n);
        vector<int> prob(n);
        map<int, int> mp;
        bool kek = false;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            a[i]--;
            q[i] = i;
            mp[a[i]] = i;
        }

        if (n == 1 || n == 2 && a[0] == 1 && a[1] == 0) {
            cout << "Impossible\n";
            continue;
        }

        set<int> s;
        for (int i = 0; i < n; ++i) {
            prob[i] = mp[i];
            s.insert(i + 1);
        }

        cout << "\n";
        for (int i = 0; i < n; ++i) {
            if (prob[i] > i) {
                s.erase(prob[i] - i);
            } else {
                s.erase(n - prob[i] + 1);
            }
        }

        int beg = *s.begin();
        for (int i = 0; i < n; ++i) {
            int f = i + beg;
            if (i + beg >= n) {
                f -= (n);
            }
//            if (i == f)
//                kek = true;
            q[i] = f;
            p[q[i]] = prob[i];
        }

        if (kek) {
            cout << "Impossible\n";
            continue;
        }

        cout << "Possible\n";
        for (int i = 0; i < n; ++i) {
            cout << p[i] + 1 << " ";
        }
        cout << "\n";
        for (int i = 0; i < n; ++i) {
            cout << q[i] + 1 << " ";
        }
        cout << "\n";
    }

    return 0;
}
