#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

int main() {

    int n;  cin >> n;

    vector<int> sorted;
    vector<vector<int>> towers;
    map<int, int> mp;

    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        vector<int> kek(k);
        for (int j = 0; j < k; ++j) {
            int t; cin >> t;
            kek[j] = t;
            sorted.push_back(t);
        }

        towers.push_back(kek);
    }

    sort(sorted.begin(), sorted.end());

    for (int i = 0; i < sorted.size(); ++i) {
        mp[sorted[i]] = i + 1;
    }

    int col = n;

    for (int i = 0; i < towers.size(); ++i) {
        for (int j = 0; j < towers[i].size() - 1; ++j) {
            if (mp[towers[i][j]] +1 != mp[towers[i][j + 1]])
                col++;
        }
    }

    cout << col - n << " " << col - 1;

    return 0;
}
