import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class H {
    static BufferedReader br;
    static PrintWriter pw;
    static StringTokenizer st;

    static String nextToken() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return st.nextToken();
    }

    static int nextInt() {
        return Integer.parseInt(nextToken());
    }

    static long nextLong() {
        return Long.parseLong(nextToken());
    }

    static String nextLine() {
        try {
            return br.readLine();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    static char next() {
        try {
            return (char) br.read();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    public static void main(String[] args) {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        int t = 1;
        for (int i = 0; i < t; i++) {
            solve();
        }
        pw.close();
    }

    private static void solve() {
        pri(0, 0);
        scan();
        pri(0, 0);
        kluch = scan();
        find(0, razmer, 0, razmer);
    }

    static int razmer = 1_000_000;
    static String kluch;
    static int count = 0;

    private static void find(int xLeft, int xRight, int yLeft, int yRight) {
        if (xLeft == xRight || yLeft == yRight) {
            for (int i = xLeft; i <=xRight ; i++) {
                for (int j = yLeft; j <=yRight ; j++) {
                    pri(i, j);
                    scan();
                }
            }
            return;
        }

        int x1 = (xRight + xLeft) / 2;
        int x2 = x1 + 1;
        int y1 = (yRight + yLeft) / 2;
        int y2 = y1 + 1;
        pri(x1, y1);
        String s1 = scan();
        String s2 = null;
        if (x2 <= xRight && y2 <= yRight) {
            pri(x2, y2);
            s2 = scan();
        }
        if (s2 != null) {
            if (s2.equals(kluch)) {
                find(xLeft, x1, y2, yRight);
                find(x2, xRight, yLeft, y1);
            } else {
                find(xLeft, x1, yLeft, y1);
                find(x2, xRight, y2, yRight);
            }
        }
    }

    private static String scan() {
        String s1 = nextLine();
        if (s1.charAt(s1.length() - 1) == '!') {
            System.exit(0);
        }
        return s1;
    }

    private static void pri(int x, int y) {
        if (count == 64) {
            throw new RuntimeException();
        }
        pw.printf("%d %d\n", x, y);
        pw.flush();
        count++;
    }
}