#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define all(v) v.begin(), v.end()

void solve()
{
	int n;
	cin >> n;
	vector<vector<int>> towers(n);
	vector<int> numsAll;
	for (int i = 0; i < n; i++)
	{
		int ni;
		cin >> ni;
		towers[i] = vector<int>(ni);
		for (int j = 0; j < ni; j++)
		{
			cin >> towers[i][j];
			numsAll.push_back(towers[i][j]);
		}
	}

	sort(all(numsAll));

	int splits = 0;
	for (int i = 0; i < n; i++)
	{
		auto it = lower_bound(all(numsAll), towers[i][0]);
		for (int j = 1; j < towers[i].size(); j++)
		{
			it++;
			if (it == numsAll.end() || towers[i][j] != *it)
			{
				splits++;
				it = lower_bound(all(numsAll), towers[i][j]);
			}
		}
	}

	cout << splits << ' ' << splits + n - 1;
}

int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(false);
#ifdef _DEBUG
	FILE* fin;
	freopen_s(&fin, "../input.txt", "r", stdin);
#endif
	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
		cout << '\n';
	}
}
