#pragma GCC optimize ("ofast")
#pragma GCC optimize ("unroll-loops")

#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <stack>
#include <queue>
#include <bitset>
#include <list>
#include <fstream>
#include <ctime>

#define vll vector<ll>
using ll = long long;
using LL = long long;
#define forn(i,n) for(ll i = 0;i< n; i++)

using namespace std;


void solve() {
	ll n; cin >> n;

	vector<vector<ll>> mat(n);

	vll v;

	forn(i, n) {
		ll t; cin >> t;
		forn(j, t) {
			ll z; cin >> z;
			mat[i].push_back(z);

			v.push_back(z);
		}

		reverse(mat[i].begin(), mat[i].end());
	}
	sort(v.rbegin(), v.rend());

	map<ll, ll> zap;

	forn(i, v.size()-1)
	{
		zap[v[i]] = v[i + 1];
	}

	zap[v[v.size() - 1]] = 0;

	ll kolBad = 0;

	forn(i, n)
	{
		forn(j, mat[i].size() - 1)
		{
			if (zap[mat[i][j]] != mat[i][j + 1])
			{
				kolBad++;
			}
		}
	}

	cout << kolBad << " " << n + kolBad - 1 << "\n";

}

int main() {

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 

	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(2);

	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}

	return 0;
}