#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef set<ll> si;

void calc(vi& v, si& nums, ll& spt, ll& mrg)
{
	ll n = v.size();

	for (int i = 0; i + 1 < n; i++)
	{
		if (v[i + 1] < v[i])
		{
			spt++;
			mrg++;
		}
		else
		{
			auto num = nums.lower_bound(v[i]);
			num++;
			if (*num != v[i + 1])
			{
				spt++;
				mrg++;
			}
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	ll n;
	cin >> n;
	vvi towers(n);
	si nums;

	for (int i = 0; i < n; i++)
	{
		ll k;
		cin >> k;
		towers[i] = vi(k);
		for (int j = 0; j < k; j++)
		{
			cin >> towers[i][j];
			nums.insert(towers[i][j]);
		}
	}

	ll spt = 0, mrg = n - 1;

	for (int i = 0; i < n; i++)
	{
		calc(towers[i], nums, spt, mrg);
	}

	cout << spt << ' ' << mrg;

	return 0;
}