#include <iostream>
#include <vector>

int main() {
    int n, a, b;
    std::cin >> n >> a >> b;

    std::vector<std::pair<int, int>> result(n);
    int first_i = -1;
    int second_i = -1;
    int draw_i = -1;
    for (int i = 0; i < n; ++i) {
        if (a >= b && a > 0) {
            result[i] = {1, 0};
            first_i = i;
            a--;
        } else if (b > a && b > 0) {
            result[i] = {0, 1};
            second_i = i;
            b--;
        } else {
            draw_i = i;
        }
    }

    if (n == 1 || a == b || std::abs(a - b) > 1) {
        result[0].first += a;
        result[0].second += b;
    } else if (a > b) {
        if (first_i >= 0) {
            result[first_i].first += a;
            result[first_i].second += b;
        } else if (draw_i >= 0) {
            result[draw_i].first += a;
            result[draw_i].second += b;
        } else {
            if (a == 1) {
                result[0].second--;
                result[1].second++;
                result[0].first++;
            } else {
                result[0].first += a;
                result[1].second += b;
            }
        }
    } else {
        if (second_i >= 0) {
            result[second_i].first += a;
            result[second_i].second += b;
        } else if (draw_i >= 0) {
            result[draw_i].first += a;
            result[draw_i].second += b;
        } else {
            if (b == 1) {
                result[0].first--;
                result[1].first++;
                result[0].second++;
            } else {
                result[0].first += a;
                result[1].second += b;
            }
        }
    }

    int count = 0;
    for (int i = 0; i < result.size(); ++i) {
        if (result[i].first == result[i].second) {
            count++;
        }
    }

    std::cout << count << "\n";
    for (int i = 0; i < result.size(); ++i) {
        std::cout << result[i].first << ":" << result[i].second << "\n";
    }

    return 0;
}
