#include <iostream>
#include <vector>

int main() {
    std::ios_base::sync_with_stdio(false);
    int32_t n, k;
    std::cin >> n >> k;
    if (k == 1 and n == 1) {
        std::cout << "YES" << std::endl;
        std::cout << 0 << std::endl;
        return 0;
    }
    if (k >= n) {
        std::cout << "NO" << std::endl;
        return 0;
    }
    std::vector<std::vector<int32_t>> graph(n);
    int32_t start_n;
    int32_t start_k;
    if (k % 2 == 0) {
        start_n = n - k + 2;
        start_k = 2;
    } else {
        start_n = n - k + 1;
        start_k = 1;
    }
    std::vector<std::pair<int32_t, int32_t>> ans;
    if (start_k == 1 and start_n > 2) {
        for (int32_t i = 0; i < start_n; i++) {
            ans.emplace_back(i, (i + 1) % start_n);
        }
    } else {
        for (int32_t i = 1; i < start_n; i++) {
            ans.emplace_back(0, i);
        }
    }
    for (int32_t u = start_n + 2; u <= n; u += 2) {
        ans.emplace_back(u - 1, u - 2);
        for (int32_t i = u - 3; i >= 0; i--) {
            ans.emplace_back(u - 2, i);
        }
    }
    std::cout << "YES" << std::endl;
    std::cout << ans.size() << std::endl;
    for (const auto &an: ans) {
        std::cout << an.first + 1 << " " << an.second + 1 << "\n";
    }
    return 0;
}
