#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <random>

using namespace std;

#define int long long
#define fi first
#define se second


void solve() {
	int n;
	cin >> n;
	int a = 0, b = 0;
	set<pair<int, int>> x;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		vector<int> q(k);

		for (int j = 0; j < k; ++j) cin >> q[j];

		int j = 0;
		int blocks = 0;
		while (j < k)
		{
			int f = q[j];
			j++;
			while (j < k && q[j] > q[j - 1]) {
				j++;
			}
			blocks++;
			x.insert(make_pair( f, q[j - 1] ));
		}
		a += blocks - 1;
	}
	while (x.size() >1) {
		auto f = *(x.begin());
		x.erase(x.begin());
		auto s = *(x.begin());
		x.erase(x.begin());
		if (f.fi < s.fi && s.se < f.se) {
			x.insert(make_pair(min(f.fi, s.fi), max(f.se, s.se)));
			a += 1, b += 2;
			continue;
		}
		if (f.se < s.fi) {
			x.insert(make_pair( min(f.fi, s.fi), max(f.se, s.se)));
			b++;
		}
		else {
			x.insert(make_pair(min(f.fi, s.fi), max(f.se, s.se)));
			a += 2, b += 3;
		}
	}
	cout << a << ' ' << b << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(nullptr);

	int tt = 1;
	while (tt--) solve();

}