#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("sse4.2")

#include <bits/stdc++.h>
using namespace std;

void initIO() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(12);
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

using graph = vector<vector<int>>;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define f first
#define s second
#define F first
#define S second

const int mod = 1000000007;
const ld eps = 1e-9;
const ll inf = 3000000000000000007ll;

template<class T> inline int sz(const T &x) { return x.size(); }

template<class T> void read(T &x) {
    cin >> x;
}
template<class T> void print(const T &x) {
    cout << x;
}
void println() { cout << '\n'; }

template<class T, class ...U> void read(T &x, U&... u) {
    read(x);
    read(u...);
}

template<class T, class ...U> void print(const T &x, const U&... u) {
    print(x);
    print(u...);
}

template<class T, class ...U> void println(const T &x, const U&... u) {
    print(x);
    println(u...);
}

template<class T, class U> inline bool chmin(T &x, const U &y) { return y < x ? x = y, 1 : 0; }
template<class T, class U> inline bool chmax(T &x, const U &y) { return y < x ? x = y, 1 : 0; }
template<class T> inline void sort(T &x) { sort(all(x)); }
template<class T> inline void reverse(T &x) { reverse(all(x)); }

#ifdef DEBUG
    string pdbg(const string &x) {
        return "\"" + x + "\"";
    }
    template<class T> string pdbg(const T&x) {
        return to_string(x);
    }
    template<class T> string dbgout(const T &x) {
        return pdbg(x);
    }
    template<class T, class ...U> string dbgout(const T &x, const U&... u) {
        return pdbg(x) + ", " + dbgout(u...);
    }
    #define dbg(...) println("[", #__VA_ARGS__, "] = ", dbgout(__VA_ARGS__)), cout << flush
#else
    #define dbg(...) 0
#endif

int n, k;
vector<int> p;
vector<vector<int>> f, pos;

bool viv = false;

void work(vector<pii> segs, int par) {
    if (viv) {
        cout << "work, par = " << par << " segs[0] = " << segs[0].F << ' ' << segs[0].S << endl;
        cout << "work, par = " << par << " segs[1] = " << segs[1].F << ' ' << segs[1].S << endl;
    }
    vector<int> var;
    for (int i = segs[0].F; i < segs[0].S; i++) {
        var.push_back(f[0][i]);
    }
    if (var.size() == 0) {
        return;
    }
    if (var.size() == 1) {
        p[var[0]] = par;
        return;
    }

    vector<int> can(var.size());
    iota(can.begin(), can.end(), 0);
    vector<set<int>> ss(var.size());

    for (int i = 0; i < k; i++) {
        vector<int> can2;
        for (auto pl : can) {
            int v = var[pl];
            int loc_pos = pos[i][v];
            ss[pl].insert(loc_pos - segs[i].F);
            if (ss[pl].size() <= 2) {
                can2.push_back(pl);
            }
        }
        can = can2;
    }
    // assert(can.size() >= 1);
    // assert(can.size() <= 3);

    // for (auto pl : can)

    set<int> sv;
    for (auto i : can)
        sv.insert(var[i]);

    int mid = -1;
    for (auto i : can) {
        if (ss[i].size() == 1)
            mid = var[i];
    }

    if (viv)
        cout << "NICE " << mid << endl; 

    if (mid == -1) {
        // cout << can.size()
        dbg(sz(can));
        if (can.size() == 2) {
            vector<int> mx(3, -1);
            vector<int> ord_0;
            int p = 0;
            for (int i = segs[0].F; i < segs[0].S; i++)
                if (sv.count(f[0][i])) {
                    ord_0.push_back(f[0][i]);
                    p++;
                } else {
                    mx[p] = max(mx[p], f[0][i]);
                }

            set<int> ss;
            for (auto i : ord_0)
                ss.insert(i);
            for (auto i : mx)
                ss.insert(i);
            bool have_1 = ss.count(-1) != 0;

            if (have_1) {
                for (int i = segs[0].F + 1; i < segs[0].S - 1; i++)
                    if (sv.count(f[0][i]))
                        mid = f[0][i];
            }

            map<int, set<int>> gg;
            if (mid == -1) {
                for (int i = 0; i < k; i++) {
                    vector<pii> lord;
                    for (auto val : ss) {
                        lord.push_back({pos[i][val], val});
                    }
                    sort(lord.begin(), lord.end());
                    assert(lord.size() == 5);
                    vector<int> l;
                    for (auto i : lord)
                        l.push_back(i.S);
                    gg[l[1]].insert(l[0]);
                    gg[l[1]].insert(l[2]);
                    gg[l[3]].insert(l[2]);
                    gg[l[3]].insert(l[4]);
                }
                if (viv) {
                    cout << "gg = ";
                    for (auto p : gg)
                        cout << p.F << ": " << p.S.size() << "; ";
                    cout << endl;
                }
                assert(gg.size() == 2);
                for (auto p : gg) {
                    if (p.S.size() == 3)
                        mid = p.F;
                }
            }
        } else {
            if (can.size() == 3) {
                vector<int> lord;
                for (int i = segs[0].F; i < segs[0].S; i++)
                    if (sv.count(f[0][i]))
                        lord.push_back(f[0][i]);
                assert(lord.size() == 3);
                mid = lord[1];
            } else {
                mid = var[can[0]];
            }
        }
    }

    if (viv)
       cout << "\tget mid = " << mid << endl;

    vector<pii> segsl, segsr;

    int pos_0 = pos[0][mid];
    int lf = pos_0 == segs[0].F ? -1 : f[0][pos_0 - 1];
    int rf = pos_0 + 1 == segs[0].S ? -1 : f[0][pos_0 + 1];

    for (int i = 0; i < k; i++) {
        int l1 = segs[i].F;
        int r2 = segs[i].S;
        int m = pos[i][mid];
        int r1 = m;
        int l2 = m + 1;
        if (i == 0) {
            dbg(l1, r1, l2, r2);
        }
        if (lf != -1) {
            if (pos[i][lf] < m) {
                segsl.push_back({l1, r1});
                segsr.push_back({l2, r2});
            } else {
                segsr.push_back({l1, r1});
                segsl.push_back({l2, r2});
            }
        } else {
            if (pos[i][rf] < m) {
                segsr.push_back({l1, r1});
                segsl.push_back({l2, r2});
            } else {
                segsl.push_back({l1, r1});
                segsr.push_back({l2, r2});
            }
        }
    }    

    p[mid] = par;

    work(segsl, mid);
    work(segsr, mid);
}

void solve() {
    cin >> n >> k;
    f.resize(k);
    pos.resize(k);
    for (auto &l : f) {
        l.resize(n);
        for (auto &i : l)
            cin >> i, i--; 
    }

    for (int i = 0; i < k; i++) {
        pos[i].resize(n);
        for (int j = 0; j < n; j++) {
            pos[i][f[i][j]] = j;
        }
    }


    p.resize(n);

    vector<pii> segs(k, {0, n});
    work(segs, -2);

    for (auto i : p)
        cout << i + 1 << ' ';
    cout << '\n';
}


signed main() {
    initIO();

    solve();

    #ifdef DEBUG
        cerr << "Runtime is: " << fixed << setprecision(5) << clock() * 1.0 /  CLOCKS_PER_SEC << endl;
    #endif
}