#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("sse4.2")

#include <bits/stdc++.h>
using namespace std;

void initIO() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

signed main() {
    initIO();
    
    int n;
    cin >> n;

    int s = 0;
    int c = 0;

    unordered_map<int, int> nxt;
    vector<vector<int>> v(n);
    vector<int> a;

    for (int i = 0; i < n; ++i) {
        int m;
        cin >> m;
        v[i].resize(m);

        for (int j = 0; j < m; ++j) {
            cin >> v[i][j];
            a.push_back(v[i][j]);
        }
    }

    sort(a.begin(), a.end());
    for (int i = 0; i < int(a.size()) - 1; ++i) {
        nxt[a[i]] = a[i + 1];
    }
    nxt[a[int(a.size()) - 1]] = -1;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < int(v[i].size()) - 1; ++j) {
            if (v[i][j + 1] != nxt[v[i][j]]) {
                s++;
            }
        }
    }

    c = n - 1 + s;
    cout << s << ' ' << c << endl;

    #ifdef DEBUG
        cerr << "Runtime is: " << fixed << setprecision(5) << clock() * 1.0 /  CLOCKS_PER_SEC << endl;
    #endif
}