#include <bits/stdc++.h>

using namespace std;

#define int long long

const bool MULTI_TEST = true;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& x : a) {
        cin >> x;
        x--;
    }
    vector<bool> b(n);
    vector<vector<int>> cycles;
    for (int i = 0; i < n; ++i) {
        if (!b[i]) {
            vector<int> cur_cycle;
            int j = i;
            while(!b[j]) {
                cur_cycle.push_back(j);
                b[j] = true;
                j = a[j];
            }
            cycles.push_back(cur_cycle);
        }
    }
    sort(cycles.begin(), cycles.end(), [](vector<int>& a, vector<int>& b) -> bool {
        return a.size() < b.size();
    });
    int count1 = 0, count2 = 0, countany = 0;
    for (auto& cycle : cycles) {
        if (cycle.size() == 1) {
            count1++;
        } else if (cycle.size() == 2) {
            count2++;
        } else {
            countany++;
        }
    }
    if (count1 <= 1 && count2 <= 1 && countany == 0) {
        cout << "Impossible" << endl;
        return;
    }
    cout << "Possible" << endl;
    vector<int> q(n), p(n);

    for (int i = 0; i < n; ++i) { // mix all
        q[i] = a[i];
    }

//    for (int i = 1; i < cycles.size(); ++i) {
//        q[cycles[i - 1][cycles[i - 1].size() - 1]] = q[cycles[i][0]];
//    }
//    q[cycles[cycles.size() - 1][cycles[n - 1].size() - 1]] = q[cycles[0][0]];

    auto mix_all_ones = [&](int start = 0) {
        if (cycles[start].size() != 1) {
            return;
        }
        for (int i = start + 1; i <= n; ++i) {
            if (i == n || cycles[i].size() != 1) {
                q[cycles[i - 1][0]] = cycles[start][0];
                break;
            }
            q[cycles[i - 1][0]] = cycles[i][0];
        }
    };

    if (count1 > 1 && count2 == 1) {
        if (count2 == 1) {
            if (count1 > 1) {
                int twos_pos = 0;
                while (cycles[twos_pos].size() == 1) {
                    twos_pos++;
                }
                if (twos_pos == 3) {
                    q[cycles[0][0]] = cycles[twos_pos][1];
                    q[cycles[1][0]] = cycles[twos_pos][0];
                    q[cycles[2][0]] = cycles[0][0];
                    q[cycles[twos_pos][0]] = cycles[1][0];
                    q[cycles[twos_pos][1]] = cycles[2][0];
                } else {
                    mix_all_ones(2);
                    q[cycles[0][0]] = cycles[twos_pos][0];
                    q[cycles[1][0]] = cycles[twos_pos][1];
                    q[cycles[twos_pos][0]] = cycles[0][0];
                    q[cycles[twos_pos][1]] = cycles[1][0];
                }
            }
        }
    } else {
        int cur_size = 0;
        int last = 0;
        while (cur_size < cycles[cycles.size() - 1].size()) {
            for (int i = last; i < cycles.size() - 1; ++i) {
                q[cycles[i][cur_size]] = cycles[i + 1][cur_size];
            }
            cur_size++;
            while (last < cycles.size() && cycles[last].size() <= cur_size) {
                last++;
            }
            if (last != cycles.size())
                q[cycles[cycles.size() - 1][cur_size]] = cycles[last][cur_size + 1];
            else {
                q[cycles[cycles.size() - 1][cur_size - 1]] = cycles[0][0];
            }
        }
    }



    for (int i = 0; i < n; ++i) {
        p[a[q[i]]] = i;
    }
    for (auto x : p) {
        cout << x + 1 << " ";
    }
    cout << endl;
    for (auto x : q) {
        cout << x + 1 << " ";
    }
    cout << endl;
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    if (MULTI_TEST) {
        cin >> t;
    }

    while (t--) {
        solve();
    }

    return 0;
}