#include <bits/stdc++.h>

using namespace std;

#define int long long

const bool MULTI_TEST = false;

void solve() {
    int n;
    cin >> n;
    set<int> all_digits;
    unordered_map<int, int> alias;
    vector<vector<int>> digits(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0, x; j < k; j++) {
            cin >> x;
            digits[i].push_back(x);
            all_digits.insert(x);
        }
    }
    {
        int i = 0;
        for (int x : all_digits) {
            alias[x] = i++;
        }
    }
    int s = 0, c = n - 1;
    for (int i = 0; i < n; i++) {
        for (int j = 1; j < digits[i].size(); j++) {
            if (alias[digits[i][j]] != alias[digits[i][j - 1]] + 1) {
                s++;
                c++;
            }
        }
    }
    cout << s << ' ' << c << endl;
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    if (MULTI_TEST) {
        cin >> t;
    }

    while (t--) {
        solve();
    }

    return 0;
}