#include <bits/stdc++.h>

using namespace std;

#define int long long

const bool MULTI_TEST = false;

void solve() {
    int n, k;
    cin >> n >> k;
    if (k == 1) {
        cout << "YES\n";
        if (n == 1) {
            cout << 0;
            return;
        }
        if (n == 2) {
            cout << 1 << '\n';
            cout << 1 << ' ' << 2 << '\n';
            return;
        }
        cout << n << '\n';
        for (int i = 0; i < n; i++) {
            cout << (i + 1) << ' ' << ((i + 1) % n + 1) << '\n';
        }
        return;
    }
    if (k >= n) {
        cout << "NO";
        return;
    }

    vector<pair<int, int>> edges;
    edges.emplace_back(0, 1);
    vector<pair<int, int>> tree = {{0, 1}, {1, 1}};
    for (int i = 1; i < k; i++) {
        int nv = tree.size();
        int j = tree.size() - 1;
        while (tree[j].second != tree[j - 1].second) {
            edges.emplace_back(nv, tree[j].first);
            tree[j].second++;
            j--;
        }
        tree[j].second++;
        edges.emplace_back(nv, tree[j].first);
        tree.emplace_back(nv, tree.size() - j);
        sort(tree.begin(), tree.end(), [&](const pair<int, int> &i, const pair<int, int> &j) {
            return i.second < j.second;
        });
//        for (auto p : tree) {
//            cout << p.first << ' ' << p.second << endl;
//        }
//        cout << endl;
    }
    if (n > k + 1) {
//        for (auto p : tree) {
//            cout << p.first << ' ' << p.second << endl;
//        }
        edges.emplace_back(0, k + 1);
        for (int i = k + 1; i < n - 1; i++) {
            edges.emplace_back(i, i + 1);
        }
    }
    cout << "YES\n";
    cout << edges.size() << '\n';
    for (auto &p : edges) {
        cout << p.first + 1 << ' ' << p.second + 1 << '\n';
    }
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    if (MULTI_TEST) {
        cin >> t;
    }

    while (t--) {
        solve();
    }

    return 0;
}