
#include <iostream>
#include <vector>
#include <string>
#include <unordered_set>
#include <unordered_map>

#define ll long long

using namespace std;

int main()
{
	long n, k;
	cin >> n >> k;

	if (n <= k)
	{
		cout << "NO\n";
		return 0;
	}

	cout << "YES\n";

	if (n == 2)
	{
		cout << 1 << "\n";
		cout << "1 2\n";
		return 0;
	}

	if (k == 1)
	{
		cout << n << "\n";
		for (long i = 1; i <= n - 1; i++)
		{
			cout << i << " " << i + 1 << "\n";
		}
		cout << n << " " << 1 << "\n";

		return 0;
	}

	vector<vector<bool>> v(n, vector<bool>(n, 0));
	unordered_map<long, long> sizes;
	unordered_map<long, long> toSize;

	for (long i = 1; i < n; i++)
	{
		v[i][0] = 1;
		v[0][i] = 1;
	}

	toSize[0] = n - 1;
	for (long i = 1; i < n; i++) toSize[i] = 1;

	sizes[1] = n - 1;
	sizes[n - 1] = 1;

	long cur = 1;
	long next = 0;
	long maxSize = n - 2;
	long curSize = 1;

	long totalSum = 2;

	while (1)
	{
		if (totalSum == k) break;

		if (cur == next)
		{
			next++;
			continue;
		}

		if (v[cur][next] == 0)
		{
			v[cur][next] = 1;
			v[next][cur] = 1;

			sizes[toSize[cur]]--;
			if (sizes[toSize[cur]] == 0) totalSum--;
			sizes[toSize[next]]--;
			if (sizes[toSize[next]] == 0) totalSum--;

			toSize[cur]++;
			toSize[next]++;

			if (sizes[toSize[cur]] == 0) totalSum++;
			sizes[toSize[cur]]++;
			if (sizes[toSize[next]] == 0) totalSum++;
			sizes[toSize[next]]++;

			next++;
			curSize++;
		}
		else
		{
			next++;
		}

		if (curSize == maxSize)
		{
			next = 0;
			cur++;
			curSize = 0;
			maxSize--;
			for (long i = 0; i < n; i++) if (v[cur][i] == 1) curSize++;
		}

		if (totalSum == k) break;
	}

	vector<pair<long, long>> res;
	unordered_map<long, unordered_set<long>> was;

	for (long i = 0; i < n; i++)
	{
		for (long j = 0; j < n; j++)
		{
			if (v[i][j] == 1)
			{
				if (was[i].find(j) == was[i].end() && was[j].find(i) == was[j].end())
				{
					was[i].insert(j);
					was[j].insert(i);
					res.push_back({ i + 1,j + 1 });
				}
			}
		}
	}

	cout << res.size() << "\n";
	for (long i = 0; i < res.size(); i++)
	{
		cout << res[i].first << " " << res[i].second << "\n";
	}

	return 0;
}