#include <bits/stdc++.h>
#define fr first
#define  sc second
#define ll long long
#define pb push_back
const double eps = 1e-7;
const double  pi = acos(-1.0);
#define all(x) x.begin(), x.end()
using namespace std;


const int N = 2e5 + 10;
int p[N], q[N], a[N];
int pos[N];
int n;
void rnd(){
    n = 100;
    vector <int> p(n);
    iota(all(p), 1);
    random_shuffle(all(p));
    for (int i = 1; i <= n; i++) a[i] = p[i - 1];
    for (int i = 1; i <= n; i++) pos[a[i]] = i;
//    cout << "PRINT " << n << endl;
//    for (int i = 1; i <= n; i++) cout << a[i] << " ";
//    cout << endl;
//    cout << endl;
}
void read(){
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pos[a[i]] = i;
    }
}
vector<int> edges[N];
int used[N];
vector<int> vt1, vt2;

void dfs(int v, int h) {
    //cout << v << " " << h << endl;
    used[v] = 1;
    if (h == 0) {
        vt1.push_back(v);
    } else {
        vt2.push_back(v);
    }
    for (int u : edges[v]) {
        if (!used[u]) {
            dfs(u, h^1);
        }
    }
}

int posq[N];
int bad[N];

void solver() {
    if (n == 1) {
        cout << "Impossible\n"; return;
    }
    if (n == 2) {
        if (a[1] == 2 && a[2] == 1) {
            cout << "Impossible\n"; return;
        }
        cout << "Possible\n";
        cout << "2 1\n";
        cout << "2 1\n";
        return;
    }
    for (int v = 1; v <= n*2; v++) {
        edges[v].clear();
    }
    for (int v = 1; v <= n; v++) {
        edges[v].push_back(v+n);
        edges[v + n].push_back(v);
        if (pos[v] != v) {
            //cout << "add edge " << v << " " << pos[v] + n << endl;
            edges[v].push_back(pos[v]+n);
            edges[pos[v] + n].push_back(v);
        }
    }
    fill(used + 1, used + 1 + 2*n, 0);
    int mxlen = 0;
    vector<int> VT1, VT2;

    fill(bad, bad + n, 0);
    bad[0] = 1;
    for (int s = 1; s <= n; s++) {
        vt1.clear(); vt2.clear();
        if (!used[s]) {
            dfs(s, 0);
            mxlen = max(mxlen, int(vt1.size()));
            int len = vt1.size();
            if (len >= 2) {
                bad[n-1] = 1;
                bad[len-1] = 1;
            }
            for (auto x : vt1) VT1.push_back(x);
            for (auto x : vt2) VT2.push_back(x);
        }
    }
    for (int shift = 0; shift < n; shift++) {
        if (bad[shift]) continue;
        for (int i = 0; i < n; i++) {
            int ni = (i + shift) % n;
            q[VT1[i]] = VT2[ni] - n;
            posq[q[VT1[i]]] = VT1[i];
        }
        for (int i = 1; i <= n; i++) {
            int v = q[i];
            p[v] = pos[i];
        }
        for (int i = 1; i <= n; i++) {
            assert(p[i] != i);
            assert(q[i] != i);
        }
        cout << "Possible\n";
        for (int i = 1; i <= n; i++) {
            cout << p[i] << " ";
        } cout << endl;
        for (int i = 1; i <= n; i++) {
            cout << q[i] << " ";
        } cout << endl;
        return;
    }
    cout << "Impossible\n";
}

void solve(){
    //rnd();
    read();
    solver();
}

int main() {
    ios::sync_with_stdio(NULL), cin.tie(0), cout.tie(0);
    cout.setf(ios::fixed), cout.precision(20);
    //freopen("C:/work/untitled/in.txt", "r", stdin);
    int step = 1;
    cin >> step;
    for (int i = 1; i <= step; i++){
        solve();
    }
    return 0;
}
