#include <bits/stdc++.h>
#define int long long
#define mod 1000000007
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using namespace std;

bool check(vector<int> &a, deque<int> &q, vector<int> &p) {
    bool m = true;
    for (int i=0; i<a.size(); i++) {
        if (p[i] == i + 1 || q[i] == i + 1) return false;
        if (a[p[q[i] - 1] - 1] != i + 1) return false;
    }

    return m;
}

void solveA() {
    int n;
    cin >> n;
    map<int, int> A;
    vector<int> D;
    deque<int> B(n);
    for (int i=0, x; i<n; i++) {
        cin >> x;
        A[x] = i + 1;
        D.emplace_back(x);
        B[i] = i + 1;
    }
    vector<int> myTest = {4, 5, 1, 2, 3};

    vector<int> C(n);
    bool ans = false;
    for (int i=1; i<=n; i++) {
        int last = B.back();
        B.pop_back();
        B.emplace_front(last);
        for (int j = 1; j<=n; j++) {
            C[B[j - 1] - 1] = A[j];
        }

//        bool flag = true;
//        for (int i=0; i<B.size(); i++) {
//            if (B[i] != myTest[i]) flag = false;
//        }

//        if (flag) {
//            cout << "C: \n";
//            for (int i=0; i<C.size(); i++) {
//                cout << C[i] << " ";
//            }
//            cout << "\n";
//        }

        if (check(D, B, C)) { ans = true; break; }
    }

    if (ans) {
        cout << "Possible\n";
        for (int i=0; i<n; i++) {
            cout << C[i] << " ";
        }
        cout << '\n';
        for (int i=0; i<n; i++) {
            cout << B[i] << " ";
        }
        cout << '\n';
    } else {
        cout << "Impossible\n";
    }
}

void testA() {
    int n;
    cin >> n;
    vector<int> A(n), C(n), ans;
    deque<int> B(n);
    vector<int> myTest = {5, 1, 4, 2, 3};
    for (int i =1; i <=n; i++) {
        A[i - 1] = i;
        B[i - 1] = i;
        C[i - 1] = i;
    }

    int ind = 1;
    do {
        bool ok = false;

        do {
          do {
              if (check(A, B, C)) {
                  cout << "A: \n";
                  for (int i=0; i<A.size(); i++) {
                      cout << A[i] << " ";
                  }
                  cout << '\n';
                  cout << "B: \n";
                  for (int i=0; i<B.size(); i++) {
                      cout << B[i] << " ";
                  }

                  cout << "\n";
                  for (int i=0; i<B.size(); i++) {
                      cout << C[i] << " ";
                  }
                  cout << '\n';
                  ok = true;
              }
          } while(next_permutation(C.begin(), C.end()));
        } while(next_permutation(B.begin(), B.end()));
        ind ++;
        ans.emplace_back(ok);
    } while (next_permutation(A.begin(), A.end()));

    for (int i=0; i<ans.size(); i++) cout << ans[i] << " ";
}

void solveL() {
    int a, k;
    cin >> a >> k;
    vector<int> A(a);
    for (int i=0; i<a; i++) {
        cin >> A[i];
    }

    vector< pair< pair<int, int>, int> > range;
    for (int i=0; i<a; i++) {
        int l = i, r = i;
        int incr = -1;
        for (int j = i + 1; j < a; j++) {
            if (incr == -1 && A[j] != A[l]) {
                if (A[j] > A[l]) incr = 1;
                else incr = 0;
            }

            if (incr && A[j] >= A[j - 1]) r = j;
            else if (!incr && A[j] <= A[j - 1]) r = j;
            else break;
        }

        range.emplace_back(make_pair(make_pair(l, r), incr));
        i = r;
    }


    int ans = 0;
    for (int i=0; i<range.size(); i++) {
        int r = range[i].first.second, l = range[i].first.first;
//        cout << l << r << '\n';
        if (r - l + 1 >= k) {
            int cnt = 1;
            for (int j = l + 1; j < A.size(); j++) {
                cnt ++;

                if (cnt == k) {
                    if (A[j - 1] == A[l]) {
                        if (A[j] != A[l]) {
                            if (range[i].second == 1) {
                                A[j - 1] = 0;
                            } else {
                                A[j - 1] = 100000;
                            }
                            ans++;
                        } else {
                            if (range[i].second == 1) {
                                A[j - 1] = 0;
                                A[j] = 100000;
                            } else {
                                A[j - 1] = 100000;
                                A[j] = 0;
                            }
                            ans += 2;
                        }
                        cnt = 1;
                    } else {
                        if (A[j] > A[l]) {
                            A[j] = 0;
                        } else {
                            A[j] = 100000;
                        }
                        ans++;
                        cnt = 1;
                    }
                }
            }
        }
    }

    cout << ans << '\n';
    for (int i=0; i<A.size(); i++) {
        int val = A[i];

        cout << val << " ";
    }
}

void solveK() {
    int n, k;
    cin >> n >> k;
    if (n == k) {
        cout << "NO\n";
        return;
    }

    if (k == 1) {
        cout << "YES\n" << n << "\n";
        for (int i=0; i<n-1; i++) {
            cout << i + 1 << " " << i + 2 << '\n';
        }
        cout << n << " " << 1 << '\n';
    } else {
        int cnt = n - 1 + (k - 2);
        vector<pair<int, int>> vec;

        for (int i=2; i<=n; i++) {
            vec.emplace_back(make_pair(1, i));
//            cout << 1 << " " << i << '\n';
        }

        int temp = k - 2;
        for (int j=0; j<k-2; j++) {
            for (int i=0; i<temp; i++) {
                vec.emplace_back(make_pair(j+3, i+j+3+1));
//                cout << j + 3 << " " << i + j + 3+ 1 << '\n';
            }
            temp-=2;
            if (temp <= 0) break;
        }
        cout << "YES\n" << vec.size() << "\n";
        for (int i=0; i<vec.size(); i++) {
            cout << vec[i].first << " " << vec[i].second << "\n";
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--)
        solveK();
}