#include<bits/stdc++.h>

#define ll long long

using namespace std;

struct triple {
    int x, y, z;
};

bool operator<(const triple &a, const triple &b) {
    if ( a.x != b.x ) {
        return a.x < b.x;
    }
    if ( a.y != b.y ) {
        return a.y < b.y;
    }
    return a.z < b.z;
}

int main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, k;
    cin >> n >> k;

    vector< vector<int> > v(k, vector< int > (n));

    for (int i = 0; i < k; i++) {
        for (int j = 0; j < n; j++) {
            cin >> v[i][j];
            v[i][j]--;
        }
    }

    vector< int > res(n, -2);

    for (int step = 0; step < (n - 1) / 2; step++) {

        set< triple > s;
        for (int j = 0; j < int( v[0].size() ) - 2; j++) {
            triple tmp = { v[0][j], v[0][j + 1], v[0][j + 2] };
            if (tmp.x > tmp.z) {
                swap(tmp.x, tmp.z);
            }

            s.insert(tmp);
        }

        for (int i = 1; i < k; i++) {
            set< triple > sec;

            for (int j = 0; j < int(v[i].size()) - 2; j++) {
                triple tmp = { v[i][j], v[i][j + 1], v[i][j + 2] };
                if (tmp.x > tmp.z) {
                    swap(tmp.x, tmp.z);
                }

                sec.insert(tmp);
            }

            set< triple > intersect;
            for (const triple &tr : s) {
                if ( sec.count(tr) ) {
                    intersect.insert(tr);
                }
            }

            swap(s, intersect);
        }

        triple now = *(s.begin());
        res[ now.x ] = now.y;
        res[ now.z ] = now.y;

//        cout << now.x + 1 << " " << now.y + 1 << " " << now.z + 1 << endl;

        for (int i = 0; i < k; i++) {
            for (int j = 0; j < int(v[i].size()) - 2; j++) {

                if ( v[i][j] == now.x  && v[i][j + 2] == now.z || v[i][j] == now.z && v[i][j + 2] == now.x ) {
                    v[i].erase( v[i].begin() + j + 2 );
                    v[i].erase( v[i].begin() + j );
                    break;
                }

            }
        }

//        for (int i = 0; i < k; i++) {
//            for (int j = 0; j < int(v[i].size()); j++) {
//                cout << v[i][j] + 1 << " ";
//            }
//            cout << endl;
//        }
//        return 0;
    }

    for (int i : res) {
        cout << i + 1 << " ";
    }
}
