#include <bits/stdc++.h>
#define ll long long
#define ff first
#define ss second
using namespace std;

const int MAX = 100000;

int N;
int A[MAX];
int Pos[MAX];
int P[MAX], Q[MAX];

void solve()
{
    cin >> N;

    for (int i = 0; i < N; ++i)
    {
        cin >> A[i];
        Pos[A[i] - 1] = i;
    }

    set <pair<int, int>> s;
    for (int i = 0; i < N; ++i)
    {
        if (i == A[i] - 1)
        {
            s.insert({0, i});
        }
        else
        {
            s.insert({1, i});
        }
    }

    queue <pair<int,int>> q;

    for (int i = 0; i < N; ++i)
    {
        //cout << i << ":\n";
        while (i == s.begin()->ss || s.begin()->ss == Pos[i])
        {
            //cout << s.begin()->ff << " " << s.begin()->ss << "\n";
            q.push(*s.begin());
            s.erase(s.begin());
            if (s.empty())
            {
                cout << "Impossible";
                return;
            }
        }
        int t = s.begin()->ss;
        P[i] = t;
        Q[t] = Pos[i];
        s.erase(s.begin());

        t = i;

        while (!q.empty())
        {
            s.insert(q.front());
            q.pop();
        }
        if (s.find({0, t}) != s.end())
        {
            s.erase(s.find({0, t}));
            s.insert({1, t});
        }
    }

    for (int i = 0; i < N; ++i)
    {
        if (P[i] == i || Q[i] == i)
        {
            cout << "Impossible";
            return;
        }
    }
    cout << "Possible\n";
    for (int i = 0; i < N; ++i)
    {
        cout << Q[i] + 1 << " ";
    }
    cout << "\n";
    for (int i = 0; i < N; ++i)
    {
        cout << P[i] + 1 << " ";
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t; cin >> t;
    while (t--)
    {
        solve();
        cout << "\n";
    }

}

/*
4
2
2 1
3
1 2 3
4
2 1 4 3
5
5 1 4 2 3

1
5
5 1 4 2 3

1
3
1 2 3

1
2
1 2
*/
















