#include<algorithm>
#include <iostream>
#include <vector>
#pragma comment(linker, "/STACK:99999")
using namespace std;

class Cont {
public:
	void main() {
		int n; cin >> n;
		vector<vector<int>>bashni(n);
		vector<int>srtd;
		for (int i = 0; i < n; i++) {
			int sz; cin >> sz;
			int k = srtd.size();
			srtd.resize(srtd.size() + sz);
			bashni[i].resize(sz);
			for (int j = 0; j < sz; ++j) {
				cin >> bashni[i][j];
				srtd[k + j] = bashni[i][j];
			}
		}
		sort(srtd.begin(), srtd.end());
		int splt_count = 0;
		for (int i = 0; i < n; i++) {
			for (int j = bashni[i].size() - 1; j > 0; j--) {
				int l = 0; int r = srtd.size();
				while (l<r-1)
				{
					int mid = (l + r) / 2;
					if (srtd[mid] > bashni[i][j]) {
						r = mid;
					}
					else {
						l = mid;
					}
				}
				// l;
				if (l == 0) {
					splt_count++;
					continue;
				}
				if (bashni[i][j - 1] != srtd[l - 1])splt_count++;
			}	
		}
		cout << splt_count<<" "<<n+splt_count-1;
	}
};


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef RED
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	int t;
	cin >> t;
	while (t--) {
#endif
		Cont cont;
		cont.main();
#ifdef RED
		cout << endl << endl;
	}
#endif
}