
#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#pragma comment(linker, "/STACK:536870912")
using namespace std;

class Cont {
public:
	void main() {
		int n, k;
		cin >> n >> k;
		if (n == k) {
			if (n == 1) cout << "YES\n0";
			else cout << "NO";
			return;
		}
		cout << "YES\n";
		if (k == 1) {
			cout << n << "\n";
			for (int i = 1; i <= n; ++i) cout << i << " " << i % n + 1 << "\n";
			return;
		}
		set <int> s;
		s.insert(1);
		int count = 0;
		int step = 0;
		int i = 0;
		vector <vector <int>> v(n, vector <int>(n, 0));

		while (s.size() != k) {
			if (step) {
				v[i][v[i].size() - 1 - i] = 1;
				v[v[i].size() - 1 - i][i] = 1;
				s.insert(i + 1);
				++count;
			}
			else {
				for (int j = i; j < v[i].size(); ++j) {
					v[i][j] = 1;
					v[j][i] = 1;
				}
				++i;
				count += v[i].size() - i;
				s.insert(v[i].size() - i);
			}
			step ^= 1;
		}

		cout << count << "\n";
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				if (v[i][j] == 1) {
					cout << i + 1 << " " << j + 1 << "\n";
				}
			}
		}
	}
};


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef RED
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	int t;
	cin >> t;
	while (t--) {
#endif
		Cont cont;
		cont.main();
#ifdef RED
		cout << endl << endl;
	}
#endif
}