#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

bool check(string &s) {
    return s[s.length() - 1] == '!';
}

int main() {
    string garbage;
    int n = 1000000;

    cout<<0<<" "<<0<<endl;
    cin>>garbage;
    if(check(garbage)) return 0;

    string a00to10, a10to01, a01to00;
    cout<<1<<" "<<0<<endl;
    cin>>a00to10;
    if(check(a00to10)) return 0;
    cout<<0<<" "<<1<<endl;
    cin>>a10to01;
    if(check(a10to01)) return 0;
    cout<<0<<" "<<0<<endl;
    cin>>a01to00;


    if (a00to10 != a01to00) {

        string closer = a00to10;
        string further = a01to00;

        int l = 0;
        int r = n;
        int u = n;
        int d = 0;



        while (l < r && d < u) {
            cout<<l<<" "<<u<<endl;
            string cur;
            cin>>cur;
            if(check(cur)) {
                return 0;
            }
            string cur1;
            cout<<r<<" "<<u<<endl;
            cin>>cur1;
            if (check(cur1)) {
                return 0;
            }
            if (cur == closer) {
                d = (u + d) / 2 + 1;
            } else if (cur == further) {
                u = (u + d) / 2 ;
            } else {
                d = (u + d) / 2;
                u =d;
            }

            if (cur1 == closer) {
                l = (l + r) / 2 + 1;
            } else if (cur1 == further) {
                r = (l + r) / 2;
            } else {
                l = (l + r) / 2;
                r = (l + r) / 2;
            }
            cout<<l<<" "<<d<<endl;
            cin>>cur;
            if(check(cur)) {
                return 0;
            }
        }

        while (l < r) {
            cout<<r<<" "<<d<<endl;
            string cur;
            cin>>cur;
            if (check(cur)) {
                return 0;
            }
            if (cur == closer) {
                l = (l + r) / 2 + 1;
            } else if (cur == further) {
                r = (r + l) / 2;
            } else {
                l = (l + r) / 2;
                r = l;
            }
            cout<<l<<" "<<d<<endl;
            cin>>cur;
            if (check(cur)) return 0;
        }

        while (d < u) {
            cout<<l<<" "<<u<<endl;
            string cur;
            cin>>cur;
            if (check(cur)) return 0;
            if (cur == closer) {
                d = (d + u) / 2 + 1;
            } else if (cur == further) {
                u = (d + u) / 2;
            } else {
                d = (d + u) / 2;
                u = d;
            }
            cout<<l<<" "<<d<<endl;
            cin>>cur;
            if (check(cur)) return 0;
        }

        cout<<l<<" "<<d<<endl;
        cin>>garbage;
        if(check(garbage)) return 0;

       // return 1; //hmm


    } else {

        cout<<n<<" "<<n<<endl;
        string a00to11;
        cin>>a00to11;
        if(check(a00to11)) {
            return 0;
        }

        if (a00to11 != a00to10 && a00to11 != a10to01) {
            cout<<n<<" "<<0<<endl;
            cin>>garbage;
            if (check(garbage)) return 0;
            cout<<0<<" "<<n<<endl;
            cin>>garbage;
            return 0;
        }

        string closer = a00to10 == a00to11 ? a10to01 : a00to10;
        string further = a00to11;
        cout<<0<<" "<<0<<endl;
        cin>>garbage;


        if (a00to10 == further) {
            int x = 0;
            int d = 0;
            int u = n;
            while (d < u) {
                cout<<x<<" "<<u<<endl;
                string cur;
                cin>>cur;

                if (cur == closer) {
                    d = (u + d) / 2 + 1;
                } else if (cur == further) {
                    u = (u + d) / 2;
                } else {
                    d = (u + d) / 2;
                    u = d;
                }
                cout<<x<<" "<<d<<endl;
                cin>>cur;
                if (check(cur)) {
                    return 0;
                }
            }
            cout<<x<<" "<<d<<endl;
            cin>>garbage;
            return 0;
        } else {
            int y = 0;
            int l = 0;
            int r = n;
            while (l < r) {
                cout << l << " " << y << endl;
                string cur;
                cin >> cur;
                if (cur == closer) {
                    l = (l + r) / 2 + 1;
                } else if (cur == further) {
                    r = (l + r) / 2;
                } else {
                    l = (l + r) / 2;
                    r = l;
                }
                cout << l << " " << y << endl;
                cin >> cur;
                if (check(cur)) {
                    return 0;
                }
            }
            cout<<l<<" "<<y<<endl;
            cin>>garbage;
            return 0;
        }

    }



    return 0;
}