#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

bool check(string &s) {
    return s[s.length() - 1] == '!';
}

int main() {
    string garbage;
    string a00to10;
    string a10toa00;
    string a90toa80;

    int n = 1000000;

    cout<<0<<" "<<0<<endl;
    cin>>garbage;
    if (check(garbage)) {
        return 0;
    }

    cout<<1<<" "<<0<<endl;
    cin>>a00to10;
    if (check(a00to10)) {
        return 0;
    }
    cout<<0<<" "<<0<<endl;
    cin>>a10toa00;

    cout<<n<<" "<<0<<endl;
    cin>>garbage;
    if (check(garbage)) {
        return 0;
    }

    cout<<n-1<<" "<<0<<endl;
    cin>>a90toa80;

    if (check(a90toa80)) {
        return 0;
    }

    if (a90toa80 == a00to10) {
        // both closer
        string closer = a00to10;
        string further = a10toa00;

        int l = 0;
        int r = n;
        int u = n;
        int d = 0;

        cout<<"0 0"<<endl;
        cin>>garbage;

        while (l < r && d < u) {
            cout<<l<<" "<<u<<endl;
            string cur;
            cin>>cur;
            if(check(cur)) {
                return 0;
            }
            string cur1;
            cout<<r<<" "<<u<<endl;
            cin>>cur1;
            if (check(cur1)) {
                return 0;
            }
            if (cur == closer) {
                d = (u + d) / 2;
            } else if (cur == further) {
                u = (u + d) / 2;
            } else {
                d = (u + d) / 2;
                u =d;
            }

            if (cur1 == closer) {
                l = (l + r) / 2;
            } else if (cur1 == further) {
                r = (l + r) / 2;
            } else {
                l = (l + r) / 2;
                r = (l + r) / 2;
            }
            cout<<l<<" "<<d<<endl;
            cin>>cur;
            if(check(cur)) {
                return 0;
            }
        }

        while (l < r) {
            cout<<r<<" "<<d<<endl;
            string cur;
            cin>>cur;
            if (cur == closer) {
                l = (l + r) / 2;
            } else if (cur == further) {
                r = (r + l) / 2;
            } else {
                l = (l + r) / 2;
                r = l;
            }
            cout<<l<<" "<<d<<endl;
            cin>>cur;
            if (check(cur)) return 0;
        }

        while (d < u) {
            cout<<l<<" "<<u<<endl;
            string cur;
            cin>>cur;
            if (cur == closer) {
                d = (d + u) / 2;
            } else if (cur == further) {
                u = (d + u) / 2;
            } else {
                d = (d + u) / 2;
                u = d;
            }
            cout<<l<<" "<<d<<endl;
            cin>>cur;
            if (check(cur)) return 0;
        }

        cout<<l<<" "<<d<<endl;
        cin>>garbage;
        if(check(garbage)) return 0;

        return 1;


    } else {
        cout<<0<<" "<<0<<endl;
        cin>>garbage;
        string a00to01;
        string a09to08;
        cout<<0<<" "<<1<<endl;
        cin>>a00to01;
        if (check(a00to01)) {
            return 0;
        }
        cout<<0<<" "<<n<<endl;
        string a00to09;
        cin>>a00to09;
        if (check(a00to09)) {
            return 0;
        }
        cout<<0<<" "<<n-1<<endl;
        cin>>a09to08;
        if (check(a09to08)) {
            return 0;
        }

        if (a09to08 == a00to01) {
            string closer = a09to08;
            string further;
            int x;
            if (closer == a00to10) {
                further = a10toa00;
                x = n;
            } else {
                further = a00to10;
                x = 0;
            }
            int d = 0;
            int u = n;
            cout<<x<<" "<<0<<endl;
            cin>>garbage;
            while (d < u) {
                cout<<x<<" "<<u<<endl;
                string cur;
                cin>>cur;
                if (cur == closer) {
                    d = (u + d) / 2;
                } else if (cur == further) {
                    u = (u + d) / 2;
                } else {
                    d = (u + d) / 2;
                    u = d;
                }
                cout<<x<<" "<<d<<endl;
                cin>>cur;
                if (check(cur)) {
                    return 0;
                }
            }
            cout<<x<<" "<<d<<endl;
            cin>>garbage;
            if (check(garbage)) {
                return 0;
            } else {
                return 1; // NOW!!
            }

        } else {
            cout<<n<<" "<<n<<endl;
            cin>>garbage;
            if (check(garbage)) {
                return 0;
            } else {
                return 1;
            }
        }
    }



   // return 1;
}