#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <unordered_map>
#include <string>
#include <queue>
#include <deque>

#define pb push_back
#define rep(i,n) for(int i = 0; i < (n); i++)
#define vi vector<int> 
#define ve vector
#define pii pair<int,int>
#define all(p) (p).begin(), (p).end()
#define mp make_pair
#define int long long

using namespace std;
using ull = unsigned long long;
using ll = long long;

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
}

vi v[505];
int cnt[505];

void solve() {
	int n, k;
	cin >> n >> k;
	if (k == 1) {
		cout << "YES\n";
		cout << n * (n - 1) / 2 << "\n";
		for (int i = 1; i <= n; i++)
			for (int j = i + 1; j <= n; j++)
				cout << i << " " << j << "\n";
		return;
	}
	
	ve<pii> ans;
	int c = 1;
	int cc = k;
	for (int i = 1; i <= k; i++) {
		if (i % 2 == 1) {
			int ost = c - cnt[i];
			for (int j = 1; j <= ost; j++) {
				if (i + j > n) {
					cout << "NO\n";
					return;
				}
				ans.push_back({ i, i + j });
				cnt[i]++;
				cnt[i + j]++;
			}
			c++;
		}
		else {
			int ost = cc - cnt[i];
			for (int j = 1; j <= ost; j++) {
				if (i + j > n) {
					cout << "NO\n";
					return;
				}
				ans.push_back({ i, i + j });
				cnt[i]++;
				cnt[i + j]++;
			}
			cc--;
		}
	}
	
	//cout << "\n";
	int pr = 1;
	for (int i = 1; i <= n; i++) {
		if (cnt[i] == 0) {
			ans.pb({ i, pr });
			cnt[i]++;
			cnt[pr]++;
			pr = i;
		}
	}
	/*rep(i, n + 1) {
		cout << cnt[i] << " ";
	}*/
	cout << "YES\n";
	cout << ans.size() << "\n";
	for (auto& x : ans) {
		cout << x.first << " " << x.second << "\n";
	}
}

signed main()
{
	fast();

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
