import sys


def solve():
    def swap(i, j):
        next = j
        tmp = p[next]
        p[next] = p[i]
        p[i] = tmp
        tmp = q[next]
        q[next] = q[i]
        q[i] = tmp

    n = int(sys.stdin.readline())
    a = list(map(int, sys.stdin.readline().split()))

    m = {}
    for i in range(n):
        m[a[i] - 1] = i

    p = [(i + 1) % n for i in range(n)]
    q = [0 for i in range(n)]

    free_p = set()

    for i in range(n):
        free_p.add(i)
        free_p.add(i)

    mp = {}
    for i in range(n):
        mp[p[i]] = i

    for i in range(n):
        q[i] = mp[m[i]]
    cc = 0
    while True:
        cc += 1
        if cc > 6 * 10 ** 5:
            print("Impossible")
            return
        # print(q)
        e = 0
        i = 0
        next = (i + 1) % n
        prev = (i - 1 + n) % n

        if p[i] == i or q[i] == i:
            swap(i, next)
            if p[i] == i or q[i] == i:
                swap(i, next)
                swap(next, (next + 1) % n)
                swap(next, (next + 1) % n)
            e = 0
            i += 1
        else:
            i += 1
            e += 1

        if e == n:
            break

    print("Possible")
    for i in p:
        sys.stdout.write(str(i) + " ")
    sys.stdout.write("\n")
    for i in q:
        sys.stdout.write(str(i) + " ")
    sys.stdout.write("\n")

    return


if __name__ == '__main__':
    t = int(sys.stdin.readline())
    for _ in range(t):
        solve()
