#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main(){
	int N, K;
	cin >> N >> K;


	if (N == 1) {
		if (K == 1) {
			cout << "YES" << endl << 0 << endl;
		}
		else { //imposible
			cout << "NO" << endl;
		}
		return 0;
	}
	if (K == N) {
		cout << "NO" << endl;
		return 0;
	}
	

	vector< vector<bool> > adjmat(N, vector<bool>(N, false));
	int countOfEdges = 0;

	if (K == 1) {
		for (int i = 0; i < N-1; i++) {
			int j = i + 1;
			adjmat[i][j] = adjmat[j][i] = true;
			countOfEdges++;
		}
		if (!adjmat[N - 1][0]) countOfEdges++;
		adjmat[N - 1][0] = adjmat[0][N - 1] = true;
		
	}
	else {
		for (int i = 1; i < N; i++) {
			adjmat[0][i] = adjmat[i][0] = true;
			countOfEdges++;
		}
		for (int k = 2; k < K; k++) {
			for (int i = 0; k+1-i >=0; i++) {
				if (i == k + 1 - i) continue;
				if (!adjmat[i][k + 1 - i]) countOfEdges++;
				adjmat[i][k + 1 - i] = adjmat[k + 1 - i][i] = true;
			}
		}
	}


	for (int i = 0; i < N; i++) {
		for (int j = 0; j < N; j++) {
			cout << adjmat[i][j] << " ";
		}
		cout << endl;
	}
	cout << "YES" << endl;
	cout << countOfEdges << endl;
	for (int i = 0; i < N; i++) {
		for (int j = i; j < N; j++) {
			if (adjmat[i][j]) {
				cout << i+1 << " " << j+1 << endl;
			}
		}
	}
	return 0;
}
