#include <iostream>
#include <vector>
#include <sstream>

using namespace std;

void copy_vector(vector<vector<unsigned int>>& tower, int i, int j) {
	vector<unsigned int> first, second;
	for (int m = 0; m < tower[i].size(); ++m) {
		if (m < j) {
			first.push_back(tower[i][m]);
		}
		else {
			second.push_back(tower[i][m]);
		}
	}
	tower.erase(tower.begin() + i);
	tower.push_back(first);
	tower.push_back(second);
}

void combine(vector<vector<unsigned int>>& tower, int i, int j) {

	for (int m = 0; m < tower[j].size(); ++m) {
		tower[i].push_back(tower[j][m]);
	}
	tower.erase(tower.begin() + j);
}

int main()
{
	unsigned int n, min, cur_vec=0, next, next_vec=0, cur_h, next_h;
	vector<vector<unsigned int>> tower;
	vector<unsigned int> in_tower;
	cin >> n;
	while (n != 0) {
		unsigned int size;
		unsigned int elem;
		cin >> size;
		while (size != 0) {
			cin >> elem;
			in_tower.push_back(elem);
			size--;
		}
		tower.push_back(in_tower);
		in_tower.clear();
		n--;
	}
	unsigned int split_count = 0, combine_count = 0;
	for (int i = 0; i < tower.size(); ++i) {
		for (int j = 1; j < tower[i].size(); ++j) {
			if (tower[i][j - 1] > tower[i][j]) {
				split_count++;
				copy_vector(tower, i, j);
			}
		}
	}
	cur_h = 0;
	min = tower[0][0];
	for (int i = 0; i < tower.size(); i++) {
		if (tower[i][0] < min) {
			min = tower[i][0];
			cur_vec = i;
		}
	}
	while (tower.size() != 1) {
		next = 1e9 + 1;
		for (int i = 0; i < tower.size(); i++) {
			for (int j = 0; j < tower[i].size(); j++) {
				if (tower[i][j]<next && tower[i][j]>min) {
					next = tower[i][j];
					next_vec = i;
					next_h = j;
				}
			}
		}
		if (next_vec != cur_vec) {
			if (cur_h != tower[cur_vec].size() - 1) {
				copy_vector(tower, cur_vec, cur_h+1);
				split_count++;
				cur_vec = tower.size() - 2;
			}
			cur_h = tower[cur_vec].size();
			combine(tower, cur_vec, next_vec);
			combine_count++;
		}
		else cur_h++;
		if (next_vec < cur_vec) cur_vec--;
		min = next;
	}

	cout << split_count << " " << combine_count;
}
