#include <bits/stdc++.h>

using namespace std;

const int N = 2e5+10;
int a[N], b[N], p[N], q[N], nxt[N], pr[N], idx[N];

void solve() {
    int n; cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    if (n == 1) {
        cout << "Impossible\n";
        return;
    }
    if (n == 2) {
        if (a[1] == 2) {
            cout << "Impossible\n";
            return;
        }
    }
    if (n == 3) {
        if (a[1] == 2 && a[2] == 1) {
            cout << "Impossible\n";
            return;
        }
        if (a[1] == 3 && a[3] == 1) {
            cout << "Impossible\n";
            return;
        }
        if (a[2] == 3 && a[3] == 2) {
            cout << "Impossible\n";
            return;
        }
    }
    vector<int> vis(n + 1);
    vector<vector<int>> cycles(n + 1);
    int cnt = 0;
    for (int i = 1; i <= n; ++i) {
        if (!vis[i]) {
            ++cnt;
            while (!vis[i]) {
                cycles[cnt].push_back(i);
                vis[i] = 1;
                i = a[i];
            }
        }
    }
    int id = -1;
    for (int i = 1; i <= cnt; ++i) {
        reverse(cycles[i].begin(), cycles[i].end());
        for (int  j = 0; j < (int)cycles[i].size(); ++j) {
            nxt[cycles[i][j]] = cycles[i][(j + 1) % (cycles[i].size())];
        }
        if (cycles[i].size() != 2) {
            id = i;
        }
    }
    int cnt2 = 0;
    for (int i = 1; i <= cnt; ++i) {
        if (cycles[i].size() != 2) {
            cnt2 += cycles[i].size();
        }
    }
    for (int i = 1; i <= cnt; ++i) {
        if (cycles[i].size() == 2 || i == id) continue;
        int a = cycles[i][0];
        int b = nxt[a];
        int c = cycles[id][0];
        int d = nxt[c];
        nxt[a] = d;
        nxt[c] = b;
    }
    id = max(id, 1);
    if (cnt2 == 1) {
        if (cycles[1].size() == 1) {
            id = 2;
        } else {
            id = 1;
        }
    }
    for (int i = 1; i <= cnt; ++i) {
        if (i == id || cycles[i].size() != 2) continue;
        int a = cycles[i][0], b = cycles[i][1];
        int c = cycles[id][0], d = nxt[c], e = nxt[d];
        nxt[d] = a;
        nxt[a] = e;
        nxt[b] = d;
        nxt[c] = b;
    }
    if (cnt2 == 1) {
        for (int i = 1; i <= cnt; ++i) {
            if (cycles[i].size() == 1) {
                int a = cycles[id][0], b = nxt[a];
                int c = cycles[i][0];
                nxt[a] = c;
                nxt[c] = b;
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        idx[a[i]] = i;
    }
    for (int i = 1; i <= n; ++i) {
        pr[i] = idx[nxt[i]];
    }
    for (int i = 1; i <= n; ++i) {
        idx[nxt[i]] = i;
    }
    for (int i = 1; i <= n; ++i) {
        b[i] = idx[i];
    }
    cout << "Possible\n";
    for (int i = 1; i <= n; ++i) {
        cout << pr[i] << " \n"[i == n];
    }
    for (int i = 1; i <= n; ++i)
        cout << b[i] << " \n"[i == n];
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}

