#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    int n, k;
    cin >> n >> k;
    if (n == 1) {
        cout << "YES" << endl;
        cout << 0 << endl;
        return 0;
    }
    if (k == 1) {
        cout << "YES" << endl;
        cout << n << endl;
        for (int i = 1; i < n; ++i) {
            cout << i << " " << (i + 1) << endl;
        }
        cout << n << " " << 1 << endl;
        return 0;
    }
    vector<vector<int>> arr(n + 1);
    int mx = k;
    for (int i = 1; i <= k; ++i) {
        int forward = i - arr[i].size();
        mx = max(mx, i + forward);
        if (i + forward > n) {
            cout << "NO" << endl;
            return 0;
        }
        for (int j = i + 1; j <= i + forward; ++j) {
            arr[i].push_back(j);
            arr[j].push_back(i);
        }
    }
    for (int i = mx + 1; i <= n; ++i) {
        int nxt = (i == n ? 1 : i + 1);
        arr[nxt].push_back(i);
        arr[i].push_back(nxt);
    }
    set<pair<int, int>> st;
    for (int i = 1; i <= n; ++i) {
        for (auto a : arr[i]) {
            st.insert({min(i, a), max(i, a)});
        }
    }
    cout << "YES" << endl;
    cout << st.size() << endl;
    for (auto a : st) {
        cout << a.first << " " << a.second << endl;
    }
    return 0;
}