#include <iostream>

using namespace std;

void solve() {
    long n; cin >> n;
    long a[n]; for (long &i : a) cin >> i;

    if (n == 2) {
        if (a[1] < a[0]) {
            cout << "Impossible\n";
            return;
        }
    } else if (n == 1) {
        cout << "Impossible\n";
        return;
    }
    cout << "Possible\n";

    bool mask[n +1]; for (bool &i : mask) i = true;
    long p1[n +1];

    for (long i = 0; i < n; i++) {
        for (long _j = i; _j < n + i; _j++) {
            long j = _j % n;
            if (mask[j] && i != j && a[i] != j + 1) {
                mask[j] = false;
                p1[j] = i;
                break;
            }
        }
    }
    for (bool &i : mask) i = true;
    long p2[n + 1];

    for (long i = 0; i < n; i++) {
        p2[a[p1[i]] - 1] = i;
    }

    for (long i = 0; i < n; i++) {
        cout << p1[i] + 1 << (i < n - 1 ? " " : "\n");
    }
    for (long i = 0; i < n; i++) {
        cout << p2[i] + 1 << (i < n - 1 ? " " : "\n");
    }
}

int main() {
    long t; cin >> t;

    for (long i = 0; i < t; i++)
        solve();
    return 0;
}
