#include <iostream>
#include <algorithm>
#include <map>

using namespace std;
typedef unsigned long long ull;

string encode(string s) {
    string prefix = "";
    while(prefix.size() + s.size() < 10) prefix += "0";
    return prefix + s;
}

ull last10(ull a) {
    return a % 10000000000ULL;
}

int main()
{
    map<string, ull> mapping;
    ull initial = 1;
    for (ull i = 1; i <= 5982; i++) {
        initial *= i;
        initial = last10(initial);
        // if (i <= 5) cout << "test " << encode(to_string(initial));
        mapping[encode(to_string(initial))] = i;
    }
    int n;
    cin >> n;
    while (n--) {
        string s;
        for (int i = 0; i <= 9; i++) {
            cout << "? " << i << endl;
            int t;
            cin >> t;
            s += '0' + t;
        }
        reverse(s.begin(), s.end());
        cout << "! " << mapping[encode(s)] << endl;
        string answer;
        cin >> answer;
        if (answer == "NO") return 0;
    }
    return 0;
}
